#ifndef BINARY_H
#define BINARY_H

/*
=======================================================================================
DEFINES
=======================================================================================
*/
#define   C_BinPass1			"2"
#define   C_BinPass2			"3"
#define   C_TemporaryDirectory	"TestCRB"
#define   C_CRBExecutable		"CRB.exe"
#define   C_World				"World"
#define   C_Levels				"Levels"
/*
=======================================================================================
GLOBALS
=======================================================================================
*/
extern char		SAVE_g_szDirName[ _MAX_PATH ];
extern char		SAVE_g_szTargetDirName[ _MAX_PATH ];
extern unsigned char	g_ucChoice;
extern BOOL bYes;
extern BOOL bBatch;
extern BOOL bAll;
extern BOOL bTbl;

extern BOOL bBMP;
extern BOOL bTGA;
extern BOOL bConvert16;
extern BOOL bConvert32;
/*
=======================================================================================
=======================================================================================
FUNCTIONS
=======================================================================================
=======================================================================================
*/
//************************************************************************
void fn_vGetFileExtension( char *szFileName , char *a4_cExtend );

/*
=======================================================================================
Directory Functions
=======================================================================================
*/
BOOL SAVE_fn_bCreateDirectory( char *szDirName );
BOOL fn_bDeleteTemporaryFiles( char *szDir, char *szLevelName );
BOOL fn_bCopyDirectory( BOOL _bRecursive, char *szExtendFile );
BOOL SAVE_fn_bCopyDirectory( char *szSourceDir, char *szTargetDir, BOOL _bRecursive, char *szExtendFile);
char fn_cExecuteGame(char *szProgramName, char *szLevelName, char *szPass);
char fn_cExecuteCRB(char *szProgramName, char *szLevelName);
char fn_cCopyAnyFilesOfADirectory(char *szSrcDirectory,  char *szDestDirectory, char *szPass) ;
char fn_cCopyBinarizedFiles(char *szSrcDirectory,  char *szDestDirectory, char *szLevel) ;
char fn_cExecuteGameFirst(char *szProgramName, char *szLevelName, char *szPass);
char fn_cExecuteMakeanim(char *szProgramName, BOOL b, BOOL a, BOOL z, char *szAnimName);
char fn_cExecuteConvImg(char *szProgramName, char * szSource, char *szDestBinDir, BOOL bBMP, BOOL bTGA, BOOL bConvert16, BOOL bConvert32, char *szTextureName);
BOOL fn_bMoveDirectory( BOOL _bRecursive, char *szExtendFile );
BOOL SAVE_fn_bMoveDirectory( char *szSourceDir, char *szTargetDir, BOOL _bRecursive, char *szExtendFile);

char fn_cExecuteConvImgOnDirectory( char *szProgramName, char *szSourceDir, char *szDestDir, BOOL bBMP, BOOL bTGA, BOOL bConvert16, BOOL bConvert32 );
void fn_vCopyTextures( char *_szBaseDir, char *_szDestinationDir, BOOL bConvertTextures );

#endif
