/*
 =======================================================================================
  Name        : DlgWarning.cpp
 
  Author      : Mihaela Tancu
 
  Description : implementation of dialog 
 =======================================================================================
 */

#include "stdafx.h"

#include "DlgWarning.h"
#include "Print.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/*
 =======================================================================================
	CDlgWarning dialog
 =======================================================================================
 */

/*
 ---------------------------------------------------------------------------------------
	Description : constructor
 ---------------------------------------------------------------------------------------
 */
CDlgWarning::CDlgWarning(CWnd* pParent /*=NULL*/) : CDialog(CDlgWarning::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgWarning)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

/*
 ---------------------------------------------------------------------------------------
	Description : message map
 ---------------------------------------------------------------------------------------
 */
BEGIN_MESSAGE_MAP(CDlgWarning, CDialog)
	//{{AFX_MSG_MAP(CDlgWarning)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*
 =======================================================================================
	CDlgWarning message handlers
 =======================================================================================
 */


/*
 ---------------------------------------------------------------------------------------
  Description : WM_INITDIALOG
 ---------------------------------------------------------------------------------------
 */
BOOL CDlgWarning::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_oStatic=(CStatic *)GetDlgItem(IDC_STATICWARNING);
    m_oStatic->SetWindowText(sMes);
	GetDlgItem(IDOK)->SetWindowText(sOK);
	GetDlgItem(IDCANCEL)->SetWindowText(sCancel);

	return TRUE;  
}

/*
 ---------------------------------------------------------------------------------------
  Description : WM_DESTROY
 ---------------------------------------------------------------------------------------
 */
void CDlgWarning::OnDestroy() 
{
	CDialog::OnDestroy();
}


