/*
 =======================================================================================
  Name        : SpecRef.h
 
  Author      : vincent lhullier            Date :10/09/97
 
  Description : functions to transform special references
 =======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#ifndef __SPECREF_H__
#define __SPECREF_H__
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	Typedef & struct 
 =======================================================================================
 */
typedef void (* tdpfn_Scr_TransformSpecialRef)(char *);

typedef struct tdstSpecialReference_
{
	char							szSectionType[512];
	char							szEntry[512];
	char							cParam;
	tdpfn_Scr_TransformSpecialRef	pfn_vTransform;
} tdstSpecialReference;

/*
 =======================================================================================
	constants 
 =======================================================================================
 */

#define C_lNumberOfSpecialRefs	1

/*
 =======================================================================================
	globals
 =======================================================================================
 */
extern tdstSpecialReference g_a_stSpecialRef[ C_lNumberOfSpecialRefs ];

/*
 =======================================================================================
	functions 
 =======================================================================================
 */
void fn_SpRef_vTransformSpecialRef( char *_szSectionType, char *_szEntryName, char _cParam, char *_szRef );

/* special ref transformation */
void fn_vTransformCSRef( char *_szRef );

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#endif