/*=========================================================================
*
* GIType.h	- Define the GI_Type class 
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef __GITYPE_H__
#define __GITYPE_H__


//--- Includes --------------------------------------------------------

#include <afxtempl.h>

#include "GIItem.h"

//----------------------------------------------------------------------


/*
 =======================================================================================
	GI_Type  class
 =======================================================================================
 */

class GI_Type 
{
// datas
public:
	// name of the type
	char							m_szName[50];	
	// number of selected objects for the type
	int								m_iSelected;	
	// the text color of the type in list box
	COLORREF						m_xTextColor;	
	// the list of objects associated with the type
	CList<GI_Item *,GI_Item *>		m_oList;		

// methods
public:
	// contructor
	GI_Type(char *szName, int _iSelected, COLORREF m_xTextColor); 
    // destructor
	~GI_Type();													  

    // return the name of type
	char* m_fn_p_oGetName(void)				{ return m_szName; }	
    // return the number of objects selected for that type
	int   m_fn_iGetSelected(void)			{ return m_iSelected; }	
	// set the number of selected objects
	void  m_fn_iSetName(int _iSelected)     { m_iSelected=_iSelected; }	
};

#endif // __GITYPE_H__