/*=========================================================================
*
* FMD.h	- Face Map Descriptor
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef __MLT_FMD_H
#define __MLT_FMD_H


//--- Includes --------------------------------------------------------

#include "typedef.h"


//--- Structures --------------------------------------------------------

typedef struct	MLT_tdstMaterial_	MLT_tdstMaterial ;
typedef struct	MLT_tdstTexture_	MLT_tdstTexture ;
typedef float	MLT_tdxUVValue ;


typedef struct ACP_tdst2DUVValues_
{
	MLT_tdxUVValue xU;
	MLT_tdxUVValue xV;
} 
ACP_tdst2DUVValues;


typedef struct MLT_tdstFaceMapDescriptor_
{
  char					AlreadySave;
  xString				sName;
  ACP_tdst2DUVValues	stUVValues[3];
  xString				sMaterial;
  xString				sMaterialFile;
  MLT_tdstMaterial		*hMaterial;
  xString				sSprObjName;
  xString				sSprObjFile;
} 
MLT_tdstFaceMapDescriptor;


#endif // __MLT_FMD_H  
