/*=========================================================================
*
* LgtLoad.h	- Loading functions for Lgt file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef _LGTLOAD_H_
#define _LGTLOAD_H_

//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "typedef.h"
#include "matrix.h"

//------------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS


//--- Structures ---------------------------------------------------------

typedef struct MLT_tdstLGT_
{
  xString sName;
  xString sSetMatrix;
  MLT_tdstMatrix *p_stMatrix;
} 
MLT_tdstLGT;



//--- Functions ---------------------------------------------------------

// load&save
extern void							MLT_vInitLGTLoad	 (void);
//extern void						MLT_vSaveVertexColor (SCR_tdst_File_Description *p_stFile, MLT_tdstVertexColor *p_stVertexColor);
extern SCR_tde_Anl_ReturnValue		MLT_xLoadLGT		 (SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue		MLT_xLoadLGTCallback (SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
// library
extern void MLT_vEraseLGTLib		(void);
extern void MLT_vLoadLGTFileInLib	(void);



#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus */
/********************************************************/
#endif // _WINDOWS

#endif // _LGTLOAD_H_ 
