/*=========================================================================
*
* SctLoad.h	- Loading functions for SCT file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef SCTLOAD_H
#define SCTLOAD_H


//--- Includes --------------------------------------------------------

#include "SCR.h"

extern int iExistStaticLight;

//--- Functions ---------------------------------------------------------

// init
extern void MLT_vInitSCTLoad();
// load section
extern SCR_tde_Anl_ReturnValue MLT_xLoadSector				(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
// load sub-sections
extern SCR_tde_Anl_ReturnValue MLT_xLoadSectorBorder		(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue MLT_xLoadSectorENVAndSRF		(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue MLT_xLoadSectorLink			(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue MLT_xLoadSectorStaticLights	(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);


#endif // SCTLOAD_H 
