/*=========================================================================
*
* SrfSave.h	- Saving functions for SRF file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef SRFSAVE_H
#define SRFSAVE_H


//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "sprobj.h"

//--- Functions ---------------------------------------------------------

// sections
extern void MLT_vSaveSrfHeader	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSaveSurface	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// file
extern void MLT_vSaveSrfFile	(MLT_tdstSprObj *hRoot);
// name
extern void MLT_vGetSurfaceName	(char *sName, char *sOldName);


#endif // SRFSAVE_H 