/*=========================================================================
*
* Submaps.h	- Submap conversion
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef __SUBMAP_H__
#define __SUBMAP_H__


//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "sprobj.h"

//--------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif //_WINDOWS



//--- Globals --------------------------------------------------------

extern MLT_tdxHandleToSuperObject	g_hRoot1;
extern MLT_tdxHandleToSuperObject	g_hRoot2;
extern BOOL							g_bSubmaps;
extern int							g_iUnivSectors;


//--- Functions --------------------------------------------------------

// hierarchy
extern void MLT_vCheckHierarchyForSubmaps (MLT_tdxHandleToSuperObject hRoot, char *sGameLevel, char *sRawLevel);
// init
extern void MLT_vInitSubMapsLoad		(void);
// save
extern void MLT_vSaveSubFile			(void);
extern void MLT_vSaveSubSectionsInFile	(void);
extern void MLT_vSaveSubMaps			(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSaveAllSubMapsSection	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void	MLT_vSaveNbSubMaps			(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSaveNumberOfSubMaps	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// load
extern SCR_tde_Anl_ReturnValue  MLT_xLoadAllSubMaps		(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);


#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus 
/********************************************************/
#endif //_WINDOWS

#endif // __SUBMAP_H__ 
