/*=========================================================================
*
* Textures.h	- Textures functions 
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef TEXTURES_H
#define TEXTURES_H


//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "typedef.h"

//--------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS


//--- Functions ---------------------------------------------------------

// compute function
extern void MLT_vComputeAllTextures	(char *RawData, char *GameData);
extern void MLT_vComputeOneTexture	(char *TextureName, char *RawData, char *GameData);
// search function
extern void MLT_vSearchGameData			(char *szParams, xString sDir);
// copy functions
extern void MLT_vCopyTexturesFromRaw	(char *szParams, xString sDir);
extern void MLT_vCopyTextureIfFound		(char *szParams, xString sDir);
// write functions
extern void MLT_vWriteTextureIfFound	(char *szParams);
extern void MLT_vSetTextureFile			(xString sFileMaterial, char* szParams, xString sDir1, xString sDir);
// load function
SCR_tde_Anl_ReturnValue MLT_xLoadTextureSection (SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);



#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS

#endif // TEXTURES_H 
