/*=========================================================================
*
* MatStack.h	- Matrix Stack 
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef MATSTACK_H
#define MATSTACK_H


//--- Includes --------------------------------------------------------

#include "matrix.h"


//--- Defines ---------------------------------------------------------

#define MLT_C_lMaxMatrixInStack 100
#define MLT_C_lStackFull		200
#define MLT_C_lStackEmpty		201


//--- Globals ---------------------------------------------------------

extern MLT_tdstMatrix	*g_p_stCurrentMatrix ;


//--- Functions ---------------------------------------------------------

// stack
extern void MLT_xInitMatrixStack	(void);
extern void MLT_xResetMatrixStack	(void);
// push&pop
extern void MLT_xPopMatrix			(void);
extern void MLT_xPushMatrix			(MLT_tdstMatrix *p_stMatrix);
extern void MLT_xPrePushMatrix		(MLT_tdstMatrix *p_stMatrix);

#endif // MATSTACK_H 

