/*
 =======================================================================================
  Name        : DLGAbout.h
 
  Author      : Vincent  Lhullier           Date :17/07/97
 
  Description : Header file for about dialog box class for MngData5
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

#ifndef __DLGABOUT_H__ 
#define __DLGABOUT_H__

/*
 =======================================================================================
	CAboutDlg dialog class
 =======================================================================================
 */

class CAboutDlg : public CDialog
{
  //data members
  private:
	UINT	m_uiTimer;
	char	m_cNbBitmaps;
	char	m_cCurBitmap;
	CBitmap	m_a_oBitmap[11];

  // Construction
  public:
	CAboutDlg(CWnd* pParent = NULL);   // standard constructor

  // Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

  // Implementation
  protected:
	// Generated message map functions
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif /*__DLGABOUT_H__*/