/*
 =======================================================================================
  Name        : logindlg.h
 
  Author      : vincent lhullier            Date :27/07/97
 
  Description : header file for CloginDialog : Dialog box to log to Vss database
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#if !defined(AFX_LOGINDLG_H__1F212DAD_B7E5_11D0_8E7B_00609736731A__INCLUDED_)
#define AFX_LOGINDLG_H__1F212DAD_B7E5_11D0_8E7B_00609736731A__INCLUDED_

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "resource.h"

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	CLoginDialog dialog
 =======================================================================================
 */
class CLoginDialog : public CDialog
{
  //private data
  private:
	BOOL m_bInit;

	char m_szUserName[100];
	char m_szPassword[100];
	char m_szDatabase[MAX_PATH];
  
  // Construction
  public:
	CLoginDialog(CWnd* pParent = NULL);   // standard constructor

	void m_fn_vSetUserName( char *_szName );
	void m_fn_vSetDatabase( char *_szDatabase );

	char *m_fnp_szGetUserName( void ) { return m_szUserName; }
	char *m_fnp_szGetPassword( void ) { return m_szPassword; }
	char *m_fnp_szGetDatabase( void ) { return m_szDatabase; }
	

  // Dialog Data
	//{{AFX_DATA(CLoginDialog)
	enum { IDD = IDD_DIALOG_LOGIN };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

  // Implementation
  protected:

	// Generated message map functions
	//{{AFX_MSG(CLoginDialog)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnButtonBrowse();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#endif // !defined(AFX_LOGINDLG_H__1F212DAD_B7E5_11D0_8E7B_00609736731A__INCLUDED_)
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/