/*
 =======================================================================================
  Name        : DlgObtai.h
 
  Author      : vincent lhullier            Date :29/08/97
 
  Description : header file for obtain dialog box class
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#if !defined(AFX_DLGOBTAI_H__35C8479B_1F76_11D1_8F1B_00609736731A__INCLUDED_)
#define AFX_DLGOBTAI_H__35C8479B_1F76_11D1_8F1B_00609736731A__INCLUDED_
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	CBatchObtainDlg dialog
 =======================================================================================
 */
class CBatchObtainDlg : public CDialog
{
  private:
	  UINT		m_uiTimer;
	  char		m_cHours;
	  char		m_cMinutes;
	  char		m_cSeconds;
	  long		m_lSeconds;
	  BOOL		m_bUseTimer;
	  BOOL		m_bTry;
	  BOOL		m_bObtain;
	  time_t	m_xNextTry;
	  long		m_lTryCount;

	  CBitmap	m_a_oDigit[10];
	  CBitmap	m_oSeparator;

  // Construction
  public:
	CBatchObtainDlg(CWnd* pParent = NULL);   // standard constructor
	CBatchObtainDlg::~CBatchObtainDlg();

	BOOL fn_bDoObtain( void ) { return m_bObtain; } 

	void fn_vComputeElapseTime();

  // Dialog Data
	//{{AFX_DATA(CBatchObtainDlg)
	enum { IDD = IDD_DIALOG_BATCHOBTAIN };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


  // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBatchObtainDlg)
	//}}AFX_VIRTUAL

  // Implementation
  protected:

	// Generated message map functions
	//{{AFX_MSG(CBatchObtainDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDIS);
	afx_msg void OnCheckWait();
	afx_msg void OnKillfocusEditSeconds();
	afx_msg void OnDeltaposSpinTime(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnCancel();
	afx_msg void OnCheckUsetimer();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDeltaposSpinSeconds(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGOBTAI_H__35C8479B_1F76_11D1_8F1B_00609736731A__INCLUDED_)
