
//
//	FILE	: App.h
//	AUTHOR	: Catalin Cocos
//__________________________________________________________________________________________________
#ifndef __APPH__
#define __APPH__

#include "scr2bin.h"

#define APPNAME "Script Converter v. 1.2"
#define DEFCFG  "Default.s2b"
#define INIFILE "WinS2B.ini"
#define MIN_CLIENTX 380 +14
#define MIN_CLIENTY 200

extern int FILTER_WIDTH;

extern HWND hWApp;
extern HWND hWToolbar;
extern HWND hWStatusbar;
extern HWND hWList;
extern HWND hWTree;
extern HWND hWListView;
extern HWND hWOut;
extern HWND hWFilter;

extern int ToolbarHeight;
extern int StatusHeight;

extern float SplitX;
extern float SplitY;
extern char CrtCfg[MAX_PATH];

extern int nFocusWnd;
#define FOCUS_LIST		0
#define FOCUS_OUT		1
#define FOCUS_TREE		2
#define FOCUS_LISTVIEW	3
#define FOCUS_FILTER	4

extern int OperatingMode;
extern volatile BOOL Processing;



extern CScr2bin CnvEng;

LRESULT CALLBACK AppWndProc( HWND hwnd, UINT uMsg, WPARAM wP, LPARAM lP ); 
void OnIdle();
void MakeToolbar( HWND hwnd );
void PositionChildwindows();	
void SaveConfiguration();
BOOL LoadConfiguration();
void UpdateAppName();
void RestoreFocus();
void Refresh();
void CleanSelection();


#endif
