/*=========================================================================
* ToolsCPA.h : CPA tools include
*
*
* Version              1.0
* Creation date        10/01/97
*	Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/

#if !defined(__MAINCPA_H__)
#define __MAINCPA_H__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/

/****************************************
 * Here is the list of disabled WARNING *
 ****************************************/
#if defined(VISUAL)
#pragma warning(disable:4010) //* single-line comment contains line-continuation character *
#pragma warning(disable:4032) //* formal parameter 1 has different type when promoted *
#pragma warning(disable:4100) //* unreferenced formal parameter *
#pragma warning(disable:4115) //* named type definition in parentheses *
#pragma warning(disable:4127) //* conditional expression is constant *
#pragma warning(disable:4201) //* nonstandard extension used : nameless struct/union *
#pragma warning(disable:4214) //* nonstandard extension used : bit field types other than int *
#pragma warning(disable:4310) //* cast truncates constant value *
#pragma warning(disable:4514) //* unreferenced inline function has been removed *
#pragma warning(disable:4702) //* unreachable code *
#pragma warning(disable:4711) //* selected for automatic inline expansion *
#endif /* VISUAL */

#include "ACP_Base.h"
#if defined(WIN32)&&defined(__cplusplus)
#include "stdafx.h"
#endif /* WIN32&&__cplusplus */

#define HieFriend
#include "CPA_Expt.h"
#include "CPA_Std.h"


#include "GEO.h"
#include "SAI.h"
#include "GLI.h"
#include "COL.h"
#include "MEC.h"
// Shaitan Clean Env {
//#include "ENV.h"
//End Shaitan Clean Env }
#include "SND.h"
// Shaitan Clean Env {
//#include "SRF.h"
//End Shaitan Clean Env }
#include "SCT.h"
#include "SPO.h"
#include "LST.h"
#include "AI.h"
#include "ERM.h"
#include "GMT.h"
#include "INO.h"
#include "IPT.h" 
#include "MMG.h"
#include "SCR.h"
#include "TMR.h"
#include "RND.h"
#include "PCS.h"
#include "PO.h"
//#include "FON.h"
#include "FIL.h"
#include "PRT.h"
#include "VIG.h"
#include "GAM.h"

#endif /* __MAINCPA_H__ */