/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_CONDITION(eCond_IsZDMCollideWithObstacle				,"ZON_ZDMCollisionAvecObstacle"		,"ZON_ZDMCollideWithObstacle"      ,"Cond_ZDMCollideWithObstacle"		,fn_p_stZDMCollideWithObstacle,USE_MASK_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_IsZDMCollideWithWall					,"ZON_ZDMContreMur"					,"ZON_IsZDMCollideWithWall"        ,"Cond_IsZDMCollideWithWall"		,fn_p_stZDMCollideWithObstacle,USE_MASK_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_IsZDMCollideWithGround					,"ZON_ZDMContreSol"					,"ZON_IsZDMCollideWithGround"      ,"Cond_IsZDMCollideWithGround"		,fn_p_stZDMCollideWithObstacle,USE_MASK_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_IsZDMCollideWithCeiling				,"ZON_ZDMContrePlafond"				,"ZON_IsZDMCollideWithCeiling"     ,"Cond_IsZDMCollideWithCeiling"		,fn_p_stZDMCollideWithObstacle,USE_MASK_PARAM,/**/ NOT_ULTRA_ABLE /**/)
/**********************************************************************************************************************************************************************************************************************************************************/
/* collision communication management : NOT ULTRA */
	M_DEFINE_CONDITION(eCond_CmtIdentifierContainsMask				,"COL_TesteCmtContreMasque"			,"COL_CmtIdentifierContainsMask"   ,"Cond_CmtIdentifierContainsMask"	,fn_p_stMiscCondition	,USE_MASK_PARAM USE_MASK_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_HitByCollider							,"COL_CollisionneurTouche"			,"COL_HitByCollider"               ,"Cond_HitByCollider"				,fn_p_stMiscCondition	,USE_NO_PARAM,/**/ NOT_ULTRA_ABLE /**/) /*la fct est dans Cond.c*/
	NU_M_DEFINE_CONDITION(eCond_IsTypeOfGMTCollide					,"TypeGMTCollision"					,"COL_IsTypeOfGMTCollide"          ,"Cond_IsTypeOfGMTCollide"			,fn_p_stMiscCondition	,USE_MASK_PARAM,/**/ NOT_ULTRA_ABLE /**/)
 
    M_DEFINE_CONDITION(eCond_IsInComport							,"EstDansComportement"				,"ACT_IsInComport"                 ,"Cond_IsInComport"					,fn_p_stMiscCondition	,USE_PERSO_INTELL_COMPORT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
    M_DEFINE_CONDITION(eCond_IsInReflexComport					,"EstDansComportementReflexe"		,"ACT_IsInReflexComport"           ,"Cond_IsInReflexComport"			,fn_p_stMiscCondition	,USE_PERSO_REFLEX_COMPORT_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_IsInAction								,"EstDansAction"					,"ACT_IsInAction"                  ,"Cond_IsInAction"					,fn_p_stMiscCondition	,USE_ACTION_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_ChangeActionEnable						,"ChangeActionPossible"				,"ACT_ChangeActionEnable"          ,"Cond_ChangeActionEnable"			,fn_p_stMiscCondition	,USE_ACTION_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_EngineReinitRequested					,"ReinitMoteurDemande"				,"ReinitMoteurDemande"          ,"Cond_EngineReinitRequested"			,fn_p_stMiscCondition	, USE_NO_PARAM ,/**/ NOT_ULTRA_ABLE /**/)
	NU_M_DEFINE_CONDITION(eCond_IsThereMechEvent					,"EvenementMecanique"				,"MEC__IsThereMechEvent"           ,"Cond_IsThereMechEvent"			,fn_p_stMiscCondition	,USE_ADDR_LONG_PARAM,/**/ NOT_ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_CollisionWP							,"COL_CollisionWP"					,"COL_CollisionWP"                 ,"Cond_CollisionWP"					,fn_p_stCollisionWP		,USE_PERSO_PARAM USE_WAYPOINT_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
/* Acteurs */
	M_DEFINE_CONDITION(eCond_IsCustomBitSet							,"ACT_TestCustomBit"				,"ACT_IsCustomBitSet"				,"Cond_IsCustomBitSet"				,fn_p_stCustomBitsCond,USE_CONSTANT_PARAM,/**/ ULTRA_ABLE /**/)
	M_DEFINE_CONDITION(eCond_IsPersoActive							,"ACT_EstActif"						,"ACT_IsPersoActive"				,"Cond_IsPersoActive"				,fn_p_stIsPersoActive,USE_PERSO_PARAM,NOT_ULTRA_ABLE)
	M_DEFINE_CONDITION(eCond_CheckActionEnd							,"ACT_TestFinAction"				,"ACT_CheckActionEnd"				,"Cond_CheckActionEnd"				,fn_p_stCheckAnimEnd,USE_NO_PARAM,ULTRA_ABLE)
	M_DEFINE_CONDITION(eCond_IsCurrentStateCustomBitSet				,"ACT_TestCustomBitDEtatCourant"	,"ACT_IsCurrentStateCustomBitSet"   ,"Cond_IsCurrentStateCustomBitSet"	,fn_p_stCustomBitsCond,USE_CAPS_PARAM,/**/ ULTRA_ABLE /**/)
 
/**********************************************************************************************************************************************************************************************************************************************************/
/* Meca */
	M_DEFINE_CONDITION(eCond_IsGiBlock								,"MEC_GiBloque"						,"MEC_GiBlock"                     ,"Cond_GiBlock"						,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	M_DEFINE_CONDITION(eCond_IsMechanicBlock						,"MEC_MecaniqueBloque"				,"MEC_MechanicBlock"               ,"Cond_MechanicBlock"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicAnimation					,"MEC_OptionAnimation"				,"MEC_IsMechanicAnimatino"         ,"Cond_IsMechanicAnimatino"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicCollide					,"MEC_OptionCollision"				,"MEC_IsMechanicCollide"           ,"Cond_IsMechanicCollide"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicGravity					,"MEC_OptionGravite"				,"MEC_IsMechanicGravity"           ,"Cond_IsMechanicGravity"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicTilt						,"MEC_OptionTilt"					,"MEC_IsMechanicTilt"              ,"Cond_IsMechanicTilt"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicGi						,"MEC_OptionGi"						,"MEC_IsMechanicGi"                ,"Cond_IsMechanicGi"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicClimb						,"MEC_OptionVarappe"				,"MEC_IsMechanicClimb"             ,"Cond_IsMechanicClimb"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicOnGround					,"MEC_OptionPlaqueAuSol"			,"MEC_IsMechanicOnGround"          ,"Cond_IsMechanicOnGround"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicSpider					,"MEC_OptionAraignee"				,"MEC_IsMechanicSpider"            ,"Cond_IsMechanicSpider"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicShoot						,"MEC_OptionShoot"					,"MEC_IsMechanicShoot"             ,"Cond_IsMechanicShoot"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicSwim						,"MEC_OptionNage"					,"MEC_IsMechanicSwim"             ,"Cond_IsMechanicSwim"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicNeverFall					,"MEC_OptionNeTombePas"				,"MEC_IsMechanicNeverFall"         ,"Cond_IsMechanicNeverFall"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicCollisionControl			,"MEC_OptionControleCollision"		,"MEC_IsMechanicCollisionControl"  ,"Cond_IsMechanicCollisionControl"	,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicKeepSpeedZ				,"MEC_OptionConserveVitesseZ"		,"MEC_IsMechanicKeepSpeedZ"        ,"Cond_IsMechanicKeepSpeedZ"		,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicSpeedLimit				,"MEC_OptionLimiteVitesse"			,"MEC_IsMechanicSpeedLimit"        ,"Cond_IsMechanicSpeedLimit"		,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicInertia					,"MEC_OptionInertie"				,"MEC_IsMechanicInertia"           ,"Cond_IsMechanicInertia"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	M_DEFINE_CONDITION(eCond_IsMechanicStream					,"MEC_OptionFlux"					,"MEC_IsMechanicStream"            ,"Cond_IsMechanicStream"			,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicStickOnPlatform			,"MEC_OptionCollerAuxPlateformes"	,"MEC_IsMechanicStickOnPlatform"   ,"Cond_IsMechanicStickOnPlatform"	,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicPatformCrash				,"MEC_EcraseParPlateforme"			,"MEC_MechanicPatformCrash"        ,"Cond_MechanicPatformCrash"		,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicScale			    		,"MEC_OptionScale"					,"MEC_IsMechanicScale"             ,"Cond_IsMechanicScale"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	NU_M_DEFINE_CONDITION(eCond_IsMechanicExec						,"MEC_Execution"					,"MEC_IsMechanicExec"              ,"Cond_IsMechanicExec"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
	M_DEFINE_CONDITION(eCond_CanFall								,"MEC_PeutTomber"					,"MEC_CanFall"                     ,"Cond_CanFall"						,fn_p_stMechanicOption, USE_ADDR_VECTOR_PARAM , ULTRA_ABLE )
	M_DEFINE_CONDITION(eCond_IsMechanicCrash						,"MEC_ActeurPrincipalEcrase"		,"MEC_IsMainActorCrashed"          ,"Cond_MainActorCrashed"				,fn_p_stMechanicOption, USE_NO_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_CONDITION(eCond_IsNullVector							,"VEC_VecteurNul"					,"VEC_NullVector"               ,"Cond_NullVector"					,fn_p_stNullVector, USE_VECTOR_PARAM, NOT_ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
 /* Hierarchy - Platform */
	M_DEFINE_CONDITION(eCond_HierIsSonOfActor						,"HIER_EstFils_acteur"				,"HIER_HierIsSonOfActor"        ,"Cond_HierIsSonOfActor"			,fn_p_stHierarchySon, USE_PERSO_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	NU_M_DEFINE_CONDITION(eCond_IsMorphing							,"MOD_MorphingEnCours"				,"MOD_IsMorphing"              ,"Cond_IsMorphing"					,fn_p_stIsMorphing, USE_CHANNEL_PARAM, ULTRA_ABLE )
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_CONDITION(eCond_CheckAnimEnd							,"ANI_TestFinAnim"					,"ANI_CheckAnimEnd"            ,"Cond_CheckAnimEnd"				,fn_p_stCheckAnimEnd,USE_NO_PARAM,ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_CONDITION(eCond_HasTheCapability						,"Caps_ALaCapacite"					,"CAPS_HasTheCapability"            ,"Cond_HasTheCapability"			,fn_p_stCheckCapabilities, USE_CAPS_PARAM USE_CAPS_PARAM,     ULTRA_ABLE)
	NU_M_DEFINE_CONDITION(eCond_HasOneOfTheCapabilities				,"Caps_AUneDesCapacites"			,"CAPS_HasOneOfTheCapabilities"     ,"Cond_HasOneOfTheCapabilities"		,fn_p_stCheckCapabilities, USE_CAPS_PARAM USE_CAPS_PARAM,     ULTRA_ABLE)
	M_DEFINE_CONDITION(eCond_HasTheCapabilityNumber					,"Caps_ALaCapaciteNumero"			,"CAPS_HasTheCapabilityNumber"      ,"Cond_HasTheCapabilityNumber"		,fn_p_stCheckCapabilities, USE_CAPS_PARAM USE_CONSTANT_PARAM, ULTRA_ABLE)
	NU_M_DEFINE_CONDITION(eCond_PersoHasTheCapability				,"Caps_PersoALaCapacite"			,"CAPS_PersoHasTheCapability"       ,"Cond_PersoHasTheCapability"		,fn_p_stCheckCapabilities, USE_CAPS_PARAM,                    ULTRA_ABLE)
	NU_M_DEFINE_CONDITION(eCond_PersoHasOneOfTheCapabilities		,"Caps_PersoAUneDesCapacites"		,"CAPS_PersoHasOneOfTheCapabilities","Cond_PersoHasOneOfTheCapabilities",fn_p_stCheckCapabilities, USE_CAPS_PARAM,                    ULTRA_ABLE)
	NU_M_DEFINE_CONDITION(eCond_PersoHasTheCapabilityNumber			,"Caps_PersoALaCapaciteNumero"		,"CAPS_PersoHasTheCapabilityNumber" ,"Cond_PersoHasTheCapabilityNumber"	,fn_p_stCheckCapabilities, USE_CONSTANT_PARAM,                ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
/*XB980824*/
#ifndef D_THROW_MGT
	NU_M_DEFINE_CONDITION(eCond_MagnetIsActivated					,"Magnet_EstActif"					,"MAGNET_IsMagnetActivated"       ,"Cond_IsMagnetActivated"			,fn_p_stMagnetActivated,   USE_NO_PARAM,                    ULTRA_ABLE)
#else
	NU_M_DEFINE_CONDITION(eCond_MagnetIsActivated					,"Magnet_EstActif"					,"MAGNET_IsMagnetActivated"       ,"Cond_IsMagnetActivated"			,fn_p_stDummyCondition,				USE_NO_PARAM,                    ULTRA_ABLE)
#endif
/*End XB*/
/**********************************************************************************************************************************************************************************************************************************************************/
/* Collision Flags */
    NU_M_DEFINE_CONDITION(eCond_NEstPasEnCollisionAvecMap                  ,"ACT_NEstPasEnCollisionAvecMap"                 ,"ACT_IsNotInCollWithMap"          ,"Cond_IsNotInCollWithMap"          ,fn_p_stIsCollisionFlag,  USE_NO_PARAM,  ULTRA_ABLE)
    NU_M_DEFINE_CONDITION(eCond_NEstPasEnCollisionAvecProjectile           ,"ACT_NEstPasEnCollisionAvecProjectiles"         ,"ACT_IsNotInCollWithProj"         ,"Cond_IsNotInCollWithProj"         ,fn_p_stIsCollisionFlag,  USE_NO_PARAM,  ULTRA_ABLE)
    NU_M_DEFINE_CONDITION(eCond_NEstPasEnCollisionAvecSecondCharact        ,"ACT_NEstPasEnCollisionAvecActeursSecondaires"  ,"ACT_IsNotInColWithSecondCharact" ,"Cond_IsNotInColWithSecondCharact" ,fn_p_stIsCollisionFlag,  USE_NO_PARAM,  ULTRA_ABLE)
    NU_M_DEFINE_CONDITION(eCond_NEstPasEnCollisionAvecMainCharact          ,"ACT_NEstPasEnCollisionAvecActeurPrincipal"     ,"ACT_IsNotInColWithMainCharact"   ,"Cond_IsNotInColWithMainCharact"   ,fn_p_stIsCollisionFlag,  USE_NO_PARAM,  ULTRA_ABLE)
    NU_M_DEFINE_CONDITION(eCond_NEstPasEnCollisionAvecAutresSecteurs       ,"ACT_NEstPasEnCollisionAvecAutresSecteurs"      ,"ACT_IsNotInColWithOtherSectors"  ,"Cond_IsNotInColWithOtherSectors"  ,fn_p_stIsCollisionFlag,  USE_NO_PARAM,  ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_CONDITION(eCond_IsInFamily							      ,"ACT_EstDeFamille"								 ,"ACT_IsOfFamily"     ,"Cond_IsOfFamily"					 ,fn_p_stIsOf,			  USE_FAMILY_PARAM,  ULTRA_ABLE)
    M_DEFINE_CONDITION(eCond_IsInModel							      ,"ACT_EstDeModele"								 ,"ACT_IsOfModel"      ,"Cond_IsOfModel"					 ,fn_p_stIsOf,			  USE_MODEL_PARAM,  ULTRA_ABLE)
/**********************************************************************************************************************************************************************************************************************************************************/
    NU_M_DEFINE_CONDITION(eCond_AJoypadIsConnected					      ,"IPT_AJoypadIsConnected"							 ,"IPT_AJoypadIsConnected"         ,"Cond_AJoypadIsConnected"			 ,fn_p_stAJoypadIsConnected,			  USE_NO_PARAM,  ULTRA_ABLE)
    M_DEFINE_CONDITION(eCond_AKeyJustPressed					      ,"IPT_AKeyJustPressed"							 ,"IPT_AKeyJustPressed"            ,"Cond_AKeyJustPressed"			 ,fn_p_stAKeyJustPressed,				  USE_NO_PARAM,  NOT_ULTRA_ABLE)
    M_DEFINE_CONDITION(eCond_AButtonPadJustPressed				      ,"IPT_AButtonPadJustPressed"						 ,"IPT_AButtonPadJustPressed"      ,"Cond_AButtonPadJustPressed"		 ,fn_p_stAButtonPadJustPressed,			  USE_NO_PARAM,  NOT_ULTRA_ABLE)
 
/**********************************************************************************************************************************************************************************************************************************************************/
/* demos */
/*HP 101298*/
	M_DEFINE_CONDITION(eCond_IsInDemoMode						, "EstDansDemoMode"				,"IsInDemoMode"					,"Cond_IsInDemoMode"		, fn_p_stDemoCondition, USE_NO_PARAM,  /**/ ULTRA_ABLE /**/)				
 
 
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_CONDITION(eCond_IsInStereoMode							,"SOUND_IsInStereoMode"			,"SOUND_IsInStereoMode"			,"Cond_IsInStereoMode"		,fn_p_stIsInStereoMode,			  USE_NO_PARAM,  NOT_ULTRA_ABLE)
    M_DEFINE_CONDITION(eCond_IsMusicPlaying							,"SOUND_IsMusicPlaying"			,"SOUND_IsMusicPlaying"			,"Cond_IsMusicPlaying"		,fn_p_stIsMusicPlaying,			  USE_NO_PARAM,  NOT_ULTRA_ABLE)

/**********************************************************************************************************************************************************************************************************************************************************/
#ifdef U64
   M_DEFINE_CONDITION(eCond_IsShapnessMax							,"VID_IsShapnessMax"			,"VID_IsShapnessMax"			,"Cond_IsShapnessMax"		,fn_p_stIsIsShapnessMax,			  USE_NO_PARAM,  NOT_ULTRA_ABLE)
#else
   M_DEFINE_CONDITION(eCond_IsShapnessMax							,"VID_IsShapnessMax"			,"VID_IsShapnessMax"			,"Cond_IsShapnessMax"		,fn_p_stDummyCondition,				  USE_NO_PARAM,  NOT_ULTRA_ABLE)
#endif

   M_DEFINE_CONDITION(eCond_IsSlotDataCorrupt,	"SLOT_IsDataCorrupt", "SLOT_IsDataCorrupt", "COND_IsDataCorrupt", fn_p_stIsSlotDataCorrupt, USE_NO_PARAM, NOT_ULTRA_ABLE)
   M_DEFINE_CONDITION(eCond_IsCheatMenu, "CHEAT_IsCheatMenu", "CHEAT_IsCheatMenu", "COND_IsCheatMenu", fn_p_stIsCheatMenu, USE_NO_PARAM, NOT_ULTRA_ABLE)
   M_DEFINE_CONDITION(eCond_IsUSBuild, "COND_IsUSBuild", "COND_IsUSBuild", "COND_IsUSBuild", fn_p_stIsUSBuild, USE_NO_PARAM, NOT_ULTRA_ABLE)
