/*-------------------------------------------------------------------------------------
DefFild.h : Field definitions
Author : Olivier Couvreur 25/08/97
--------------------------------------------------------------------------------------*/
 
#if !defined(M_DEFINE_FIELD)
#error You should define M_DEFINE_FIELD accordingly before including this file !
#endif
 
#include "..\AIBase\Specif\AIOption.h"
 
/* 6 parameters to define a fiels : enum , editor name, script name, type, function pointers Get, function pointers Set */
 
/**********************************************************************************************************************************************************************************************************************************************************/
/* Affect the Perso */
    M_DEFINE_FIELD(eField_Position           ,"Position"            ,"Position"         ,"Position"         , eFieldType_Vector , fn_ucGetFieldPosition, fn_ucSetFieldDefaultFunction)
 
    M_DEFINE_FIELD(eField_Orientation        ,"Orientation"         ,"Orientation"      ,"Orientation"       , eFieldType_Vector , fn_ucGetFieldOrientation, fn_ucSetFieldOrientation)
    M_DEFINE_FIELD(eField_Speed              ,"Speed"               ,"Speed"            ,"Speed"             , eFieldType_Vector , fn_ucGetFieldSpeed, fn_ucSetFieldDefaultFunction)
    M_DEFINE_FIELD(eField_NormSpeed          ,"NormSpeed"           ,"NormSpeed"        ,"NormSpeed"        , eFieldType_Float  , fn_ucGetFieldNormSpeed, fn_ucSetFieldDefaultFunction)
/**********************************************************************************************************************************************************************************************************************************************************/
/*	M_DEFINE_FIELD(eField_SightAxis          ,"AxeDeVue"            ,"SightAxis"         , eFieldType_Vector , fn_ucGetFieldSightAxis, fn_ucSetFieldSightAxis)*/
/*    M_DEFINE_FIELD(eField_FirstCompAxis      ,"AxeComplementaire1"  ,"FirstCompAxis"     , eFieldType_Vector , fn_ucGetFieldFirstCompAxis, fn_ucSetFieldFirstCompAxis)*/
/*    M_DEFINE_FIELD(eField_SecondCompAxis     ,"AxeComplementaire2"  ,"SecondCompAxis"    , eFieldType_Vector , fn_ucGetFieldSecondCompAxis, fn_ucSetFieldSecondCompAxis)*/
 
	M_DEFINE_FIELD(eField_AbsoluteAxisX      ,"AxeXEnAbsolu"        ,"AbsoluteAxisX"    ,"AbsoluteAxisX"     , eFieldType_Vector , fn_ucGetFieldAbsoluteAxisX, fn_ucSetFieldDefaultFunction)
    M_DEFINE_FIELD(eField_AbsoluteAxisY      ,"AxeYEnAbsolu"        ,"AbsoluteAxisY"    ,"AbsoluteAxisY"     , eFieldType_Vector , fn_ucGetFieldAbsoluteAxisY, fn_ucSetFieldDefaultFunction)
    M_DEFINE_FIELD(eField_AbsoluteAxisZ      ,"AxeZEnAbsolu"        ,"AbsoluteAxisZ"    ,"AbsoluteAxisZ"     , eFieldType_Vector , fn_ucGetFieldAbsoluteAxisZ, fn_ucSetFieldDefaultFunction)
/**********************************************************************************************************************************************************************************************************************************************************/
    M_DEFINE_FIELD(eField_PrevComportIntell  ,"ComportIntelPrec"    ,"PrevComportIntell","PrevComportIntell" , eFieldType_Comport, fn_ucGetFieldPrevComportIntell, fn_ucSetFieldDefaultFunction)
    M_DEFINE_FIELD(eField_PrevComportReflex  ,"ComportReflexePrec"  ,"PrevComportReflex","PrevComportReflex" , eFieldType_Comport, fn_ucGetFieldPrevComportReflex, fn_ucSetFieldDefaultFunction)
/**********************************************************************************************************************************************************************************************************************************************************/
/* ANNECY AV {*/
/*    M_DEFINE_FIELD(eField_CollisionFlag      ,"CollisionFlag"      ,"CollisionFlag"     , eFieldType_0To255  , fn_ucGetFieldCollisionFlag, fn_ucSetFieldCollisionFlag)*/
/* END ANNECY AV }*/
/**********************************************************************************************************************************************************************************************************************************************************/
	M_DEFINE_FIELD(eField_ShadowScaleX       ,"ShadowScaleX"        ,"ShadowScaleX"     ,"ShadowScaleX"     , eFieldType_Float  , fn_ucGetFieldShadowScaleX, fn_ucSetFieldShadowScaleX)
	M_DEFINE_FIELD(eField_ShadowScaleY       ,"ShadowScaleY"        ,"ShadowScaleY"     ,"ShadowScaleY"     , eFieldType_Float  , fn_ucGetFieldShadowScaleY, fn_ucSetFieldShadowScaleY)
 
#if defined(M_DEFINE_FIELD)
#undef M_DEFINE_FIELD
#endif
