/*-------------------------------------------------------------------------------------
DefSAI.h : Variables save type definitions (use SAI flags (cf Francois Mahieu))
Author : Olivier Couvreur 25/09/97
--------------------------------------------------------------------------------------*/
 
#if !defined(M_DEFINE_DSGVAR_SAVE_TYPE)
#error You should define M_DEFINE_DSGVAR_SAVE_TYPE accordingly before including this file !
#endif
 
#define DEFAULT_DSGVAR_SAVE_TYPE_ENTRY 0
 
	M_DEFINE_DSGVAR_SAVE_TYPE("Aucune","None",(SAI_tdeFlags) 0)
	M_DEFINE_DSGVAR_SAVE_TYPE("Joueur","Player",SAI_ePlayerSaveCurrentValue)
	M_DEFINE_DSGVAR_SAVE_TYPE("Niveau","Level",SAI_eLevelSaveCurrentValue)
	/*M_DEFINE_DSGVAR_SAVE_TYPE("JoueurEtNiveau","PlayerAndLevel",(SAI_tdeFlags) (SAI_ePlayerSaveCurrentValue|SAI_eLevelSaveCurrentValue) )*/
 
#if defined(M_DEFINE_DSGVAR_SAVE_TYPE)
#undef M_DEFINE_DSGVAR_SAVE_TYPE
#endif
