/*-------------------------------------------------------------------------------------
FildType.h : Field type definition
Author : Olivier Couvreur 28/10/97
--------------------------------------------------------------------------------------*/
 
#if !defined(M_DEFINE_FIELD_TYPE)
#error You should define M_DEFINE_FIELD_TYPE accordingly before including this file !
#endif
 
/* Field Type Prototypes : type, internal type, post processing , preprocessing */
  M_DEFINE_FIELD_TYPE(eFieldType_Integer    ,E_vt_Integer		,fn_vGetFieldTypeInteger	,fn_vSetFieldTypeInteger)
  M_DEFINE_FIELD_TYPE(eFieldType_Float      ,E_vt_Float		    ,fn_vGetFieldTypeFloat		,fn_vSetFieldTypeFloat)
  M_DEFINE_FIELD_TYPE(eFieldType_Vector     ,E_vt_Vector		,fn_vGetFieldTypeVector		,fn_vSetFieldTypeVector)
  M_DEFINE_FIELD_TYPE(eFieldType_Comport    ,E_vt_Comport		,fn_vGetFieldTypeComport	,fn_vSetFieldTypeComport)
  M_DEFINE_FIELD_TYPE(eFieldType_0To255     ,E_vt_0To255		,fn_vGetFieldType0To255		,fn_vSetFieldType0To255)
 
#if defined(M_DEFINE_FIELD_TYPE)
#undef M_DEFINE_FIELD_TYPE
#endif
 
