/*-----------------------------------------------------------------------------------------*/
/* AI_Edit.h : This file must contains all necessary Intelligence Engine Header files */
/*             for Editor.*/
/* author : Olivier Couvreur*/
/* date   : 14/02/1997*/
/*-----------------------------------------------------------------------------------------*/
 
#if !defined(__AI_EDIT_H__)
#define __AI_EDIT_H__
 
#if defined(ACTIVE_EDITOR)
#include "Gam/ToolsCPA.h"
#include "Gam.h"
#include "AIBase/StrIntel.h"   /* All allocations functions*/
#endif /* ACTIVE_EDITOR*/
 
#include "AIBase/ReadRule.h"   /* for C_..... defines*/
 
#if defined(ACTIVE_EDITOR)
#include "AIBase/DsgMem.h"     /* tables of DsgVar types*/
#include "AIBase/Action.h"     /* bof*/
#include "AIBase/GetSet.h"     /* bof*/
#endif /* ACTIVE_EDITOR*/
 
#if defined(ACTIVE_EDITOR)
#include "AIGame/Convert.h"    /* type of parameters*/
#include "AIGame/EnumAct.h"    /* tables of action names*/
#include "AIGame/EnumCond.h"   /* tables of conditions names*/
#include "AIGame/EnumKey.h"    /* tables of keywords names*/
#include "AIGame/EnumFunc.h"   /* tables of functions names*/
#include "AIGame/EnumOper.h"   /* tables of operator*/
#include "AIGame/EnumProc.h"   /* tables of Procedure.*/
#include "AIGame/EnumFild.h"   /* tables of fields*/
#endif /* ACTIVE_EDITOR*/
 
#include "AIBase/WPWayPt.h"
 
#endif /* __AI_EDIT_H__*/
 
 
 
