/*---------------------------------------------------------------------------*/
/* AI.h : This file contains all necessary Intelligence Engine Header files.*/
/* author : Olivier Didelot.*/
/* date   : 24/01/1997*/
/*---------------------------------------------------------------------------*/
#ifndef __AI_PUB_H__
#define __AI_PUB_H__
 
#include "AIBase/Specif/AIOption.h"   /* for Xavier*/
 
#define AI_FRIEND
 
#ifdef AI_FRIEND
#include "AIBase/AI_Struc.h"	/* private structure & access macros*/
#include "AIBase/AI_Macro.h"	/* to change function calls into macros*/
#include "AIBase/AI_Handl.h"	/* handle definition*/
#include "AIBase/AI_Proto.h"	/* complex functions*/
#include "AIBase/CFast.h"
#else
#include "AIBase/AI_Handl.h"	/* handle definition*/
#include "AIBase/AI_Funct.h"	/* accessors*/
#include "AIBase/AI_Proto.h"	/* complex functions*/
#endif
 
#endif /* __AI_PUB_H__*/
