 
/*******************************************************************************/
/* To use the functions of this file, define USE_ZDM_BOX*/
/*******************************************************************************/
#ifdef USE_ZDM_BOX
 
 
#ifndef COL_CSBOXELT_H
#define COL_CSBOXELT_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#include "cpa_expt.h"
 
/* For Global declaration in C files : */
#ifdef COL_GLOBALS
 #define COL_EXTERN extern
#else /* !COL_GLOBALS */
 #define COL_EXTERN
#endif /* !COL_GLOBALS */
 
/*
-----------------------------------------------------------------------------
INCLUDES FILES
-----------------------------------------------------------------------------
*/
 
#include "Futil.h"
#include "Box.h"
#include "Inters.h"
#include "IntersGO.h"
#include "OctreeGO.h"
#include "CollGOCo.h"
#include "CsEltPts.h"
#include "CsEltEdg.h"
 
/*
-----------------------------------------------------------------------------
CONSTANT DECLARATION
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
TYPES DEFINITION
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
GLOBAL VARIABLE DECLARATION
-----------------------------------------------------------------------------
*/
 
/*
-----------------------------------------------------------------------------
FUNCTIONS DECLARATION
-----------------------------------------------------------------------------
*/
 
extern CPA_EXPORT void COL_fn_vCollideStaticAlignedBoxWithStaticIndexedTriangle ( COL_tdstGVForCollision *p_stGV, ACP_tdxBool bFaceMapInsteadOfIndexedTriangle);
extern CPA_EXPORT void COL_fn_vCollideStaticElementAlignedBoxesWithStaticElementIndexedTriangles ( COL_tdstGVForCollision *p_stGV );
 
/*extern CPA_EXPORT void COL_fn_vCollideStaticElementAlignedBoxesWithStaticElementFaceMapDescriptors ( COL_tdstGVForCollision *p_stGV );*/
 
extern CPA_EXPORT void COL_fn_vCollideStaticAlignedBoxWithStaticSphere ( COL_tdstGVForCollision *p_stGV );
 
extern CPA_EXPORT void COL_fn_vCollideStaticElementAlignedBoxesWithStaticElementSpheres ( COL_tdstGVForCollision *p_stGV );
 
extern CPA_EXPORT void COL_fn_vCollideStaticAlignedBoxWithStaticAlignedBox ( COL_tdstGVForCollision *p_stGV );
extern CPA_EXPORT void COL_fn_vCollideStaticElementAlignedBoxesWithStaticElementAlignedBoxes ( COL_tdstGVForCollision *p_stGV );
 
extern CPA_EXPORT void COL_fn_vCollideStaticElementAlignedBoxesWithStaticOctree ( COL_tdstGVForCollision *p_stGV );
extern CPA_EXPORT void COL_fn_vCollideStaticElementAlignedBoxesWithStaticElements ( COL_tdstGVForCollision *p_stGV );
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* COL_CSSPHELT_H */
 
#endif  /* USE_ZDM_BOX*/
