/* CTL_Editor_ComboBox window*/
/**/
/* YB*/
/*///////////////////////////////////////////////////////////////////////////*/
#ifndef _CTL_COMBO_BOX_
#define _CTL_COMBO_BOX_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
#include "ACP_Base.h"
#include "CTL\WControls\CTL_BWC.hpp"
#include "CTL\Others\CTL_ClBk.hpp"
 
/*############################################################################*/
typedef enum CTL_eComboBoxType
{
	CTL_COMBO_BOX_TYPE__STANDARD = 0,
 
	CTL_COMBO_BOX_TYPE_USE_USER_DEFINED_TYPE,
 
} CTL_tdeComboBoxType;
 
/*############################################################################*/
class CTL_Editor_Control;
 
/*ROMTEAM Selection (Cristian Stegaru 24/03/98)*/
typedef (*tpf_iCheckString) (CString csText); 
/*ENDROMTEAM Selection (Cristian Stegaru)*/
 
class CPA_EXPORT CTL_Editor_ComboBox :	public CComboBox,
																				public CTL_BaseWindowsControl
{
 
/* Construction*/
public:
	CTL_Editor_ComboBox(CTL_tdeComboBoxType _eType,
											long _lAdditionnalStyles,
											CTL_Editor_Control *_pclControl,
											CWnd *_pclParentWnd,
											long _lUserDefinedType = 0,
											long _lUserDefinedCode = 0);
 
/*ROMTEAM Selection (Cristian Stegaru 24/03/98)*/
private:
	int m_iOldSelection;
/*ENDROMTEAM Selection (Cristian Stegaru)*/
 
/* Attributes*/
public:
 
private:
	CTL_tdp_fn_vComboBoxSelChanged m_pri_p_td_fn_vSelChanged_CallBack;
	CTL_tdp_fn_vComboBoxSelChanged m_pri_p_td_fn_vDropDown_CallBack;
/*ROMTEAM Selection (Cristian Stegaru 24/03/98)*/
	CTL_tpf_iCheckString		   m_pfCanISelectThisItem;
/*ENDROMTEAM Selection (Cristian Stegaru)*/
	
	CTL_tdeComboBoxType m_pri_eType;
 
/* Operations*/
public:
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CTL_Editor_ComboBox)*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
public:
	virtual ~CTL_Editor_ComboBox();
 
	void m_pub_fn_vSetSelChanged_CallBack(CTL_tdp_fn_vComboBoxSelChanged _p_fn_vCallBack);
	void m_pub_fn_vSetDropDown_CallBack(CTL_tdp_fn_vComboBoxSelChanged _p_fn_vCallBack);
/*ROMTEAM Selection (Cristian Stegaru 24/03/98)*/
	void m_fn_vSetCanISelect_CallBack (CTL_tpf_iCheckString pfCheckString) 
	{
		m_pfCanISelectThisItem = pfCheckString;
	}
/*ENDROMTEAM Selection (Cristian Stegaru)*/
 
	/*For TUT registration*/
	virtual void m_pub_fn_vRegisterWindowsControl(CString _csAdditionnalInfo);
 
	/* Generated message map functions*/
protected:
	/*{{AFX_MSG(CTL_Editor_ComboBox)*/
	afx_msg void OnSelchange();
	afx_msg void OnDropdown();
	/*}}AFX_MSG*/
 
	DECLARE_MESSAGE_MAP()
};
 
 
#endif /*_CTL_COMBO_BOX_*/
