/* CTL_Editor_CheckBox window*/
/**/
/* YB*/
/*///////////////////////////////////////////////////////////////////////////*/
#ifndef _CTL_CHECK_BOX_
#define _CTL_CHECK_BOX_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
#include "ACP_Base.h"
#include "CTL\WControls\CTL_BWC.hpp"
#include "CTL\Others\CTL_ClBk.hpp"
 
/*###########################################################################*/
typedef enum CTL_eCarCheckBoxType
{
	CTL_CHECK_BOX_TYPE__NORMAL = 0,
 
	CTL_CHECK_BOX_TYPE__USE_USER_DEFINED_TYPE,
 
} CTL_tdeCarCheckBoxType;
 
/*###########################################################################*/
class CPA_EXPORT CTL_Editor_CheckBox :	public CButton,
																				public CTL_BaseWindowsControl
{
/* Construction*/
public:
	CTL_Editor_CheckBox(CTL_tdeCarCheckBoxType _tdeType,
											long _lAdditionnalStyles,
											CTL_Editor_Control *_pclControl, 
											CWnd *_pclParentWnd,
											long _lUserDefinedType = 0,
											long _lUserDefinedCode = 0,
											CString _csFalseText = "",
											CString _csTrueText = "");
 
 
/* Attributes*/
public:
 
private:
	CTL_tdp_fn_vCheckBoxHasBeenClicked m_pri_td_p_fn_vHasBeenClicked_CallBack;
 
	CTL_tdeCarCheckBoxType m_pri_tdeType;
	
	CString m_pri_csFalseText;
	CString m_pri_csTrueText;
 
/* Operations*/
public:
	void SetCheck(BOOL bCheck);
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CTL_Editor_CheckBox)*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
public:
	virtual ~CTL_Editor_CheckBox();
 
	void m_pub_fn_vSetHasBeenClicked_CallBack(CTL_tdp_fn_vCheckBoxHasBeenClicked _p_fn_vCallBack);
 
	/*For TUT registration*/
	virtual void m_pub_fn_vRegisterWindowsControl(CString _csAdditionnalInfo);
 
	/* Generated message map functions*/
protected:
	/*{{AFX_MSG(CTL_Editor_CheckBox)*/
	afx_msg void OnClicked();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	/*}}AFX_MSG*/
 
	DECLARE_MESSAGE_MAP()
};
 
/*///////////////////////////////////////////////////////////////////////////*/
#endif /*_CTL_CHECK_BOX_*/
 
