/*=========================================================================
* Caps.h : Capabilities.
* This is a part of the Game project.
*
* Version              1.0
* Creation date        29/01/98
* Author               Fred "Bart" Compagnon
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1998
*=======================================================================*/
#if !defined(__Caps_h__)
#define __Caps_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
extern CPA_EXPORT void fn_vSetCapabilities(struct tdstEngineObject_ *_p_stObject, unsigned long _ubf32Capabilities);
extern CPA_EXPORT unsigned long fn_ulGetCapabilities(struct tdstEngineObject_ *_p_stObject);
extern CPA_EXPORT void fn_vAddCapabilities(struct tdstEngineObject_ *_p_stObject, unsigned long _ubf32Capabilities);
extern CPA_EXPORT void fn_vSubCapabilities(struct tdstEngineObject_ *_p_stObject, unsigned long _ubf32Capabilities);
 
extern CPA_EXPORT void fn_vChangeCapabilities(struct tdstEngineObject_ *_p_stObject, unsigned long _ubf32Capabilities, long lValue);
 
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __Caps_h__ */
