/*=========================================================================
* Handles.h :       Define All Handles (used by Lists).
* This is a part of the Game project.
*
* Version              1.0
* Creation date        11/03/97 DAVID Sebastien (Gizmo)
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/
#if !defined(__GAMLst_H__)
#define __GAMLst_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
#include "GAM/GAMHandl.h"
#include "lst.h"
/*----------------------------------------------------------------------
 * Handles    Sebastien DAVID
 *--------------------------------------------------------------------*/
LST2_M_DynamicUseListOf(tdxHandleToFamilyList);
LST2_M_StaticUseListOf(tdxHandleToState);
LST2_M_StaticUseListOf(tdxHandleToTransition);
LST2_M_StaticUseListOf(tdxHandleToProhibit);
LST2_M_StaticUseListOf(tdxHandleToObjectsTablesList);
 
/* ANNECY AV DEMO {*/
#ifndef U64
    LST2_M_StaticUseListOf(DEMO_tdxHandleToDemoSOElement);
    typedef LST2_M_StaticAnchorDeclaration(DEMO_tdxHandleToDemoSOElement) *DEMO_tdxHandleToDemoSOList;
    LST2_M_StaticUseListOf(DEMO_tdxHandleToDemoGMTElement);
    typedef LST2_M_StaticAnchorDeclaration(DEMO_tdxHandleToDemoGMTElement) *DEMO_tdxHandleToDemoGMTList;
#endif
/* END ANNECY AV }*/
 
/*----------------------------------------------------------------------
 * Handles    Olivier JOURDAN
 *--------------------------------------------------------------------*/
LST2_M_DynamicUseListOf(tdxHandleToNodeCamera);
LST2_M_DynamicUseListOf(MC_tdxHandleToMainCharacterNode);
 
 
/*----------------------------------------------------------------------
 * Handles    Francois Mahieu
 *--------------------------------------------------------------------*/
LST2_M_DynamicUseListOf(ALW_tdxHandleToModelList);
 
/*----------------------------------------------------------------------
 * Handles    Michael Ryssen
 *--------------------------------------------------------------------*/
 
/* fbolefeysot - 25/06/98{*/
/*LST2_M_DynamicUseListOf(CHN_tdxHandleToCSOElement);*/
/*END fbolefeysot}*/
LST2_M_DynamicUseListOf(CHN_tdxHandleToCASElement);
/*ANNECY AV {*/
LST2_M_DynamicUseListOf(CHN_tdxHandleToMorphElement);
/*ENDANNECY AV }*/
 
/* fbolefeysot - 25/06/98{*/
typedef struct tdstAChannel_ *CHN_tdxHandleToChannelArray;
/*typedef LST2_M_DynamicAnchorDeclaration(CHN_tdxHandleToCSOElement) *CHN_tdxHandleToCSOList;*/
/*END fbolefeysot}*/
 
typedef LST2_M_DynamicAnchorDeclaration(CHN_tdxHandleToCASElement) *CHN_tdxHandleToCASList;
/*ANNECY AV {*/
typedef LST2_M_DynamicAnchorDeclaration(CHN_tdxHandleToMorphElement) *CHN_tdxHandleToMorphList;
/*ENDANNECY AV }*/
 
/*----------------------------------------------------------------------
 * Handles    Frederic Bourbon
 *--------------------------------------------------------------------*/
LST2_M_DynamicUseListOf(tdxHandleToAlwaysActiveCharacterNode);
 
 
#endif /* __GAMLst_H__ */
