/*=========================================================================
* HitPts.h : Hit points.
* This is a part of the Game project.
*
* Version              1.0
* Creation date        15/05/97
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/
#if !defined(__HitPts_h__)
#define __HitPts_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
extern CPA_EXPORT unsigned char fn_ucGetHitPoints(struct tdstEngineObject_ *_p_stObject);
extern CPA_EXPORT void fn_vSetHitPoints(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
extern CPA_EXPORT void fn_vSetHitPointsInit(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
extern CPA_EXPORT void fn_vSetHitPointsToMaxValue(struct tdstEngineObject_ *_p_stObject);
extern CPA_EXPORT void fn_vAddHitPoints(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
extern CPA_EXPORT unsigned char fn_ucSubHitPoints(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
 
extern CPA_EXPORT unsigned char fn_ucGetHitPointsMax(struct tdstEngineObject_ *_p_stObject);
extern CPA_EXPORT void fn_vSetHitPointsMax(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
extern CPA_EXPORT void fn_vSetHitPointsMaxToMaxValue(struct tdstEngineObject_ *_p_stObject);
extern CPA_EXPORT void fn_vAddHitPointsMax(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
extern CPA_EXPORT unsigned char fn_ucSubHitPointsMax(struct tdstEngineObject_ *_p_stObject,unsigned char _ucValue);
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __HitPts_h__ */
