/*=========================================================================
* InitEng.h : Engine initialzed functions.
* This is a part of the Game project.
*
* Version                      1.0
* Creation date        20/08/96
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
#if !defined(__INITENG_H__)
#define __INITENG_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
/*HP 230698*/
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
EXTERN long *gp_lBeginMapSoundEventID;
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
EXTERN SND_tduRefEvt g_stBeginMapSoundEvent;
 
//XB 01/06/99
//EXTERN ACP_tdxBool g_bBeginMapSoundEventFlag;
extern ACP_tdxBool g_bBeginMapSoundEventFlag;
//End XB 01/06/99
 
 
void fn_vInitEngineWhenInitApplication(void);
void fn_vDesinitEngineWhenLeaveApplication(void);
 
void fn_vFirstInitEngine(void);
void fn_vLastDesinitEngine(void);
 
void fn_vInitGameLoop(void);
void fn_vDesInitGameLoop(void);
void fn_vInitLevelLoop(void);
void fn_vDesInitLevelLoop(void);
void fn_vInitDeadLoop(void);
void fn_vDesInitDeadLoop(void);
 
void fn_vInitAllLinkTables(void);
 
void fn_vReinitTheMap(void);
void fn_vReinitTheStaticHierarchie(HIE_tdxHandleToSuperObject hSuperObject);
 
void fn_vVerifySomeProgramVariables(void);
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* !__INITENG_H__ */
