/*=========================================================================
* Input.h : Contain the pad structure.
* This is a part of the Game project.
*
* Version              1.0
* Creation date        22/08/96
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
#if !defined(__INPUT_H__)
#define __INPUT_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#define C_Section_IPTLink                "IptLink"
#define C_Entry_IPTLink                  "AddRef"
 
 
void fn_vInit3DOSSpecialKey();
 
#if !defined(U64)
SCR_tde_Anl_ReturnValue fn_eScriptCallBackIPTLink(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
#endif /* U64 */
 
void fn_vAnalyse3DOSSpecialInputActions();
 
void fn_vEngineReadInput(void);
void fn_vCommandsMode(void);
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
    extern unsigned char g_ucDisplayCenters;
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __INPUT_H__ */
