/* ***********************************************************************************/
/* * "a3x_pref.h"																	**/
/* * Written by :	Sbastien Rubens												**/
/* * Tabulations :	4 char															**/
/* ***********************************************************************************/
#ifndef A3X_PREF_H
#define A3X_PREF_H
 
/* ***********************************************************************************/
/*																		Main Defines*/
 
#define	PC
#define	NoInvalid
 
#define DIR_EXE					"x:\\cpa\\exe\\main\\"
#define DIR_FAMILIES			"gamedata\\World\\Levels\\_common\\Families"
#define DIR_ANIMS				"World\\graphics\\anims"
#define DIR_DATA				"GameData"
 
#define REL_DIR_FAMILY			"World\\Levels\\_common\\Families"
 
/*#define	A3xDebug					// A3x debug version ?*/
/*#define	A3X_CUT							// Cutted animations*/
/*#define	MaxRAMSizeOfAnim	10240		// 10 Ko*/
 
/*#define	A3X_AcpLight				// If you want a light version of ACP structures*/
 
#define	A3X_PC						/* If you are on PC computer (nothing else)*/
 
#ifndef	A3X_PC						/* do not use with PC*/
#define	A3X_N64						/* We are on N64 ?*/
#endif
 
#ifdef A3X_BINARISATION
#define	SEB_xReal	double			/* For binarisation*/
#else
#define	SEB_xReal	float			/* For realtime*/
#endif
/*#define	A3X_CacheIsUsed				// If you use cache*/
 
#ifndef	A3X_CacheIsUsed				/* do not use with cache !*/
 
/*ANNECY TQ 22/07/98{*/
/* We no longer use the static tables*/
/*#define	A3X_StaticTables			// If you use static tables (or alloc tables)*/
/*ENDANNECY TQ}*/
 
#endif
 
 
 
/* ***********************************************************************************/
#endif
