/*=========================================================================
* 3DOSLkTb.h : Link tables structures
*
*
*
*
* Version              1.0
* Creation date        25/03/97
*	Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined(__3DOSLkTb_H__)
#define __3DOSLkTb_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
typedef struct tdst3DOSLinkTable_
{
 /**** Those link-tables are for the editors and for the engine ****/
#if !defined(U64)
 SCR_tdst_Link_Table stCharacter;
 SCR_tdst_Link_Table stState;
 SCR_tdst_Link_Table stAnimation;
#endif /* U64 */
 
 /**** Familly, Model and Personnal engine object's types (used in abjtype.c) ****/
 /*
 unsigned long ulNumberOfFamily;
 SCR_tdst_Link_Table stFamilyType;
 unsigned long ulNumberOfModel;
 SCR_tdst_Link_Table stModelType;
 unsigned long ulNumberOfPersonal;
 SCR_tdst_Link_Table stPersonnalType; 
 */
 
 /**** Those link-tables are only used by the editors ****/
#if !defined(U64)
 SCR_tdst_Link_Table stACZ;
#else /* U64 */
	char	cNotEmpty;
#endif /* U64 */
 
#if !defined(U64)
 #if defined(ACTIVE_EDITOR)||defined(BIN_SaveBin)
 SCR_tdst_Link_Table stCharacterZone;
 SCR_tdst_Link_Table stLipsSynchroList;
 /* JO 06/11/97*/
 SCR_tdst_Link_Table stPrtGenLinkTable;
 SCR_tdst_Link_Table stPrtSrcLinkTable;
 SCR_tdst_Link_Table stPrtSysLinkTable;
 SCR_tdst_Link_Table stPrtSysSpriteLinkTable;
 SCR_tdst_Link_Table stPrtEnvLinkTable;
 SCR_tdst_Link_Table stZDXList;
 SCR_tdst_Link_Table stACZList;
 #endif /* ACTIVE_EDITOR || BIN_SaveBin */
#endif /* U64 */
} tdst3DOSLinkTable;
 
 
#ifndef _FIRE_DEADCODE_U64_
EXTERN CPA_EXPORT tdst3DOSLinkTable g_st3DOSLinkTable;
#endif /* _FIRE_DEADCODE_U64_ */
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __3DOSLkTb_H__ */
