#if !defined(__INPUT_S_H__)
#define __INPUT_S_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
/****************************************************************************
 *** WARNING :                                                            ***
 ***                                                                      ***
 ***    If you modifie this structure, thing to modifie the file link.ipt ***
 ***                                                                      ***
 ****************************************************************************/
struct tdst_EntryActions_
{
 #if !defined (U64)
 IPT_tdxHandleToEntryElement hScreenSnapShot;
/* ANNECY AV {*/
/* IPT_tdxHandleToEntryElement hDisplayBench;*/
/* END ANNECY AV }*/
 #endif /*!defined (U64)*/

#if !defined(PRESS_DEMO)
 
/* ANNECY AV {*/
/* IPT_tdxHandleToEntryElement hPause;*/
/* END ANNECY AV }*/
 
 /**** Toggle wired/solid rendering ****/
 IPT_tdxHandleToEntryElement hDisplayModeToggle;
 
/* ANNECY AV {*/
/*
 IPT_tdxHandleToEntryElement hDisplayFixMode;
 IPT_tdxHandleToEntryElement hIncScreenSize;
 IPT_tdxHandleToEntryElement hDecScreenSize;
 IPT_tdxHandleToEntryElement hStopTheVideo;
*/
/* END ANNECY AV }*/
 
  /**** Debug handle ****/
 IPT_tdxHandleToEntryElement hDisplayRaster;
 IPT_tdxHandleToEntryElement hDisplayRasterMode;
 IPT_tdxHandleToEntryElement hDisplayRasterPCU64;

#endif /* PRESS_DEMO */


 IPT_tdxHandleToEntryElement hReinitTheMap;
 
#if !defined(PRESS_DEMO)

#ifdef U64
 IPT_tdxHandleToEntryElement hRecordDemo;
 IPT_tdxHandleToEntryElement hPlayDemo;
 
#endif
 IPT_tdxHandleToEntryElement hDisplayOnlyStatic;
 IPT_tdxHandleToEntryElement hDisplayLight;
 IPT_tdxHandleToEntryElement hDisplayZDC;
 IPT_tdxHandleToEntryElement hDisplaySectorInfos;
 IPT_tdxHandleToEntryElement hDisplayWaypoints;
 IPT_tdxHandleToEntryElement hDisplayBoundingVolumes;
#ifndef U64
 IPT_tdxHandleToEntryElement hDisplayRayTraceSegments;
#endif /*U64*/
/*ENDANNECY TQ}*/
 
 /*ANNECY CG KEY 4 ACTIVATED GENDOORS 18/06/98{*/
IPT_tdxHandleToEntryElement hDisplayActivatedGendoors;
/*ENDANNECY CG}*/
 
 /*ANNECY CG 20/10/98{*/
/* Oliv' - Portage v14*/
#ifndef U64
IPT_tdxHandleToEntryElement hClearOptionsDisplayed;
#endif /* U64 */
/* EndOfOliv'*/
/*ENDANNECY CG}*/
 
#endif /* PRESS_DEMO */
 
/*ANNECY VL 24/05/98{*/
 /**** changing map menu*/
 IPT_tdxHandleToEntryElement hChooseLevel;
 IPT_tdxHandleToEntryElement hChooseLevelUp;
 IPT_tdxHandleToEntryElement hChooseLevelDown;
 IPT_tdxHandleToEntryElement hChooseLevelValidate;
 IPT_tdxHandleToEntryElement hChooseLevelInvalidate;
/*ENDANNECY VL}*/
 
#if !defined(PRESS_DEMO)
	 
 /**** Flying mode cheat code ****/
 IPT_tdxHandleToEntryElement hFlyingMode;
 IPT_tdxHandleToEntryElement hFlyingModeForward;
 IPT_tdxHandleToEntryElement hFlyingModeBackward;
 IPT_tdxHandleToEntryElement hFlyingModeUp;
 IPT_tdxHandleToEntryElement hFlyingModeDown;
 IPT_tdxHandleToEntryElement hFlyingModeLeft;
 IPT_tdxHandleToEntryElement hFlyingModeRight;
 IPT_tdxHandleToEntryElement hFlyingModeStrafeLeft;
 IPT_tdxHandleToEntryElement hFlyingModeStrafeRight;
/* ANNECY AV {*/
/* IPT_tdxHandleToEntryElement hFlyingModeSpeedIncrease;*/
/* IPT_tdxHandleToEntryElement hFlyingModeSpeedDecrease;*/
/* END ANNECY AV }*/
 IPT_tdxHandleToEntryElement hFlyingModeDoubleSpeed;
 
#ifndef U64	/* Oliv' - don't need that */
 /* add to stop the game pause (for DC)*/
 IPT_tdxHandleToEntryElement hEndPause;
 /* add to do a soft reset using the pad (for DC)*/
 IPT_tdxHandleToEntryElement hSoftReset;
#endif /* U64 */
 
 /* *** Log For Anim Memory Stack ****/
#ifdef WIN32
 IPT_tdxHandleToEntryElement hMemoryStackLog;
#endif /* WIN32*/
 
/* Oliv' - Portage v15 : Please, I removed warnings in the following comment. Keep this like it :-)*/
/* ANNECY AV {*/
/*
 // *** Memory cheat code ***
 IPT_tdxHandleToEntryElement hTestMemory;
 
 // *** Borders gothrough ***
 IPT_tdxHandleToEntryElement hBorderActive;
 
 IPT_tdxHandleToEntryElement hConstantAnimSpeed;
*/
/* END ANNECY AV }*/
#ifdef WIN32
 IPT_tdxHandleToEntryElement hDisplayTextOverScanLimit ;
 IPT_tdxHandleToEntryElement hAltDisplayTextOverScanLimit ;
 
 IPT_tdxHandleToEntryElement hGliMenu_Activate ;
 IPT_tdxHandleToEntryElement hGliMenu_Next ;
 IPT_tdxHandleToEntryElement hGliMenu_Prev ;
 IPT_tdxHandleToEntryElement hGliMenu_Select ;
 IPT_tdxHandleToEntryElement hGliMenu_Zoom ;
 IPT_tdxHandleToEntryElement hGliMenu_Goto ;

 IPT_tdxHandleToEntryElement hStartStopStep ;
 IPT_tdxHandleToEntryElement hPulseStep ;
#endif /* WIN32 */

#endif /* PRESS_DEMO */
 
};
 
EXTERN struct tdst_EntryActions_ g_st_3DOS_EntryActions;
 
//XB 01/06/99
//EXTERN unsigned char g_ucSCTDisplaySectors;
extern unsigned char g_ucSCTDisplaySectors;
//End XB 01/06/99

#ifndef RETAIL
 
EXTERN char g_cChooseLevel;

#endif /* !RETAIL */
 
#endif /* __INPUT_S_H__ */
