 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_GLD
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_GLD
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef _GLD_H_
#define _GLD_H_
 
#include "GLD/ErrGLD.h"
#include "GLD/MmgGLD.h"
 
#include "GLD/GLD_Pub.h"
#include "GLD/PixFmt.h"
 
#endif
 
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
