 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_GLI
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_GLI
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef GLIH
#define GLIH
 
/*#define RELEASE(x) if (x != NULL) {x->Release(); x = NULL;}*/
 
#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif
 
#include "MTH.h"
 
/*#include <windows.h>
#include <windowsx.h>
//#include <ddraw.h>
#include <malloc.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <math.h>
 
*/
#define ACTIVE_EDITOR_MOTEUR
 
#ifdef __cplusplus
extern "C"
{
#endif
 
#include "GLI/GLI_defn.h"
#include "GLI/util.h"
 
#include "GLI/vertex.h"
#include "POS.h"
#include "GLI/polygon.h"
 
 
#include "GLI/material.h"
#include "GLI/send.h"
#include "GLI/object.h"
/*HP #if !defined(U64)*/
#include "GLI/load.h"
/* HP #endif /* U64   */
#include "GLI/LgtLoad.h"
 
#include "GLI/camera.h"
#include "GLI/texture.h"
#include "GLI/light.h"
#include "GLI/vpt3D.h"
#include "GLI/init_gli.h"
 
#include "GLI/matstack.h"
 
#include "GLI/lines.h"
#include "GLI/VisuSet.h"
#include "GLI/proj.h"
#if !defined(U64)
#include "GLI/LinkTab.h"
#endif /* U64 */
#include "GLI/watrplan.h"
#include "GLI/zbuffer.h"
#include "GLI/GLI_defn.h"
 
#include "PIC.h"

/*#include "..\tempgrp\gliglou\multidrv\inc\glitext.h"*/
 
#ifdef __cplusplus
} /* extern "C" */
#endif
 
 
#endif
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
