#if !defined(__GLI_Vig_h__)
#define __GLI_Vig_h__
 
/********************************************************
 *** Definition of formats :                          ***
 ***  GLI_EVF_xxxxyyyy_zz                             ***
 ***  xxxx : order of colors Red Green Blue and Alpha ***
 ***  yyyy : bits description                         ***
 ***  zz   : Origin coordinate (Up Down Left Right)   ***
 ********************************************************/
 
typedef enum GLI_tdeVignetteFormat_
{
 GLI_EVF_RGB888_DL,
 GLI_EVF_BGRA8888_UL,
 GLI_EVF_BGR565_UL,
 GLI_EVF_BGR1555_UL,
 GLI_EVF_BGR4444_UL,
 GLI_EVF_NumberOfFormat
} GLI_tdeVignetteFormat;
 
extern CPA_EXPORT GLI_tdeVignetteFormat GLI_fn_eConvertVignetteFormat(unsigned char *_p_ucBuffer,unsigned long _ulWidth,unsigned long _ulHeight,GLI_tdeVignetteFormat _eActualFormat,GLI_tdeVignetteFormat _eWantedFormat);
extern CPA_EXPORT void GLI_fn_vMemoryCopyBufferToBackBufferAndFlip(GLD_tdhDevice _hGLDDevice,GLD_tdhViewport _hGLDViewport,void *_p_vSourceBuffer,long _lWidth,long _lHeight,long _lDestX,long _lDestY,long _lWidthOfSource,GLI_tdeVignetteFormat _eFormat);
extern CPA_EXPORT void GLI_fn_vMemoryCopyBufferToBackBuffer(GLD_tdstViewportAttributes *_p_stViewportAttr,GLD_tdhDevice _hGLDDevice,GLD_tdhViewport _hGLDViewport,void *_p_vSourceBuffer,long _lWidth,long _lHeight,long _lDestX,long _lDestY,long _lWidthOfSource,GLI_tdeVignetteFormat _eFormat);
extern CPA_EXPORT void GLI_fn_vMemoryCopyBufferToBackBufferAndFlip2 ( GLD_tdhDevice _hGLDDevice,
                                                    GLD_tdhViewport _hGLDViewport,
                                                    void *_p_vSourceBuffer,
                                                    long _lWidth,
                                                    long _lHeight,
                                                    long _lDestX,
                                                    long _lDestY,
                                                    long _lWidthOfSource,
                                                    GLI_tdeVignetteFormat _eFormat );
extern CPA_EXPORT void GLI_fn_vMemoryCopyBufferToBackBuffer2 ( GLD_tdhDevice _hGLDDevice,
                                             GLD_tdhViewport _hGLDViewport,
                                             void *_p_vSourceBuffer,
                                             long _lWidth,
                                             long _lHeight,
                                             long _lDestX,
                                             long _lDestY,
                                             long _lWidthOfSource,
                                             GLI_tdeVignetteFormat _eFormat );
 
#endif /* __GLI_Vig_h__ */
