#ifndef GLI_VPT3D_H
#define GLI_VPT3D_H
 
/* Vpt3D.h*/
/* Additionnal attributes for 3D Viewports*/
/* Author : Christophe MARTINAUD*/
/* Last update : 07/18/1996*/
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#include "vertex.h"
#include "POS.h"
 
#define C_MAX_MATRIX_IN_VPT 100
 
typedef struct GLI_tdstSpecificAttributesFor3D_
{
/*    long                lNumberOfMatrixToPush;*/
/*    POS_tdstCompletePosition      aDEF_stMatrixStack[C_MAX_MATRIX_IN_VPT];*/
    struct GLI_tdstCamera_      *p_stCam;
    MTH_tdxReal        xNear;
/*    GLI_tdst2DVertex    stTransVertex ;  */
 
#if defined(U64)
	Gfx a_stGList[8];
	Mtx stProjectionMtx;
	float a16_fProjectionMtx[16];
	unsigned short uwPerspNorm;
#endif /* U64 */
 
} GLI_tdstSpecificAttributesFor3D, *GLI_pstSpecificAttributesFor3D;
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* GLI_VPT3D_H*/
 
