/* (c) Ubi R&D 1996*/
/* See Alain Robin for any comment or question*/
 
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_GMT
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_GMT
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
 
#ifndef __GMT_H__
#define __GMT_H__
 
#ifdef  __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#ifdef GMT_FRIEND			/* You must include the GMT private directory into your path*/
#include "GmtStruc.h"		/* private structure & access macros*/
#include "GmtMacro.h"		/* to change function calls into macros*/
#include "GMT/GmtHandl.h"	/* handle definition*/
#else
#include "GMT/GmtHandl.h"	/* handle definition*/
#include "GMT/GmtFunct.h"	/* accessors*/
#endif
 
#include "GMT/GmtProto.h"	/* complex functions*/
#include "GMT/GmtLoad.h"	/* load functions*/
#include "GMT/GmtLnkTb.h"	/* Link tables*/
#include "GMT/GmtZnLod.h"	/* Zone load functions*/
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __GMT_H__*/
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
 
