/*///////////////////////////////////////////////////////////*/
/*															//*/
/*	  Management of the link table of the Module GMT		//*/
/*															//			   */
/* File Name	: GmtLnkTb.h								//*/
/* Date			: 04/01/97									//*/
/* Author		: Alain Robin								//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
/*															//*/
/* abbreviation of the module-name. Used in macro is 'Gmt'	//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __GMTLNKTB_H__
#define __GMTLNKTB_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
#include "SCR.h"
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __GMTLNKTB_EXTERN
#ifndef __DeclareGlobalVariableGmtLnkTb_h__
#define __GMTLNKTB_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableGmtLnkTb_h__*/
#define __GMTLNKTB_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableGmtLnkTb_h__*/
 
#undef __GMTZONELNKTB_EXTERN
#ifndef __DeclareGlobalVariableGmtZoneLnkTb_h__
#define __GMTZONELNKTB_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableGmtZoneLnkTb_h__*/
#define __GMTZONELNKTB_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableGmtZoneLnkTb_h__*/
 
 
#if !defined(U64)
 
__GMTLNKTB_EXTERN CPA_EXPORT SCR_tdst_Link_Table g_stGmtLinkTable;
__GMTLNKTB_EXTERN CPA_EXPORT SCR_tdst_Link_Table g_stGmtZoneLinkTable;
 
/*------------------*/
/* Public functions*/
/*------------------*/
extern CPA_EXPORT SCR_tdst_Link_Table* GMT_fn_p_stGetLinkTable();
extern CPA_EXPORT SCR_tdst_Link_Table* GMT_fn_p_stGetZoneLinkTable();
 
#endif /* U64 */
 
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__GMTLNKTB_H__*/
