#ifndef _HDLPROTO_H_
#define _HDLPROTO_H_
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
/*----------------------------------------------------------------------------
--  Description : HDL_fn_vInitModulesFor3DOS()
--  Initialise all the ACP modules for the 3dos client 
------------------------------------------------------------------------------
--  Input :             
--  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void HDL_fn_vInitModulesFor3DOS();
 
/*----------------------------------------------------------------------------
--  Description : HDL_fn_vInitModulesForA3D()
--  Initialise all the ACP modules for the A3D client 
------------------------------------------------------------------------------
--  Input :             
--  Output : 
----------------------------------------------------------------------------*/
extern CPA_EXPORT void HDL_fn_vInitModulesForA3D();
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif
