/* (c) Ubi R&D 1997*/
/* See Sebastien DAVID for any comment or question*/
 
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_IPO
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_IPO
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
 
 
#ifndef __IPO_H__
#define __IPO_H__
 
/*#undef extern*/
 
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLL using these function :*/
#include "cpa_expt.h" 
 
/*////////////////////////////////*/
#ifdef PSX
/*////////////////////////////////*/
 
	#include "IPO/PSX/IPO_Stru.h"
	#include "IPO/PSX/IPO_Hndl.h"
	#include "IPO/PSX/IPO_Glob.h"
	#include "IPO/PSX/IPO_Accs.h"
	#include "IPO/PSX/IPO_Load.h"
	#include "IPO/PSX/IPO_Func.h"
 
/*////////////////////////////////*/
#else /* PSX */
/*////////////////////////////////*/
 
	#include "IPO/IPOHandl.h"	/* handle definition*/
 
	#ifdef IPO_FRIEND
	  #include "IPO/IPOStruc.h"	/* private structure & access macros*/
	  #include "IPO/IPOMacro.h"	/* to change function calls into macros*/
	#else
	  #include "IPO/IPOFunct.h"	/* accessors*/
	#endif
 
	#include "IPO/IPOProto.h"	/* complex functions*/
	/*HP #if !defined(U64)*/
	#include "IPO/IPOLoad.h"	/* load functions*/
	/*HP #endif*/
 
/*////////////////////////////////*/
#endif /* PSX */
/*////////////////////////////////*/
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
/*#define extern Do_not_use_extern_in_c_files*/
 
#endif /* __IPO_H__*/
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
