/* (c) Ubi R&D 1997*/
/* See Sebastien DAVID for any comment or question*/
 
#ifndef __IPOPROTO_H__
#define __IPOPROTO_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
 
/* ***************************************************************************** */
/* ********************** Basics functions for IPOs **************************** */
/* ***************************************************************************** */
extern CPA_EXPORT IPO_tdxHandleToInstanciatedPhysicalObject IPO_fn_hAllocInstanciatedPhysicalObject(void);
extern CPA_EXPORT void IPO_fn_vFreeInstanciatedPhysicalObject(IPO_tdxHandleToInstanciatedPhysicalObject _hInstanciatedPhysicalObject);
 
/* ***************************************************************************** */
/* ******************** Access functions to Objects in IPO *********************** */
/* ***************************************************************************** */
 
extern CPA_EXPORT PO_tdxHandleToPhysicalObject  IPO_fn_hGetPhysicalObject(IPO_tdxHandleToInstanciatedPhysicalObject _hInstanciatedPhysicalObject);
extern CPA_EXPORT void IPO_fn_vSetPhysicalObject(IPO_tdxHandleToInstanciatedPhysicalObject _hInstanciatedPhysicalObject
								,PO_tdxHandleToPhysicalObject _hPhysicalObject);
 
 
extern CPA_EXPORT ACP_tdxHandleToRadiosity IPO_fn_hGetRadiosity(IPO_tdxHandleToInstanciatedPhysicalObject _hInstanciatedPhysicalObject);
extern CPA_EXPORT void IPO_fn_vSetRadiosity(IPO_tdxHandleToInstanciatedPhysicalObject _hInstanciatedPhysicalObject
								,ACP_tdxHandleToRadiosity _hRadiosity);
 
 
/*extern CPA_EXPORT void GLI_vSendIPOToViewport ( GLD_tdstViewportAttributes *p_stVpt , IPO_tdxHandleToInstanciatedPhysicalObject h_stInstanciablePhysicalObject , long lDrawModeMask );*/
 
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
/* __IPOPROTO_H__*/
#endif 
