/*=========================================================================
*
* CPAdPerm.h :  class CPA_DialogPermission
*
*
* Version			1.0
* Creation date
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR
 
 
#ifndef __DIALOGPERMISSION_H__
#define __DIALOGPERMISSION_H__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#include "CPARes.h"
#include "CPAMCapt.hpp"
 
 
class CPA_Interface;
class CPA_BaseObject;
 
/*///////////////////////////////////////////////////////////////////////////*/
/* CPA_DialogPermission dialog*/
 
class CPA_EXPORT CPA_DialogPermission : public CDialog, public CPA_MouseCapturer
{
protected:
	CPA_Interface	*m_pInterface;
	CPA_BaseObject	*m_pObject;
	long			m_lUserIndex;
	BOOL			m_bCanModify;
	BOOL			m_bAlways;
 
public:
 /*any class deriving from CPA_MouseCapturer one must declare this method as is*/
	CWnd *m_p_oGrabCapture() { return m_p_oGrabCaptureFor(this); }
 
/* parent editor*/
	CPA_Interface * GetInterface (void) { return m_pInterface; }
 
/* standard constructor*/
	CPA_DialogPermission(CWnd* pParent = NULL);
/* dialog*/
	BOOL fn_bDoDialog (CPA_Interface *pInterface, CPA_BaseObject *pModifiedObject, long lUserIndex);
	void fn_vCloseDialog (void);
 
/* Dialog Data*/
	/*{{AFX_DATA(CPA_DialogPermission)*/
	enum { IDD = CPA_IDD_DIALOGPERMISSION };
	CEdit		m_cObjectName;
	CEdit		m_cDesignerName;
	CButton		m_cModify;
	CButton		m_cCancel;
	CButton		m_cAlways;
	/*}}AFX_DATA*/
 
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CPA_DialogPermission)*/
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    /* DDX/DDV support*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
protected:
 
	/* Generated message map functions*/
	/*{{AFX_MSG(CPA_DialogPermission)*/
	virtual BOOL OnInitDialog();
	afx_msg void OnModify();
	afx_msg void OnCancel();
	afx_msg void OnAlways();
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
#endif /*__DIALOGPERMISSION_H__*/
#endif /* ACTIVE_EDITOR*/
