/*===================================================================
 *
 * Name of Objects and DLL used by Interface
 *
 *=================================================================*/
 
#ifndef __STDDLLID_H__
#define __STDDLLID_H__
 
/*===================================================================
 * Name of Objects
 *=================================================================*/
 
/* SectTest.dll or Sector.dll*/
#define C_szSectorTypeName              "Sector"
 
/* GeomTest.dll or 3DGeom.dll*/
#define C_szGeometricObjectTypeName     "Geometric"
#define C_sz3DFileTypeName              "GeometricFile"
 
/* CamTest.dll*/
#define C_szCameraObjectTypeName        "Camera"
 
/* po_test.dll*/
#define C_szPhysicalObjectTypeName		"Physical"
 
/* ipo_test.dll : instanciated physicla object*/
#define C_szInstanciatedPhysicalObjectTypeName	"InstanciatedPhysical"
#define C_szPhysicalObjectClassTypeName			"PhysicalClass"
 
/*===================================================================
 * Name of DLL
 *=================================================================*/
 
/* Hierarchy.dll*/
#define C_szDLLHierarchyName	"Hierarchy"
 
/* SectTest.dll or Sector.dll*/
#define C_szDLLSectorName       "Sector"
 
/* GeomTest.dll or 3DGeom.dll*/
#define C_szDLLGeometryName     "Geometry DLL"
 
/* CamTest.dll*/
#define C_szDLLCameraName       "Camera DLL"
 
/* po_test.dll*/
#define C_szDLLPhysicalObjectName "Physical DLL"
 
/* ipo_test.dll : instanciated physical object DLL */
#define C_szDLLInstanciatedPhysicalObjectName "Instanciated Physical DLL"
 
/*===================================================================
 *=================================================================*/
 
#endif /* __STDDLLID_H__*/
