/*=========================================================================
* 
* CPAdOpt.h :  class CPA_DialogOption
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR
 
 
#ifndef __DIALOGOPTION_H__
#define __DIALOGOPTION_H__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#include "CPAres.h"
 
class CPA_Interface;
 
/*===========================================================================
*		Description:	CPA_DialogOption dialog
*		Creation date:
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                        Author:
*=========================================================================*/
 
class CPA_DialogOption : public CDialog
{
protected:
	CPA_Interface		*m_pInterface;
 
public:
/* parent editor*/
	CPA_Interface		* GetInterface	(void) { return m_pInterface; }
 
/* standard constructor*/
	CPA_DialogOption (CWnd* pParent = NULL);   
/* dialog*/
	void fn_vDoDialog (CPA_Interface *pInterface);
 
 
/* Dialog Data*/
	/*{{AFX_DATA(CPA_DialogOption)*/
	enum { IDD = CPA_IDD_DIALOGOPTION };
	/* general options*/
	CButton	m_cCoheMngr;
	CButton	m_cReinitMap;
	CButton	m_cScaleEditor;
	CEdit	m_cPyramidDepth;
	CEdit	m_cTargetDepth;
	CButton m_cAuthorisation;
	CButton m_cKeyboard;
	/* move options*/
	CEdit	m_cRotStep;
	CEdit	m_cTranStep;
	CButton	m_cGothrough;
	CButton	m_cBlock;
	CButton m_cAccelerate;
	/*CPA2 Gabi Dumitrascu 98/07/09*/
	/*screen options*/
	CButton m_cAutomaticSwap;
	CButton m_cSwapLeft;
	CButton m_cSwapRight;
	CButton m_cSwapBoth;
	/*End CPA2 Gabi Dumitrascu 98/07/09*/
	/*}}AFX_DATA*/
 
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CPA_DialogOption)*/
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    /* DDX/DDV support*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
protected:
 
	/* Generated message map functions*/
	/*{{AFX_MSG(CPA_DialogOption)*/
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	
	afx_msg void OnAuthorisation();
	afx_msg void OnKeyboard();
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
#endif /*__DIALOGMOVE_H__*/
#endif /* ACTIVE_EDITOR*/
