/*----------------------*/
/*     DNMLinkE.h       */
/*----------------------*/
/* Date : 1997-04-02    */
/* Version : 0.10       */
/* Modify : 1997-04-02  */
/* (c) Ubi R&D 1997     */
/*----------------------*/
 
/*-----------------------*/
/* Link Table            */
/*-----------------------*/
 
#ifndef __DNMLINKE_H__
#define __DNMLINKE_H__
 
/* For DLL using these function */
#include "cpa_expt.h" 
#include "SCR.h"
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* Initialisation Function */
extern CPA_EXPORT void DNM_fn_vInitLinkTableOfMecEnvironment();
 
#if !defined(U64)
extern CPA_EXPORT SCR_tdst_Link_Table * DNM_fn_p_stGetMecEnvironementLinkTable();
extern CPA_EXPORT SCR_tdst_Link_Table * DNM_fn_p_stGetMecEnvironmentLinkTable();
#endif /* U64 */
 
/* Create an Entry */
extern CPA_EXPORT void DNM_fn_v_SetValueInLinkTableOfMecEnvironment( char *_p_szKey,unsigned long _ulValue);
 
/* Find Handle with Key */
extern CPA_EXPORT unsigned long DNM_fn_ulLink_SearchKeyInLinkTableOfMecEnvironment( char *_p_szKey);
 
/* Find Key with Handle */
extern CPA_EXPORT char * DNM_fn_p_cSearchValueInLinkTableOfMecEnvironment( unsigned long _ulValue);
 
#ifdef  __cplusplus
}
#endif
 
#endif /* __DNMLINKE_H__ */
 
