/*----------------------*/
/*     DNMLoadI.h       */
/*----------------------*/
 
#ifndef __DNMLOADI_H__
#define __DNMLOADI_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
#include "cpa_std.h"
#include "MEC/hIdCard.h"
 
#include "MEC/DNMLinkI.h"
 
/* For DLL using these function */
#include "cpa_expt.h" 
#include "SCR.h"
 
#define C_SectionIdCardCamera			"IdCardCamera"
 
/* camera */
#define C_EntryAngularSpeed				"AngularSpeed"
#define C_EntryLinearSpeed				"LinearSpeed"
#define C_EntrySpeedingUp				"SpeedingUp"
 
/*** MecBaseIdCard scripts ***/
#define C_SectionMecBaseIdCardDescription					"MecBaseIdCard"
#define C_EntryMecBaseIdCardChamp							"Champ"
#define C_EntryBaseAnimation								"Animation"
#define C_EntryBaseCollide									"Collide"
#define C_EntryBaseGravity									"Gravity"
#define C_EntryBaseGi										"Gi"
#define C_EntryBaseOnGround									"OnGround"
#define C_EntryBaseClimb									"Climb"
#define C_EntryBaseSpider									"Spider"
#define C_EntryBaseShoot									"Shoot"
#define C_EntryBaseSwim										"Swim"
#define C_EntryBaseTilt										"Tilt"
#define C_EntryBaseCollisionControl							"CollisionControl"
#define C_EntryBaseKeepWallSpeedZ							"KeepSpeedZ"
#define C_EntryBaseSpeedLimit								"SpeedLimit"
#define C_EntryBaseInertia									"Inertia"
#define C_EntryBaseStream									"Stream"
#define C_EntryBaseStickOnPlatform							"StickOnPlatform"
#define C_EntryBaseUseScale									"Scale"
#define C_EntryBaseGravityFactor							"G"
#define C_EntryBaseSlide									"Slide"					
#define C_EntryBaseRebound									"Rebound"					
#define C_EntryBaseSlopeLimit								"SlopeLimit"					
#define C_EntryBaseInertiaFactorX							"Ix"					
#define C_EntryBaseInertiaFactorY							"Iy"					
#define C_EntryBaseInertiaFactorZ							"Iz"					
#define C_EntryBaseTiltIntensity							"TiltIntensity"					
#define C_EntryBaseTiltInertia								"TiltInertia"					
#define C_EntryBaseTiltOrigin								"TiltOrigin"					
#define C_EntryBaseMaxSpeed									"MaxSpeed"					
#define C_SectionIdCardBase									"IdCardBase"
 
 
#if !defined(U64)
 
/*---------------------*/
/* Call Back           */
/* to Read Camera IdCard  */
/*---------------------*/
SCR_tde_Anl_ReturnValue DNM_fn_eScriptCallBackCameraIdCard(
                                                     SCR_tdst_File_Description *_p_stFile,
                                                     char *_p_szName,
                                                     char *_ap_szPars[],
                                                     SCR_tde_Anl_Action _eAction);
/*---------------------
 * Call Back           
 * to Base IdCard 
 * jt 19/01/98
 *---------------------*/
SCR_tde_Anl_ReturnValue DNM_fn_eScriptCallBackBaseIdCard(
   SCR_tdst_File_Description *_p_stFile,
   char *_p_szName,
   char *_ap_szPars[],
   SCR_tde_Anl_Action _eAction);
 
 
#endif /* U64 */
 
/*------------------------------------------------*/
/*  Description :   Init the load of IdCard       */
/*------------------------------------------------*/
void  DNM_fn_vInitLoadIdCard(void);
 
/*-----------------------------------------------------------------------------
 *  Description :   Prepare save of all Id cards
 *---------------------------------------------------------------------------*/
void DNM_fn_vPrepareSaveMecIdCards();
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
 
#endif /*__DNMLOADI_H__ */
