/*
 *=======================================================================================
 * Name        : MecBhv.c
 * Author      : J Thnoz               Date : 01/05/98
 * Description : Mechanic Behaviours
 *=======================================================================================
 */
 
 
 
#ifndef _MECBHV_H_
#define _MECBHV_H_
 
#ifdef __cplusplus
extern "C" {
#endif
 
 
void MEC_fn_vCollideBaseMechanic
(
	struct DNM_stDynamics *p_stDynamic,
    HIE_tdxHandleToSuperObject hSupObj,
	long lObstacle,
	DNM_tdstMecObstacle a_stObstacle[COL_C_xMaxNumberOfCollisions],
	MTH_tdxReal xDT
);
 
 
void MEC_fn_vBaseObstacleManagement 
( 
	struct DNM_stDynamics *p_stDynamic, 
	HIE_tdxHandleToSuperObject hSupObj, 
	MTH_tdxReal xDT 
);
 
 
void MEC_fn_vGiObstacleManagement 
( 
	struct DNM_stDynamics *p_stDynamic, 
	HIE_tdxHandleToSuperObject hSupObj, 
	MTH_tdxReal xDT 
);
 
 
void MEC_fn_vClimbObstacleManagement 
( 
	struct DNM_stDynamics *p_stDynamic, 
	HIE_tdxHandleToSuperObject hSupObj, 
	MTH_tdxReal xDT 
);
 
void MEC_fn_vGroundObstacleManagement 
( 
	struct DNM_stDynamics *p_stDynamic, 
	HIE_tdxHandleToSuperObject hSupObj,     
	MTH_tdxReal xDT
);
 
 
void MEC_fn_vSpiderObstacleManagement
( 
	struct DNM_stDynamics *p_stDynamic, 
	HIE_tdxHandleToSuperObject hSupObj, 
	MTH_tdxReal xDT 
);
 
void MEC_fn_vGroundGuess (DNM_tdstDynamics *p_stDynamic, MTH_tdxReal xDT);
 
 
#ifdef __cplusplus
}
#endif
 
 
#endif /* _MECBHV_*/
