/*///////////////////////////////////////////////////////////*/
/**/
/*      Memory Management of the Module : Mrc*/
/**/
/* File Name    : MmgMrc.h*/
/* Date         : 97/07/21*/
/* Author       : Yan Marchal*/
/**/
/*///////////////////////////////////////////////////////////*/
#ifndef __MmgMrc_H__
#define __MmgMrc_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "MMG.h"
 
typedef enum e_ucMrcStaticBlocks_{
    E_ucMrcBlock1, 
    E_ucMrcMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucMrcStaticBlocks;
 
#undef EXTERN
#ifdef __DeclareGlobalVariableMmgMrc_h__
#define EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgMrc_h__*/
#define EXTERN extern
#endif /*__DeclareGlobalVariableMmgMrc_h__*/
 
EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stMrcBlocksInfo[E_ucMrcMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stMrcDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MmgMrc_H__*/
