/*
 
NetSynch.h : Synchronisation API
 
*/
 
/* Synchronisation module */
 
/*      Author: David Fournier
 *
 *      Creation Date:      10/04/97
 */
 
#if !defined (__NETLIB_SYNCHRO__)
#define __NETLIB_SYNCHRO__
 
#include "NET\NetSer.h"
 
typedef unsigned char NetLib_uxSynchroId;
 
#define NetLib_C_InvalidSynchroId 0xFF
 
 
typedef void (_NET_CALLING_CONV_ *NetLib_tdfnvSynchroCallback)(NetLib_tduxPlayerId,NetLib_uxSynchroId,void *BufMes,unsigned long SizeMes);
 
_NET_EXPORT_ NetLib_tdeErrorStatus _NET_CALLING_CONV_ eNetLibWaitSynchro(NetLib_uxSynchroId uxSyncId,
               NetLib_tdulTimeInfo ulTimeOut,void *pBufMes,unsigned long ulSizeMes,
               NetLib_tdfnvSynchroCallback tdfnvCallback,int bWithoutAck,
               NetLib_tduxPlayerId ucMaster);
 
#endif /* __NETLIB_SYNCHRO__ */
 
