 
/*
  MODULE : COL (Intersection & Collision Library)
  AUTHOR : Frederic PHILIPPE
           UBI R&D
  FILE : COL.h (Principal header file)
*/
 
#ifndef OGD_H
#define OGD_H
 
/*ROMTEAM WorldEditor (Cristian Stegaru) 11/97*/
#define C_uiStartITEditor		10
#define	C_uiEndITEditor			11
#define	C_uiGetITEditor			12
#define	C_uiCreateObject		13
#define C_uiSetName				14
/* BEGIN CPA2 Cristi Petrescu 98-03-*/
#define	C_uiCreateCloneObject	15
/* END CPA2 Cristi Petrescu 98-03-*/
#define	C_origGeomObjectFlag	(1 << 30)
/*ENDROMTEAM WorldEditor (Cristian Stegaru)*/
 
#include "OGD/3Dobject.hpp"
 
 
/*ROMTEAM WorldEditor*/
#include "OGD/Shape3D.hpp"
#include "OGD/Sphere3D.hpp"
#include "OGD/Arrows3D.hpp"
#include "OGD/Box3D.hpp"
#include "OGD/Cone3D.hpp"
#include "OGD/Point3D.hpp"
#include "OGD/Oktaedron3D.hpp"
#include "OGD/ParamSurface3D.hpp"
#include "OGD/Alt3D.hpp"
#include "OGD/ITSphere3D.hpp"
#include "OGD/Plane3D.hpp"
#include "OGD/ITBox3D.hpp"
#include "OGD/ITObject.hpp"
#include "OGD/Bar3D.hpp"
#include "OGD/Symbolical3D.hpp"
#include "OGD/ITCon3D.hpp"
/*ENDROMTEAM WorldEditor*/
 
#endif /* OGD_H */
