/*ROMTEAM WorldEditor*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
/* File        : ITObject3D.hpp: interface for the ITObject3D class.*/
/* Author      : Ionut Grozea*/
/* Date        : 97.11*/
/* Description :*/
/*//////////////////////////////////////////////////////////////////////////////////////*/
#ifndef __ITObject3D_HPP__
#define __ITObject3D_HPP__
 
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
 
class CPA_EXPORT ITObject3D : public Shape3D
{
private:
 
private:
	void CommonITObject3D(int vi_x ,int vi_y,   float( *vf_Ver )[3] ,  WORD (*vf_IT)[3]);
	void CreateITObject3D(int vi_x ,int vi_y,   float(* vf_Ver )[3] ,  WORD (*vf_IT)[3]);
	int m_vi_x;
	int m_vi_y;
 
 
public:
 	ACP_tdxHandleOfElement GetHElement();
 	BOOL _OnLButtonDblClk (UINT nFlags, tdstMousePos *p_stPos, ACP_tdxIndex xIndex, HIE_tdstPickInfo *p_stPickInfo);
	void  SetScaleX(float fScale);
	void  SetScaleY(float fScale);
	void  SetScaleZ(float fScale);
 
	/* constructors & destructors*/
/*ROMTEAM WorldEditor (Cristian Stegaru 12/97)*/
	ITObject3D (CPA_EditorBase *_p_oEditor ,int vi_x ,int vi_y,   float(* vf_Ver )[3] , WORD (*vf_IT)[3] , const CString _csName = "", tdeSaveStatus _eStatus = E_ss_NoSave);
/*ENDROMTEAM WorldEditor (Cristian Stegaru)*/
	~ITObject3D();
};
#endif /* */
