 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_PIC
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_PIC
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef PICH
#define PICH
 
 
#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif
 
#include "MTH.h"
 
#if !defined(U64)
 
#include <windows.h>
#include <windowsx.h>
#include <malloc.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <math.h>
 
#else /* U64 */
 
#include <cpa_std.h>
 
#endif /* U64 */
 
 
#define ACTIVE_EDITOR_MOTEUR
 
#ifdef __cplusplus
extern "C"
{
#endif
 
#include "PIC/Pick_st.h"
#include "PIC/picking.h"
#include "PIC/deplacer.h"
 
 
 
#ifdef __cplusplus
} /* extern "C" */
#endif
 
 
#endif
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
