/* (c) Ubi R&D 1997*/
/* See Sebastien DAVID for any comment or question*/
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_PO
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_PO
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#ifndef __PO_H__
#define __PO_H__
 
/*#undef extern*/
 
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLL using these function :*/
#include "cpa_expt.h" 
 
/*////////////////////////////////*/
#ifdef PSX
/*////////////////////////////////*/
 
    #include "PO/PSX/PO_BdVol.h"
	#include "PO/PSX/PO_Struc.h"
	#include "PO/PSX/PO_Hndl.h"
	#include "PO/PSX/PO_Glob.h"
	#include "PO/PSX/PO_Accs.h"
	#include "PO/PSX/PO_Load.h"
	#include "PO/PSX/PO_Func.h"
 
/*////////////////////////////////*/
#else /* PSX */
/*////////////////////////////////*/
 
	#include "PO/POHandl.h"	/* handle definition*/
 
	#ifdef PO_FRIEND
		#include "PO/POStruc.h"	/* private structure & access macros*/
		#include "PO/POMacro.h"	/* to change function calls into macros*/
	#else
 
		#include "PO/POFunct.h"	/* accessors*/
	#endif
 
	#include "PO/POProto.h"	/* complex functions*/
	#include "PO/POLoad.h"	/* load functions*/
	#include "PO/VSLoad.h"	/* load functions for VisualSet (here temporarily)*/
	#include "PO/CSLoad.h"	/* load functions for CollideSet (here temporarily)*/
 
/*////////////////////////////////*/
#endif /* PSX */
/*////////////////////////////////*/
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
/*#define extern Do_not_use_extern_in_c_files*/
 
#endif /* __PO_H__*/
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
 
 
