/*///////////////////////////////////////////////////////////*/
/**/
/*		Memory Management of the Module : Scr*/
/**/
/* File Name	: MmgScr.h*/
/* Date			: 703/10/96*/
/* Author		: First_Name Last_Name*/
/**/
/*///////////////////////////////////////////////////////////*/
#ifndef __MmgScr_H__
#define __MmgScr_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "MMG.h"
 
typedef enum e_ucScrStaticBlocks_
{
	E_ucSCRMemoryBlock0 = 0,
	E_ucSCRMemoryBlock1 = 1,
	E_ucSCRMemoryBlock2 = 2,
	E_ucSCRMemoryBlock3 = 3,
	E_ucSCRMemoryBlock4 = 4,
	E_ucSCRMemoryBlock5 = 5,
	E_ucSCRMemoryBlock6 = 6,
	E_ucSCRMemoryBlock7 = 7,
	E_ucSCRMemoryBlock8 = 8,
	E_ucScrMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucScrStaticBlocks;
 
#undef EXTERN
#ifdef __DeclareGlobalVariableMmgScr_h__
#define EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgScr_h__*/
#define EXTERN extern
#endif /*__DeclareGlobalVariableMmgScr_h__*/
 
EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stScrBlocksInfo[E_ucScrMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stScrDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MmgScr_H__*/
