/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          SHWCpa.H
 
DESCRIPTION :   cpa include for SHW Module
 
VERSION :       1.00 / Philippe Thibaut / Creation
 
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef __SHW_CPA_H__
#define __SHW_CPA_H__
 
#if defined(VISUAL)
 #pragma warning(disable:4010) /** single-line comment contains line-continuation character **/
 #pragma warning(disable:4100) /** unreferenced formal parameter **/
 #pragma warning(disable:4702) /** unreachable code **/
 #pragma warning(disable:4244) /** conversion from 'type1' to 'type2', possible loss of data **/
#endif /* VISUAL */
 
/* ##INCLUDE#----------------------------------------------------------------------------
                          Includes Files
---------------------------------------------------------------------------------------*/
#include "ACP_Base.h"
 
#include "GEO.h"
#include "GLI.h"
#include "COL.h"
#include "SPO.h"
#include "PCS.h"
#include "PO.h"
/*XB980821*/
#ifndef D_THROW_IPO
#include "IPO.h"
#endif /* D_THROW_IPO */
/*End XB*/
/* Oliv' - Portage v15*/
#ifndef U64
#include "DPT.h"
#endif
/* EndOfOliv'*/
#include "MEC.h"
/*#include "ENV.h"*/
/*#include "SRF.h"*/
#include "SND.h"
#include "SCT.h"
 
#undef EXTERN
#undef extern
 
#endif /* __SHW_CPA_H__ */
