/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          SHWStruc.H
 
DESCRIPTION :   Structure of SHW Module
 
VERSION :       1.00 / Philippe Thibaut / Creation
 
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef __SHWStruc_H__
#define __SHWStruc_H__
 
#ifdef SHW_MAIN
 
#ifdef  __cplusplus
extern "C" {
#endif
 
 
typedef struct SHW_tdstShadowInfo_
{
  
  COL_tdstShadowElement       a_stShadowObject[SHW_C_xMaxTriangles];
  short                       bDrawFace[SHW_C_xMaxTriangles];
  MTH3D_tdstVector            pstGlobalNormal[SHW_C_xMaxTriangles];
  HIE_tdxHandleToSuperObject  hPickedSpObj;
  ACP_tdxHandleOfObject       hPickedObject;
  ACP_tdxIndex                xNbElement;
} SHW_tdstShadowInfo;
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* SHW_MAIN*/
 
#endif /* __SHWStruc_H__*/
