/* (c) Ubi Studios 1996-97*/
/* See Vincent Greco for any comment or question*/
 
#ifndef __HIECONST_H__
#define __HIECONST_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/*ANNECY VL SPOFLAG 04/12/97{*/
/*
 =======================================================================================
	Constants 
 =======================================================================================
 */
#define HIE_C_MaxNumberOfSPOInTheFix  32
/*
 * flag mask
 */
#define HIE_C_Flag_ulNotPickable				0x00000001
#define HIE_C_Flag_ulHidden						0x00000002
#define HIE_C_Flag_ulNoTransformationMatrix		0x00000004    /* The transformation matrix is always the identity*/
#define HIE_C_Flag_ulZoomInsteadOfScale			0x00000008    /* The scale factor is the same for the three axis*/
#define HIE_C_Flag_ulTypeOfBoundingVolume		0x00000010
#define HIE_C_Flag_ulSuperimposed				0x00000020
#define HIE_C_Flag_ulNotHitByRayTrace			0x00000040
#define HIE_C_Flag_ulNoShadowOnMe			    0x00000080
#define HIE_C_Flag_ulSemiLookAt					0x00000100
#define HIE_C_Flag_ulCheckChildren				0x00000200
 
/*XB980824*/
#ifndef D_THROW_MGT
#define HIE_C_Flag_MagnetModification			0x00008000
#endif /* D_THROW_MGT */
/*End XB*/
#define HIE_C_Flag_ModuleTransparency			0x00010000	   /* module transparency is setting	*/
#define HIE_C_Flag_ExcluLight					0x00020000	   
 
 
 
/* fbolefeysot - 01/10/98*/
/* change SPO enum to flags{*/
#define HIE_C_ulSuperObject				0x00000001			/* SO with no linked object*/
#define HIE_C_ulActor					0x00000002			/* actor*/
#define HIE_C_ulSector					0x00000004			/* sector*/
#define HIE_C_ulPO						0x00000008			/* Physical Object*/
#define HIE_C_ulPO_Mirror				0x00000010			/* Physical Object Mirror (?)*/
#define HIE_C_ulIPO						0x00000020			/* Instanciated Physical Object*/
#define HIE_C_ulIPO_Mirror				0x00000040			/* Instanciated Physical Object Mirror (?)*/
#define HIE_C_ulSpecialEffect			0x00000080			/* Special Effect (?)*/
#define HIE_C_ulNoAction				0x00000100			/* empty SO (?)*/
#define HIE_C_ulMirror					0x00000200			/* Mirror (?)*/
#define HIE_C_ulEDT_Geometric			0x00000400			/* geometric object (Editor)*/
#define HIE_C_ulEDT_Light				0x00000800			/* light object (Editor)*/
#define HIE_C_ulEDT_Waypoint			0x00001000			/* Waypoint object (Editor) */
#define HIE_C_ulEDT_ZdD					0x00002000			/* ZdD object (Editor) */
#define HIE_C_ulEDT_ZdE					0x00004000			/* ZdE object (Editor) */
#define HIE_C_ulEDT_ZdM					0x00008000			/* ZdM object (Editor) */
#define HIE_C_ulEDT_ZdR					0x00010000			/* ZdR object (Editor) */
#define HIE_C_ulEDT_BdV					0x00020000			/* Bounding Volume object (Editor) */
#define HIE_C_ulEDT_TestPoint			0x00040000			/* TestPoint object (Editor) */
/*END fbolefeysot}*/
 
 
/* fbolefeysot - 01/10/98*/
/* change SPO enum to flags{*/
/*
typedef enum HIE_tdeTypeOfObject_
{
	C_ucSuperObject=0,
	C_ucPhysical,
	C_ucLight,
	C_ucCamera,
	C_ucCharacter,
	C_ucAnimation,
	C_ucStaticWorld,
	C_ucStandardPlatForm,
	C_ucSector,
	C_ucWaypoint,
	C_ucGeometric,
	C_ucPhysicalObject,
	C_ucSpecialEffect,
	C_ucInstanciatedPhysicalObject,
	C_ucA3dPickableObject,
	C_ucA3dUnpickableObject,
	C_ucA3dInvisibleObject,
	C_ucMirror,
	C_ucPoMirror,
	C_ucIpoMirror,
	C_ucWorld=64,
	C_ucStaticSubWorld,
	C_ucEngineSubWorld,
	C_ucInactiveEngineSubWorld,
  	C_ucNoAction=		128
	
	  } HIE_tdeTypeOfObject;
//C_uc... so lType should not be a long ...
*/
/*END fbolefeysot}*/
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __HIECONST_H__ */
