/* (c) Ubi Studios 1996*/
/* See Vincent Greco for any comment or question*/
 
#ifndef __HIEDRAW_H__
#define __HIEDRAW_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLL using these function :*/
#include "cpa_expt.h" 
/*
//no more exported	
extern CPA_EXPORT 
void GLI_fn_vSendSuperObjectToViewport ( struct GLD_tdstViewportAttributes_ *p_stVpt ,
                            HIE_tdxHandleToSuperObject   _hSprObj ,
                            GLI_tdxHandleToLight _hLight,
							long _DrawMask);
*/
 
#if defined(ACTIVE_EDITOR) /* {*/
extern CPA_EXPORT 
void HIE_fn_vSendSuperObjectToViewport (GLD_tdxHandleToViewportAttributes _hVpt ,
                            			HIE_tdxHandleToSuperObject   _hSprObj ,
										long _DrawMask);
#endif /* ACTIVE_EDITOR }*/
 
extern CPA_EXPORT 
void HIE_fn_vSelectSuperObject(HIE_tdxHandleToSuperObject _hSprObj);
 
extern CPA_EXPORT 
void HIE_fn_vUnselectSuperObject(HIE_tdxHandleToSuperObject _hSprObj);
 
 
 
 
extern CPA_EXPORT void HIE_fn_vSendStaticWorldToViewport(
	GLD_tdxHandleToViewportAttributes _hVpt,
	HIE_tdxHandleToSuperObject   _hSprObj,
	long _DrawMask,
	long _lCullingResult
);
 
extern CPA_EXPORT void HIE_fn_vSendCharacterToViewport(
	GLD_tdxHandleToViewportAttributes _hVpt,
	HIE_tdxHandleToSuperObject   _hSprObj,
	long _DrawMask,
	long _lCullingResult
);
 
 
extern CPA_EXPORT HIE_tdxHandleToSuperObject HIE_fn_hFindFirstMirrorInHierarchy(GLD_tdxHandleToViewportAttributes _hVpt ,
                                        HIE_tdxHandleToSuperObject   _hSprObj);
 
extern CPA_EXPORT int HIE_fn_bFindMirrorInHierarchy(HIE_tdxHandleToSuperObject _hSprObj);
 
extern CPA_EXPORT void HIE_fn_hFindAllMirrorsInHierarchy(
	GLD_tdxHandleToViewportAttributes _hVpt ,
	HIE_tdxHandleToSuperObject   _hSprObj,
	HIE_tdxHandleToSuperObject *p_hHandleOfMirror,
	ACP_tdxHandleOfObject	*p_hHandleOfGeometricMirror,
	short *p_shNbOfMirrors,
	short shNbMaxOfMirrors
);
 
extern CPA_EXPORT 
void HIE_fn_vRecursiveRotationUpdate(HIE_tdxHandleToSuperObject _hSprObj, unsigned long _ulTime);
 
/*ANNECY JMD 24/02/98 {*/
extern CPA_EXPORT ACP_tdxBool HIE_fn_bSendSPOToFixViewport ( struct GLD_tdstViewportAttributes_ *p_stFixViewportAttr, long _lDrawMask ) ;
extern CPA_EXPORT void HIE_vSetCharactereRLI ( unsigned char ucNbRLI, unsigned char ucIndex1, unsigned char ucIndex2, MTH_tdxReal xPercent) ;
/*ENDANNECY JMD }*/
 
 
extern CPA_EXPORT GEO_tdstGeometricObject *HIE_fn_p_stGetGeometricObjectFromSuperObject( HIE_tdxHandleToSuperObject  h_SuperObject );
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __HIEDRAW_H__*/
