/* (c) Ubi Studios 1996*/
/* See Vincent Greco or Marc Villemain for any comment or question*/
 
 
#ifndef __HIELOAD_H__
#define __HIELOAD_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLL using these functions :*/
#include "cpa_expt.h" 
 
 
/*=======================================================*/
/*	Functions used for loading one SuperObject           */
/*=======================================================*/
#if !defined(U64)
extern CPA_EXPORT SCR_tdst_Link_Table * HIE_fn_p_stGetSuperObjectLinkTable();
extern CPA_EXPORT SCR_tdst_Link_Table * HIE_fn_p_stGetLinkedObjectLinkTable();
#endif /* U64 */
/*extern CPA_EXPORT void HIE_fn_vPrepareSaveSuperObjectsBinaryBloc();*/
extern CPA_EXPORT BOOL HIE_fn_bInitSPOLoading();
extern CPA_EXPORT BOOL HIE_fn_bStopSPOLoading();
#if !defined(U64)
extern CPA_EXPORT SCR_tde_Anl_ReturnValue HIE_fn_xLoadOneMatrix(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern CPA_EXPORT SCR_tde_Anl_ReturnValue HIE_fn_xLoadSuperObject(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
#endif /* U64 */
 
 
/*============================================================*/
/* Function used for loading a whole file                     */
/*============================================================*/
extern CPA_EXPORT HIE_tdxHandleToSuperObject HIE_fn_hLoadSPOFile(char *szLoadPath, char *szFileName);
/* ANNECY MT - 08/09/98 {*/
extern CPA_EXPORT HIE_tdxHandleToSuperObject HIE_fn_hLoadSUBFile(char *szLoadPath, char *szFileName, long _lSubMap, long _lEntry);
/* END ANNECY MT }*/
 
extern CPA_EXPORT HIE_tdxHandleToSuperObject HIE_fn_hLoadOneSuperObject(char *p_cScriptFile);
 
extern CPA_EXPORT BOOL HIE_fn_bInitSPOLoading2();
extern CPA_EXPORT BOOL HIE_fn_bStopSPOLoading2();
#if !defined(U64)
extern CPA_EXPORT SCR_tde_Anl_ReturnValue HIE_fn_xLoadSuperObject2(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
/* ANNECY MT - 08/09/98 {*/
extern CPA_EXPORT SCR_tde_Anl_ReturnValue HIE_fn_xLoadSubMap(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
/* END ANNECY MT }*/
#endif /* U64 */
extern CPA_EXPORT void HIE_fn_vLoadLinkedObject(HIE_tdxHandleToSuperObject _hSuperObject);
 
 
/*-----------------------------------------------------------------*/
 
 
 
/*extern CPA_EXPORT void HIE_fn_vPrepareSaveSuperObjectsBinaryBloc();*/
/*-----------------------------------------------------------------------------
 *  Description :   function to write a binary SPO
 *-----------------------------------------------------------------------------
 *-----------------------------------------------------------------------------
 *  Creation date : Aug 97            Author : Alain Robin
 *-----------------------------------------------------------------------------*/
/*extern CPA_EXPORT unsigned long SPO_fn_ulWriteBinaryBloc(unsigned long _ulStructAddress, char* _p_cDestBuffer);*/
/*extern CPA_EXPORT unsigned long SPO_fn_ulWriteBinaryBloc2(unsigned long _ulStructAddress, char* _p_cDestBuffer);*/
/*-----------------------------------------------------------------------------
 *  Description :   function to write all the binary SPO
 *-----------------------------------------------------------------------------
 *-----------------------------------------------------------------------------
 *  Creation date : Aug 97            Author : Alain Robin
 *-----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void SPO_fn_vWriteAllSPOBinaryBlocs(char* _szBinaryFileName);*/
/*extern CPA_EXPORT void SPO_fn_vWriteAllSPOBinaryBlocs2(char* _szBinaryFileName);*/
/*-----------------------------------------------------------------------------
 *  Description :   function to read a binary SPO
 *-----------------------------------------------------------------------------
 *-----------------------------------------------------------------------------
 *  Creation date : Aug 97            Author : Alain Robin
 *-----------------------------------------------------------------------------*/
/*
extern CPA_EXPORT unsigned long SPO_fn_ulReadBinaryBloc(char* _p_cLoadedBuffer,unsigned long _ulLoadedBufferSize);
extern CPA_EXPORT void SPO_fn_vChangeIdsIntoAddresses(unsigned long ulAddress);
extern CPA_EXPORT void SPO_fn_vChangeAllIdsIntoAddresses(char* _szBinaryFileName);
extern CPA_EXPORT void SPO_fn_vResolveBinaryBloc(unsigned long _ulAddress);
extern CPA_EXPORT void SPO_fn_vResolveBinaryBloc2(unsigned long _ulAddress);
*/
 
/*-----------------------------------------------------------------------------
 *  Description :   function to read all the binary blocs for SPO
 *-----------------------------------------------------------------------------
 *-----------------------------------------------------------------------------
 *  Creation date : Aug 97            Author : Alain Robin
 *-----------------------------------------------------------------------------*/
/* extern CPA_EXPORT void SPO_fn_vReadAllSPOBinaryBlocs(char* _szBinaryFileName);*/
 
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __HIELOAD_H__ */
