/*///////////////////////////////////////////////////////////*/
/**/
/*      Memory Management of the Module : Tde*/
/**/
/* File Name    : MmgTde.h*/
/* Date         : 703/10/96*/
/* Author       : Yan Marchal*/
/**/
/*///////////////////////////////////////////////////////////*/
#ifndef __MmgTde_H__
#define __MmgTde_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "MMG.h"
 
typedef enum e_ucTdeStaticBlocks_{
    E_ucTdeBlock1, 
/*  E_ucTdeBlock2,*/
/*  E_ucTdeBlock3,     */
/*  E_ucTdeBlock4,     */
    E_ucTdeMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucTdeStaticBlocks;
 
#undef EXTERN
#ifdef __DeclareGlobalVariableMmgTde_h__
#define EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgTde_h__*/
#define EXTERN extern
#endif /*__DeclareGlobalVariableMmgTde_h__*/
 
EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stTdeBlocksInfo[E_ucTdeMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stTdeDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MmgTde_H__*/
