#ifndef __ACP_BASE_H
#define __ACP_BASE_H
 
/* Index for ACP : */
#ifndef U64
typedef signed short ACP_tdxIndex;
#else
/* U64 runs faster with long index*/
typedef signed long ACP_tdxIndex;
#endif
 
 
/* If DREAMCAST is defined, we'll have pragma inlines instead of __inline */
#ifdef DREAMCAST
#define INLINE
#else
/* CODEWARRIOR doesnt like static __inline in .h files */
#ifndef CODEWARRIOR
#define	INLINE		static __inline
#else
#define INLINE		__inline
#endif
#endif
 
 
/* Booleans for ACP : */
typedef unsigned char ACP_tdxBool;
#define TRUE    1
#define FALSE   0
 
/* Address for ACP */
#define ACP_tdxAddress unsigned long
 
#ifdef U64
#define LST2_StaticIsOptimised
#endif
 
/* Handles for ACP */
#include "HDL.h"
 
#endif /* __ACP_BASE_H */
 
