/*///////////////////////////////////////////////////////////*/
/*															//*/
/*		Memory Management of the Module : AI 				//*/
/*															//			   */
/* File Name	: MmgAI.h									//*/
/* Date			: 703/10/96									//*/
/* Author		: First_Name Last_Name						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#ifndef __MmgAI_H__
#define __MmgAI_H__
 
enum e_ucAIStaticBlocks
{
	E_ucAIBlockFix,
	E_ucAIBlockLevel,
	E_ucAIMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
};
 
#undef EXTERN_MEMAI
#undef extern
#ifdef __DeclareGlobalVariableMmgAI_h__
#define EXTERN_MEMAI /*nothing*/
#else /* no __DeclareGlobalVariableMmgAI_h__*/
#define EXTERN_MEMAI extern
#endif /*__DeclareGlobalVariableMmgAI_h__*/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
EXTERN_MEMAI CPA_EXPORT  tdstBlockInfo g_a_stAIBlocksInfo[E_ucAIMaxBlocksNb];
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN_MEMAI CPA_EXPORT  tdstDynInfo g_stAIDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#endif /*__MmgAI_H__*/
