/*
------------------------------------------------------------------------------------------
HEADER FILE FOR :
memory definition file for mathematic module
------------------------------------------------------------------------------------------
File Name :
MemMth.h
------------------------------------------------------------------------------------------
Creation :
  * Date : 
    Feburary 18,1997
  * Author : 
    Albert Pais
------------------------------------------------------------------------------------------
Contents :
This file contains definition for the memory management concerning the mathematical
module
------------------------------------------------------------------------------------------
Modification :
  * Date : 
 
  * Author : 
 
  * Modify :
------------------------------------------------------------------------------------------
*/
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#ifndef __MemMth_H__
#define __MemMth_H__
 
enum e_ucMthStaticBlocks{
	E_ucMTHBlock1, /* Not used now*/
	E_ucMTHMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
};
 
#undef EXTERN
#undef extern
#ifdef __DeclareGlobalVariableMemMth_h__
#define EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMemMth_h__*/
#define EXTERN extern
#endif /*__DeclareGlobalVariableMemMth_h__*/
 
EXTERN CPA_EXPORT  tdstBlockInfo g_a_stMTHBlocksInfo[E_ucMTHMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN CPA_EXPORT  tdstDynInfo g_stMTHDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#undef extern
 
#endif /*__MemMth_H__*/
