/*///////////////////////////////////////////////////////////*/
/**/
/*		Memory Management of the Module : AIDebug*/
/**/
/* File Name	: MmgAIDebug.h*/
/* Date			: 703/10/96*/
/* Author		: First_Name Last_Name*/
/**/
/*///////////////////////////////////////////////////////////*/
#ifndef __MmgAIDebug_H__
#define __MmgAIDebug_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "MMG.h"
 
typedef enum e_ucAIDebugStaticBlocks_{
	E_ucAIDebugBlock1, /* Not used now*/
	E_ucAIDebugMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucAIDebugStaticBlocks;
 
#undef __MMGAIDEBUG_EXTERN
#ifdef __DeclareGlobalVariableMmgAIDebug_h__
#define __MMGAIDEBUG_EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgAIDebug_h__*/
#define __MMGAIDEBUG_EXTERN extern
#endif /*__DeclareGlobalVariableMmgAIDebug_h__*/
 
__MMGAIDEBUG_EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stAIDebugBlocksInfo[E_ucAIDebugMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
__MMGAIDEBUG_EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stAIDebugDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MmgAIDebug_H__*/
