/*=========================================================================
* 
* EDTdMove.h :  class EDT_DialogMove
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR


#ifndef __DIALOGMOVE_H__
#define __DIALOGMOVE_H__

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#include "EDTRes.h"

class EDT_HierarchyEditor;
class CPA_Interface;

/*===========================================================================
*		Description:	EDT_DialogMove dialog
*		Creation date:
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                        Author:
*=========================================================================*/

class EDT_DialogMove : public CDialog
{
protected:
	EDT_HierarchyEditor		*m_pEditor;
	BOOL					m_bAcceptModif;

public:
// parent editor
	EDT_HierarchyEditor * GetParentEditor	(void) { return m_pEditor; }
	CPA_Interface		* GetInterface		(void);

// standard constructor
	EDT_DialogMove (CWnd* pParent = NULL);   
// dialog
	BOOL fn_bDoDialog (EDT_HierarchyEditor *pEditor);


// Dialog Data
	//{{AFX_DATA(EDT_DialogMove)
	enum { IDD = EDT_IDD_DIALOGMOVE };
	CListBox	m_cListObject;
	CListBox	m_cListParent;
	CListBox	m_cListSector;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EDT_DialogMove)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EDT_DialogMove)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__DIALOGMOVE_H__
#endif // ACTIVE_EDITOR
