/*******************************************************/
/**** For the structures and variables declarations ****/
/*******************************************************/
#define D_SectInfo_StructureDefine
#define D_SectInfo_VariableDefine
 
#include "ToolsCPA.h"
 
#include "Options/Options.h"
#include "Macros.h"
 
#include "Actions/AllActs.h"
 
#include "Structur/MemGame.h"
#include "Structur/ErrGame.h"
#include "Structur/Objects.h"
#include "Structur/GameScpt.h"
#include "Structur/StdObjSt.h"
#include "Structur/EngMode.h" 
#include "Structur/anim_s.h"
 
#include "Basic.h"
#include "GameEng.h"
#include "micros.h"
#include "MainChar.h"
#include "ObjInit.h"
#include "ZeMem.h"
#include "AlwAct.h"
#include "Playanim/playanim.h"
 
#ifdef GAM_USE_SNA
#include "sna.h"
#endif /* GAM_USE_SNA */
 
#include "always.h"
extern BOOL bFirst;
 
#if defined(GAM_USE_SNA)
extern tdstEngineObject *g_a20_stSNAObjectsInFix[20];
extern unsigned long g_ulSNANbObjectsInFix;
#endif /* GAM_USE_SNA */
 
#include "ldt.h"
 
 
 
/*****************************************************************
Function name   : fn_iCreateSectInfo
Description     : 
Author          : Ovidiu Scripa (oscripa@ubisoft.ro) - ROMTEAM
Creation Date   : 13-Oct-98
Modified        : 
Return type     : int 
Argument        : LDT_tdst_Link *pLink
*****************************************************************/
int fn_iCreateSectInfo( LDT_tdst_Link *pLink )
{
	MS_tdxHandleToSectInfo h_SectInfo;
	struct tdstEngineObject_ *p_stEngineObject = (struct tdstEngineObject_ *)pLink->pParent->pObject;
 
    MMG_fn_vBeginMemoryInfo (MMG_C_lTypeMiniStructure , MMG_C_lSubTypeSectInfo , p_stEngineObject);
	h_SectInfo = fn_h_SectInfoRealAlloc();
    MMG_fn_vEndMemoryInfo ();
 
	h_SectInfo->hCurrentSector=NULL;
	p_stEngineObject->h_SectInfo=h_SectInfo;
 
	pLink->pObject = (void*)h_SectInfo;
 
  return 0;
}
 
/* load for 'SectInfo' section is default*/
