#ifndef __FONMEM_H__
#define __FONMEM_H__
 
#include "CPA_Expt.h"
 
#ifdef  __cplusplus
extern "C" {
#endif
 
#include "mmg.h"
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
enum e_ucFONStaticBlocks
{
	E_ucFONTextMemoryBlock,
	/*E_ucFONMemoryBlock,*/
	E_ucFONMaxBlocksNb
};
 
#undef EXTERN
#undef extern
#if !defined(FON_MainFile)
#define EXTERN extern
#else
#define EXTERN
#endif /* MNU_MainFile */
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
EXTERN tdstBlockInfo g_a_stFONBlocksInfo[E_ucFONMaxBlocksNb];
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN tdstDynInfo g_stFONDynInfo;
#endif /* __DEBUG_MALLOC_MODE__ */
#endif /* __DYNAMIC_MALLOC_ALLOWED__ */
 
#undef EXTERN
#undef extern
 
extern CPA_EXPORT void *FON_fn_p_vAllocInBloc(enum e_ucFONStaticBlocks eBloc,unsigned long lSize);
extern CPA_EXPORT void *FON_fn_p_vReallocInBloc(enum e_ucFONStaticBlocks eBloc,void *p_vPointer,unsigned long lSize);
extern CPA_EXPORT void FON_fn_vFreeInBloc(enum e_ucFONStaticBlocks eBloc,void *p_vPointer);
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __FONMEM_H__ */
