/*=========================================================================
* DspFix.c : Display fix module
* This is a part of the Game project.
*
* Version              1.0
* Creation date        04/05/97
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1997
*=======================================================================*/
#if !defined(__DspFix_h__)
#define __DspFix_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
typedef struct tdstDisplayVignetteDuringPlaying_
{
	unsigned char bAskToDisplayVignette;
	char szName[_MAX_PATH];
#ifdef GAM_VIGNETTE
	struct VIG_tdstVignetteStructure_ stVignette;
#endif /* GAM_VIGNETTE */
} tdstDisplayVignetteDuringPlaying;
 
extern void fn_vAskToDisplayVignette(char *szName);
 
extern void fn_vDisplayFix(void);
EXTERN tdstDisplayVignetteDuringPlaying g_stDisplayVignetteDuringPlaying;
	
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __DspFix_h__ */
