/*
 =======================================================================================
  Name        : DX6_Choose.h
  Author      : vincent lhullier            Date :21/08/98
  Description : choose DirectX modes
 =======================================================================================
 */
 
#ifndef __DX6_CHOOSE_H__
#define __DX6_CHOOSE_H__
 
#include <d3d.h>
 
#define DX6_C_Dev_Hardware          0x00000001
 
/*
 =======================================================================================
    Main function
 =======================================================================================
 */
 
void GLI_fn_vChooseDisplay( void );
 
/*
 =======================================================================================
    Access functions
 =======================================================================================
 */
 
/*
 * for device
 */
char            GLIDX6_fnc_IsHardware( void );
long            GLIDX6_fnl_GetDeviceFlag( void );
D3DDEVICEDESC * GLIDX6_fnpst_GetDeviceDesc( void );
 
#endif /*__DX6_CHOOSE_H__*/
