#ifndef __TEXBENCH_H__
#define __TEXBENCH_H__
 
/*#define BENCH_TEXTURE*/
 
#ifdef BENCH_TEXTURE
 
#include "textu_st.h"
 
#define TEXBENCH_C_cComputedSize		0
#define TEXBENCH_C_cRealSize			1

#define TEXBENCH_C_cBeginUnload         0
#define TEXBENCH_C_cEndUnload           1
#define TEXBENCH_C_cBeginUncompress     2
#define TEXBENCH_C_cEndUncompress       3
#define TEXBENCH_C_cBeginCompression    4
#define TEXBENCH_C_cEndcompression      5
#define TEXBENCH_C_cBeginComputeLod     6
#define TEXBENCH_C_cEndComputeLod       7
#define TEXBENCH_C_cBeginDownload       8
#define TEXBENCH_C_cEndDownload         9
#define TEXBENCH_C_cBeginDownload1     10
#define TEXBENCH_C_cEndDownload1       11
#define TEXBENCH_C_cBeginDownload2     12
#define TEXBENCH_C_cEndDownload2       13
#define TEXBENCH_C_cBeginDownload3     14
#define TEXBENCH_C_cEndDownload3       15


void TEXBENCH_fn_vInitTextureSize( void );
void TEXBENCH_fn_vSetTextureSizeWithIndex( long _lTextureIndex, char _cSizeType, long _lSize );
void TEXBENCH_fn_vSetTextureSize( GLI_tdstTexture *_p_stTexture, char _cSizeType, long _lSize );
void TEXBENCH_fn_vWriteSizeInFile( void );
void TEXBENCH_fn_vSetTime( char _cFor );
 
#else
 
#define TEXBENCH_fn_vInitTextureSize()
#define TEXBENCH_fn_vSetTextureSizeWithIndex( a, b, c)
#define TEXBENCH_fn_vSetTextureSize( a, b, c )
#define TEXBENCH_fn_vWriteSizeInFile()
#define TEXBENCH_fn_vSetTime( a )
 
#endif
 
#endif /*__TEXBENCH_H__*/
