/*
 =======================================================================================
  Name        : TexName.h
  Author      : GLIGLOU corporation
  Description : Fonction for texture name analysis / storage
 =======================================================================================
 */
 
#ifndef __TEXNAME_H__
#define __TEXNAME_H__
 
#include "texture.h"
  
#ifdef __cplusplus
extern "C" 
{
#endif
 
 
/*
 * Analyse name of texture 
 */
long GLI_fn_lAnalyseTextureName( char *_szFileName, long *_p_lTextureCaps, unsigned char *_p_ucCyclingMode );
void TEX_fnv_FixTextureName(char *_pszOut, char *_pszIn);

#ifdef __cplusplus
}
#endif
 
 
#endif
