/*
 =======================================================================================
  Name        : TexProcedural.c
  Author      : vincent lhullier            Date :01/02/99
  Description : function for procedural texture
 =======================================================================================
 */
 
#ifdef PROCEDURAL_TEXTURE
 
#ifndef __TEX_PROCEDURAL_H__
#define __TEX_PROCEDURAL_H__
 
#include "textu_st.h"
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/*
 =======================================================================================
    Structure 
 =======================================================================================
 */
 
/*
typedef struct
{
    long            lFlags;
    GLI_tdstTexture *pst_Texture;
} TEX_tdstProceduralData;
*/
 
long TEXPRO_fnl_InitProceduralTexture( GLI_tdstTexture *_pst_Texture, long _l_Type, long _l_Width, long _l_Height, long _l_RefreshRate );
long TEXPRO_fnl_InitProceduralTextureWithName( GLI_tdstTexture *_pst_Texture, char *_sz_ProcName, long _l_Width, long _l_Height, long _l_RefreshRate );
void TEXPRO_fnv_RefreshProceduralTexture( GLI_tdstTexture *_pst_Texture, long _l_ActualRefreshNumber );
 
 
 
#ifdef __cplusplus
}
#endif /* __cplusplus */
 
 
#endif /*__TEX_PROCEDURAL_H__*/
 
#else /*PROCEDURAL_TEXTURE*/
 
#define TEXPRO_fnl_InitProceduralTexture(a,b,c,d,e)
#define TEXPRO_fnl_InitProceduralTextureWithName(a,b,c,d,e)
#define TEXPRO_fnv_RefreshProceduralTexture(a,b)
 
#endif /*PROCEDURAL_TEXTURE*/
 
