/**********************************************************
 *                                                        *
 *                   Magnet                               *
 *                                                        *
 * Author : Ubi China - Marc Trabucato                    *
 *                                                        *
 **********************************************************/
 
#if !defined( _MGTINIT_H_ )
#define _MGTINIT_H_
 
/*************************************************************************************************/
#include "cpa_expt.h"
 
#include "MGT\MGTStruc.h"
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/*************************************************************************************************/
 
extern CPA_EXPORT void MGT_fn_vAddObjectToMagnetList        ( HIE_tdxHandleToSuperObject p_stObject );
extern CPA_EXPORT void MGT_fn_vDeleteObjectFromMagnetList   ( HIE_tdxHandleToSuperObject p_stObject );
extern CPA_EXPORT void MGT_fn_vFirstInitMagnet				( void );
extern CPA_EXPORT void MGT_fn_vLastDesInitMagnet			( void );
 
/*************************************************************************************************/
 
void MGT_fn_vDeleteMagnetFromMagnetList   ( ACP_tdxIndex x_Magnet );
void MGT_fn_vDeleteMagnet                 ( ACP_tdxIndex x_Magnet );
void MGT_fn_vDeleteMSMagnetIfNeeded       ( ACP_tdxIndex x_Magnet );
void MGT_fn_vUpdateModifiedObjectsList	  ( void );
void MGT_fn_vUpdateActivatedMagnetsList	  ( void );
 
/*************************************************************************************************/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
/*************************************************************************************************/
 
#endif /* _MGTINIT_H_ */
