// Constants definition for the Charactersitics Editor
////////////////////////////////////////////////////////
#ifndef _EDCAR_CONST_HPP_
#define _EDCAR_CONST_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//Definitions for Editor
#define C_EDITOR_SUBSTRACTED_HEIGHT		0
#define C_EDITOR_WIDTH								250
#define C_SCROLLBAR_WIDTH							7

//Definitions for MS placing
#define C_SPACE_FOR_BORDER						2
#define C_MS_LINE_HEIGHT							20
#define C_MS_SPACING									3

//Definitions for MS internal controls
#define C_TABULATION									0
#define C_ALLOC_BUTTON_PERCENT_WIDTH	20

//Definitions for special tool tips windows
#define C_TTIPS_SPACING								4

//Definitions for Actors' View
//Defines for next/prev buttons display
#define C_BUTTON_SIZE_H								32
#define C_BUTTON_SIZE_V								20

//Definitions for Main View
#define C_MAIN_VIEW_SPACING						2

//Definitions for Buttons
#define C_BUTTON_MARGIN								3

//Definitions for Spin Buttons
#define C_SPIN_PRECISION							3
#define C_ACCEL_NB										5

//Global definitions for control
#define C_SPACE_BETWEEN_CONTROLS			2
#define C_EDIT_HEIGHT									16

//Definitions for ObjectList control
#define C_OLIST_BOX_TOTAL_HEIGHT			80
#define C_OLIST_COMBO_BOX_HEIGHT			20
#define C_OLIST_BOX_PERCENT_WIDTH			55
#define C_OLIST_BOX_MIN_WIDTH					60
#define C_OLIST_NAME_PERCENT_WIDTH		20
#define C_OLIST_BUTTON_PERCENT_WIDTH	22
#define C_OLIST_BUTTON_MIN_WIDTH			25
#define C_OLIST_BUTTON_HEIGHT					19

//Definitions for Actions/States control
#define C_STATE_NAME_PERCENT_WIDTH			50
#define C_STATE_NAME_MIN_WIDTH					40
#define C_STATE_COMBO_BOX_PERCENT_WIDTH	50
#define C_STATE_COMBO_BOX_MIN_WIDTH			40
#define C_STATE_COMBO_BOX_HEIGHT				20
#define C_STATE_STATIC_NAME_PERCENT_WIDTH		30
#define C_STATE_STATIC_PERCENT_WIDTH		50
#define C_STATE_STATIC_MIN_WIDTH				30
#define C_STATE_STATIC_HEIGHT						20
#define C_STATE_BUTTON_PERCENT_WIDTH		20
#define C_STATE_BUTTON_MIN_WIDTH				20
#define C_STATE_BUTTON_HEIGHT						20

//For Dialog Lists
#define EDAC_C_szFamiliesList				"Families"
#define EDAC_C_szModelsList					"Models"
#define EDAC_C_szInstancesList			"Instances"
//CPA2 Stegaru Cristian 98-05
#define EDAC_C_szAlwaysList					"Loaded Always"
//End CPA2 Stegaru Cristian 98-05
#define EDAC_C_szTreeView						"Tree View"
//CPA2 Stegaru Cristian 98-05
#define EDAC_C_szUnloadedAlwaysList			"Unloaded Always"
//End CPA2 Stegaru Cristian 98-05

#endif //_EDCAR_CONST_HPP_
