// EdActors_Dialog_InconsistentAllocations dialog
/////////////////////////////////////////////////////////////////////////////
#ifndef _ED_ACTORS_DIALOG_INCONSISTENT_ALLOCATION_
#define _ED_ACTORS_DIALOG_INCONSISTENT_ALLOCATION_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EDACIRes.h"

class CPA_Actor;
class EdActors_ActorMiniStructure;

class EdActors_Dialog_InconsistentAllocations : public CDialog
{
// Construction
public:
	// standard constructor
	EdActors_Dialog_InconsistentAllocations(CPA_Actor *_pclModel,
																					CPA_Actor *_pclInstance,
																					BOOL _bAllocatedInModel,
																					EdActors_ActorMiniStructure *_pclModelAMS,
																					EdActors_ActorMiniStructure *_pclInstanceAMS,
																					CWnd* pParent = NULL);


// Dialog Data
	//{{AFX_DATA(EdActors_Dialog_InconsistentAllocations)
	enum { IDD = IDD_CAR_PB_ALLOCATION };
	int		m_iRadioValue;
	CString	m_csText;
	//}}AFX_DATA

private:
	BOOL m_pri_bAllocatedInModel;
	
	EdActors_ActorMiniStructure *m_pri_pclInstanceAMS;
	EdActors_ActorMiniStructure *m_pri_pclModelAMS;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EdActors_Dialog_InconsistentAllocations)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EdActors_Dialog_InconsistentAllocations)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	
	
	DECLARE_MESSAGE_MAP()
};

#endif //_ED_ACTORS_DIALOG_INCONSISTENT_ALLOCATION_
