#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// cpacdgol.hpp : header file
#include "EdAcIRes.h"
#include "acp_base.h"
//#include "cpadllb.hpp"

/////////////////////////////////////////////////////////////////////////////
// EdActors_EditObjectListsDialog dialog

class EdActors_EditorActorInstance;
class EdtList;

typedef struct tdstCarEditObjectListsDialogArgs_
{
 struct
 {
  EdActors_EditorActorInstance *p_oEditorActor;
  EdtList *p_oCurrentObjectList;
  EdtList *p_oDefaultSelectedObjectList;
  const char *p_c_szObjectListType;
 } stIn;
 struct
 {
  EdtList *p_oLastSelectedObjectList;
  EdtList *p_oDefaultSelectedObjectList;
 } stOut;
} tdstCarEditObjectListsDialogArgs;


class EdActors_EditObjectListsDialog : public CDialog
{
// Construction
public:
 EdActors_EditObjectListsDialog(tdstCarEditObjectListsDialogArgs *p_stArgs, CWnd* pParent = NULL);   // standard constructor
 ~EdActors_EditObjectListsDialog(); //bbb 25/03/97
 tdstCarEditObjectListsDialogArgs *m_p_stArgs;

// Dialog Data
	//{{AFX_DATA(EdActors_EditObjectListsDialog)
	enum { IDD = IDD_CAR_DIALOG_OBJECTLIST_CHOICE };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EdActors_EditObjectListsDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
 CEdit *m_p_oListNameEdit;
 CComboBox *m_p_oListNameCombo;
 //bbb 25/03/97 {
 CButton *m_p_oListRenameButton, *m_p_oListSetDefaultButton, *m_p_oButtonMessage;
 CStatic *m_p_oStaticTitle;
 CFont   m_oBoldFont;
 //bbb 25/03/97 }


	// Generated message map functions
	//{{AFX_MSG(EdActors_EditObjectListsDialog)
	afx_msg void OnOlcSetDefaultButtonClicked();
	afx_msg void OnOlcRenameButtonClicked();
	afx_msg void OnOlcObjListsComboSelChange();
	afx_msg void OnOlcEditNameChange();
	virtual BOOL OnInitDialog();
 afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct); //bbb 25/03/97
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
