#if !defined(AFX_DLGCLEANALWFILE_H__8DE5049D_10B9_11D2_B421_00A0244F34C3__INCLUDED_)
#define AFX_DLGCLEANALWFILE_H__8DE5049D_10B9_11D2_B421_00A0244F34C3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// dlgcleanalwfile.h : header file
//

#define LEFT			0
#define RIGHT			1
#define COLUMNS			2

#define TASK_CLEAN_ALW_FILE		0
#define TASK_UPDATE_ALW_FILE	1

/////////////////////////////////////////////////////////////////////////////
// CDlgCleanAlwFile dialog

class CDlgCleanAlwFile : public CDialog
{
// Construction
public:
	CDlgCleanAlwFile(CStringList &rlstOfAlways, int nCurrentTask = TASK_CLEAN_ALW_FILE, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgCleanAlwFile)
	enum { IDD = IDD_CLEAN_ALW_FILE };
	CListBox	m_lstAlways;
	CListBox	m_lstAlwaysToBeRemoved;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCleanAlwFile)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CStringList &m_rlstOfAlways;
	int			m_nCurrentTask;
	const static CString		m_aColumnHeaders [][COLUMNS];
	const static CString		m_aDlgTitle [];
	const static CString		m_aOKText [];
	// Generated message map functions
	//{{AFX_MSG(CDlgCleanAlwFile)
	afx_msg void OnLeft();
	afx_msg void OnRight();
	afx_msg void OnRightAll();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnDblclkLoadedAlways();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGCLEANALWFILE_H__8DE5049D_10B9_11D2_B421_00A0244F34C3__INCLUDED_)
