#if !defined(AFX_DLGSELECTINSTANCES_H__5967B56D_0C08_11D2_B41C_00A0244F34C3__INCLUDED_)
#define AFX_DLGSELECTINSTANCES_H__5967B56D_0C08_11D2_B41C_00A0244F34C3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// dlgselectinstances.h : header file
//

#define REGULAR_INSTANCE		1
#define STANDARD_INSTANCE		2
#define TEXT_LENGTH				256
/////////////////////////////////////////////////////////////////////////////
// CDlgSelectInstances dialog

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Class	: CSimpleCheckListBox 
// Date		: 98/06/25
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description	:
// Author		: Stegaru Cristian - CPA
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification	: 
// Date			:
// By			:
//////////////////////////////////////////////////////////////////////////////////////////////////////
class CSimpleCheckListBox : public CCheckListBox
{
	DECLARE_DYNAMIC (CSimpleCheckListBox)
public:
	CSimpleCheckListBox ();
	virtual void DrawItem (LPDRAWITEMSTRUCT pDrawItemStruct);
};


//////////////////////////////////////////////////////////////////////////////////////////////////////
// Class	: CDlgSelectInstances 
// Date		: 98/06/25
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Description	:
// Author		: Stegaru Cristian - CPA
//////////////////////////////////////////////////////////////////////////////////////////////////////
// Modification	: 
// Date			:
// By			:
//////////////////////////////////////////////////////////////////////////////////////////////////////
class CDlgSelectInstances : public CDialog
{
private:
	CStringList		&m_rlstAllInstances;
	CStringList		&m_rlstStandardInstances;

	BOOL			m_bAllInstances;

	mfn_bIsAStandardInstance (CString csInstanceName);
// Construction
public:
	CDlgSelectInstances(CStringList &rlstAllInstances, CStringList &rlstStandardInstances, CWnd* pParent = NULL);   // standard constructor
	BOOL mfn_bProcessAllInstances () { return m_bAllInstances;}
// Dialog Data
	//{{AFX_DATA(CDlgSelectInstances)
	enum { IDD = IDD_PROPAGATE_INSTANCES };
	CSimpleCheckListBox	m_lstInstances;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgSelectInstances)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgSelectInstances)
	afx_msg void OnCheckAll();
	afx_msg void OnCheckStandard();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeListInstances();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGSELECTINSTANCES_H__5967B56D_0C08_11D2_B41C_00A0244F34C3__INCLUDED_)
