#if !defined(AFX_PAGEROTCENTER_HPP__CC24C3C9_DC14_11D0_BE57_00609775AC86__INCLUDED_)
#define AFX_PAGEROTCENTER_HPP__CC24C3C9_DC14_11D0_BE57_00609775AC86__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// pagerotcenter.hpp : header file
//

#include "pagebase.hpp"
#include "incitf.h"

class Camera;
class CPA_SuperObject;
/////////////////////////////////////////////////////////////////////////////
// PageRotationCenter dialog

class PageRotationCenter : public PageBase
{

// Construction
public:
	PageRotationCenter(Camera* p_oCamera);
	~PageRotationCenter();

	BOOL IsPageValid();
	void MakeChangesAvailable();
	void DoUpdate();

private:
	BOOL CheckComboSO();
	BOOL CheckRotationCenterType();

	
	// Dialog Data
	//{{AFX_DATA(PageRotationCenter)
	enum { IDD = IDD_PROPPAGE_ROTATIONCENTER };
	CComboBox	m_oComboSO;
	CString		m_csPointX;
	CString		m_csPointY;
	CString		m_csPointZ;
	CString		m_csSuperObjectX;
	CString		m_csSuperObjectY;
	CString		m_csSuperObjectZ;
	int			m_iRotationCenterType;
	int			m_iPointCoords;
	CString		m_csComboEdit;
	BOOL		m_bPointRelative;
	//}}AFX_DATA

private:
	Camera *m_p_oCamera;
	long	m_lIDofCurrentEdit;

	CPA_CameraCoords		m_oRotationCenterPoint;
	CPA_SuperObject			*m_p_oRotationCenterSuperObject;
	tdeRotationCenterType	m_eRotationCenterType;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(PageRotationCenter)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(PageRotationCenter)
	afx_msg void OnBtCopytopoint();
	afx_msg void OnBtReturn();
	afx_msg void OnKillfocusEditPointx();
	afx_msg void OnSetfocusEditPointx();
	afx_msg void OnKillfocusEditPointy();
	afx_msg void OnSetfocusEditPointy();
	afx_msg void OnKillfocusEditPointz();
	afx_msg void OnSetfocusEditPointz();
	virtual BOOL OnInitDialog();
	afx_msg void OnRbPointCoords();
	afx_msg void OnSelChangeComboSO();
	afx_msg void OnEditChangeComboSO();
	afx_msg void OnSetfocusComboso();
	afx_msg void OnKillfocusComboso();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGEROTCENTER_HPP__CC24C3C9_DC14_11D0_BE57_00609775AC86__INCLUDED_)
