// DlgCon3D.hpp : header file
//

#ifndef __DLGCON3D_HPP__
#define __DLGCON3D_HPP__

#include "3DGe_res.h"

class Cone3D;

/////////////////////////////////////////////////////////////////////////////
// CDlgCone3D dialog

class CDlgCone3D : public CDialog
{
// Construction
public:
	CDlgCone3D (Cone3D * pCone3D, CWnd * pParent = NULL);

    // Dialog Data
	//{{AFX_DATA(CDlgCone3D)
	enum { IDD = IDD_DIALOGCONE3D };
	CString	m_Edition_Zone_Angle;
	CString	m_Edition_Zone_Radius;
	CString	m_Edition_Zone_X_Base;
	CString	m_Edition_Zone_X_Top;
	CString	m_Edition_Zone_Y_Base;
	CString	m_Edition_Zone_Y_Top;
	CString	m_Edition_Zone_Z_Base;
	CString	m_Edition_Zone_Z_Top;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCone3D)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:

    // Generated message map functions
	//{{AFX_MSG(CDlgCone3D)
	virtual BOOL OnInitDialog();
	afx_msg void On_Change_Edition_Zone_Angle();
	afx_msg void On_Change_Edition_Zone_Radius();
	afx_msg void On_Change_Edition_Zone_X_Base();
	afx_msg void On_Change_Edition_Zone_X_Top();
	afx_msg void On_Change_Edition_Zone_Y_Base();
	afx_msg void On_Change_Edition_Zone_Y_Top();
	afx_msg void On_Change_Edition_Zone_Z_Base();
	afx_msg void On_Change_Edition_Zone_Z_Top();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Personal data
private:
	Cone3D   * m_pCone3D;
	MTH3D_tdstVector m_InitialTop;
	MTH3D_tdstVector m_InitialBase;
	GLI_tdxValue m_InitialRadius;
	GLI_tdxValue m_InitialAngle;

    void RefreshData ();     
	void RedrawBackground ();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __DLGCON3D_HPP__
