//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : DlgITCone.hpp: interface for the DlgITCone class.
// Author      : Ionut Grozea
// Date        : 97.11
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#ifndef __AFX_DLGITCONE_HPP__
#define __AFX_DLGITCONE_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "3dge_res.h"
#include "stdafx.h"

class ITCon3D;
 

/////////////////////////////////////////////////////////////////////////////
// DlgITCone dialog

class DlgITCone : public CDialog
{
// Construction
public:
	DlgITCone(ITCon3D * pCon , float  Radius , float  Height ,int Nt , int Ns , CWnd* pParent =NULL);
	int    mfn_iGetIntPos(float fVal);
	float  mfn_fSliderInt2Float(int sliderVal);
	ITCon3D * m_poCon;
	float	m_fHeightOld;
	float	m_fRadiusOld;
	int		m_iNxOld;
	int		m_iNyOld;

// Dialog Data
	//{{AFX_DATA(DlgITCone)
	enum { IDD = IDD_DIALOGCONE };
	CSliderCtrl	m_SliderY;
	CSliderCtrl	m_SliderX;
	CSliderCtrl	m_fSliderRadius;
	CSliderCtrl	m_fSliderHeight;
	float	m_fHeight;
	float	m_fRadius;
	int		m_iNx;
	int		m_iNy;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DlgITCone)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(DlgITCone)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeEditheight();
	afx_msg void OnChangeEditradius();
	afx_msg void OnChangeEditx();
	afx_msg void OnChangeEdity();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.
#endif // __AFX_DLGITCONE_HPP__
