// DSphere.h : header file
//

#ifndef __DLGSPH3D_HPP__
#define __DLGSPH3D_HPP__

#include "3DGe_res.h"

class Sphere3D;

/////////////////////////////////////////////////////////////////////////////
// CDlgSphere3D dialog

class CDlgSphere3D : public CDialog
{
// Construction
public:
	CDlgSphere3D(Sphere3D *pSphere, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgSphere3D)
	enum { IDD = IDD_DIALOGSPHERE3D };
	CSliderCtrl	m_Slider_Radius;
	CString	m_Center_X;
	CString	m_Center_Y;
	CString	m_Center_Z;
	CString	m_Radius;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgSphere3D)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgSphere3D)
	afx_msg void OnChangeEditRadius();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeEditCenterX();
	afx_msg void OnChangeEditCenterY();
	afx_msg void OnChangeEditCenterZ();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	Sphere3D *m_pSphere3D;
	GLI_tdxValue m_InitialRadius;
	MTH3D_tdstVector m_InitialCenter;

	void RefreshSlider ();
    void RefreshRadiusFromSlider ();
    void RefreshData ();     
	void RedrawBackground ();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !__DLGSPH3D_HPP__
