// DlgAltimap3D.h : header file
//
#ifndef __DLGALT3D_HPP__
#define __DLGALT3D_HPP__

#include "3DGe_res.h"

class Altimap3D;

/////////////////////////////////////////////////////////////////////////////
// CDlgAltimap3D dialog

class CDlgAltimap3D : public CDialog
{
// Construction
public:
	void RefreshData (void);
	void RefreshSquare (void);
	CDlgAltimap3D(Altimap3D *pAltimap3D,CWnd* pParent = NULL);   // standard constructor

	Altimap3D		*m_pAltimap3D;

	BOOL			m_bSquareOrientation;
	BOOL			m_bSetLeft;
	BOOL			m_bSetRight;

	unsigned char	m_ucSquareType;

// Dialog Data
	//{{AFX_DATA(CDlgAltimap3D)
	enum { IDD = IDD_ALTIMAP3D };
	CBitmapButton	m_btnSquareOrientation;
	CBitmapButton	m_btnSetLeft;
	CBitmapButton	m_btnSetRight;
	CSliderCtrl	m_Slider_SizeY;
	CSliderCtrl	m_Slider_SizeX;
	CSliderCtrl	m_Slider_NbY;
	CSliderCtrl	m_Slider_NbX;
	int		m_iNbY;
	float	m_SizeX;
	float	m_SizeY;
	int		m_iNbX;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgAltimap3D)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgAltimap3D)
	virtual BOOL OnInitDialog();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnKillfocusNbx();
	afx_msg void OnKillfocusNby();
	afx_msg void OnKillfocusSizex();
	afx_msg void OnKillfocusSizey();
	afx_msg void OnSetOrientation();
	afx_msg void OnSetLeft();
	afx_msg void OnSetRight();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __DLGALT3D_HPP__
