//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : CDlgITSphere.hpp: interface for the CDlgITSphere class.
// Author      : Ionut Grozea
// Date        : 97.11
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#ifndef __AFX_DLGITSPHERE_HPP__
#define __AFX_DLGITSPHERE_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "3dge_res.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgITSphere dialog
class ITSphere3D;
class CDlgITSphere : public CDialog
{
// Construction
public:
	float mfn_fSliderInt2Float(int);
	CSliderCtrl* mfn_poGetSlider1();
	CSliderCtrl* mfn_poGetSlider2();
	CSliderCtrl* mfn_poGetSlider3();
	CDlgITSphere(float radius,int m_Ns,int m_Nt ,ITSphere3D*pSphere, CWnd* pParent = NULL);   // standard constructor
	ITSphere3D* m_poSphere;
// Dialog Data
	//{{AFX_DATA(CDlgITSphere)
	enum { IDD = IDD_DIALOGSPHERE };
	float	m_fRadius;
	int m_Nx;
	int m_Ny;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgITSphere)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int mfn_iGetIntPos(float);
	float m_fRadiusOld ;
	int m_NxOld;
	int m_NyOld;


	// Generated message map functions
	//{{AFX_MSG(CDlgITSphere)
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeEdit1();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChangeEdit2();
	afx_msg void OnChangeEdit3();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __AFX_DLGITSPHERE_HPP__
