//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : EdThread.h: interface for the CEdThread class.
// Author      : 
// Date        : 
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#ifndef __AFX_EDTHREAD_HPP__
#define __AFX_EDTHREAD_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// EdThread.h : header file
//



/////////////////////////////////////////////////////////////////////////////
// CEdThread thread
class CTriEdit;
class CIndexedTriangleFrame;
class CPA_ObjectDLLBase;
class CEdThread : public CWinThread
{
	DECLARE_DYNCREATE(CEdThread)
protected:
	CEdThread();           // protected constructor used by dynamic creation
	Geometry3D_Interface	*m_pLinkDll;
// Attributes
public:
	 static BOOL m_bAlreadyRunning;
private:
	CIndexedTriangleFrame *m_pFrame;
	CSingleDocTemplate *m_pDocTemplate;
// Operations
//ROMTEAM WorldEditor (Cristian Stegaru 11/97)
public:
	void mfn_vLinkToDll (Geometry3D_Interface	*pLinkDll) {m_pLinkDll = pLinkDll;}
	CTriEdit* mfn_pGetITEditor ();
	BOOL mfn_bCreateITObject (CTriEdit *pITEditor, CString csName);
//ENDROMTEAM WorldEditor (Cristian Stegaru)

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEdThread)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CEdThread();

	// Generated message map functions
	//{{AFX_MSG(CEdThread)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __AFX_EDTHREAD_HPP__
