//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : EToolBar.h
// Author      : Cristian S
// Date        : 97.11
// Description :
////////////////////////////////////////////////////////////////////////////////////////

#ifndef __AFX_EDITOR_TOOLBAR_HPP__
#define __AFX_EDITOR_TOOLBAR_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CIndexedTriangleView;
class CEditorToolBar : public CToolBar
{
private:
	//attributes
	CStatic		m_stName,
				m_stXNb,
				m_stYNb;
	CEdit		m_edName,
				m_edXNb,
				m_edYNb;
	CSliderCtrl	m_Slider;

	int			m_iXNb;
	int			m_iYNb;
	CString		m_csName;

public:
	//methods
	CEditorToolBar ();
	~CEditorToolBar ();
	BOOL Init (CWnd *pParent);
	CIndexedTriangleView* GetView ();

	void UpdateData (BOOL bGet = TRUE);
	int SetXNb (int iXNb) { return m_iXNb = iXNb; }
	int GetXNb () { return m_iXNb; }
	int SetYNb (int iYNb) { return m_iYNb = iYNb; }
	int GetYNb () { return m_iYNb; }
	CString SetName (CString csName) { return m_csName = csName; }
	CString GetName () { return m_csName; }
	void SetAttributes (int iXNb, int iYNb, CString csName) 
	{ 
		m_iXNb = iXNb;
		m_iYNb = iYNb; 
		m_csName = csName;
		UpdateData (FALSE);
	}
	void GetAttributes (int &riXNb, int &riYNb, CString &rcsName) 
	{ 
		UpdateData ();
		riXNb = m_iXNb;
		riYNb = m_iYNb; 
		rcsName = m_csName;
	}

protected:
	//{{AFX_MSG(CEditorToolBar)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif //__AFX_EDITOR_TOOLBAR_HPP__