//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : ITFrame.h: interface for the CIndexedTriangleFrame class.
// Author      : 
// Date        : 
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#ifndef __INDEXEDTRIANGLEFRAME_HPP__
#define __INDEXEDTRIANGLEFRAME_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// IndexedTriangleFrame.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CIndexedTriangleFrame frame
class CTriEdit;
class CIndexedTriangleFrame : public CFrameWnd
{
	DECLARE_DYNCREATE(CIndexedTriangleFrame)

protected:
	CIndexedTriangleFrame();           // protected constructor used by dynamic creation
	CEditorToolBar m_wndToolBar;
// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIndexedTriangleFrame)
	public:
	//}}AFX_VIRTUAL

//ROMTEAM WorldEditor (Cristian Stegaru 11/97)
public:
	CTriEdit * mfn_pGetITEditor (); 
	CString		mfn_csGetITName ();
//ENDROMTEAM WorldEditor (Cristian Stegaru)

public:
	// Implementation
	virtual ~CIndexedTriangleFrame();
protected:
	CIndexedTriangleView* GetView ();
	// Generated message map functions
	//{{AFX_MSG(CIndexedTriangleFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnNew ();
	afx_msg void OnSave ();
	afx_msg void OnHide ();
	afx_msg void OnUndo ();
	afx_msg void OnRedo ();
	afx_msg void OnOnTop ();
	afx_msg void OnExit ();
	afx_msg void OnUpdateNewObject (CCmdUI* pCmdUI);
	afx_msg void OnUpdateSave (CCmdUI* pCmdUI);
	afx_msg void OnUpdateHide (CCmdUI* pCmdUI);
	afx_msg void OnUpdateUndo (CCmdUI* pCmdUI);
	afx_msg void OnUpdateRedo (CCmdUI* pCmdUI);
	afx_msg void OnUpdateOnTop (CCmdUI* pCmdUI);
	afx_msg void OnUpdateExit (CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __INDEXEDTRIANGLEFRAME_HPP__
