// dlgcaract.h : header file
//

#ifndef __DLGCARACT_HPP__
#define __DLGCARACT_HPP__

#ifdef ACTIVE_EDITOR


#include "3DGe_res.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgCaract dialog
class FRMBase;
class Geometry3D_Interface;

//#include "gli.h"

class Geometry3D;

class CDlgCaract : public CFormView
{
protected:
    Geometry3D_Interface *m_p_oParentDLL;
	Geometry3D			 *m_p_oCurrentObject;
	CPA_SuperObject		 *m_p_oSuperObject;
// Construction
public:
	CDlgCaract(CWnd* pParent = NULL);   // standard constructor
    DECLARE_DYNCREATE(CDlgCaract)

    void fn_vUpdateInfo             (CPA_SuperObject *_p_oSprObj, Geometry3D *_p_oObject);
    void fn_vSetParentDLL           (Geometry3D_Interface *_p_oParentDLL)
                                        { m_p_oParentDLL = _p_oParentDLL ; }
// Dialog Data
	//{{AFX_DATA(CDlgCaract)
	enum { IDD = IDD_DLGCARACT };
	//}}AFX_DATA
    long    m_Data_lNbPoints;
	long	m_Data_lNbEdges;
    long    m_Data_lNbBdV;
	long	m_Data_lNbElements;
	CString	m_Data_cName;
	BOOL	m_bFirstInit;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCaract)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void fn_vInitValues();
    void fn_vShowValue(int _nID, long _lValue);

	void fn_vInitList();
	void fn_vUpdateList(Geometry3D *_p_oObject);

	// Generated message map functions
	//{{AFX_MSG(CDlgCaract)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChangeList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //ACTIVE_EDITOR
#endif //__DLGCARACT_HPP__