//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : DlgEditPoints3D.hpp: interface for the CDlgEditPoints class.
// Author      : Viorel Preoteasa
// Date        : 97.11
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_DLGEDITPOINTS_HPP__BE1AE613_7ADD_11D1_BEE8_00A0244F4D78__INCLUDED_)
#define AFX_DLGEDITPOINTS_HPP__BE1AE613_7ADD_11D1_BEE8_00A0244F4D78__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// dlgeditpoints.hpp : header file
//

#include "3DGe_res.h"


/////////////////////////////////////////////////////////////////////////////
// CDlgEditPoints form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif


/////////////////////////////////////////////////////////////////////////////
// CStaticLine window

class CStaticLine : public CStatic
{
// Construction
public:
	CStaticLine();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticLine)
	//}}AFX_VIRTUAL

// Implementation
public:
	void Init(float *Lin);
	virtual ~CStaticLine();
	float Effect(float dist);

	// Generated message map functions
protected:
	//{{AFX_MSG(CStaticLine)
	afx_msg void OnPaint();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
private:
	float * m_pLin;
};


class CDlgEditPoints : public CFormView
{
protected:
	CDlgEditPoints();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDlgEditPoints)

// Form Data
public:
	//{{AFX_DATA(CDlgEditPoints)
	enum { IDD = IDD_POINT_EDIT_DIALOG };
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	void Init();
	float Effect(float dist);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgEditPoints)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CDlgEditPoints();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDlgEditPoints)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	float m_fLinearity;
};

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGEDITPOINTS_HPP__BE1AE613_7ADD_11D1_BEE8_00A0244F4D78__INCLUDED_)
