#if !defined(AFX_RLIDIA_HPP__E534C5DB_D8C4_11D0_9542_006097367311__INCLUDED_)
#define AFX_RLIDIA_HPP__E534C5DB_D8C4_11D0_9542_006097367311__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Rlidia.hpp : header file
//

/////////////////////////////////////////////////////////////////////////////
// RliDia dialog


class Light_Interface;

class RliDia : public CDialog
{
protected:
	Light_Interface* m_poInterface;
	
	
// Construction
public:
	RliDia(Light_Interface* poInterface, CWnd* pParent = NULL);   // standard constructor


// Dialog Data
	//{{AFX_DATA(RliDia)
	enum { IDD = IDD_LIGHT_RLI };
	CSliderCtrl	m_oColorScaleSlider;
	CButton	m_oCommandButton;
	float	m_fColorScale;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RliDia)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(RliDia)
	virtual BOOL OnInitDialog();
	afx_msg void OnCommandButton();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnKillfocusLightColorScaleEdit();
	afx_msg void OnCommandAllButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RLIDIA_HPP__E534C5DB_D8C4_11D0_9542_006097367311__INCLUDED_)
