/*=========================================================================
*
* SECdDist.hpp :  class SECT_DialogDistance
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifndef __SECT_D_DIST_HPP__
#define __SECT_D_DIST_HPP__

#include "SECTres.h"

class Sector_Interface;

//#################################################################################
// Sector Links 
//#################################################################################

/*===========================================================================
*		Description:	Class for the Distance Dialog
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================*/
class SECT_DialogDistance : public CDialog
{
protected:
// dialog parameters
	Sector_Interface	*m_pSectorInterface;
	long				m_lLinkDistance;

public:
// standard constructor
	SECT_DialogDistance (CWnd* pParent = NULL); 
	
	void fn_vInitSectorInterface (Sector_Interface *pInterface);

	long GetLinkDistance (void) { return m_lLinkDistance; }

protected:
	
// Dialog Data
	//{{AFX_DATA(SECT_DialogDistance)
	enum { IDD = SEC_IDD_DIALOGDISTANCE};

	CEdit	m_cEditDistance;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SECT_DialogDistance)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SECT_DialogDistance)
	afx_msg void OnSize(UINT, int, int);
	afx_msg void OnDestroy();	
	// env elem
	virtual BOOL OnInitDialog();
	afx_msg void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#endif //__SECT_D_DIST_HPP__
