/*=========================================================================
* 
* SECdDist.cpp :  Distance dialog - Implementation file
* 
*
* Version			1.0
* Creation date		16/08/97	
* Revision date		18/08/97
*
* Shaitan
*=======================================================================*/

#include "stdafx.h"
#include "acp_base.h"

#include "SECdDist.hpp"

#include "SECTint.hpp"

#include "..\Main\Inc\_EditID.h"
#include "TUT.h"

//#################################################################################
// SECT_DialogReplace dialog
//#################################################################################

/*----------------------------------------
----------------------------------------*/
SECT_DialogDistance::SECT_DialogDistance(CWnd* pParent /*=NULL*/)
	: CDialog(SECT_DialogDistance::IDD, pParent)
{
	// init editor
	m_pSectorInterface = NULL;
	m_lLinkDistance = 1;
}


/*----------------------------------------
----------------------------------------*/
void SECT_DialogDistance::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(SECT_DialogDistance)
	DDX_Control(pDX, SECT_IDC_DISTANCE, m_cEditDistance);
	//}}AFX_DATA_MAP
}


/*----------------------------------------
----------------------------------------*/
BEGIN_MESSAGE_MAP(SECT_DialogDistance, CDialog)
	//{{AFX_MSG_MAP(SECT_DialogDistance)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//#################################################################################
// SECT_DialogDistance message handlers
//#################################################################################

/*----------------------------------------
----------------------------------------*/
BOOL SECT_DialogDistance::OnInitDialog (void) 
{
	CString csText;

	CDialog::OnInitDialog();

// FOR TUTORIAL
	TUT_M_vGetTutDll();

	TUT_M_vRegisterControl(m_cEditDistance.m_hWnd,	"OSC_DDIST_EDIT_DISTANCE",	TUT_e_TextEdit);
// END TUTORIAL

	// Init Distance
	csText.Format("%ld", m_lLinkDistance);
	m_cEditDistance.SetWindowText(csText);
	return TRUE;  
}

/*----------------------------------------
----------------------------------------*/
void SECT_DialogDistance::OnOK (void)
{
	char szText[15];
	
	// get distance
	m_cEditDistance.GetWindowText(szText, 15);
	m_lLinkDistance = atol(szText);

	CDialog::OnOK();
}

/*----------------------------------------
----------------------------------------*/
void SECT_DialogDistance::fn_vInitSectorInterface (Sector_Interface *pInterface)
{
	m_pSectorInterface = pInterface;
}


/*----------------------------------------
----------------------------------------*/
void SECT_DialogDistance::OnDestroy (void)
{
// FOR TUTORIAL
	TUT_M_vGetTutDll();

	TUT_M_vUnregisterControl(m_cEditDistance.m_hWnd);
// END TUTORIAL

	CDialog::OnDestroy();
}
