/*
///////////////////////////////////////////////////////////////////////////////////////////////////
// Description : LinkArc.hpp
//   
//  Definition of the link editors objects            
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// inherit from  :	Link2D
///////////////////////////////////////////////////////////////////////////////////////////////////
// Creation date: 30 jan 1997                        Author: J Thnoz
///////////////////////////////////////////////////////////////////////////////////////////////////
// Modification date:			                      Author: 
// 
//
// 
//
///////////////////////////////////////////////////////////////////////////////////////////////////
*/

//ANNECY Shaitan Nettoyage (12/05/98) {
/*

#ifndef __LinkArc_HPP__
#define __LinkArc_HPP__

//ROMTEAM WorldEditor (Viorel Preoteasa 20/01/98) 
#include "ogd.h"
//ENDROMTEAM WorldEditor (Viorel Preoteasa) 

class LinkArc : public Link2D
{
protected:	
	static char ms_cType;						// type of link 
	static char ms_szName [10];					// name of the link
	BOOL m_bFirstEdition;						// This object was not yet edited
	BOOL m_bEditPlane;							// Must we draw the edit plane
	Cursor*	m_poCursor;							// cursor object
	MTH3D_tdstVector	m_stCenterVertex;			// Local vertex of translation 

//ROMTEAM WorldEditor (Viorel Preoteasa 20/01/98) 
//	EDWAY_tdhCircleArcObject m_hArcObject;		// editor object
	Arc3D m_hArcObject;							// editor object
//ENDROMTEAM WorldEditor (Viorel Preoteasa) 

	BOOL m_bInitCenter;							// m_stCenterVertex must be reinit


public:
	static Link* fn_pConstruct ( CPA_ObjectDLLBase *p_oDLL, CPA_BaseObject *p_oOwner, WP_tdhLink hLink) {	if (hLink) return new LinkArc ( p_oDLL, p_oOwner, hLink); 
																																			else return new LinkArc ( p_oDLL, p_oOwner ); }
	static void fn_vRegisterObject (void);	// this function is used to register this object
	
	LinkArc ( CPA_ObjectDLLBase *p_oDLL, CPA_BaseObject *p_oOwner, WP_tdhLink hLink );
	LinkArc ( CPA_ObjectDLLBase *p_oDLL, CPA_BaseObject *p_oOwner );
	char fn_cGetType (void) { return ms_cType; }
	char* fn_pGetName (void) { return ms_szName; }
	CDialog* fn_pGetSpecificDialog (CWnd* pParentWnd);
	void fn_vFreeSpecificDialog (CDialog* pDialog);	 

//ROMTEAM WorldEditor (Viorel Preoteasa 20/01/98) 
//	EDWAY_tdhCircleArcObject fn_hGetEditArcObject (void) { return m_hArcObject; }
	Arc3D *fn_hGetEditArcObject (void) { return &m_hArcObject;}
//ENDROMTEAM WorldEditor (Viorel Preoteasa) 

	void fn_vConstructGraphic (void);
	void fn_vRotationGraphic (BOOL bRotation);	
	void fn_vDrawNormal (void);
	void fn_vDrawOutHierarchy (GLD_tdstViewportAttributes *pViewportAttributes);
	void fn_vSetWaypoints ( WayPoint* poFirstWP, WayPoint* poSecondWP );
	void fn_vGetSaveInfo ( char dszParam [20][20], long& lNbParam );
	void fn_vInitGraphic (void);


	void fn_vStopEdit (void);
	void fn_vStartEdit (void);

	// Update data
	void fn_vUpdateCenter (void);

protected :
	void fn_vSetEngineStructure (void);
	void fn_vInitCenter (BOOL bInit);
	void fn_vGetAbsoluteCenter (MTH3D_tdstVector* pstCenter);
	void fn_vSetAbsoluteCenter (MTH3D_tdstVector* pstCenter);
	void fn_vComputeCursorVertex ( MTH3D_tdstVector* pstCursorVertex );
	void fn_vInitPlaneOrientation (void);
};

#endif

*/
//ENDANNECY Shaitan Nettoyage }
