//ROMTEAM Networks (Gabriela Dumitrascu 25/02/98)

///////////////////////////////////////////////////////////////////////////////////////////////////
// Description : IsoWpDia.cpp
//   
// Definition of the waypoint ,implementation file
///////////////////////////////////////////////////////////////////////////////////////////////////
// inherit from  :	CDialog
///////////////////////////////////////////////////////////////////////////////////////////////////
// Creation date: 1998-02-23                        Author: CPA2 Gabriela Dumitrascu
///////////////////////////////////////////////////////////////////////////////////////////////////
// Modification date:			                      Author: 
///////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "acp_base.h"
#include "resource.h"
#include "incitf.h"
#include "incai.h"
#include "WPObj.hpp"
//ANNECY Shaitan Nettoyage (12/05/98) {
/*
#include "WayObj.hpp"
#include "LinkObj.hpp"
#include "WayDia.hpp"
*/
//ENDANNECY Shaitan Nettoyage }
#include "WPDia.hpp"
#include "Inter.hpp"
#include "x:\cpa\main\inc\_EditId.h"
#include "isowpdia.hpp"
#include "tut.h"

#ifdef _DEBUG
#define new DEBUG_NEW
 #undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IsoWPDia dialog


IsoWPDia::IsoWPDia(CWnd* pParent /*=NULL*/)
	: CDialog(IsoWPDia::IDD, pParent)
{
	//{{AFX_DATA_INIT(IsoWPDia)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void IsoWPDia::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(IsoWPDia)
	DDX_Control(pDX, IDC_LIST_WP, m_IsoWpList);
	//}}AFX_DATA_MAP
	
}


BEGIN_MESSAGE_MAP(IsoWPDia, CDialog)
	//{{AFX_MSG_MAP(IsoWPDia)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IsoWPDia message handlers

void IsoWPDia::OnOK() 
{
	int i = 0;
	POSITION lPos;
	m_oListOfSelWP.RemoveAll();
	for (WayPoint* poWP = m_oListOfWP.GetHeadElement(lPos); poWP; poWP = m_oListOfWP.GetNextElement(lPos), i++)
	{
		if (m_IsoWpList.GetSel(i))
			m_oListOfSelWP.AddTail(poWP);
	}
	
	CDialog::OnOK();
}

BOOL IsoWPDia::OnInitDialog() 
{
	CDialog::OnInitDialog();

	WayPoint* poWP;
	POSITION lPos;
	for (poWP = m_oListOfWP.GetHeadElement(lPos); poWP; poWP = m_oListOfWP.GetNextElement(lPos))
			m_IsoWpList.AddString(poWP->GetName());
	return TRUE;
}

BOOL IsoWPDia::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	TUT_M_vGetTutDll ();
	TUT_M_vRegisterControlID (IDC_LIST_WP, "IsoWp_List",TUT_e_ListBox);
    TUT_M_vRegisterControlID (IDOK,			"WP_Ok",	TUT_e_Button);
    TUT_M_vRegisterControlID (IDCANCEL,		"WP_Cancel",TUT_e_Button);

	return CDialog::Create(IDD, pParentWnd);
}


void IsoWPDia::OnDestroy() 
{
	TUT_M_vGetTutDll ();
	TUT_M_vUnregisterControlID (IDC_LIST_WP);
    TUT_M_vUnregisterControlID (IDOK       );
    TUT_M_vUnregisterControlID (IDCANCEL   );

	CDialog::OnDestroy();
	
}

//ENDROMTEAM Networks (Gabriela Dumitrascu)
