#ifndef _SNDINI_H_
#define _SNDINI_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus


#undef DLL_IMPEXP
#undef CPA_EXPORT
#ifdef _DLL_COMPILATION_MODE
	#define DLL_IMPEXP __declspec(dllexport)
	#define CPA_EXPORT
#else
	#define DLL_IMPEXP
	//**************************************
	#if defined(CPA_WANTS_IMPORT)
	#define CPA_EXPORT __declspec(dllimport)
	#elif defined(CPA_WANTS_EXPORT)
	#define CPA_EXPORT __declspec(dllexport)
	#else
	#define CPA_EXPORT
	#endif
	//**************************************
#endif

//gestion des options

void SND_fn_vInitOptions(SND_tdstInitStruct *pInitStruct);
void SND_fn_vDesInitOptions(void);

#define INI_FILENAME "CPA\\DLL\\SND_CPA.INI"

#if defined(_DLL_COMPILATION_MODE) && !defined(SNDDLL_MODULE)
    #pragma message("-> sndini : functions pointers defined in SNDDLL.H")
#else
DLL_IMPEXP SndBool SND_CALL SND_fn_bGetOptions(char* section,char* key,char* value,int size_value);
DLL_IMPEXP void SND_CALL SND_fn_vSetOptions(char* section,char* key,char* value);
DLL_IMPEXP SndBool SND_CALL SND_fn_bCanSetOptions(void);
#endif

#ifdef __cplusplus
}
#endif // __cplusplus


#endif //SNDINI
