#if !defined(AFX_VOICESPAGE_H__FA1253D3_DE04_11D2_9F40_00104B6833D0__INCLUDED_)
#define AFX_VOICESPAGE_H__FA1253D3_DE04_11D2_9F40_00104B6833D0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// VoicesPage.h : header file
//

//Module Structure : 
//
//id : 
//cDescription :ex: "ADPCM Virtual voice module", etc..
//apVirtualVoicesArray : array of Vitual voices descriptors
typedef struct VirtualVoiceModule{
	
	long	lIdModule;
	CString cDescription;
	CPtrArray	apVirtualVoicesArray;
}VirtualVoiceModule;



//Virtual Voices Structure
typedef struct VirtualVoice{
	
	long	lId;
	BOOL bStillActive;
	BOOL bDisplayed;
	double dNorme;
	BOOL bPaused;
	long lResId;
	long lResRef;
	BOOL bLoop;
	long lInstance;
	long lAudible;
	long lVoice;

}VirtualVoice;

typedef struct RegKeyVoicePage{
	int iColVoiceId;
	int  iColPaused;
	int iColResPtr;
	int iColResId;
	int iColLoop;
	int iColNorm;
	int iColInstance;
	int iColAudibleV;
	int iColHardV;
}RegKeyVoicePage;

/////////////////////////////////////////////////////////////////////////////
// CVoicesPage dialog

class CVoicesPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CVoicesPage)

// Construction
public:
	void AddVoiceToList(long lIndex, long lModuleIndex);
	void RefreshVoiceList();
	CVoicesPage();
	~CVoicesPage();

// Dialog Data
	//{{AFX_DATA(CVoicesPage)
	enum { IDD = IDD_VOICES_PAGE };
	CComboBox	m_VoicesCombo;
	CListCtrl	m_VoicesListCtrl;
	int		m_iMaxVoices;
	int		m_iUsedVoices;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CVoicesPage)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CVoicesPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VOICESPAGE_H__FA1253D3_DE04_11D2_9F40_00104B6833D0__INCLUDED_)
