//==============================================================================================
//							FICHIER D'EN-TETE DU MODULE DE TRAITEMENT DE L'"ADPCM"
//
//		Crer	  :	03 / 11 / 97
//		Auteur	  :	Nicolas Meyer
//		Fichier	  :	Adpcm.h
//
//		Descriptif:	Module charge de fournir des dcompresseurs de donnes "ADPCM". Ce fichier
//					d'en-tte dfinit du source spcifique et optimis pour chacune des targets
//					Pentium ou MMX
//
//==============================================================================================

#ifndef _ADPCM_H_
#define _ADPCM_H_

#include "ApmType.h"

#include "ApmVoice.h"

/*********************************************************************************************************
// DEFINITION DE FONCTIONS

*/
// Fonction bas niveau
extern void	__cdecl	AdpcmDecoderMono( unsigned long nLen, char** ppchDataIn, long** pplDataOut, LPADPCMSTATEMONO pState );
extern void __cdecl	AdpcmDecoderStereo( unsigned long nLen, char** ppchDataIn, long** pplDataOut, LPADPCMSTATESTEREO pStateStereo );
extern void __cdecl	AdpcmMix_( long* pParam1, long* pParam2, long* pParam3, lpSND_tdstADPCMVoice pParam4 );
void				AdpcmStoreClampDatas( long* plClampBegin, long* plClampEnd, short** ppshDataOut );

#endif	//	_ADPCM_H_
