#ifndef _SNDTEST_H_
#define _SNDTEST_H_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

/*
//////////////////////////////////////////////////////////////
//      SNDTEST.H                                                                                               //
//////////////////////////////////////////////////////////////
//      Module de test de configuration PC                                              //
//////////////////////////////////////////////////////////////
*/

#undef DLL_IMPEXP
#undef CPA_EXPORT
#ifdef _DLL_COMPILATION_MODE
        #define DLL_IMPEXP __declspec(dllexport)
        #define CPA_EXPORT
#else
        #define DLL_IMPEXP
        //**************************************
        #if defined(CPA_WANTS_IMPORT)
        #define CPA_EXPORT __declspec(dllimport)
        #elif defined(CPA_WANTS_EXPORT)
        #define CPA_EXPORT __declspec(dllexport)
        #else
        #define CPA_EXPORT
        #endif
        //**************************************
#endif


#if defined(_DLL_COMPILATION_MODE) && !defined(SNDDLL_MODULE)
    #pragma message("-> sndtest : functions pointers defined in SNDDLL.H")
#else
DLL_IMPEXP BOOL SND_CALL SND_fn_bTestSnd_Pentium(void);
DLL_IMPEXP BOOL SND_CALL SND_fn_bTestSnd_MMX(void);
DLL_IMPEXP BOOL SND_CALL SND_fn_bTestSnd_WinMM(WAVEFORMATEX *format);
DLL_IMPEXP BOOL SND_CALL SND_fn_bTestSnd_Win32(void);
DLL_IMPEXP BOOL SND_CALL SND_fn_bTestSnd_WinNT(void);

//to force symbols reference (fuction must be EXPORTable)
#ifndef __WATCOMC__
#pragma comment(linker, "/INCLUDE:_SND_fn_bTestSnd_Pentium@0")
#pragma comment(linker, "/INCLUDE:_SND_fn_bTestSnd_MMX@0")
#pragma comment(linker, "/INCLUDE:_SND_fn_bTestSnd_WinMM@4")
#pragma comment(linker, "/INCLUDE:_SND_fn_bTestSnd_Win32@0")
#pragma comment(linker, "/INCLUDE:_SND_fn_bTestSnd_WinNT@0")
#endif
#endif

#ifdef __cplusplus
}
#endif // __cplusplus

#endif //_SNDTEST_H_


