/*/==============================================================================================
//							FICHIER D'EN-TETE DU MODULE DE TRAITEMENT DE L'"ADPCM"
//
//		Crer	  :	17 / 02 / 98
//		Auteur	  :	Nicolas Meyer
//		Fichier	  :	ApmThrd.h
//
//		Descriptif:	Fonctions et structures prives de gestion de taches
//
//==============================================================================================*/

#ifndef _APMTHRD_H_
#define _APMTHRD_H_

#include <windows.h>
#include <winbase.h>/* Api Win32 Gestion multi thread */

/*********************************************************************************************************
// DEFINITION DE STRUCTURES

*/
typedef CRITICAL_SECTION	SND_tdstADPCMCriticalSection;/* Section critique*/
typedef LPCRITICAL_SECTION	lpSND_tdstADPCMCriticalSection;/* Pointeur de section critique*/

/*********************************************************************************************************
// DEFINITION DE FONCTIONS

*/
void SND_fn_vInitializeCriticalSection( lpSND_tdstADPCMCriticalSection pstSection );
void SND_fn_vDeleteCriticalSection( lpSND_tdstADPCMCriticalSection pstSection );
void SND_fn_vEnterCriticalSection( lpSND_tdstADPCMCriticalSection pstSection );
void SND_fn_vLeaveCriticalSection( lpSND_tdstADPCMCriticalSection pstSection );

#endif	/*	_APMTHRD_H_ */
