/* (c) Ubi Studios 1998*/
/* See Vincent Greco for any comment or question*/
 
#ifndef __HIEALLDRW_H__
#define __HIEALLDRW_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
#define HIE_M_MustBeDisplayed(_lDrawMask)  \
  (( (_lDrawMask&GLI_C_lIsNotVisibleInRealWorld)     &&   (_lDrawMask&GLI_C_lIsNotDrawingInMirror) ) || \
   ( (_lDrawMask&GLI_C_lIsNotVisibleInSymetricWorld) &&  !(_lDrawMask&GLI_C_lIsNotDrawingInMirror) ))
 
#define HIE_C_InheritableFlags  \
	(GLI_C_lIsNotVisibleInRealWorld|\
	 GLI_C_lIsNotVisibleInSymetricWorld|\
	 GLI_C_lCameraIsUnderWater|\
	 GLI_C_lIsNotDrawingSuperObjectBoundingVolume|\
	 GLI_C_lIsNotDrawingInMirror|\
	 GLI_C_lNotInvertBackfaces|\
	 GLI_C_lNotHideWhatIsUnderWater|\
	 GLI_C_lIsNotWired)
 
 
 
void fn_vSendOneModuleToViewPort(GLD_tdxHandleToViewportAttributes _hVpt,
                                 HIE_tdxHandleToSuperObject   _hSprObj ,
                                 long _lDrawMask);
 
 
ACP_tdxBool fn_bSendOneSuperObjectToViewport(
	GLD_tdxHandleToViewportAttributes _hVpt,
	HIE_tdxHandleToSuperObject _hSprObj,
	long *_DrawMask,
	long _lCullingResult
);
 
 
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __HIEALLDRW_H__*/
