#ifndef __T3DFRMBS_HPP__
#define __T3DFRMBS_HPP__

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#ifdef ACTIVE_EDITOR

class Tool3D_Interface;

// ALX
//#include "FRMBsMn.hpp"
// End ALX

class Tool3D_FRMBaseMenu : public FRMBaseMenu
{
protected:
    Tool3D_Interface *m_p_oTool3D;
public:
    Tool3D_FRMBaseMenu();
    ~Tool3D_FRMBaseMenu();
    void mfn_vSetTool3D(Tool3D_Interface *_p_oTool3D)    { m_p_oTool3D = _p_oTool3D; }
    void fn_vInitGeneralMenuWithContext(void);
    void mfn_vUpdateDeviceToolBar(void);
    DECLARE_DYNCREATE(Tool3D_FRMBaseMenu);
protected:
	//{{AFX_MSG(CPA_MainFrame)
	afx_msg int     OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void    OnSysCommand( UINT nID, LPARAM lParam );
    afx_msg void    OnSize( UINT nType, int cx, int cy );
    afx_msg void    OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
    //}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#endif ACTIVE_EDITOR
#endif __T3DFRMBS_HPP__