#if !defined(AFX_DLGANIM_HPP__C7833E83_CCF7_11D0_B183_0060973673C5__INCLUDED_)
#define AFX_DLGANIM_HPP__C7833E83_CCF7_11D0_B183_0060973673C5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DlgAnim.hpp : header file
//

#include "TAct_Res.h"

class TAction_Interface;

/////////////////////////////////////////////////////////////////////////////
// CDlgAnimList form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CDlgAnimList : public CFormView
{
private:
    TAction_Interface   *m_p_oParentDLL;
    BOOL                 m_bAllFamilies;
// CPA_Ed_1 Mihaela Tancu begin
	CPA_State 			*m_p_oStatePrevious;	//the previous state of the state to move (in the list)
	CPA_State           *m_p_oStateTarget;		//the target state before which we have to insert
// CPA_Ed_1 Mihaela Tancu end
protected:
	CDlgAnimList();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDlgAnimList)

// Form Data
public:
	//{{AFX_DATA(CDlgAnimList)
	enum { IDD = IDD_DLG_ANIM };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:
	BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName,
				DWORD dwRequestedStyle, const RECT& rect, CWnd* pParentWnd, UINT nID,
				CCreateContext* pContext);

// Operations
public:
    void mfn_vSetFamily                 (CPA_Family *_p_oFamily);
    void mfn_vSetParentDLL              (TAction_Interface *_p_oDLL);
    void mfn_vFillCBFamilies            (void);
    void mfn_vOnDrawItemListBoxAnimation(LPDRAWITEMSTRUCT lpDIS);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgAnimList)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
    BOOL OnLButtonDownLbAnim    (MSG* pMsg);
    BOOL OnRButtonDownLbAnim    (MSG* pMsg);
// CPA_Ed_1 Mihaela Tancu begin
	BOOL OnLButtonUpLbAnim(MSG* pMsg);
	void mfn_vCreateStatesMove(BOOL _bNormal);
// CPA_Ed_1 Mihaela Tancu end
    void mfn_vFillLBAnimations  (CPA_Family *_p_oFamily);
    void mfn_vCreateStates      (BOOL _bNormal);
    virtual ~CDlgAnimList       ();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDlgAnimList)
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBtCreatestates();
	afx_msg void OnSelchangeLbAnim();
	afx_msg void OnBtMore();
	afx_msg void OnSelchangeComboFamily();
// CPA_Ed_1 Mihaela Tancu begin
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
// CPA_Ed_1 Mihaela Tancu end
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGANIM_HPP__C7833E83_CCF7_11D0_B183_0060973673C5__INCLUDED_)