#include "stdafx.h"
#include "Acp_Base.h"
#include <string.h>
#define HieFriend
#include "incgam.h"
#include "dpt.h"
#include "gmt.h"
#include "scr.h"
#include "diacol.hpp"
#include "_interf.hpp"
#include "gmatobj.hpp"
#include "CopyPaste.hpp"
#include "MatList.hpp"
#include "x:\cpa\main\inc\_editid.h"
#include "TUT.h"


extern Material_Interface *gs_p_oMaterialInterface;

extern DiaCol	*g_oMaterialCol; /* pour les callbacks du chrgement */

#include "ldt.h"


/*****************************************************************
Function name   : DiaCol::fn_iLoadZDMNames
Description     : 
Author          : Ovidiu Scripa (oscripa@ubisoft.ro) - ROMTEAM
Creation Date   : 15-Oct-98
Modified        : 
Return type     : int 
Argument        : LDT_tdst_Link *pLink
*****************************************************************/
int DiaCol::fn_iLoadZDMNames( LDT_tdst_Link *pLink )
{
  LDT_tdeParseResult result=ParseResult_BeginSection;

  g_oMaterialCol->m_currentNameRead = 0;


  while( result!=ParseResult_EndSection ) 
  {
  	result=LDT_GetNextEntry();
  	switch( result )
  	{
  	  case ParseResult_Entry: /* an entry */
  	  {
  	    char *szEntry=LDT_szGetEntryName();

		    g_oMaterialCol->m_p_oMyNameObject[g_oMaterialCol->m_currentNameRead].fn_eRename((CString)szEntry);
	
		    g_oMaterialCol->m_currentNameRead ++;

  	  }
  	}
  }

  return 0;
}



/*****************************************************************
Function name   : DiaCol::fn_iLoadZDRNames
Description     : 
Author          : Ovidiu Scripa (oscripa@ubisoft.ro) - ROMTEAM
Creation Date   : 15-Oct-98
Modified        : 
Return type     : int 
Argument        : LDT_tdst_Link *pLink
*****************************************************************/
int DiaCol::fn_iLoadZDRNames( LDT_tdst_Link *pLink )
{
  LDT_tdeParseResult result=ParseResult_BeginSection;

  g_oMaterialCol->m_currentNameRead = C_uc_NumberOfNames;

  while( result!=ParseResult_EndSection ) 
  {
  	result=LDT_GetNextEntry();
  	switch( result )
  	{
  	  case ParseResult_Entry: /* an entry */
  	  {
  	        char *szEntry=LDT_szGetEntryName();

            g_oMaterialCol->m_p_oMyNameObject[g_oMaterialCol->m_currentNameRead].fn_eRename((CString)szEntry);
		    g_oMaterialCol->m_currentNameRead ++;
  	  }
  	}
  }

  return 0;
}


/*****************************************************************
Function name   : DiaCol::fn_iLoadZDENames
Description     : 
Author          : Ovidiu Scripa (oscripa@ubisoft.ro) - ROMTEAM
Creation Date   : 15-Oct-98
Modified        : 
Return type     : int 
Argument        : LDT_tdst_Link *pLink
*****************************************************************/
int DiaCol::fn_iLoadZDENames( LDT_tdst_Link *pLink )
{
  LDT_tdeParseResult result=ParseResult_BeginSection;

  g_oMaterialCol->m_currentNameRead = C_uc_NumberOfNames * 2;

  while( result!=ParseResult_EndSection ) 
  {
  	result=LDT_GetNextEntry();
  	switch( result )
  	{
  	  case ParseResult_Entry: /* an entry */
  	  {
  	        char *szEntry=LDT_szGetEntryName();

            g_oMaterialCol->m_p_oMyNameObject[g_oMaterialCol->m_currentNameRead].fn_eRename((CString)szEntry);
		    g_oMaterialCol->m_currentNameRead ++;
  	  }
  	}
  }

  return 0;
}
