// EdIRCstB.hpp : implementation file
//

#ifndef _EDIRCSTB_HPP_
#define _EDIRCSTB_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EdIRRes.h"

class CPA_EdIR_ConstantList;

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_ConstantDialog dialog
/////////////////////////////////////////////////////////////////////////////

class CPA_EdIR_ConstantDialog : public CDialog
{
	//Attributes
	private:
		CPA_EdIR_ConstantList	*m_pclConstantList;

	//Operations
	private:
//Stefan Dumitrean 17-06-98
		void	m_fn_vSaveSettings();
//End Stefan Dumitrean 17-06-98
		void	m_fn_vNotifySave();
		int		m_fn_iGetCurSel();
		void	m_fn_vAddItem(CString,CString,CString,LPARAM);
		void	m_fn_vSetItem(int,CString,CString,CString,LPARAM);

	// Construction
	public:
		CPA_EdIR_ConstantDialog(CPA_EdIR_ConstantList *,CWnd* pParent = NULL);   // standard constructor

	// Dialog Data
		//{{AFX_DATA(CPA_EdIR_ConstantDialog)
		enum { IDD = IDD_IR_CONSTANTS_DIALOG };
			// NOTE: the ClassWizard will add data members here
		//}}AFX_DATA


	// Overrides
		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CPA_EdIR_ConstantDialog)
		protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		//}}AFX_VIRTUAL

	// Implementation
	protected:

		// Generated message map functions
		//{{AFX_MSG(CPA_EdIR_ConstantDialog)
		afx_msg void OnButtonNewConstant();
		afx_msg void OnButtonChangeConstant();
		afx_msg void OnButtonDeleteConstant();
		afx_msg void OnColumnClicked(NMHDR* pNMHDR, LRESULT* pResult);
		virtual BOOL OnInitDialog();
		virtual void OnOK();
		afx_msg void OnClose();
	//}}AFX_MSG
		DECLARE_MESSAGE_MAP()
};

#endif // _EDIRCSTB_HPP_
