// EdIRDVVw.hpp : header file
//

#ifndef _EDIRDVVW_HPP_
#define _EDIRDVVW_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EdIRRes.h"

#include "CTL.h"

class CPA_Editor_ControlList;
class CPA_Editor_BaseDataList;
class EdActors_MyDocument;
//BEGIN ROMTEAM Cristi Petrescu 98-06-
class CPA_EdIR_Brain;
//END ROMTEAM Cristi Petrescu 98-06-

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_DesignerVariablesView
/////////////////////////////////////////////////////////////////////////////

class CPA_EdIR_DesignerVariablesView : public CTL_Editor_BaseFormView
{
	protected:
		CPA_EdIR_DesignerVariablesView();	// protected constructor used by dynamic creation
		DECLARE_DYNCREATE(CPA_EdIR_DesignerVariablesView)

	// Form Data
	public:
		//{{AFX_DATA(CPA_EdIR_DesignerVariablesView)
		enum { IDD = IDD_IR_DESVAR_VIEW };
			// NOTE: the ClassWizard will add data members here
		//}}AFX_DATA

	// Attributes
	private:
		CTL_Editor_ControlList	*m_pclListOfDesignerVariableControl;
		unsigned long						m_ulOldHeight;

	public:

	// Operations
	private:
		EdActors_MyDocument *m_fn_pclGetDocument();
		BOOL								m_fn_bMustDisplay(CTL_Editor_Control *);
//ANNECY CB
	public:
		BOOL	m_bCanUpdateControls;
		BOOL	m_bHideVars;
//END
	public:
		void	m_fn_vUpdateControls(CTL_Editor_ControlList *);
		void	m_fn_vUpdateValues(CTL_Editor_DataList *);
		void	m_fn_vUpdateDisplayWithValues(CTL_Editor_DataList *);
		void	m_fn_vUpdateDisplay();
		void	m_fn_vAModelHasBeenRemoved(CTL_Editor_ControlList *);

		void					m_fn_vSetOldHeight(unsigned long);
		unsigned long	m_fn_ulGetOldHeight();

		//BEGIN ROMTEAM Cristi Petrescu 98-05-
		CTL_Editor_Data *m_fn_pclGetVariable (CString);
		//END ROMTEAM Cristi Petrescu 98-05-
		//BEGIN ROMTEAM Cristi Petrescu 98-06-
		void	m_fn_vSynchronizeWithBrain (CPA_EdIR_Brain *);
		//END ROMTEAM Cristi Petrescu 98-06-
		//CPA2 Stegaru Cristian 98-06
		BOOL	mfn_bHideVariables ();
		void	mfn_vHideVariables (BOOL bHide);
		//End CPA2 Stegaru Cristian 98-06
	// Overrides
		// ClassWizard generated virtual function overrides
		//{{AFX_VIRTUAL(CPA_EdIR_DesignerVariablesView)
	public:
		virtual void OnInitialUpdate();
	protected:
		virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
		//}}AFX_VIRTUAL

	// Implementation
	protected:
		virtual ~CPA_EdIR_DesignerVariablesView();
#ifdef _DEBUG
		virtual void AssertValid() const;
		virtual void Dump(CDumpContext& dc) const;
#endif

		// Generated message map functions
		//{{AFX_MSG(CPA_EdIR_DesignerVariablesView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
//ANNECY CB
//	afx_msg void OnCheckClicked(void);
//END
	afx_msg void OnCheckShowPrivate();
	//CPA2 Stegaru Cristian 98-06
	afx_msg void OnCheckHideVariableForModel ();
	//End CPA2 Stegaru Cristian 98-06
	//}}AFX_MSG

		DECLARE_MESSAGE_MAP()
};

#endif //_EDIRDVVW_HPP_
