// EdIRDbg.hpp : header file
//

#ifndef _EDIRDBG_HPP_
#define _EDIRDBG_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_DebugInfo
/////////////////////////////////////////////////////////////////////////////

class CPA_EdIR_DebugInfo
{
	private:
		struct tdstNodeInterpret_	*m_pstNode;
		long											m_lLineNumber;
		long											m_lColumnNumber;
		long											m_lIndex;
		CString										m_csBehaviourName;
		// BEGIN ROMTEAM Cristi Petrescu 98-08-
		long											m_lMacroIndex;
		CString											m_csMacroName;
		// END ROMTEAM Cristi Petrescu 98-08-

		//BEGIN ROMTEAM Cristi Petrescu 98-05-
		BOOL											m_bExecuted;
		//END ROMTEAM Cristi Petrescu 98-05-

	public:
//ANNECY CB
		CPA_EdIR_DebugInfo(struct tdstNodeInterpret_ *,long,long,long,CString&);
//		CPA_EdIR_DebugInfo(struct tdstNodeInterpret_ *,long,long,long,CString);
//END
		struct tdstNodeInterpret_	*m_fn_pstGetNode();
		long											m_fn_lGetLineNumber();
		long											m_fn_lGetColumnNumber();
		long											m_fn_lGetIndex();
		CString										m_fn_csGetBehaviourName();
		// BEGIN ROMTEAM Cristi Petrescu 98-08-
		long											m_fn_lGetMacroIndex() {return m_lMacroIndex;};
		CString											m_fn_csGetMacroName () {return m_csMacroName;};
		// END ROMTEAM Cristi Petrescu 98-08-
		//BEGIN ROMTEAM Cristi Petrescu 98-05-
		void	m_fn_vSetExecuted (BOOL bExecuted) {m_bExecuted = bExecuted;};
		BOOL	m_fn_bGetExecuted (void) {return m_bExecuted;};	
		void	m_fn_vSetLineNumber (long lLineNumber) {m_lLineNumber = lLineNumber;};
		//END ROMTEAM Cristi Petrescu 98-05-
		// BEGIN ROMTEAM Cristi Petrescu 98-08-
		void	m_fn_vSetIndex (long lIndex) {m_lIndex = lIndex;};
		void	m_fn_vSetBehaviourName (CString csBehaviourName) { m_csBehaviourName = csBehaviourName;};
		void	m_fn_vSetMacroIndex (long lMacroIndex) {m_lMacroIndex = lMacroIndex;};
		void	m_fn_vSetMacroName (CString csMacroName) { m_csMacroName = csMacroName;};
		// END ROMTEAM Cristi Petrescu 98-08-
};

#endif //_EDIRDBG_HPP_
