// EdIRREdD.hpp : header file
//

#ifndef _EDIRREDD_HPP_
#define _EDIRREDD_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_UndoDelete
/////////////////////////////////////////////////////////////////////////////

#include "ITF\CPAMdf.hpp"

class CPA_EdIR_EditCtrl;

class CPA_EdIR_UndoDelete : public CPA_Modif
{
	// Construction
	public:
		CPA_EdIR_UndoDelete(CPA_EdIR_EditCtrl *,CString,long,long,BOOL bBlock=FALSE);
		~CPA_EdIR_UndoDelete();

	// Attributes
	private:
		CPA_EdIR_EditCtrl	*m_pclEditCtrl;
		CString				m_csString;
		long				m_lIndex;
		long				m_lScrollPosition;

	// Operations
	public:
		BOOL	Do();
		BOOL	Undo();
};

#endif //_EDIRREDD_HPP_
