// EdIRDbg.cpp : implementation file
//

#include "stdafx.h"

#include "Defines.hpp"

#ifdef D_ED_IR_ACTIVE

#include "EdIRDbg.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_DebugInfo
/////////////////////////////////////////////////////////////////////////////

/****************************************************************************/
CPA_EdIR_DebugInfo::CPA_EdIR_DebugInfo(struct tdstNodeInterpret_ *pstNode,
																			 long lLineNumber,
																			 long lColumnNumber,
																			 long lIndex,
//ANNECY CB
																			 CString &csBehaviourName)
//																			 CString csBehaviourName)
//END
{
	m_pstNode					=pstNode;
	m_lLineNumber			=lLineNumber;
	m_lColumnNumber		=lColumnNumber;
	m_lIndex					=lIndex;
	m_csBehaviourName	=csBehaviourName;
	m_bExecuted = FALSE;

	// BEGIN ROMTEAM Cristi Petrescu 98-08-
	m_lMacroIndex = -1;
	m_csMacroName = "";
	// END ROMTEAM Cristi Petrescu 98-08-
}

/****************************************************************************/
struct tdstNodeInterpret_ *CPA_EdIR_DebugInfo::m_fn_pstGetNode()
{
	return m_pstNode;
}

/****************************************************************************/
long CPA_EdIR_DebugInfo::m_fn_lGetLineNumber()
{
	return m_lLineNumber;
}

/****************************************************************************/
long CPA_EdIR_DebugInfo::m_fn_lGetColumnNumber()
{
	return m_lColumnNumber;
}

/****************************************************************************/
long CPA_EdIR_DebugInfo::m_fn_lGetIndex()
{
	return m_lIndex;
}

/****************************************************************************/
CString CPA_EdIR_DebugInfo::m_fn_csGetBehaviourName()
{
	return m_csBehaviourName;
}

#endif //D_ED_IR_ACTIVE