// CallBacks (called to compute the string displayed in Editor Tree)
//
// YB
////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
#define HieFriend

#include "IADClBck.hpp"

#include "_IADItrf.hpp"
#include "IADGlob.hpp"
#include "IADVwMn.hpp"

#include "x:/cpa/tempgrp/tia/inc/ai_intf.hpp"
#include "x:/cpa/main/inc/_EditId.h"

#include "OAc.h"

#define TID_C_szUnknownEntryName	"<< Unknown >>"

//#######################################################################################################
//#######################################################################################################
//#######################################################################################################
// Type

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_EngineLoop(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Engine Loop";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_ReflexOrAI(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	CString csReturnedString;
	
	if ( M_GetSetParam_ulValue(_p_tdstGetSetParam) == 1 )
		csReturnedString = "AI";
	else if ( M_GetSetParam_ulValue(_p_tdstGetSetParam) == 0 )
		csReturnedString = "Reflex";
	else
		csReturnedString = "<< Unknown (not Ai, nor Reflex) >>";

	return csReturnedString;	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_CurrentComport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Current Behaviour";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Field(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Field";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Constant(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Constant";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_DsgVarId(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Designer Var ID";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_DsgVar(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Designer Var";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Button(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Button";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_EnvRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Environment";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_SectorRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Sector";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_SurfaceRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Surface";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_PersoRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Actor";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_ActionRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "State";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Real(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Constant Real";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Vector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Vector";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_ConstantVector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Constant Vector";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Way(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Way";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_WayPoint(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Way Point";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Module(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Module";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_ChannelNumber(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Channel Number";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Mask(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{

	return "Mask";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_String(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "String";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_LipsSynchroRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Lips Synchro";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_SoundEventRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Sound Event";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_FamilyRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Family";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_BeginMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Begin Macro";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_EndMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "End Macro";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Comport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Change Behaviour";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_KeyWord(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "KeyWord";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Condition(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Condition";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Function(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Function";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Operator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Operator";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_Procedure(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Procedure";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_MetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Meta Action";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_BeginMetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Begin Meta Action";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_TextRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Texture";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_FontRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Font";	
}

//******************************************************************************
CString IAD_fn_vGetTypeCallBack_ParticleGenerator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "Particle";	
}


//#######################################################################################################
//#######################################################################################################
//#######################################################################################################
// Name

//******************************************************************************
CString IAD_fn_vGetNameCallBack_EngineLoop(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_ReflexOrAI(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_CurrentComport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Field(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindFieldEditorNameFromId((enum tdeFieldId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Constant(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_DsgVarId(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_DsgVar(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	CString csReturnedString;
	
	if ( g_pclInterface->m_clDocument.m_pub_fn_p_stGetSelectedActor() != NULL )
	{
		//Gets IA DLL
		CPA_DLLBase *p_clDll = g_pclInterface->GetMainWorld()->GetToolDLLWithName(C_szDLLAIEditorName);
		if ( p_clDll != NULL )
		{
			tdstActorsIACom tdstCom;
			tdstCom.pvThis = (void *)g_pclInterface->m_clDocument.m_pub_fn_p_stGetSelectedActor()->pclActor;
			tdstCom.lData = _lID;

			p_clDll->OnQueryAction(g_pclInterface, C_uiAI_GetDsgVarName, (long)(&tdstCom));
			
			csReturnedString = tdstCom.csData;
		}
		else
			csReturnedString = "Unknown";
	}
	else
		csReturnedString = "Unknown";

	return csReturnedString;	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Button(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	CString csReturnedString;
	
	csReturnedString.Format("'%s'", IPT_fn_szGetEntryActionName((IPT_tdxHandleToEntryElement)_lID));

	return csReturnedString;	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_EnvRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_SectorRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_SurfaceRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_PersoRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_ActionRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Real(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Vector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_ConstantVector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Way(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_WayPoint(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Module(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_ChannelNumber(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Mask(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_String(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_LipsSynchroRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_SoundEventRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_FamilyRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_BeginMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_EndMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Comport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_KeyWord(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindKeyWordEditorNameFromId((enum tdeKeyWordId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Condition(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindConditionEditorNameFromId((enum tdeCondId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Function(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindFunctionEditorNameFromId((enum tdeFuncId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Operator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindOperatorEditorNameFromId((enum tdeOperatorId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_Procedure(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindProcedureEditorNameFromId((enum tdeProcedureId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_MetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindMetaActionEditorNameFromId((enum tdeMetaActionId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_BeginMetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return szFindMetaActionEditorNameFromId((enum tdeMetaActionId_)_lID);	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_TextRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_FontRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetNameCallBack_ParticleGenerator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}


//#######################################################################################################
//#######################################################################################################
//#######################################################################################################
// Value

//******************************************************************************
CString IAD_fn_vGetValueCallBack_EngineLoop(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_ReflexOrAI(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_CurrentComport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Field(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Constant(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_DsgVarId(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	CString csReturnedString;
	
	csReturnedString.Format("%ld", M_GetSetParam_lDsgVarIdValue(_p_tdstGetSetParam));

	return csReturnedString;	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_DsgVar(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Button(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_EnvRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_SectorRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_SurfaceRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_PersoRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_ActionRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Real(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Vector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_ConstantVector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Way(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_WayPoint(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Module(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
//	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_ChannelNumber(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
//	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Mask(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_String(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_LipsSynchroRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_SoundEventRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_FamilyRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_BeginMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_EndMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Comport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_KeyWord(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Condition(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Function(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Operator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_Procedure(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_MetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_BeginMetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_TextRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_FontRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetValueCallBack_ParticleGenerator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}


//#######################################################################################################
//#######################################################################################################
//#######################################################################################################
// Return value

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_EngineLoop(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_ReflexOrAI(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_CurrentComport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Field(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Constant(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_DsgVarId(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_DsgVar(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Button(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_EnvRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_SectorRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_SurfaceRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_PersoRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_ActionRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Real(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Vector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_ConstantVector(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Way(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_WayPoint(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Module(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_ChannelNumber(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Mask(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_String(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_LipsSynchroRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_SoundEventRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_FamilyRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_BeginMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_EndMacro(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Comport(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_KeyWord(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Condition(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return (M_GetSetParam_lValue(_p_tdstGetSetParam) == 0) ? "False" : "True";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Function(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Operator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_Procedure(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_MetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return IAD_fn_csComputeValueFromGetSetParam(_p_tdstGetSetParam);	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_BeginMetaAction(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_TextRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_FontRef(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

//******************************************************************************
CString IAD_fn_vGetReturnValueCallBack_ParticleGenerator(long _lID, tdstGetSetParam *_p_tdstGetSetParam)
{
	return "";	
}

