/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          DecompressFunc.h

DESCRIPTION :  Include file of VDO module

	       Set of functions in charge of searching for video expander (decompresseur video)
	       and using it. This module avoids using the high level function "AVIStreamGetFrame"  
		

VERSION :       1.00/Nicolas Meyer/Creation

		Nota Bene : This file is only portable on PC platform
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/


#ifndef _DECOMPRESSFUNC_H_
#define _DECOMPRESSFUNC_H_

/* ##INCLUDE#----------------------------------------------------------------------------
                          Includes Files
---------------------------------------------------------------------------------------*/
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <windef.h>
#include <wingdi.h>
#include <vfw.h>
#include <math.h>

#ifdef _DEBUG
#include <crtdbg.h>			/* "CRT" Debugging function  */
#endif

/* ##FUNCDEF#----------------------------------------------------------------------------
                          Functions definition
---------------------------------------------------------------------------------------*/
BOOL			DecompressDesInitModule( );
BOOL			DecompressInitModule( LPBITMAPINFOHEADER pBmpInfoHdrIn, LPAVISTREAMINFO pAviStrInfoIn, PAVISTREAM ppAviStream );
LPBITMAPINFOHEADER	DecompressGetFrame( long nIndiceFrame );

#endif	//	_DECOMPRESSFUNC_H_