// **********************************************************************************
// * "Anims.h"																		*
// * Written by :	Mihaela Tancu													*
// **********************************************************************************
#ifndef ANIMS_H
#define ANIMS_H

#include "Scr.h"

/*
 =======================================================================================
	Defines
 =======================================================================================
 */
#define M_CreateNewState "CreateNewState"
#define M_FichierSTA ".sta"
#define M_Animation "Animation"

typedef struct MLT_tdstAnim_
{
  char sName[256];
  char sAnimation[500];
} MLT_tdstAnim;

extern MLT_tdstAnim **g_hAnimInFile;
extern long g_lAnimIndex;
extern BOOL bUsed;

void MLT_vLoadSTAFileInLib(char *szFileName);
void MLT_vInitSTALoad();
SCR_tde_Anl_ReturnValue GLI_xLoadSTACallback(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
void MLT_vEraseSTALib();

#endif
