/*
 =======================================================================================
  Name        : GIItem.h 
 
  Author      : Mihaela Tancu
  Description : Define the GI_Item class  
 =======================================================================================
 */

#ifndef __GIITEM_H__
#define __GIITEM_H__

#include <afxtempl.h>

class GI_Item 
{
// datas
public:
    BOOL m_bActived;	//boolean for telling if the object is active 
						//or inactive (in the list box is drawn a cross in front of an activ object
	char m_szName[50];	//the name of the object

    CList<  char *,  char *> m_oListOfFamilies;
    CList<  char *,  char *> m_oListOfAnimations;
    CList<  char *,  char *> m_oListOfTextures;

public:
// methods
	GI_Item(BOOL bAct, char *szName);	//constructor
    ~GI_Item();							//destructor

    char* m_fn_p_oGetName(void)       { return m_szName; }	//return the name of the object
};

#endif // __GIITEM_H__