// **********************************************************************************
// * "Tbl_Format.h"																	*
// * Written by :	Carlos Torres													*
// * Tabulations :	4 char															*
// **********************************************************************************

#ifndef TBL_FORMAT_H
#define TBL_FORMAT_H

/////////////////////////////////////////////////////////// Key word use in TBL Files

// header
#define TBL_HEADER_SECTION	"TBL_HEADER"
#define TBL_VERSION				"VersionNumber"
#define TBL_MAXINDEX			"MaximumIndex"

// physic objects
#define TBL_PHYSIC_SECTION	"TBL"
#define TBL_PHYSIC				"PHY"
#define TBL_ZOOM				"CustomZoom"

// Event
#define TBL_EVENT_SECTION	"EVT"
#define TBL_OBJECTTYPE			"ObjectType"
#define TBL_SOUNDEVT			"SoundEvent"
#define TBL_GENERICEVT			"GenericEvent"
#define TBL_GENERATEEVT			"GenerateEvent"
#define TBL_MECHANICEVT			"MechanicEvent"
#define TBL_FIRSTCALL			"FirstCall"
#define TBL_PERIOD				"Period"
#define TBL_PRIORITY			"Priority"

//////////////////////////////////////////////////////////////////////////// Constant
// TBL Version
#define C_TblVersion		1
#define C_TBL_MAXOBJECT		0x7FFF


#endif