// **********************************************************************************
// * "scr2bin.h"																	*
// * Written by :	Sbastien Rubens												*
// * Tabulations :	4 char															*
// **********************************************************************************
#ifndef MAKEANIM_H
#define MAKEANIM_H

#include <conio.h>
#include "l_global_v6.h"

// ********************************************************************************** Constant

#define MAKEANIM_OPTIONS_FILE			"MakeAnim.ini"

#define WaitKeyStroke()					if (!bBatch) getch()

// ********************************************************************************** struct tdstAnimInfo

// ANIM INFO Struct
typedef struct tdstAnimInfo_ {
	tdFileName		szShortFileName;
	SEB_xReal		xPrecision;
	int				iValid;
} tdstAnimInfo;

// Macro Access
#define szAnimName(tab)	(tab)->szShortFileName
#define xPrecision(tab)	(tab)->xPrecision
#define bValid(tab)		(tab)->iValid

// ********************************************************************************** Varaibles gloables
extern	char			szFamilyName[];

extern	unsigned short	uwAnalysedAnim;


// Table of anim info
extern tdstAnimInfo stAnims[NombreDanimationsParDirectory];
extern  unsigned short	g_uwTotalNumOfAnim;

extern	char			LongFileName[];
extern	char			AnimationName[];

// default epsilon precision
extern SEB_xReal xDefaultEps;

// compress TBL fla
extern int				bCompactTbl;

// in batch mode no wait for key stroke
extern unsigned char bBatch;

// **********************************************************************************
#endif