/*=========================================================================
*
* DLGWarning.h	- Header file for warning dialog box class
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef __DLGWARNING_H__ 
#define __DLGWARNING_H__

//--- Includes --------------------------------------------------------

#include "Resource.h"

//----------------------------------------------------------------------

typedef enum tdeWarningMode_
{
	E_ForceCommon,
	E_ForceSpecific
}
tdeWarningMode;

/*
 =======================================================================================
	CDlgWarning dialog class
 =======================================================================================
 */

class CDlgWarning : public CDialog
{
  //data members
  private:
	char m_sMes[500];
	char m_sOK[256];
	char m_sCancel[256];

	CStatic *m_oStatic;

  // Construction
  public:
	CDlgWarning(CWnd* pParent = NULL);   // standard constructor

	void m_fn_vBuildTextMessage (tdeWarningMode eMode, char *sName);

  // Dialog Data
	//{{AFX_DATA(CDlgWarning)
	enum { IDD = IDD_DIALOGWARNING };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

  // Implementation
  protected:
	// Generated message map functions
	//{{AFX_MSG(CDlgWarning)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnApplyAll();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__DLGWARNING_H__
