/*=========================================================================
*
* A3dSave.h	- Saving functions for A3d file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef A3DSAVE_H
#define A3DSAVE_H

//--- Includes --------------------------------------------------------

#include "SCR.h"
#include "MTH.h"

#include "typedef.h"
#include "sprobj.h"


//--- Functions --------------------------------------------------------

// save
extern void MLT_vSaveA3dHeader	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
extern void MLT_vSaveA3dFile	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// matrix
extern void MLT_vGetPositions			(MLT_tdxHandleToSuperObject *p_hRoot);
extern void MLT_vSetQuaternionFromMatrix (MTH_tdxReal stMatrix[3][3], float stQ[4]);


#endif //  A3DSAVE_H
