/*=========================================================================
*
* Banks.h	- Bank conversion
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef BANKS_H
#define BANKS_H


//--- Includes --------------------------------------------------------

#include "typedef.h"

#include "sprobj.h"

//----------------------------------------------------------------------


#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus
/********************************************************/
#endif // _WINDOWS


//--- Globals --------------------------------------------------------

extern MLT_tdxHandleToSuperObject	g_hBankRoot;


//--- Functions --------------------------------------------------------

// computation functions
extern void MLT_vComputeAllBanks	(char *sRawData, char *sGameData);
extern void MLT_vComputeOneBank		(char *sBankName, char *sRawData, char *sGameData);
extern void MLT_vComputeOneMod		(char *sBankName, char *sModName, char *sRawData, char *sGameData);

// search functions
extern BOOL MLT_bFindFileInBank				(char *sFile, char *sIdent, char *sFamily);
extern BOOL MLT_bFindFileInBankInGameData	(char *sFile, char *sIdent, char *sFamily);
extern void MLT_vFindInDir					(xString sDirectory, xString sGame, char* sFile, char *sIdent, char *sFamily, BOOL *bRes);

extern void MLT_vExistFile					(char *sBankName, char *sRawData, char *sDir, char *sExt, int *j);
extern void MLT_vExistFileInBank			(char *sBankName, char * sDir, char *sExt, int *j);
extern void MLT_vGetCommonExt				(int *iNbCommonFiles);

//----------------------------------------------------------------------


#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus
/********************************************************/
#endif // _WINDOWS


#endif // BANKS_H 
