/*=========================================================================
*
* Families.h	- Family Conversion
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef FAMILIES_H
#define FAMILIES_H

//--- Includes --------------------------------------------------------

#include "typedef.h"

//----------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS


//--- Globals ---------------------------------------------------------

extern int  g_iSpecific1; 
extern int  g_iSpecific2;

// files
extern char g_szFiles[20][5];
extern int  g_iNbFiles;


//--- Functions --------------------------------------------------------

// computation functions
extern void MLT_vComputeAllFamilies	(char *RawData, char *GameData);
extern void MLT_vComputeOneFamily	(char *FamilyName, char *RawData, char *GameData);
extern void MLT_vComputeOneObj		(char *sFamilyName, char *sObjName, char *sRawData, char *sGameData);

// anims functions
extern void MLT_vCopyAnims				 (char *sFamily);
extern void MLT_vSubstituteAnimInStaFile (char *sFamily);

// search functions
extern void MLT_vSearchInGame		(char *sFamily, BOOL *bFound, xString sGame, xString sAnim);
extern BOOL MLT_bSearchExt			(char *sExt);


#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS

#endif // FAMILIES_H 
