/*=========================================================================
*
* GeoSprite.h	- Sprite Object
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef GEOSPRIT_H
#define GEOSPRIT_H


//--- Includes --------------------------------------------------------

#include "MTH.h"

#include "typedef.h"

#include "Material.h"


//--- defines --------------------------------------------------------

#define MLT_C_lSpriteDrawMode2DScaled  1
#define MLT_C_lSpriteDrawMode2DRotativ 2
#define MLT_C_lSpriteDrawDisable       4


//--- structures --------------------------------------------------------

typedef struct MLT_tdstSprite_
{ 
	// flag
	char				AlreadySave;
	// name
	xString				sName;
	// parameters
	long				xNbSprites;
	short				*d_xSpriteDrawMode;
	MTH_tdxReal			*d_xThresholds;
	MTH2D_tdstVector	*d_xSizeOfSprite;
	MTH2D_tdstVector	*d_xDisplacementOfSprite;
	// material
	xString				*d_sMaterial;
	MLT_tdstMaterial	**d_hMaterial;
} 
MLT_tdstSprite;



#endif // GEOSPRIT_H 