/*=========================================================================
*
* SaveMdf.h	- Saving functions for ModifLst.txt file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef SAVEMODIF_H
#define SAVEMODIF_H


//--- Includes --------------------------------------------------------

#include "typedef.h"

//----------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS



//--- Globals ---------------------------------------------------------

extern BOOL g_bPrintOutOK;


//--- Defines ---------------------------------------------------------

#define M_TempSCR_Modif "TempModifLst.txt"


//--- Functions ---------------------------------------------------------

// texture file
extern void MLT_vBeginSaveTextureFile	(char *sDir);
extern BOOL MLT_bFirstAccesInFile		(char *sDir);
extern void MLT_vWriteInTextureFile		(char *sDir, char *sMessage);
extern void MLT_vEndSaveTextureFile		(void);
// modif file
extern void MLT_vSavePosInModifFile		(void);
extern void MLT_vAddEntryToModifFile	(char *sLine);
extern void MLT_vUpdatePathInModifFile	(char *_p_cPath);


#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus 
/********************************************************/
#endif // _WINDOWS

#endif // SAVEMODIF_H 