/*=========================================================================
*
* SpoSave.h	- Saving functions for SPO file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef SPOSAVE_H
#define SPOSAVE_H


//--- Includes --------------------------------------------------------

#include "SCR.h"
#include "MTH.h"

#include "sprobj.h"

//--- Globals ---------------------------------------------------------

extern double g_fLimit1;
extern double g_fLimit2;
extern double g_fLimit3;


//--- Functions ---------------------------------------------------------

// header
extern void MLT_vSaveEmptySpoHeader	(SCR_tdst_File_Description *p_stFile, char *sFileName, void *p_vPtr, SCR_tde_Ntfy_Action xAction);
// sections
extern void MLT_vSaveSuperObject	(SCRIPT_tdstSaveFile *p_stFile, MLT_tdxHandleToSuperObject hSprObj);
extern void MLT_vSaveMatrix			(SCRIPT_tdstSaveFile *p_stFile, MLT_tdstMatrix *p_stMatrix);
// file
extern void MLT_vSaveSpoFile		(MLT_tdxHandleToSuperObject hRoot);
extern void MLT_vSaveHierarchy		(MLT_tdxHandleToSuperObject hRoot);
// test
extern BOOL MLT_vCompareMatrix		(MTH_tdxReal RotMatrix[3][3], MTH_tdxReal RotMatrixComp[3][3]);


#endif // SPOSAVE_H 