/*=========================================================================
*
* VseLoad.h	- loading functions for VSE file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef VSELOAD_H
#define VSELOAD_H


//--- Includes --------------------------------------------------------

#include "SCR.h"


//--- Structures ---------------------------------------------------------

typedef struct MLT_tdstVSE_
{
  int iVSE;
} 
MLT_tdstVSE;


//--- Functions ---------------------------------------------------------

// init
extern void MLT_vInitVSELoad();
// load
extern SCR_tde_Anl_ReturnValue MLT_xLoadVS	(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue MLT_xLoadLOD	(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);


#endif // VSELOAD_H