/*=========================================================================
*
* Zooload.h	- loading functions for ZOO file
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef ZOOLOAD_H
#define ZOOLOAD_H


//--- Includes --------------------------------------------------------

#include "SCR.h"

#include "typedef.h"


//--- Structures ---------------------------------------------------------

typedef struct MLT_tdstZoo_
{
  xString sCS[1000];
  xString sZDR[1000];
  xString sZDM[1000];
  xString sZDE[1000];
  xString sZDD[1000];
} 
MLT_tdstZoo;


//--- Functions ---------------------------------------------------------

// init
extern void MLT_vInitZOOLoad();
// load
extern SCR_tde_Anl_ReturnValue MLT_xLoadAllCollideSets(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
extern SCR_tde_Anl_ReturnValue MLT_xLoadCS(SCR_tdst_File_Description *p_fFile, char *szAction, char *szParams[], SCR_tde_Anl_Action cType);
// search
extern BOOL MLT_bExistIn (xString * p_sArray, xString sIdent1);
extern int	MLT_iIndex	 (xString sIdent, MLT_tdstZoo* p_stZoo);


#endif // ZOOLOAD_H