/*=========================================================================
*
* Main.h	- globals
*
* Version			1.0
* Revision date
*
*=======================================================================*/
#ifndef __MAIN_H__
#define __MAIN_H__


//--- Includes --------------------------------------------------------

#include "typedef.h"

//----------------------------------------------------------------------

#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
extern "C" {
#endif // __cplusplus 
/********************************************************/
#endif //_WINDOWS


//--- Typedefs ---------------------------------------------------------

typedef enum { C_Anim, C_Family, C_Bank, C_Level, C_Classe , C_Texture} MLT_tdeCategory;

//--- Globals ---------------------------------------------------------

// current version
extern char g_fVersion[9];
extern BOOL g_bVersionN64;

// modes
extern BOOL g_bOneAnimMode,		g_bAnimMode;
extern BOOL g_bOneBankMode,		g_bBankMode;
extern BOOL g_bOneClassMode,	g_bClassMode;
extern BOOL g_bOneLevelMode,	g_bLevelMode;
extern BOOL g_bOneFamilyMode,	g_bFamilyMode;
extern BOOL g_bOneTextureMode,	g_bTextureMode;

// data
extern MLT_tdeCategory g_cCategoryType;

extern xString	g_sAnim[100];
extern xString	g_sBank[100];
extern xString	g_sClass[100];
extern xString	g_sLevel[100];
extern xString	g_sFamily[100];
extern xString	g_sTexture[100];

extern long		g_lAnimNum;
extern long		g_lBankNum;
extern long		g_lClassNum;
extern long		g_lLevelNum;
extern long		g_lFamilyNum;
extern long		g_lTextureNum;

// directories
extern xString g_sInitialDir;

extern xString g_sRawData;
extern xString g_sGameData;



#ifdef _WINDOWS
/********************************************************/
#ifdef __cplusplus
}
#endif // __cplusplus 
/********************************************************/
#endif //_WINDOWS

#endif //__MAIN_H__
