/*
 =======================================================================================
  Name        : HelpId.h
 
  Author      : vincent lhullier            Date :27/07/97
 
  Description : topic id of help file
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#ifndef __MNGDTHLP_H__
#define __MNGDTHLP_H__
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	CONSTANTS 
 =======================================================================================
 */

/*
 * Help file name
 */
#define C_szHelpFile	"MngData5.Hlp"


/*
 * topic IDs
 */
#define IDH_J_BUGS					1
#define IDH_J_CHANGINGLOCALPATH		2
#define IDH_J_CONFIGFILELIST		3
#define IDH_J_CONFLICT				4
#define IDH_J_FAQ					5
#define IDH_J_INIFILE				6
#define IDH_J_INTERFACE				7
#define IDH_J_ITF_COMMANDBUTTONS	8
#define IDH_J_ITF_INFOS				9
#define IDH_J_ITF_RESULTWINDOW		10
#define IDH_J_LOGIN					11
#define IDH_J_OBTAIN				12
#define IDH_J_REQUESTS				13
#define IDH_J_REQUIREMENTS			14
#define IDH_J_SECTIONFILELIST		15
#define IDH_J_SECTIONOBTAINING		16
#define IDH_J_SECTIONTARGETPATH		17
#define IDH_J_SECTIONVSS			18
#define IDH_J_SECTIONWINPREF		19
#define IDH_J_STARTING				20
#define IDH_J_SUMMARY				21
#define IDH_J_UPDATE				22
#define IDH_J_UPDATEOPTIONS			23
#define IDH_J_VIEWMODIF				24
#define IDH_J_WAIT					25
#define IDH_P_BROWSE				26
#define IDH_P_HELP					27
#define IDH_P_INOBTAIN				28
#define IDH_P_INUPDATE				29
#define IDH_P_LOCALPATH				30
#define IDH_P_LOOKINOBTAIN			31
#define IDH_P_LOOKINUPDATE			32
#define IDH_P_ME					33
#define IDH_P_MESSAGEERROR			34
#define IDH_P_MODIF					35
#define IDH_P_MODIFLIST				36
#define IDH_P_MORE					37
#define IDH_P_OBTAIN				38
#define IDH_P_OBTAININGTIME			39
#define IDH_P_QUIT					40
#define IDH_P_REFRESH				41
#define IDH_P_RESULTVIEW			42
#define IDH_P_UPDATE				43
#define IDH_P_VIEWMODIF				44
#define IDH_P_VSSEXE				45
#define IDH_P_VSSPATH				46


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#endif __MNGDTHLP_H__
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/