/*
 =======================================================================================
  Name        :TimeFunc.h
 
  Author      :vincent lhullier             Date :26/07/97
 
  Description :header file for time functions
 =======================================================================================
  Modification -> Author :                  Date :
  Description :
 =======================================================================================
 */

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
#ifndef __TIMEFUNC_H__
#define __TIMEFUNC_H__
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*
 =======================================================================================
	Globals 
 =======================================================================================
 */
extern time_t	g_xUpdateTime;
extern char		g_szUpdateTimeString[20];


/*
 =======================================================================================
	Functions to analyse content of a buffer
 =======================================================================================
 */


BOOL fn_bReadInt( char *p_cBuf, int iNumDigit, int *p_iResult);
BOOL fn_bReadDate( char *p_cBuf, struct tm *p_stTime);

/*
 =======================================================================================
	Time functions
 =======================================================================================
 */


BOOL fn_bSynchronizeTime( BOOL _bMessage );
void fn_vInitUpdateTime( void );
void fn_vFormatDateTime( time_t xTime, char *szString );
BOOL fn_bRequestTimeServer( BOOL _bMessage );

#endif //__TIMEFUNC_H__