
//
//	FILE	: List.h
//	AUTHOR	: Catalin Cocos
//__________________________________________________________________________________________________

#ifndef __LISTH__
#define __LISTH__

#include "tipwin.h"
extern CTip* pListTip;

extern WNDPROC OutIWP;
extern WNDPROC ListIWP;
extern WNDPROC FilterIWP;

LRESULT CALLBACK ListWndProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp );
LRESULT CALLBACK OutWndProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp );
LRESULT CALLBACK FilterWndProc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp );


void DeleteListItem(int idx);
void DeleteCollectionList();
void ShowItemPath( HWND hwnd, int iItem);
void InsertCollectionFile(HWND hwnd, char* buffer);

#endif