; SCR 201
; Scripts Parser Version 2.0.1
; (c) Ubi Simulations 1997

;***************************************************************************
;*** This section contain all data's directories classed by type of file ***
;*** it can be used to overload one or more files without destroy        ***
;*** old files                                                           ***
;***************************************************************************


{DirectoriesDescription:

 ;*** Texture's directory ***
 DirectoryOfEngineDLL("DLL")

 ;*** Texture's directory ***
 DirectoryOfTexture("\World\Graphics\Textures")
 DirectoryOfFixTexture("\FixTex")

 ;*** Texts directory ***
 DirectoryOfTexts("\Texts")

 ;*** GameData directories ***
 DirectoryOfGameData("GameData")

 ;*** World directories ***
	DirectoryOfWorld("\World")

 ;*** Levels directories ***
	DirectoryOfLevels("\World\Levels")

 ;*** Families directories ***
	DirectoryOfFamilies("\World\Levels\_Common\Families")

 ;*** Characters directories ***
 DirectoryOfCharacters("\World\Levels")

 ;*** Animations directories ***
	DirectoryOfAnimations("\World\Graphics\Anims")

 ;*** Graphic Objects directories ***
	DirectoryOfGraphicsClasses("\World\Graphics\Objects\Classes")
	DirectoryOfGraphicsBanks("\World\Graphics\Objects\Banks")

 ;*** Mechanics directories ***
	DirectoryOfMechanics("\World\Libraries\Mechanics")

 ;*** SoundData directories ***
	DirectoryOfSound("\World\Sound")
 ;	DirectoryOfSound("\World\Sound\English")

 ;*** Material directories ***
	DirectoryOfVisuals("\World\Graphics\Visuals")
	DirectoryOfMaterials("\World\Libraries\Materials")

 ;*** Environment directories ***
 DirectoryOfEnvironment("\World\Libraries\Environment")

 ;*** SaveGame directories ***
	DirectoryOfSaveGame("\SaveGame")

 ;*** Extras directories ***
	DirectoryOfExtras("\Extras")

 ;*** Vignettes directories ***
	DirectoryOfVignettes("\Vignette")

 ;*** Options directory ***
 DirectoryOfOptions("\Options")

 ;*** Options directory ***
 DirectoryOfZdx("\World\Levels")

 ;*** Options directory ***
 DirectoryOfLipsSync("\World\SyncLips\English")

 ;*** Effects Directory ***
 DirectoryOfEffects("\World\Effects")
}

;********************
;*** Concat files ***
;********************
{BigFiles:
; Vignettes("\Vignette.cnt")
 Textures("\Textures.cnt")
}
{Vignette:
;	LoadVignette("UbiSoft.bmp")
;	DisplayVignette
}

;******************************************
;*** Input devices manager descriptions ***
;******************************************
{InputDeviceManagerDescription:
	InitInputDeviceManager(16)

; List of all the keys and buttons
	AddInputDeviceFile("KeyDef.ipt")

; List of the active devices
	AddInputDeviceFile("Device.ipt")

; List of the actions for the AI
	AddInputDeviceFile("AiAction.ipt")
	AddInputDeviceFile("Camera.ipt")

; List of the actions for the engine
	AddInputDeviceFile("Debug.ipt")
	AddInputDeviceFile("Cheat.ipt")
	
	Computetable()

; For the engine to use the actions
	AddInputDeviceFile("Link.ipt")
}

;*******************
;*** Text loader ***
;*******************
{Texts:

 AddStringsFile("Game.txt")
 AddStringsFile("Cheats.txt")
 AddStringsFile("Cinematiques_SUN.txt")
 AddStringsFile("Cinematiques_MOM.txt")
 AddStringsFile("Cinematiques_SDZ.txt")
 AddStringsFile("Cinematiques_NIK.txt")
 AddStringsFile("Dialogues_SUN.txt")
 AddStringsFile("Dialogues_MOM.txt")
 AddStringsFile("Dialogues_SDZ.txt")
 AddStringsFile("Dialogues_NIK.txt")
 AddStringsFile("Menus.txt")
 AddStringsFile("MapMonde.txt")
 AddStringsFile("Livre.txt")
 AddStringsFile("Demos.txt")
 AddStringsFile("AOJ_jcp_cb_xp.txt")
 AddStringsFile("Textes_FRH.txt")
 AddStringsFile("course.txt")
 AddStringsFile("Seat_10_hp.txt")
 AddStringsFile("Cinematiques_OLD.txt")
 AddStringsFile("Raycap.txt")
; AddStringsFile("CdtStd.txt")
; AddStringsFile("CdtNme.txt")
; AddStringsFile("Credits.txt")
; AddStringsFile("SaveName.txt")
}

;***********************************
;*** Random manager descriptions ***
;***********************************
{RandomManagerDescription:
	InitRandomManager("Game.rnd")
}

;********************
;*** Game Options ***
;********************
{GameOptionsFile:
 DefaultFile("Default.cfg")
 CurrentFile("Current.cfg")
; SkipMainMenu
; CreditsLevelName(outro)

;FrameSynchro(ON,0,50) hystreresis 50%
;2 trames minimum
FrameSynchro(ON,2,95)
}


;****************************************************************************************
;*** Binary Use                                                                       ***
;*** UseA3b : 0=Use A3B, 1=Don't use A3B, 2=Force generate A3B                        ***
;*** UseBinaryMod : 0=Don't use binary MOD 1=Use binary MOD                           ***
;*** UseBinaryData : 0=Don't use binary data 1=Use binary data 2=Generate binary data ***
;****************************************************************************************
{BinaryUse:
 UseA3b(0)
 UseBinaryMod(0)
 UseBinaryData(0)
}


{FirstLevelDescription:
LevelName(MapTuto_F)
LevelName(Gymg)
LevelName(raygear)
LevelName(MapTuto_G)
LevelName(MapTuto_T)
LevelName(MapTuto_V)
LevelName(lvl1G)
}


;*********************************************
;*** Dimentionnement des stacks Animation  ***
;*** Max 65534 sauf pour FramesKF (+4.10E9)***
;*** La taille represe le nommbre d'elem.  ***
;*********************************************
; NE PAS CHANGER L'ORDRE 0 --> A3dGeneral .... 11 --> MorphData
{AnimStacks:
   A3dGeneral(1500)
   Vertexes(70000)
   Quaternions(60000)
   Hierarchies(5000)
   NTTO(40000)
   OnlyFrames(30000)
   Channels(30000)
   Frames(52000)
   FramesKF(230000)
   KeyFrames(70000)
   Events(5000)
   MorphData(30000)
}
