/*-----------------------------------------------------------------------------*/
/* create : 23/10/96 Olivier Couvreur */
/* modify : 30/10/96 Olivier Couvreur */
/*	970115 :	Field Position in perso					(Fabien Morales)*/
/*	970120 :	Field ComportOnGeneration in perso		(Fabien Morales)*/
/*	970128 :	Fields from the AimData structure		(Fabien Morales)*/
/*  970731 :    Script & Editor Names + Lint            (Olivier Couvreur)*/
/* modify : Olivier Couvreur*/
/* date   : 18/02/1997  CPA_EXPORT + new functions for editor*/
/* modify : Olivier Couvreur 25/03/1997  ACTIVE_EDITOR support*/
/*-----------------------------------------------------------------------------*/
 
#if !defined(__GET_SET_H__)
#define __GET_SET_H__
 
/**************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/**************************************/
#undef extern
#define EXTERN_AI_DLL extern
 
/*******************************************************************************/
 
/* get set functions */
EXTERN_AI_DLL CPA_EXPORT unsigned char fn_ucSetFieldValue(enum tdeFieldId_ eFieldId, HIE_tdxHandleToSuperObject hSuperObjPerso, struct tdstGetSetParam_ *p_stGetSetParam);
EXTERN_AI_DLL CPA_EXPORT unsigned char fn_ucGetFieldValue(enum tdeFieldId_ eFieldId, HIE_tdxHandleToSuperObject hSuperObjPerso, struct tdstGetSetParam_ *p_stGetSetParam);
 
/*******************************************************************************/
#undef EXTERN_AI_DLL
 
#endif
