#if !defined(__VAR_TYPE_H__)
#define __VAR_TYPE_H__
 
typedef enum tdeVariableType_{
	E_vt_None=0,
		E_vt_Boolean,			/*TRUE or FALSE value. a char is used, after we will use a bit field*/
		E_vt__128To127,			/*char */
		E_vt_0To255,			/*unsigned char*/
		E_vt__32768To32767,		/*short*/
		E_vt_0To65535,			/*unsigned short	*/
		E_vt_Integer,			/*long*/
		E_vt_PositiveInteger,	/*unsigned long*/
		E_vt_Float,				/* MTH_tdxReal for example for store a distance*/
		E_vt_String,            /* char **/
		E_vt_WayPoint,			/* handle to a waypoint*/
		E_vt_Perso,				/* tdstPerso * : pointer at a perso*/
		E_vt_List,				/*List of C_ucSizeOfMinimalList element. E_vt_List+n  specifies a list with C_ucSizeOfMinimalList+n-2 elements*/
		E_vt_1bit, /* 1 bit*/
		E_vt_2bit, /* 2 bit*/
		E_vt_3bit, /* 3 bit*/
		E_vt_4bit, /* 4 bit*/
		E_vt_5bit, /* 5 bit*/
		E_vt_6bit, /* 6 bit*/
		E_vt_7bit, /* 7 bit*/
		E_vt_MetaActionReturn, /*unsigned char*/
		E_vt_Vector,	/* MTH3D_tdstVector*/
		E_vt_Module,    /* long*/
		E_vt_DsgVarId,  /* long*/
		E_vt_Action, /* tdxHandleToState*/
		E_vt_Button,
		E_vt_Mask,      /* GMTMask*/
		E_vt_Surface,
		E_vt_LipsSynchro, /* CGHT*/
		E_vt_ObjectTable, /* CGHT*/
		/*E_vt_Sector,*/
		E_vt_SuperObject, /* for object*/
		E_vt_Environment,
		E_vt_Family,
		E_vt_SoundEvent,  
		E_vt_Comport,
		E_vt_Font,
		E_vt_Text,
		E_vt_ParticleGenerator, /* JO 09/10/97*/
		E_vt_GameMaterial,
		E_vt_Color,
		E_vt_Model,
		E_vt_Array, 
		E_vt_Light, 
		E_vt_Caps, 
		E_vt_Graph, 
		/*********************************/
		E_Nb_vt       /* MUST BE AT  END */
		/*********************************/
} tdeVariableType;
 
#endif /* __VAR_TYPE_H__*/
