/*
  MODULE : COL (Intersection & Collision Library)
  AUTHOR : Frederic PHILIPPE
           UBI R&D
  FILE : CsEltEdg.h (Geometric object collision)
*/
 
#ifndef COL_CSELTEDG_H
#define COL_CSELTEDG_H
 
#ifdef __cplusplus
    extern "C" {
#endif
 
#include "cpa_expt.h"
 
/* For Global declaration in C files : */
#ifdef COL_GLOBALS
 #define COL_EXTERN extern
#else /* !COL_GLOBALS */
 #define COL_EXTERN
#endif /* !COL_GLOBALS */
 
/*
-----------------------------------------------------------------------------
INCLUDES FILES
-----------------------------------------------------------------------------
*/
 
#include "Futil.h"
#include "Box.h"
#include "Inters.h"
#include "IntersGO.h"
#include "OctreeGO.h"
#include "CollGOCo.h"
 
/*
-----------------------------------------------------------------------------
FUNCTIONS DECLARATION
-----------------------------------------------------------------------------
*/
 
extern CPA_EXPORT void COL_fn_vCollideStaticSphereWithStaticEdge (COL_tdstGVForCollision *p_stGV,
/* ANNECY AV {*/
                                                                  MTH3D_tdstVector * p_stNormal);
/* END ANNECY AV }*/
 
#ifdef __cplusplus
    };
#endif
 
#endif /* COL_COEDGELT_H */
