/* Constants definition for the Charactersitics Editor*/
/*//////////////////////////////////////////////////////*/
#ifndef _CTL_CONSTANTS_
#define _CTL_CONSTANTS_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
/*Definitions for Spin Buttons*/
#define C_SPIN_PRECISION							3
#define C_ACCEL_NB										5
 
/*Global definitions for controls*/
#define C_SPACE_BETWEEN_CONTROLS			2
#define C_EDIT_HEIGHT									16
#define C_SPIN_WIDTH									13
#define C_SPIN_HEIGHT									17
 
/*Definitions for Boolean control*/
#define C_BOOL_NAME_BOX_PERCENT_WIDTH	70
#define C_BOOL_NAME_BOX_MIN_WIDTH			40
#define C_BOOL_BUTTON_PERCENT_WIDTH		30
#define C_BUTTON_HEIGHT								20
#define C_BUTTON_WIDTH								40
 
/*Definitions for Enum control*/
#define C_ENUM_BOX_TOTAL_HEIGHT				100
#define C_ENUM_COMBO_BOX_HEIGHT				20
#define C_ENUM_BOX_PERCENT_WIDTH			50
#define C_ENUM_BOX_MIN_WIDTH					90
#define C_ENUM_NAME_PERCENT_WIDTH			50
 
/*Definitions for Float control*/
#define C_DECIMAL_NAME_BOX_PERCENT_WIDTH				70
#define C_DECIMAL_CURRENT_VALUE_PERCENT_WIDTH		30
#define C_DECIMAL_CURRENT_VALUE_MIN_WIDTH				50		/*for Auto Spacing*/
 
/*Definitions for Int control*/
#define C_INT_NAME_BOX_PERCENT_WIDTH						70
#define C_INT_CURRENT_VALUE_PERCENT_WIDTH				30
#define C_INT_CURRENT_VALUE_MIN_WIDTH						50		/*for Auto Spacing*/
 
/*Definitions for Text control*/
#define C_TEXT_NAME_BOX_PERCENT_WIDTH						60
#define C_TEXT_CURRENT_VALUE_PERCENT_WIDTH			40
#define C_TEXT_CURRENT_VALUE_MIN_WIDTH					50		/*for Auto Spacing*/
 
#endif /*_CTL_CONSTANTS_*/
