/* Definition for the list of Masks*/
/**/
/* (used by Masked Data and Controls)*/
/**/
/* Written by YB*/
/*/////////////////////////////////////////*/
#ifndef _CTL_EDITORS__MASK_LIST_HPP_
#define _CTL_EDITORS__MASK_LIST_HPP_
 
#include <afxtempl.h>
#include "ACP_Base.h"			/*For CPA_EXPORT*/
 
/*######################################################################*/
class CPA_EXPORT CTL_Editor_Mask
{
public:
	CTL_Editor_Mask(CString _csString, unsigned long _ulValue);
	~CTL_Editor_Mask();
 
/*Members*/
public:
 
protected:
 
private:
	CString m_pri_csString;
	unsigned long m_pri_ulMaskValue;
 
/*Functions*/
public:
	CString m_pub_fn_csGetString();
	unsigned long m_pub_fn_ulGetMaskValue();
 
protected:
 
private:
 
};
 
/*######################################################################*/
class CPA_EXPORT CTL_Editor_MaskDescriptor : public CList<CTL_Editor_Mask *, CTL_Editor_Mask *>
{
public:
	CTL_Editor_MaskDescriptor(CString _csName);
	~CTL_Editor_MaskDescriptor();
 
/*Members*/
public:
 
protected:
 
private:
	CString m_pri_csName;
 
/*Functions*/
public:
	CString m_pub_fn_csGetName();
	CTL_Editor_Mask *m_pub_fn_pclAddMask(CString _csString, unsigned long _ulValue);
 
protected:
 
private:
	void m_pri_fn_vEmptyList();
 
};
 
/*######################################################################*/
class CPA_EXPORT CTL_Editor_MaskList : public CList<CTL_Editor_MaskDescriptor *, CTL_Editor_MaskDescriptor *>
{
public:
	CTL_Editor_MaskList();
	~CTL_Editor_MaskList();
 
/*Members*/
public:
	CTL_Editor_MaskDescriptor *m_pub_fn_pclAddMaskDescriptor(CString _csName);
	void m_pub_fn_vEmptyList();
 
	CTL_Editor_MaskDescriptor *m_fn_pclGetMaskDescriptorByName(CString _csDescriptorName);
 
protected:
 
private:
 
/*Functions*/
public:
 
protected:
 
private:
 
};
 
 
#endif /*_CTL_EDITORS__MASK_LIST_HPP_*/
 
