/* CPACEdBu.hpp : header file*/
/*///////////////////////////////////////////////////////////////////////////*/
#ifndef _CPACEDBU_HPP_
#define _CPACEDBU_HPP_
 
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000*/
 
#include "ACP_Base.h"
#include "CTL\WControls\CTL_BWC.hpp"
#include "CTL\Others\CTL_ClBk.hpp"
 
/*###########################################################################*/
typedef enum CTL_eButtonType
{
	CTL_BUTTON_TYPE__EDIT = 0,
	CTL_BUTTON_TYPE__DEVELOP,
	
	CTL_BUTTON_TYPE__USE_USER_DEFINED_TYPE,
 
} CTL_tdeButtonType;
 
/*###########################################################################*/
class EdActors_SpecialToolTip;
class CTL_Editor_Control;
 
class CPA_EXPORT CTL_Editor_Button :	public CButton,
																			public CTL_BaseWindowsControl
{
/* Construction*/
public:
	CTL_Editor_Button(CString _csName,
										CTL_tdeButtonType _tdeType,
										long _lAdditionnalStyles,
										CTL_Editor_Control *_pclParentControl,
										CWnd *_pclParentWnd,
										long _lUserDefinedType = 0,
										long _lUserDefinedCode = 0);
 
/* Attributes*/
public:
 
private:
	CTL_tdeButtonType m_tdeType;
 
	CTL_tdp_fn_vButtonHasBeenClicked m_pri_td_p_fn_vButtonHasBeenClicked_CallBack;
 
/*	EdActors_SpecialToolTip *m_pclToolTip;*/
	
/* Operations*/
public:
	void m_fn_vSetText(CString csText);
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CTL_Editor_Button)*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
public:
	virtual ~CTL_Editor_Button();
 
	void m_pub_fn_vSetButtonHasBeenClicked_CallBack(CTL_tdp_fn_vButtonHasBeenClicked _p_fn_vCallBack);
 
	/*For TUT registration*/
	virtual void m_pub_fn_vRegisterWindowsControl(CString _csAdditionnalInfo);
	
	/* Generated message map functions*/
protected:
	/*{{AFX_MSG(CTL_Editor_Button)*/
	afx_msg void OnClicked();
	/*}}AFX_MSG*/
 
	DECLARE_MESSAGE_MAP()
};
 
/*///////////////////////////////////////////////////////////////////////////*/
#endif /*_CPACEDBU_HPP_*/
 
