/*=========================================================================
* AllActs.h :       This file contain included files to define all object.
* This is a part of the Hed project.
*
* Version              1.0
* Creation date        09/08/96
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
 
#if !defined(__ALLACTS_H__ )
#define __ALLACTS_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#include "ACP_Base.h"
#include "GAM/Structur/StdObjSt.h"
 
#include "GAM/objinit.h"
#include "GAM/TypeCam.h"
 
/**** Include here all actions headers files ****/
 
#include "Brain.h"
#include "Dynam.h"
#include "Cineinfo.h"
#include "CollSet.h"
#include "MSWay.h"
#include "MSLight.h"
#include "SectInfo.h"
#include "MS_Micro.h"
#ifndef D_THROW_PRT
#include "MSPrtSrc.h"
#endif /* D_THROW_PRT */
#include "MSSound.h"		/* JO 08/12/97*/
#ifndef D_THROW_ANIM_EFFECT
#include "Animfx.h"
#endif /* D_THROW_ANIM_EFFECT */
/*XB980824*/
#ifndef D_THROW_MGT
#include "MSMag.h"
#endif /* D_THROW_MGT */
/*End XB*/
 
#include "3dData.h"
#include "StdGame.h"
 
 
void fn_vRegisterAllActionsScriptSections();
 
#define C_SectionOneCharacters		  "Character"
 
#if !defined(U64)
SCR_tde_Anl_ReturnValue fn_eScriptCallBackOneCharacter(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
 
/* For binary purposes*/
unsigned long EngineObject_fn_ulWriteBinaryBloc(unsigned long _ulStructAddress, char* _p_cDestBuffer);
void EngineObject_fn_vReadBinaryBloc(unsigned long _ulStructAddress);
 
#endif /* U64 */
 
 
#endif /* !__ALLACTS_H__ */
 
