/*=========================================================================
* LoadGls.h   : This module contain all functions used to load
*               global variables.
* This is a part of the Game project.
*
* Version              1.0
* Creation date        28/08/96
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
 
#if !defined(__LOADGLS_H__)
#define __LOADGLS_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#define C_SectionFirstLevelDescription "FirstLevelDescription"
 
#define C_SectionLanguage	"Languages"
#define C_AddLanguage		"AddLanguage"
 
#define C_SectionAddStringsFiles "Texts"
#define C_EntryAddStringsFile    "AddStringsFile"
/*#define C_EntryAddFontFile       "AddFontFile"*/
 
#define C_SectionPreloadSectionInFix   "PreloadSectionInFix"
#define C_Entry_PreloadSection         "PreloadSection"
#define C_Entry_SecondPassForCharacter "SecondPassForCharacter"
void fn_vLoadGameMemoryScript(void);
void fn_vLoadGameScript(void);
void fn_vLoadGameFixScript(void);
 
/* Modif Gus 98/08/11*/
void fn_vLoadReducedGameScript(void);
 
#if !defined(U64)
SCR_tde_Anl_ReturnValue fn_eScriptCallBackDirectoriesDescription(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackInputDeviceManagerDescription(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackRandomManagerDescription(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackGameOptionsFileDescription(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackPreloadSectionInFix(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackAddStringsFiles(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackFirstLevel(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackBigFile(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
 
SCR_tde_Anl_ReturnValue fn_eScriptCallBackAnimStacksDescription(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action	_eAction);
 
/*ANNECY BBB 24/10/97 {*/
SCR_tde_Anl_ReturnValue fn_eScriptCallBackAdditionalLevel(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action _eAction);
SCR_tde_Anl_ReturnValue fn_eScriptCallBackLanguage(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action _eAction);
 
/*BEGIN OS 09-Mar-98*/
SCR_tde_Anl_ReturnValue fn_eScriptCallBackBinAdditionalLevel(SCR_tdst_File_Description *_p_stFile,char *_p_szName,char *_ap_szParams[],SCR_tde_Anl_Action _eAction);
/*END OS 09-Mar-98*/
 
/*ENDANNECY BBB 24/10/97 }*/
#endif /* U64 */
 
void fn_vDeleteAllFixReUsableSections(void);
 
#endif /* __LOADGLS_H__ */
