#if !defined(__FON_Eff_h__)
#define __FON_Eff_h__
 
#include "CPA_Expt.h"
 
#undef EXTERN
#undef extern
#if !defined(FON_MainFile)
#define EXTERN extern
#else
#define EXTERN
#endif /* FON_MainFile */
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/********************************************/
/**** ComeFromeFrontOrBack : 0x00xxyyzz*/
/****       xx = Speed * 10*/
/****       yy = Delta Z * 10*/
/****       zz = Z position*/
/*****/
/**** Rotation : 0x00xxyyzz*/
/****       xx = X rotation * 100*/
/****       yy = Y rotation * 100*/
/****       zz = Z rotation * 100*/
/********************************************/
 
typedef enum FON_tdeEffect_
{
 FON_E_EffectNoEffect            = 0x00000000,
 FON_E_EffectTranslationX        = 0x00000001,
 FON_E_EffectTranslationXTo0     = 0x00000002,
 FON_E_EffectTranslationY        = 0x00000004,
 FON_E_EffectTranslationYTo0     = 0x00000008,
 FON_E_EffectTranslationZ        = 0x00000010,
 FON_E_EffectTranslationZTo0     = 0x00000020,
 FON_E_EffectRotation            = 0x00000040,
 FON_E_EffectRotationTo0         = 0x00000080,
 FON_E_EffectScaleXWave          = 0x00000100,
 FON_E_EffectScaleXWaveTo1       = 0x00000200,
 FON_E_EffectScaleXTo1           = 0x00000400,
 FON_E_EffectScaleYWave          = 0x00000800,
 FON_E_EffectScaleYWaveTo1       = 0x00001000,
 FON_E_EffectScaleYTo1           = 0x00002000,
 FON_E_EffectScaleZWave          = 0x00004000,
 FON_E_EffectScaleZWaveTo1       = 0x00008000,
 FON_E_EffectScaleZTo1           = 0x00010000,
 FON_E_EffectLight               = 0x00020000,
} FON_tdeEffect;
 
/*typedef struct FON_tdstEffect_
{
 FON_tdeEffect  eEffect;
 unsigned long  ulTranslationXParam;
 unsigned long  ulTranslationYParam;
 unsigned long  ulTranslationZParam;
 unsigned long  ulRotationParam;
 unsigned long  ulScaleXParam;
 unsigned long  ulScaleYParam;
 unsigned long  ulScaleZParam;
 GLI_tdstLight *p_stLight;
} FON_tdstEffect;*/
 
/*typedef struct FON_stEffectByDisplay_
{
 struct FON_tdstEffect_  stEnabledEffect;
 struct FON_tdstEffect_  stDisabledEffect;
 struct FON_tdstEffect_  stSelectedEffect;
 struct FON_tdstEffect_  stPressedEffect;
} FON_stEffectByDisplay;*/
 
#if defined(U64) /* en attendant la vritable transplantation ( voir avec Franois ) */
/* Menu item text*/
/*typedef struct FON_stTextFont_
{
	char                       *szText;
 POS_tdxHandleToPosition    *d_hLocalMatrix;
 POS_tdxHandleToDynRotation *d_hLocalDynRotation;
	FON_tdxHandleOfFont        p_stFont;
 struct FON_tdstEffect_     stEffect;
} FON_tdstTextFont;*/
 
#endif /* U64 */
 
extern CPA_EXPORT void FON_fn_vSetElapsedTime(unsigned long ulTime);
 
/*extern CPA_EXPORT void FON_fn_vCopyEffectOfOneCharact(FON_tdxHandleOfString _hTextDest,unsigned long _ulIndexDest,FON_tdxHandleOfString _hTextSrc,unsigned long _ulIndexSrc);*/
 
/*extern CPA_EXPORT void FON_fn_vInitEffectOfOneCharactFor(FON_tdxHandleOfString _hText,enum FON_tdeTypeOfDisplay_ _eTypeOfDisplay,unsigned long _ulIndex);*/
/*extern CPA_EXPORT void FON_fn_vReinitTextEffectOfOneCharact(FON_tdxHandleOfString _hText,unsigned long _ulIndex);*/
/*extern CPA_EXPORT void FON_fn_vReinitTextEffectOfOneCharactWithEffect(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulIndex);*/
/*extern CPA_EXPORT void FON_fn_vDesinitTextEffectOfOneCharact(FON_tdxHandleOfString _hText,unsigned long _ulIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitEffectFor(FON_tdxHandleOfString _hText,enum FON_tdeTypeOfDisplay_ _eTypeOfDisplay);*/
/*extern CPA_EXPORT void FON_fn_vReinitTextEffect(FON_tdxHandleOfString _hText);*/
/*extern CPA_EXPORT void FON_fn_vReinitTextEffectWithEffect(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffect(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,FON_tdeEffect _eEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffect(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitTextEffectTranslationXTo0(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectTranslationXTo0OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectTranslationYTo0(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectTranslationYTo0OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectTranslationZTo0(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectTranslationZTo0OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectTranslationXYZTo0(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitTextEffectRotation(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectRotationOfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectRotation(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitTextEffectRotationTo0(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectRotationTo0OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectRotationTo0(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleX(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXOfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectScaleX(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXTo1OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleYTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleYTo1OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleZTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleZTo1OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectScaleXYZTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXWave(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXWaveOfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXWaveTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleXWaveTo1OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleYWave(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleYWaveOfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleYWaveTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleYWaveTo1OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleZWave(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleZWaveOfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleZWaveTo1(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectScaleZWaveTo1OfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectScaleXYZWave(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*extern CPA_EXPORT void FON_fn_vInitTextEffectLight(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam);*/
/*extern CPA_EXPORT void FON_fn_vInitTextEffectLightOfOneCharact(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long _ulParam,unsigned long lIndex);*/
/*extern CPA_EXPORT void FON_fn_vPlayLetterEffectLight(FON_tdxHandleOfString _hText,FON_tdstEffect *p_stEffect,unsigned long lIndex);*/
 
/*EXTERN FON_stEffectByDisplay FON_g_stEffectByDisplay;*/
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif /* __FON_Eff_h__ */
