#ifndef __MICROS_H__
#define __MICROS_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
#undef EXTERN
#undef extern
#if !defined(D_Micros_VariableDefine)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_CollSet_VariableDefine */
 
#define GAM_C_NBLOCKEVENTSLOTNUMBER		10

/* sound objects types */
EXTERN long g_lSoundObjectTypeAnim,	
#ifdef D_USE_LIPSYNC
			g_lSoundObjectTypeLipsSynchro,	/* for voices */
#endif
			g_lSoundObjectTypeMenu,			/* for menu and inventory */
			g_lSoundObjectTypeMusic;		/* for ambience musics */
 
/* sound volume lines */
EXTERN long 
#ifdef D_USE_LIPSYNC
			g_lSoundVolumeLineVoices,		/* for voices */
#endif
			g_lSoundVolumeLineSound,		/* voices of characters */
			g_lSoundVolumeLineMusic;		/* ambience musics */
 
/* temporary objects id. for Music */
#define C_SOUNDOBJECT_MUSIC 1
#define C_SOUNDOBJECT_SECTOR 2

/******************************************/
#define GAM_C_NBLOCKEVENTSLOTNUMBER		10

EXTERN SND_tdstBlockEvent	*ga_pstBlockEventSlotMemory[GAM_C_NBLOCKEVENTSLOTNUMBER];
/******************************************/
 
void fn_lInitSoundForAnim();

void GAM_fn_lSaveBlockEventSlotMemory(SND_tdstBlockEvent *_p_stBlockEvent,unsigned long _ulIndex);
SND_tdstBlockEvent *GAM_p_stGetBlockEventSlotMemory(unsigned long _ulIndex);
 
#endif /* __MICROS_H__ */
