/*=========================================================================
* SubMapPs.h :       Define the submap positions structure
* This is a part of the Game project.
*
* Version                      1.0
* Creation date        08/09/98
* Revision date
*
*
* (c) Ubi Studios 1998
*=======================================================================*/
 
#if !defined(__SUBMAPPS_H__)
#define __SUBMAPPS_H__ /*	{*/
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/******************************************/
#ifdef  __cplusplus
extern "C" {
#endif
/******************************************/
 
#include "GAM/Header.h"
 
/**/
typedef struct tdstSubMapPosition_
{
	long						lSubMap;
	POS_tdxHandleToPosition		hPosition;
	struct tdstSubMapPosition_	*p_stNextPosition;
} tdstSubMapPosition;
 
/**/
extern CPA_EXPORT void						GAM_fn_vAddSubMapPosition(long _lSubMapNumber , long _lEntryNumber , POS_tdxHandleToPosition	_hPosition);
extern CPA_EXPORT POS_tdxHandleToPosition	GAM_fn_hGetSubMapPosition(long _lSubMapNumber , long _lEntryNumber);
extern CPA_EXPORT void						GAM_fn_vInitSubMapPositionList();
extern CPA_EXPORT void						GAM_fn_vClearSubMapPositionList();
extern CPA_EXPORT void						GAM_fn_vLoadSubMapPositions(char *_szFileName);
 
/**/
extern tdstSubMapPosition *gs_hFirstSubMapPosition;
 
/******************************************/
#ifdef  __cplusplus
}/* extern "C" */
#endif
/******************************************/
 
 
/******************************************/
#endif /* __SUBMAPPS_H__	}*/
/******************************************/
