/*///////////////////////////////////////////////////////////*/
/*															//*/
/*		Memory Management of the Module : Game				//*/
/*															//			   */
/* File Name	: MemGame.h									//*/
/* Date			: 03/10/96									//*/
/* Author		: First_Name Last_Name						//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __MemGame_H__
#define __MemGame_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
enum e_ucGameStaticBlocks
{
 E_ucFirstMemoryBlock = 0,
 E_ucFirstFixMemoryBlock    = E_ucFirstMemoryBlock,
	E_ucGameFixMemory          = E_ucFirstFixMemoryBlock,
/*	E_ucGameTempFixMemory,*/
 E_ucLastFixMemoryBlock     = E_ucGameFixMemory,
 
 E_ucFirstLevelMemoryBlock,
 E_ucGameLevelMemory       = E_ucFirstLevelMemoryBlock,
	/*E_ucGameTempLevelMemory,*/
 E_ucLastLevelMemoryBlock  = E_ucGameLevelMemory,
 
 E_ucLastMemoryBlock = E_ucLastLevelMemoryBlock, 
	E_ucGameMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
};
 
#ifndef _FIRE_DEADCODE_U64_
EXTERN tdstBlockInfo g_a_stGameBlocksInfo[E_ucGameMaxBlocksNb];
#endif /* _FIRE_DEADCODE_U64_ */
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN tdstDynInfo g_stGameDynInfo;
#endif /* __DEBUG_MALLOC_MODE__ */
#endif /* __DYNAMIC_MALLOC_ALLOWED__ */
 
#endif /* __MemGame_H__ */
