/*=========================================================================
* StdObjSt.h : Define standard objects structures
*
* This is a part of the Game project.
*
* Version              1.0
* Creation date        01/10/96
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
 
#if !defined(__STDOBJST_H__)
#define __STDOBJST_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
M_BeginDeclareEnumerate(tdeObjectinitInit)
	OI_WhenPlayerGoOutOfActionZone = 0,
	OI_Always,
	OI_WhenPlayerIsDead,
	OI_WhenMapJustLoaded,
	OI_WhenSavedGameJustLoaded,
	OI_NeverBackWhenTaken,
	OI_NumberOfObjectInit,
	OI_WhenGeneratorIsDesactivated
M_EndDeclareEnumerate(tdeObjectinitInit,unsigned char)
 
typedef long tdObjectType;
#define C_InvalidObjectType -1
#define C_AlwaysObjectType  0x00010000
 
#endif /* __STDOBJST_H__ */
 
