#ifndef __TOOLCAM_H__
#define __TOOLCAM_H__
 
#if _MSC_VER >= 1000
#pragma once
#endif 
 
#include "GAM/Header.h"
 
 
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
 
#define CAM_Nb_Viewport	2
typedef struct tdstViewportManagement_
{
	HIE_tdxHandleToSuperObject	hCamera;
	HIE_tdxHandleToSuperObject	hTempCamera;
	struct GLI_tdstCamera_		*p_stCamera;
	ACP_tdxBool					bValid;
}tdstViewportManagement;
 
 
typedef struct tdstNodeCamera_
{
	HIE_tdxHandleToSuperObject	p_stSuperObjectCamera; 
	LST2_M_DynamicElementDeclaration(tdxHandleToNodeCamera)
} tdstNodeCamera;
 
 
void		CAM_fn_vCameraManagement(void);
void		CAM_fn_vActualizeAViewport(long);
void		CAM_fn_vAssignCameraToAViewport(long, HIE_tdxHandleToSuperObject);
#if !defined(PRESS_DEMO)
void		CAM_vDisplayInfo(void);
#endif /* PRESS_DEMO */
ACP_tdxBool	CAM_fn_bSuperObjectIsACamera(HIE_tdxHandleToSuperObject);
void		CAM_fn_vInitCameras(void);
void		CAM_fn_vReInitCameras(void);
 
extern CPA_EXPORT HIE_tdxHandleToSuperObject	CAM_fn_hGetActiveCamera(long);
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __TOOLCAM_H__ */
