/* FM970130 : Matrix tool*/
/*=========================================================================
* ToolMatr.h : This module contain simple used functions 
* This is a part of the Game project.
*
* It contains adding function concerning the matrix management
*
* Version			1.0
* Creation date		30/01/97
* Author			Fabien MORALES
* Revision date
*
* That file needs to be compatible for all platforms.
*
* (c) Ubi Studios 1996
*=======================================================================*/
#ifndef TOOL_MATR_H
#define TOOL_MATR_H
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#include "GAM/Header.h"
 
/********************************************/
/*   Operations on Rotation-Matrices		*/
/********************************************/
/* Set the absolute angle of rotation (X, Y or Z axis) for a super perso matrix :*/
void	fn_vSetRotationMatrixX ( POS_tdstCompletePosition *p_stMatrix, GLI_tdxValue xAngle );
void	fn_vSetRotationMatrixY ( POS_tdstCompletePosition *p_stMatrix, GLI_tdxValue xAngle );
void	fn_vSetRotationMatrixZ ( POS_tdstCompletePosition *p_stMatrix, GLI_tdxValue xAngle );
 
void	fn_vTurnMatrixX(POS_tdstCompletePosition *, MTH_tdxReal);
void	fn_vTurnMatrixY(POS_tdstCompletePosition *, MTH_tdxReal);
void	fn_vTurnMatrixZ(POS_tdstCompletePosition *, MTH_tdxReal);
 
#endif /* TOOL_MATR_H */
