/* (c) Ubi R&D 1997*/
/* See Alain Robin for any comment or question*/
 
#ifndef __LOADBIN_H__
#define __LOADBIN_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
/*----------------------------------------------------------------------------
//  Description : GEO_fn_p_stLoadIndexedTriangle
//  Loads an indexed triangle with script or a binary file
------------------------------------------------------------------------------
//  Input :  _szSectionName
//  Output : The pointer to the indexed triangle
----------------------------------------------------------------------------*/
extern CPA_EXPORT GEO_tdstElementIndexedTriangles* GEO_fn_p_stLoadIndexedTriangle(char* _szSectionName);
 
/*----------------------------------------------------------------------------
//  Description : GEO_fn_hLoadGeometricObject
//  Load a geometric object from an ascii script or from a binary script
------------------------------------------------------------------------------
//  Input :  _szSectionName : Name of the section to load
//  Output : Handle to the geometric element loaded
----------------------------------------------------------------------------*/
extern CPA_EXPORT ACP_tdxHandleOfObject GEO_fn_hLoadGeometricObject(char* _szSectionName, unsigned short _uwScriptMode);
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
#endif
