/* ##CONSTANTE#--------------------------------------------------------------------------
                          Constantes declaration
---------------------------------------------------------------------------------------*/
enum Synchro {
	C_AutoSynchro=0,
	C_1FrameSynchro,
	C_2FrameSynchro,
	C_3FrameSynchro,
	C_MaxFrameSynchro=0x07,
	C_DefaultSynchro=0xFE,
	C_NoSynchro=0xFF
};
 
#ifndef U64
/* Old call to flip device remain not synchronized*/
#define GLD_bFlipDevice(GLD_tdhDevice) GLD_bFlipDeviceWithSynchro(GLD_tdhDevice,C_NoSynchro)
 
 
/* ##F===================================================================================
NAME :          GLD_vSetFrameSynchro
DESCRIPTION :   This function set the type of synchro used with its parameter 
				For script interpretation
INPUT :         Synchro ON or OFF
				NbTrame (0 for hysteresis system)
				Percent use to decrease NbTrame
=========================================================================================
CREATION : Carlos Torres / 11-12-1997
=======================================================================================*/
extern CPA_EXPORT void GLD_vSetFrameSynchro(char * szOnOff,char * szNbTrame,char * szPctLowLimit);
#endif /* U64 */
