#ifndef INIT_GLI_H
#define INIT_GLI_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLL using these function :*/
#include "cpa_expt.h" 
 
/*
extern CPA_EXPORT void GLI_vInitGliDFX(void);
extern CPA_EXPORT void GLI_vInitGliD3D(void);
extern CPA_EXPORT void GLI_vInitGliCif(void);
extern CPA_EXPORT void GLI_vInitGliP5(void);
*/
 
extern CPA_EXPORT void GLI_xInitGli (void) ;
#ifdef U64
#include "Rom64.h"
#include "h_level.h"
extern void GLI_fn_vInitCache(unsigned short _a6_uwCacheSize[6]);
#endif /* U64 */
extern CPA_EXPORT void GLI_xInitGliGlobal (void);
extern CPA_EXPORT void GLI_vEndofGeometricLoad();
extern CPA_EXPORT void GLI_vCloseGli ();
extern CPA_EXPORT void GLI_vSignalCurrentMemoryChannel(unsigned char CurrentChannel);
extern CPA_EXPORT void GLI_vKillMemoryChannel(unsigned char CurrentChannel);
extern CPA_EXPORT long GLI_xIsGliInit();
extern CPA_EXPORT void GLI_vSetBenchMode(long lEnable);
extern CPA_EXPORT void GLI_vChangeBenchMode();
  /* End of turn engine.*/
//extern CPA_EXPORT void GLI_vEndOfTurnEngine(void);
 
#define GLI_C_VersionGlide      0
#define GLI_C_VersionPentium    1
#define GLI_C_VersionSoft       1
#define GLI_C_VersionD3DRM      2
#define GLI_C_VersionD3DDP      3
#define GLI_C_VersionCIF        4
#define GLI_C_VersionGlide3     5
 
extern CPA_EXPORT long GLI_lWhatIsGLI();
 
  /* Return a pointer on the text version of GLI engine.*/
extern CPA_EXPORT unsigned char *GLI_ucGetTextOfVersion(void);
 
  /* Return version number.*/
extern CPA_EXPORT long GLI_lGetNumOfVersion(void);
 
/*bart990108:*/
extern CPA_EXPORT char GLI_fn_cWindowedModeIsOptimized(void);
extern CPA_EXPORT void GLI_fn_vOptimizedWindowedMode(void);
extern CPA_EXPORT void GLI_fn_vNonOptimizedWindowedMode(void);
extern CPA_EXPORT void GLI_fn_vSetMainWindowForRender(void * _hWnd);
extern CPA_EXPORT void GLI_fn_vRecomputeViewportToMaximizeDisplay(int _arg);
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* INIT_GLI_H*/
