#ifndef GLIERR_H
#define GLIERR_H
 
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define GLI_C_BaseErr 4096
#define GLI_C_NoErr 0
 
#define GLI_C_NotEnoughMemory                   ( 1 + GLI_C_BaseErr )
#define GLI_C_UnduplicableObject                ( 2 + GLI_C_BaseErr )
#define GLI_C_SendObjectToUnassociateViewport   ( 3 + GLI_C_BaseErr )
#define GLI_C_NullObjext                        ( 4 + GLI_C_BaseErr )
 
#define GLI_C_ErrorOpenFile  (100+GLI_C_BaseErr) /*Erreur d'ouverture de fichier*/
#define GLI_C_ErrorBadFile   (101+GLI_C_BaseErr) /*Mauvais type de fichier*/
#define GLI_C_ErrorReadFile  (102+GLI_C_BaseErr) /*Erreur de lecture de fichier*/
#define GLI_C_UnfindableFile (103+GLI_C_BaseErr)
#define GLI_C_EndOfFile      (104+GLI_C_BaseErr)
#define GLI_C_ErrorCloseFile (105+GLI_C_BaseErr)
#define GLI_C_BadVersionFile (106+GLI_C_BaseErr)
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* GLIERR_H*/
