#ifndef GLI_POLYGON_H
#define GLI_POLYGON_H
 
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#include "vertex.h"
 
#define C_MaxVertexInPolygLine    30
 
typedef struct GLI_tdstIndexedTriangle_
{
  long lA ;
  long lB ;
  long lC ;
}
  GLI_tdstIndexedTriangle ;
 
typedef struct GLI_tdstSphere_
{
  MTH3D_tdstVector stCentre ;
  MTH_tdxReal xRadius ;
}
  GLI_tdstSphere ;
 
typedef struct GLI_tdst2DTriangle_
{
  GLI_tdst2DVertex stA2DVertex ;
  GLI_tdst2DVertex stB2DVertex ;
  GLI_tdst2DVertex stC2DVertex ;
}
  GLI_tdst2DTriangle ;
 
typedef struct GLI_tdstTriangle_
{
  MTH3D_tdstVector stAVertex ;
  MTH3D_tdstVector stBVertex ;
  MTH3D_tdstVector stCVertex ;
}
  GLI_tdstTriangle ;
 
typedef struct GLI_tdstPolygLine_
{
  long lNbVertex ;
  MTH3D_tdstVector aDEF_stVertex[C_MaxVertexInPolygLine] ;
}
  GLI_tdstPolygLine ;
 
typedef struct GLI_tdst2DPolygLine_
{
  long lNb2DVertex ;
  GLI_tdst2DVertex aDEF_st2DVertex[C_MaxVertexInPolygLine] ;
}
  GLI_tdst2DPolygLine ;
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* GLI_POLYGON_H*/
