#define C_SectionGameMaterial "GameMaterial"
 
#define C_EntryVisualGameMaterialToLoad "VisualMat"
#define C_EntryMechanicalMaterialToLoad "MechanicalMat"
#define C_EntryCollideMaterialToLoad "CollideMat"
#define C_EntrySoundMaterial "SoundType"
 
/* Not used anymore : Use DPT functions instead */
/*#define GMT_C_VisualMaterialPath "GameData\\World\\Graphics\\Visuals\\"*/
/*#define GMT_C_MaterialPath "GameData\\World\\Libraries\\Materials\\"*/
 
/*****************************************************************************
//  Description : GMT_fn_vInitLoadGameMaterial
//  Loading process initialization 
//////////////////////////////////////////////////////////////////////////////
//  Input :             
//  Output :  
*****************************************************************************/
void  GMT_fn_vInitLoadGameMaterial(void);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_hLoadGameMaterial
//  Load a game material from the scripts or from the binary bloc
//----------------------------------------------------------------------------
//  Input : _szSectionName : Name of the section to load            
//  Output : A handle to the loaded game material
----------------------------------------------------------------------------*/
GMT_tdxHandleToGameMaterial GMT_fn_hLoadGameMaterial(char* _szSectionName);
 
/*BEGIN OS 4/3/98*/
GMT_tdxHandleToGameMaterial GMT_fn_hLoadBinGameMaterial(char* _szSectionName);
/*END OS 4/3/98*/
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vWriteAllGameMaterialBinaryBlocs
//----------------------------------------------------------------------------
//  Input :  _szBinaryFileName : Name of the binary file
//  Output : 
----------------------------------------------------------------------------*/
void GMT_fn_vWriteAllGameMaterialBinaryBlocs(char* _szBinaryFileName);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vRestorePointerFromIds
//-------------------------------------------------------
//  Input : _ulPointer: Handle to the loaded game material
//  Output : 
----------------------------------------------------------------------------*/
void GMT_fn_vRestorePointerFromIds(unsigned long _ulPointer);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_ulWriteBinaryBloc
//----------------------------------------------------------------------------
//  Input : _hGmtMaterial : Handle to the game material to save
//			_p_cBuffer : Binarisation buffer
//			_szBinaryFileName : Name of the binary file
//  Output : The pointer to the created game material
----------------------------------------------------------------------------*/
unsigned long GMT_fn_ulReadBinaryBloc(char* _p_cLoadedBuffer, unsigned long _ulLoadedBufferSize);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vReadAllGameMaterialBinaryBlocs
//----------------------------------------------------------------------------
//  Input :  _szBinaryFileName : Name of the binary file
//  Output : 
----------------------------------------------------------------------------*/
void  GMT_fn_vReadAllGameMaterialBinaryBlocs(char* _szBinaryFileName);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vReadAllGameMaterialBinaryBlocs2
//----------------------------------------------------------------------------
//  Input :  _szBinaryFileName : Name of the binary file
//  Output : 
----------------------------------------------------------------------------*/
void  GMT_fn_vReadAllGameMaterialBinaryBlocs2(char* _szBinaryFileName);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_vPrepareSaveBinaryBloc
//----------------------------------------------------------------------------
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
void GMT_fn_vPrepareSaveBinaryBloc();
 
/*---------------------------------------------------------------------------/
//  Description : GMT_fn_vDeleteGMTEntryWithPriority
------------------------------------------------------------------------------
//  Input :             
//  Output : 
----------------------------------------------------------------------------*/
void  GMT_fn_vDeleteGMTEntryWithPriority(unsigned char ucPrioMin, unsigned char ucPrioMax);
 
/*----------------------------------------------------------------------------
//  Description : GMT_fn_p_cGeneralAllocationFunction
//----------------------------------------------------------------------------
//  Input :  _ulSize : size to be allocated
//  Output : 
----------------------------------------------------------------------------*/
char* GMT_fn_p_cGeneralAllocationFunction(unsigned long _ulSize);
