 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_INO
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_INO
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
 
#ifndef _INO_H
#define _INO_H
 
 
#include "INO/Joystick.h"
#include "INO/Specif/Joy.h"
 
/*XB980429*/
/*#ifndef PSX*/
/*	#include "INO/Keyboard.h"*/
/*#endif /* PSX   */
 
#if (!defined(U64) && !defined(PSX))
	#include "INO/Mouse.h"
	#include "INO/Keyboard.h"
#endif /* !U64 && !PSX */
/*End XB*/
 
/*HP 141298*/
#ifdef U64
#include "INO/specif/u_demo.h"
#endif
 
#endif /*_INO_H*/
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
 
