/*=========================================================================
* IPT_Lib.h :  This file contain included all extern files of INPUT.
*
* Version              1.0
* Creation date        01/04/97
* Revision date
*
* (c) Ubi Studios 1996
*=======================================================================*/
 
/* ###### BEGIN : DEPENDANCIES CHECKING  #########################################################
 Checking dependancies :
 - Add this at the begining (before everything else) of all <TAG>.h Public header files.
 - Customize these line by replacing CPA_<TAG> with the module TAG
 - Add '#undef CPA_PUBLIC_HEADER' at the last line of this file
 - Add 'CPA_SRC_TAG_NAME=CPA_<TAG>' as compiler definition in your Makefile (or Visual C Project).
 
   Begining of Top File Dependancies checking instructions : 
 */
#ifdef CPA_PUBLIC_HEADER_TAG_NAME
#undef CPA_PUBLIC_HEADER_TAG_NAME
#endif /* CPA_PUBLIC_HEADER_TAG_NAME */
#define CPA_PUBLIC_HEADER_TAG_NAME CPA_IPT
#include "cpa_dep.h"
#define CPA_PUBLIC_HEADER CPA_IPT
/* End Of Top File Dependancies checking instructions. 
   ###############################################################################################
*/
 
#if !defined(__IPT_Lib_H__)
#define __IPT_Lib_H__
 
#include "IPT/IPT_Hdl.h"
 
#include "IPT/IPT_Kwan.h"
 
#include "IPT/IPT_Def.h"
 
#include "IPT/IPT_Main.h"
#include "IPT/IPT_Hist.h"
 
#include "IPT/IPT_Anal.h"
 
#include "IPT/IPT_Save.h"
 
#endif /* __IPT_Lib_H__ */
 
/* ############################################################################################## 
 This must be at the End of this file. 
   Begining Of Bottom File Dependancies checking instructions : */
#undef CPA_PUBLIC_HEADER
/* End Of Bottom File Dependancies checking instructions. 
   ##############################################################################################
*/
