/*=========================================================================
* IPT_Anal.h : 
*     Analyse entry
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined(__IPT_Anal_h__)
#define __IPT_Anal_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/****************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/****************************************/
 
#undef EXTERN
#undef extern
#if !defined(D_IPT_Input_VariableDefine)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_IPT_Input_VariableDefine*/
 
#if defined (__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
extern CPA_EXPORT void IPT_fn_vReadInput(void);
 
extern CPA_EXPORT unsigned char IPT_fn_bIsJustValidated(IPT_tdxHandleToEntryElement _hEntryElement);
extern CPA_EXPORT unsigned char IPT_fn_bIsValidated(IPT_tdxHandleToEntryElement _hEntryElement);
extern CPA_EXPORT unsigned char IPT_fn_bIsJustInvalidated(IPT_tdxHandleToEntryElement _hEntryElement);
extern CPA_EXPORT unsigned char IPT_fn_bIsInvalidated(IPT_tdxHandleToEntryElement _hEntryElement);
 
extern CPA_EXPORT long IPT_fn_lHowManyFrame(IPT_tdxHandleToEntryElement _hEntryElement);
extern CPA_EXPORT unsigned long IPT_fn_ulHowManyAbsoluteFrame(IPT_tdxHandleToEntryElement _hEntryElement);
 
extern CPA_EXPORT long IPT_fn_lGetAnalogicValue(IPT_tdxHandleToEntryElement _hEntryElement);
 
/*AR980629 For IPT recorder*/
/*extern char IPT_DemoMode;
#define IPT_M_DemoStopMode		0
#define IPT_M_DemoRecordMode	1
#define IPT_M_DemoPlayMode		2
#define IPT_M_IsDemoStopMode		(IPT_DemoMode == IPT_M_DemoStopMode)
#define IPT_M_IsDemoRecordingMode	(IPT_DemoMode == IPT_M_DemoRecordMode)
#define IPT_M_IsDemoPlayingMode		(IPT_DemoMode == IPT_M_DemoPlayMode)
#define IPT_M_NextDemoEntry			NbDemoEntry++
#define C_NbAction 200 /* --> 200 bits*/
/*#define C_NbCodedEntry 7 /* 200 bits / 32 bits (for unsigned long type).*/
/*#define C_MaxDemoEntry 2000
#define IPT_M_DemoFinished (IPT_M_IsDemoPlayingMode)&&((NbDemoEntry>=C_MaxDemoEntry)/*||(g_st_3DOS_EntryActions.hIPTRecord->lState==1)*//*)*/
 
/*#define U64_DEMO_RECORDER // for tests only AR980629*/
 
extern void IPT_fnvRecordDemoMode();
extern void IPT_fnvStopDemoMode();
extern void IPT_fnvPlayDemoMode();
 
#if defined (__cplusplus)
}
#endif /* __cplusplus */
 
#undef EXTERN
#undef extern
 
#endif /* __IPT_Anal_h__ */
