/*=========================================================================
* IPT_Bin.h : 
*     binary files functions
*
* (c) Ubi Studios 1998
*=======================================================================*/
 
#if !defined (__IPT_Bin_H__)
#define __IPT_Bin_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/****************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/****************************************/
 
#undef EXTERN
#undef extern
#if !defined(D_IPT_Input_VariableDefine)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_IPT_Input_VariableDefine*/
 
#if defined (__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
extern CPA_EXPORT void IPT_fn_vSaveBinaryFile(char *_p_szFileName,IPT_tdxHandleToEntryElement *dExchangeArray,unsigned long ulExchangeArraySize);
extern CPA_EXPORT void IPT_fn_vLoadBinaryFile(char *_p_szFileName,HINSTANCE hInstance, HWND hWindow,GLD_tdhDevice _tdGLDDeviceHandle,IPT_tdxHandleToEntryElement *dExchangeArray,unsigned long ulExchangeArraySize);
extern CPA_EXPORT unsigned char IPT_fn_bIsBinaryFileLoaded(void);
 
#if defined (__cplusplus)
}
#endif /* __cplusplus */
 
#undef EXTERN
#undef extern
 
#endif /* __IPT_Edit_H__ */
