/*=========================================================================
* IPT_Hist.h : 
*     Historic
*
* (c) Ubi Studios 1997
*=======================================================================*/
 
#if !defined (__IPT_Hist_H__)
#define __IPT_Hist_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/****************************************/
#if !defined(CPA_EXPORT)
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif /*CPA_WANTS_IMPORT || CPA_WANTS_EXPORT*/
#endif /*CPA_EXPORT*/
/****************************************/
 
#undef EXTERN
#undef extern
#if !defined(D_IPT_Input_VariableDefine)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_IPT_Input_VariableDefine*/
 
#if defined (__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
extern CPA_EXPORT unsigned long IPT_fn_ulSizeOfHistoric();
extern CPA_EXPORT unsigned char IPT_fn_bIsEmptyHistoricElement(unsigned long _ulElementNumber);
extern CPA_EXPORT unsigned char IPT_fn_bIsKeyboardHistoricElement(unsigned long _ulElementNumber);
extern CPA_EXPORT unsigned char IPT_fn_bIsPadHistoricElement(unsigned long _ulElementNumber);
 
#if defined (__cplusplus)
}
#endif /* __cplusplus */
 
void IPT_fn_vActualizeHistoric();
 
#undef EXTERN
#undef extern
 
#endif /* __IPT_Hist_H__ */
