/*=========================================================================
* 
* CPAdStat.h :  class CPA_DialogStatus
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR
 
#ifndef __DIALOGSTATUS_H__
#define __DIALOGSTATUS_H__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
 
#include "CPARes.h"
 
class CPA_SpecificInterface;
 
 
/*#################################################################################*/
/*	CPA_DialogStatus dialog*/
/*#################################################################################*/
 
class CPA_EXPORT CPA_DialogStatus : public CDialog
{
/* Construction*/
protected:
	CPA_SpecificInterface	*m_pEditor;
	BOOL					m_bCanUpdate;
 
public:
 
/* parent editor*/
	CPA_SpecificInterface * GetEditor (void) { return m_pEditor; }
 
/* standard constructor*/
	CPA_DialogStatus (CWnd* pParent = NULL);   
 
/* Dialog*/
	void fn_vDoDialog (CPA_SpecificInterface *pEditor, BOOL bCanUpdate);
 
/* Dialog Data*/
	/*{{AFX_DATA(CPA_DialogStatus)*/
	enum { IDD = CPA_IDD_DIALOGSTATUS };
	CButton		m_cGraphic;
	CButton		m_cDesign;
	CButton		m_cManager;
	CButton		m_cSaveStatus;
	CButton		m_cOK;
	/*}}AFX_DATA*/
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CPA_DialogStatus)*/
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    /* DDX/DDV support*/
	/*}}AFX_VIRTUAL*/
 
 
/* Implementation*/
protected:
 
	/* Generated message map functions*/
	/*{{AFX_MSG(CPA_DialogStatus)*/
	virtual BOOL OnInitDialog();
	afx_msg	void OnSave();
	afx_msg	void OnOK();
	afx_msg	void OnCancel();
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
#endif /*__DIALOGSTATUS_H__*/
#endif /* ACTIVE_EDITOR*/
