/*===========================================================================*/
/* A3dKeyboardConfDlg.hpp : implementation of Keyboard Configuration Dialog*/
/**/
/* Version			1.0*/
/* Creation date	21/10/96*/
/* Author:			Philippe Touillaud*/
/**/
/* Revision date*/
/* Author:			*/
/**/
/* (c) Ubi Pictures 1996*/
/**/
/*===========================================================================*/
 
#ifndef __A3dKeyAll_HPP__
#define __A3dKeyAll_HPP__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#ifdef ACTIVE_EDITOR
 
#include "CPAKACnf.hpp"
#include "A3dVKeyT.hpp"
#include "CPAres.h"
 
/*///////////////////////////////////////////////////////////////////////////*/
/* A3d_KeyboardConfDlg dialog*/
class CPA_EXPORT A3d_KeyboardAllConfDlg : public CDialog
{
/* Construction*/
public:
	A3d_KeyboardAllConfDlg();   /* standard constructor*/
 
/* Dialog Data*/
	/*{{AFX_DATA(A3d_KeyboardConfDlg)*/
	enum { IDD = CPA_IDD_MAINKEYB };
	/*}}AFX_DATA*/
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(A3d_KeyboardConfDlg)*/
	protected:
	virtual BOOL OnInitDialog();
	virtual BOOL UpdateData(BOOL bSaveToClass);
	virtual void DoDataExchange(CDataExchange* pDX);    /* DDX/DDV support*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
protected:
 
	/* Generated message map functions*/
	/*{{AFX_MSG(A3d_KeyboardConfDlg)*/
    afx_msg void OnEdit(void);
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
 
/*///////////////////////////////////////////////////////////////////////////*/
#endif /* ACTIVE_EDITOR*/
 
#endif /* __A3dKeyAll_HPP__*/
