/*=========================================================================*/
/* A3dVKeyTypedDetect.hpp :	Special class for key value detection*/
/*							used for keyboard configuration.*/
/**/
/* Version			1.0*/
/* Creation date	30/10/96*/
/* Author:			Philippe Touillaud*/
/**/
/* Revision date*/
/* Author:			*/
/**/
/* (c) Ubi Pictures 1996*/
/**/
/*=========================================================================*/
 
#ifndef __A3dVKeyTypedDetect_HPP__
#define __A3dVKeyTypedDetect_HPP__
 
#ifdef ACTIVE_EDITOR
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
/*///////////////////////////////////////////////////////////////////////////*/
/* A3d_VKeyTypedDetect window*/
 
class CPA_EXPORT A3d_VKeyTypedDetect : public CListBox
{
/* Construction*/
public:
	A3d_VKeyTypedDetect();
 
/* Attributes*/
public:
 
/* Operations*/
public:
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(A3d_VKeyTypedDetect)*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
public:
	virtual ~A3d_VKeyTypedDetect();
 
	/* Generated message map functions*/
protected:
	/*{{AFX_MSG(A3d_VKeyTypedDetect)*/
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags); /* CPA2 Corneliu Babiuc (Alt Key) 14-05-98 */
	afx_msg void OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);   /* END CPA2 Corneliu Babiuc (Alt Key) 14-05-98 */
	/*}}AFX_MSG*/
 
	DECLARE_MESSAGE_MAP()
};
 
 
 
/*///////////////////////////////////////////////////////////////////////////*/
#endif /* __A3dVirtualKeyTypedButton_HPP__*/
#endif /* ACTIVE_EDITOR*/
