/*=========================================================================
*
* CPAdlang.h :  class CPA_DialogLanguage
*
*
* Version			1.0
* Creation date
* Revision date
*
* Xavier Billault
*=======================================================================*/
#ifdef ACTIVE_EDITOR
 
 
#ifndef __CPADLANG_H__
#define __CPADLANG_H__
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#include "CPARes.h"
 
class CPA_Interface;
 
/*///////////////////////////////////////////////////////////////////////////*/
/* CPA_DialogLanguage dialog*/
 
class CPA_DialogLanguage : public CDialog
{
private:
	CStringList		*m_pcslLanguageList;
	CPA_Interface	*m_pclInterface;
 
public:
	CString			m_csLanguage;
 
public:
/* standard constructor*/
	CPA_DialogLanguage(CPA_Interface *,CStringList *,CWnd* pParent = NULL);
 
/* Dialog Data*/
	/*{{AFX_DATA(CPA_DialogLanguage)*/
	enum { IDD = CPA_IDD_LANG_CHOICE };
	/*}}AFX_DATA*/
 
 
/* Overrides*/
	/* ClassWizard generated virtual function overrides*/
	/*{{AFX_VIRTUAL(CPA_DialogLanguage)*/
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    /* DDX/DDV support*/
	/*}}AFX_VIRTUAL*/
 
/* Implementation*/
protected:
 
	/* Generated message map functions*/
	/*{{AFX_MSG(CPA_DialogLanguage)*/
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg	void OnSave();
	/*}}AFX_MSG*/
	DECLARE_MESSAGE_MAP()
};
 
#endif /*__CPADLANG_H__*/
#endif /* ACTIVE_EDITOR*/
