/*=========================================================================
*
* EDTEnum.hpp
*
*
* Version			1.0
* Creation date
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR
 
/****************************************/
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
/****************************************/
 
#ifndef __CPAENUM_HPP__
#define __CPAENUM_HPP__
 
#include "DEVVp3D.hpp"		
 
#define C_ucModel 1973
 
/* colors for selection*/
typedef enum tdeLightMode_
{ 
	E_lm_ShowSelected, 
	E_lm_ShowNormal, 
	E_lm_ShowOnly, 
	E_lm_ShowChild, 
	E_lm_ShowParent, 
	E_lm_ShowBrother 
} 
tdeLightMode;
 
/* selection*/
typedef enum tdeSelectMode_
{
	E_sm_SelectParent,
	E_sm_SelectByType,
	E_sm_SelectPFather,
	E_sm_SelectChoice,
	E_sm_SelectNormal
}
tdeSelectMode;
 
/* update mode for drawing and dialogs*/
typedef enum 
{ 
	E_mc_JustDraw, 
	E_mc_UpdateSelection, 
	E_mc_UpdateDialog, 
	E_mc_UpdateAll 
} 
tdeModeChange;
 
/* local drawing*/
typedef enum
{
	E_df_Normal,
	E_df_Grided,
	E_df_Wired,
/* FBF 20 03 98 {*/
	E_df_BoundingV
/* FBF 20 03 98 }*/
}
tdeDrawingFlag;
 
 
typedef enum tdeTypeSO_
{
	C_Static,
	C_Dynamic,
	C_Protected,
	C_NoType
}
tdeTypeSO;
 
/* user status*/
typedef enum tdeUserStatus_
{
	E_us_StatusGraphic, 
	E_us_StatusDesign, 
	E_us_StatusAll,
	E_us_NoStatus
}
tdeUserStatus;
 
/*#################################################################################*/
/* PICKING INFO*/
/*#################################################################################*/
typedef struct tdstPosition_
{
	tdstMousePos				stPos;
	ACP_tdxIndex				xIndex;
	HIE_aDEF_stTabOfPickInfo	a_stPickInfo;
}
tdstPosition;
 
#endif /* __CPAENUM_HPP__*/
#endif /* ACTIVE_EDITOR*/
