#ifndef __DNMLDMAT_H__
#define __DNMLDMAT_H__
 
#ifdef  __cplusplus
extern "C" {
#endif
 
#include "cpa_expt.h" 
#include "SCR.h"
 
#define C_SectionMecMatCharacteristics "MechanicalMaterial"
 
#define C_EntrySlide				"BaseSlide"
#define C_EntryRebound				"BaseRebound"
 
 
/* Call Back       */
/* to Read xxx.mmc */
#if !defined(U64)
SCR_tde_Anl_ReturnValue fn_eScriptCallBackMecMatCharacteristics(
                                                     SCR_tdst_File_Description *_p_stFile,
                                                     char *_p_szName,
                                                     char *_ap_szPars[],
                                                     SCR_tde_Anl_Action _eAction);
#endif /* U64 */
 
/* Init the load of mechanical material */
void  DNM_fn_vInitLoadMecMatCharacteristics(void);
 
/*----------------------------------------------------------------------------
//  Description : DNM_fn_vWriteAllMMTBinaryBlocs
//----------------------------------------------------------------------------
//  Input :  _szBinaryFileName           
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void DNM_fn_vWriteAllMMTBinaryBlocs(char* _szBinaryFileName);*/
 
/*----------------------------------------------------------------------------
//  Description : DNM_fn_vReadAllMMTBinaryBlocs
//----------------------------------------------------------------------------
//  Input :		_szBinaryFileName : The binary file name           
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void DNM_fn_vReadAllMMTBinaryBlocs(char* _szBinaryFileName);*/
 
/*----------------------------------------------------------------------------
//  Description : DNM_fn_vReadAllMMTBinaryBlocs2
//----------------------------------------------------------------------------
//  Input :		_szBinaryFileName : The binary file name           
//  Output : 
----------------------------------------------------------------------------*/
/*extern CPA_EXPORT void DNM_fn_vReadAllMMTBinaryBlocs2(char* _szBinaryFileName);*/
 
#ifdef  __cplusplus
}/* extern "C" */
#endif
 
 
#endif
