/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          MTH_trig.h
MODULE :        MTH     (Common Mathematic Library) 
 
DESCRIPTION : Additional Trigonometric table for U64 and float
 
VERSION :       MTH V5.0.13 / Alexandre LANGER [ALX] Ubi R&D / Add Comments
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
#ifndef MTH_TRIG_H
#define MTH_TRIG_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* ##FUNCDEF#----------------------------------------------------------------------------
                          Functions definition
---------------------------------------------------------------------------------------*/
 
extern void MTH_fn_vInitTableASin( void );
 
extern MTH_tdxReal MTH_fn_xComputeASin( MTH_tdxReal x);
 
extern MTH_tdxReal MTH_fn_xComputeACos( MTH_tdxReal x);
 
extern void MTH_fn_vInitTableATan( void );
 
extern MTH_tdxReal MTH_fn_xComputeATan( MTH_tdxReal x);
 
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /* MTH_TRIG_H */ 
