/*----------------------------------------------------------------------------------*/
/* Filename :   sw.h                                                                */
/* Author   :   Frederic Philippe                                                   */
/*          :   Marc Trabucato                                                      */
/* Target   :   PC                                                                  */
/*----------------------------------------------------------------------------------*/
 
/* -----------------15/04/98 15:58-------------------
 * Conversion : useless (avec version 23.04.98 19:58 (2066))
 * --------------------------------------------------*/
 
#ifndef _SW_H_
#define _SW_H_
 
/*----------------------------------------------------------------------------------*/
 
#include "MTH\Specif\SCA\SCA_sw.h"
 
/*----------------------------------------------------------------------------------*/
 
/* Define the type DNM_tdxReal */
#define td_sw   SCA_td_sw
 
/* Constants */
#define sw_ZERO     SCA_sw_C_ZERO
#define sw_ONE      SCA_sw_C_ONE
#define sw_TWO      8192
 
/* Comparisons */
#define sw_bGreater(_swOp1,_swOp2)       SCA_sw_M_bGreater(_swOp1,_swOp2)
#define sw_bGreaterEqual(_swOp1,_swOp2)  SCA_sw_M_bGreaterEqual(_swOp1,_swOp2)
#define sw_bLess(_swOp1,_swOp2)          SCA_sw_M_bLess(_swOp1,_swOp2)
#define sw_bLessEqual(_swOp1,_swOp2)     SCA_sw_M_bLessEqual(_swOp1,_swOp2)
#define sw_bEqual(_swOp1,_swOp2)         SCA_sw_M_bEqual(_swOp1,_swOp2)
#define sw_bDiferent(_swOp1,_swOp2)      SCA_sw_M_bDifferent(_swOp1,_swOp2)
#define sw_bIsNull(_swOp)                SCA_sw_M_bIsNull(_swOp)
#define sw_bGreaterZero( A )             sw_bGreater( (A), sw_ZERO )
#define sw_bGreaterEqualZero( A )        sw_bGreaterEqual( (A), sw_ZERO )
#define sw_bLessZero( A )                sw_bLess( (A), sw_ZERO )
#define sw_bLessEqualZero( A )           sw_bLessEqual( (A), sw_ZERO )
 
/* Operations */
#define sw_Add(_swOp1,_swOp2) SCA_sw_M_swAdd(_swOp1,_swOp2)
#define sw_Sub(_swOp1,_swOp2) SCA_sw_M_swSub(_swOp1,_swOp2)
#define sw_Mul(_swOp1,_swOp2) SCA_sw_M_swMul(_swOp1,_swOp2)
#define sw_Div(_swOp1,_swOp2) SCA_sw_M_swDiv(_swOp1,_swOp2)
 
#define sw_Inv(_swOp) SCA_sw_M_swInv(_swOp)
#define sw_Neg(_swOp) SCA_sw_M_swNeg(_swOp)
#define sw_Sqr(_swOp) SCA_sw_M_swSqr(_swOp)
#define sw_Cub(_swOp) sw_Mul(_swOp,sw_Sqr(_swOp))
#define sw_Sqrt(_swOp) SCA_sw_M_swSqrt(_swOp)
#define sw_Abs(_swOp) SCA_sw_M_swAbs(_swOp)
 
#define sw_Sin(_swOp) SCA_sw_M_swSin(_swOp)
#define sw_Cos(_swOp) SCA_sw_M_swCos(_swOp)
#define sw_Tan(_swOp) SCA_sw_M_swTan(_swOp)
 
#define sw_ASin(_swOp) SCA_sw_M_swASin(_swOp)
#define sw_ACos(_swOp) SCA_sw_M_swACos(_swOp)
 
/*----------------------------------------------------------------------------------*/
 
#endif /* _SW_H_ */
