/*----------------------------------------------------------------------------------*/
/* Filename :   sw12.h                                                              */
/* Author   :   Frederic Philippe                                                   */
/*          :   Marc Trabucato                                                      */
/* Target   :   PC                                                                  */
/*----------------------------------------------------------------------------------*/
 
/* -----------------15/04/98 15:58-------------------
 * Conversion : OK  (avec version 24.08.98 16:46 (2231))
 * --------------------------------------------------*/
 
#ifndef _SW12_H_
#define _SW12_H_
 
/*----------------------------------------------------------------------------------*/
 
#include "MTH\Specif\SCA\SCA_sw12.h"
 
/*----------------------------------------------------------------------------------*/
 
/* Define the type DNM_tdxReal */
#define td_sw12 SCA_td_sw12
 
/* Constants */
#define sw12_ZERO     SCA_sw12_C_ZERO
#define sw12_ONE      SCA_sw12_C_ONE
 
/* Comparisons */
#define sw12_bGreater(_sw12Op1,_sw12Op2)       SCA_sw12_M_bGreater(_sw12Op1,_sw12Op2)
#define sw12_bGreaterEqual(_sw12Op1,_sw12Op2)  SCA_sw12_M_bGreaterEqual(_sw12Op1,_sw12Op2)
#define sw12_bLess(_sw12Op1,_sw12Op2)          SCA_sw12_M_bLess(_sw12Op1,_sw12Op2)
#define sw12_bLessEqual(_sw12Op1,_sw12Op2)     SCA_sw12_M_bLessEqual(_sw12Op1,_sw12Op2)
#define sw12_bEqual(_sw12Op1,_sw12Op2)         SCA_sw12_M_bEqual(_sw12Op1,_sw12Op2)
#define sw12_bDiferent(_sw12Op1,_sw12Op2)      SCA_sw12_M_bDifferent(_sw12Op1,_sw12Op2)
#define sw12_bIsNull(_sw12Op1,_sw12Op2)        SCA_sw12_M_bIsNull(_sw12Op1,_sw12Op2)
 
/* Operations */
#define sw12_Add(_sw12Op1,_sw12Op2) SCA_sw12_M_sw12Add(_sw12Op1,_sw12Op2)
#define sw12_Sub(_sw12Op1,_sw12Op2) SCA_sw12_M_sw12Sub(_sw12Op1,_sw12Op2)
#define sw12_Mul(_sw12Op1,_sw12Op2) SCA_sw12_M_sw12Mul(_sw12Op1,_sw12Op2)
#define sw12_Div(_sw12Op1,_sw12Op2) SCA_sw12_M_sw12Div(_sw12Op1,_sw12Op2)
 
#define sw12_Add3(_sw12Op1,_sw12Op2,_sw12Op3) sw12_Add(_sw12Op1,sw12_Add(_sw12Op2,_sw12Op3))
#define sw12_Mul3(_sw12Op1,_sw12Op2,_sw12Op3) sw12_Mul(_sw12Op1,sw12_Mul(_sw12Op2,_sw12Op3))
 
#define sw12_Inv(_sw12Op) SCA_sw12_M_sw12Inv(_sw12Op)
#define sw12_Neg(_sw12Op) SCA_sw12_M_sw12Neg(_sw12Op)
#define sw12_Sqr(_sw12Op) SCA_sw12_M_sw12Sqr(_sw12Op)
#define sw12_Cub(_sw12Op) sw12_Mul(_sw12Op,sw12_Sqr(_sw12Op))
#define sw12_Sqrt(_sw12Op) SCA_sw12_M_sw12Sqrt(_sw12Op)
#define sw12_Abs(_sw12Op) SCA_sw12_M_sw12Abs(_sw12Op)
 
#define sw12_Sin(_sw12Op) SCA_sw12_M_sw12Sin(_sw12Op)
#define sw12_Cos(_sw12Op) SCA_sw12_M_sw12Cos(_sw12Op)
#define sw12_Tan(_sw12Op) SCA_sw12_M_sw12Tan(_sw12Op)
 
#define sw12_ASin(_sw12Op) SCA_sw12_M_sw12ASin(_sw12Op)
#define sw12_ACos(_sw12Op) SCA_sw12_M_sw12ACos(_sw12Op)
 
/*----------------------------------------------------------------------------------*/
 
#endif /* _SW12_H_ */
