/**********************************************************
 *                                                        *
 *                   Magnet                               *
 *                                                        *
 * Author : Ubi China - Marc Trabucato                    *
 *                                                        *
 **********************************************************/
 
#if !defined( _MGTPROTO_H_ )
#define _MGTPROTO_H_
 
/*************************************************************************************************/
#include "cpa_expt.h"
 
#include "MGTStruc.h"
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/*************************************************************************************************/
/* MGTInit.c */
 
extern CPA_EXPORT void MGT_fn_vAddObjectToMagnetList        ( HIE_tdxHandleToSuperObject p_stObject );
extern CPA_EXPORT void MGT_fn_vDeleteObjectFromMagnetList   ( HIE_tdxHandleToSuperObject p_stObject );
extern CPA_EXPORT void MGT_fn_vFirstInitMagnet				( void );	
extern CPA_EXPORT void MGT_fn_vLastDesInitMagnet			( void );	
 
/*************************************************************************************************/
/* MGTMain.c */
 
extern CPA_EXPORT void MGT_fn_vTreatMagnets                 ( void );
 
/*************************************************************************************************/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
/*************************************************************************************************/
 
#endif /* _MGTPROTO_H_ */
 
