/*
  MODULE : COL (Intersection & Collision Library)
  AUTHOR : Frederic PHILIPPE
           UBI R&D
  FILE : COL.h (Principal header file)
*/
 
#ifndef OPD_H
#define OPD_H
 
/*ROMTEAM WorldEditor (Cristian Stegaru) 11/97*/
/*data type*/
class Geometry3D;
struct QueryActionParam
{
	Geometry3D	*m_p3DObject;
	CString		m_csName;
	int m_iIdx;  /* object index*/
	/*methods*/
	QueryActionParam (Geometry3D *p3DObject = NULL, CString csName = "") { SetContent (p3DObject, csName);}
	void SetContent (Geometry3D *p3DObject = NULL, CString csName = "", int idx = 0)
	{
		m_p3DObject = p3DObject;
		m_csName = csName;
		m_iIdx = idx;
	}
};
 
/*ENDROMTEAM WorldEditor (Cristian Stegaru)*/
 
#include "OPD/PO_Inter.hpp"
 
#endif /* OGD_H */
