/*******************************************************************************/
/**  _zQuery.hpp                                                              **/
/*******************************************************************************/
/**                                                                           **/
/** This public file contains structure used when sending message to the      **/
/**  Zones dll                                                                **/
/**                                                                           **/
/*******************************************************************************/
/** Author : Alexis Vaisse                                                    **/
/*******************************************************************************/
#ifndef _ZQUERY_HPP_
#define _ZQUERY_HPP_
 
typedef struct stCreateZoneMess_
{
    CString               csTypeName;        /* C_szZddName, C_szZdeName, C_szZdmName, C_szZdrName or C_szBoundingVolumeName*/
    void                * hEngineZone;       /* Handle to the engine zone*/
    CString               csName;            /* Name of the zone to create*/
    CPA_BaseObject      * pOwner;            /* Owner of the zone*/
    char                * szDataPath;
    CString               csReferenceSectionName;
} tdstCreateZoneMess;
 
/*CPA2 Corneliu Babiuc 27-04-1998*/
#define  C_uiQueryActorWasMoved           7
/*END CPA2 Corneliu Babiuc 27-04-1998*/
/*CPA2 Stegaru Cristian 98-04*/
#define  C_uiQueryEditBoundingVolume				8
#define  C_uiQueryCreateBoundingVolumeObject		9
#define C_uiQueryCheckZonesAgainstBV		10
/*End CPA2 Stegaru Cristian 98-04*/
 
/*CPA2 Corneliu Babiuc 27-04-1998*/
typedef struct stMoveZoneMess_
{
	CPA_SuperObject     * pActorSuperObject; /*Actor who was moved*/
	MTH3D_tdstVector      stTranslation;    /*translation vector in global coordinates*/
} tdstMoveZoneMess;
/*END CPA2 Corneliu Babiuc 27-04-1998*/
#endif /*_ZQUERY_HPP_*/
