/* ##H_FILE#
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FILE :          PCS_Cpa.h
 
DESCRIPTION :   Cpa include for Physical collide set module
 
VERSION :       1.00/Olivier Jourdan/Creation
 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef __PCS_CPA_H__
#define __PCS_CPA_H__
 
#if defined(VISUAL)
 #pragma warning(disable:4010) /** single-line comment contains line-continuation character **/
 #pragma warning(disable:4100) /** unreferenced formal parameter **/
 #pragma warning(disable:4702) /** unreachable code **/
 #pragma warning(disable:4244) /** conversion from 'type1' to 'type2', possible loss of data **/
#endif /* VISUAL */
 
#include "ACP_Base.h"
#include "GEO.h"
 
 
#undef EXTERN
#undef extern
 
#endif /* __PCS_CPA_H__ */
