/*///////////////////////////////////////////////////////////*/
/*															//*/
/*		Memory Management of the Module : Pos				//*/
/*															//			   */
/* File Name	: MemPos.h									//*/
/* Date			: Mar 97									//*/
/* Author		: Alain Robin								//*/
/*															//*/
/*///////////////////////////////////////////////////////////*/
#ifndef __MemPos_H__
#define __MemPos_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/* For DLLs who are using this module : */ 
#include "CPA_expt.h"
 
#include "MMG.h"
 
typedef enum e_ucPosStaticBlocks_{
	E_ucPosBlock1,    
	E_ucPosMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucPosStaticBlocks;
 
#undef __MMGPOS_EXTERN
#ifdef __DeclareGlobalVariableMmgPos_h__
#define __MMGPOS_EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgPos_h__*/
#define __MMGPOS_EXTERN extern
#endif /*__DeclareGlobalVariableMmgPos_h__*/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
__MMGPOS_EXTERN CPA_EXPORT  unsigned char g_ucPOSMMemMallocMode /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableMmgPos_h__) && !defined(CPA_WANTS_IMPORT)
= E_ucDynamic
#endif /*__DeclareGlobalVariableErrPOS_h__&& CPA_WANTS_IMPORT*/
;
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
__MMGPOS_EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stPosBlocksInfo[E_ucPosMaxBlocksNb];
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
__MMGPOS_EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stPosDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MemPos_H__*/
