#if !defined(__RND_CPA_H__)
#define __RND_CPA_H__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
/****************************************
 * Here is the list of disabled WARNING *
 ****************************************/
#if defined(VISUAL)
#pragma warning(disable:4010) /** single-line comment contains line-continuation character **/
#pragma warning(disable:4115) /** named type definition in parentheses **/
#pragma warning(disable:4127) /** conditional expression is constant **/
#pragma warning(disable:4201) /** nonstandard extension used : nameless struct/union **/
#pragma warning(disable:4214) /** nonstandard extension used : bit field types other than int **/
#pragma warning(disable:4514) /** unreferenced inline function has been removed **/
#pragma warning(disable:4711) /** selected for automatic inline expansion **/
#endif /*VISUAL*/
 
#if defined (WIN32)
#include "wtypes.h"
#include "winuser.h"
#include "string.h"
#endif /* WIN32 */
 
#include "ACP_Base.h"
 
#include "SCR.h"
#include "MTH.h"
#include "MMG.h"
#include "ERM.h"
 
#endif /* __RND_CPA_H__ */
