/*///////////////////////////////////////////////////////////*/
/**/
/*			Management of the Module : Scr*/
/**/
/* File Name	: ErrScr.h*/
/* Date			: 22/08/97*/
/* Author		: CB*/
/**/
/*///////////////////////////////////////////////////////////*/
/**/
/* abbreviation of the module-name. Used in macro is 'Scr'*/
/**/
/*///////////////////////////////////////////////////////////*/
 
#ifndef __ERRScr_H__
#define __ERRScr_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
#define C_szScrVersion "SCR V5.5.2" /* The format is Scr Va.b.c with Scr is the Tag of the module */
#define C_szScrFullName  "Scripts Module"/* the complete and clear name of the module */
#define C_szScrDate __DATE__ /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "ERM.h"
 
/*------------------*/
/* Global Variables*/
/*------------------*/
#undef __ERRScr_EXTERN
#ifndef __DeclareGlobalVariableErrScr_h__
#define __ERRScr_EXTERN extern /*external declaration*/
#else /*__DeclareGlobalVariableErrScr_h__*/
#define __ERRScr_EXTERN /*replace by nothing : we have to declare*/
#endif /*__DeclareGlobalVariableErrScr_h__*/
 
__ERRScr_EXTERN CPA_EXPORT  unsigned char g_ucScrModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrScr_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif /*__DeclareGlobalVariableErrScr_h__&& CPA_WANTS_IMPORT*/
;
 
#ifdef __ERROR_STRINGS__
 
__ERRScr_EXTERN CPA_EXPORT  char * g_a_szScrInformationModule []
#if defined(__DeclareGlobalVariableErrScr_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szScrVersion, C_szScrFullName, C_szScrDate}
#endif /*__DeclareGlobalVariableErrScr_h__ &&  CPA_WANTS_IMPORT*/
;
 
__ERRScr_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stScrTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrScr_h__) && !defined(CPA_WANTS_IMPORT)
= {0, NULL}; /*The Erm module need this variable even if it's equal to NULL*/ 
#endif /*__DeclareGlobalVariableErrLgh_h__ && CPA_WANTS_IMPORT*/
;
 
#endif /*__ERROR_STRINGS__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__ERRScr_H__*/
