#ifndef _SIFFUNC_H_
#define _SIFFUNC_H_
 
 
/*********************************************************************  */
/**					SifLoadS.h:										**  */
/**																	**  */
/**	 Header file for Public SIF module Script Load functions		**  */
/**																	**  */
/*********************************************************************  */
 
 
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus*/
 
 
/****************************************/
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
/****************************************/
 
 
 
extern CPA_EXPORT BOOL SIF_fn_bInitSoundInfos(void);
 
extern CPA_EXPORT BOOL SIF_fn_bDesInitSoundInfos(void);
extern CPA_EXPORT int SIF_fn_iGetSoundInfosCount(void);
extern CPA_EXPORT const char *SIF_fn_czGetSoundInfoNameForType(int _iInfoType);
 
 
#ifdef __cplusplus
}
#endif /* __cplusplus*/
 
 
 
#endif /*_SIFFUNC_H_*/
