/****************************************************************************
 
         VAR.H : global variables         
         Last update : 26 july 96
 
*****************************************************************************/
 
/*
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
You must do : 
#define TDE_GLOBALS 
in one (and only one) .c file of your Module.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
 
/* To avoid unnecessary includes :  */
#ifndef  __TDE_VAR_H
#define __TDE_VAR_H
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
/* For Global declaration in C files : */
#ifndef TDE_GLOBALS
 #define __TDE_EXTERN extern
#else /* !TDE_GLOBALS */
 #define __TDE_EXTERN
#endif /* !TDE_GLOBALS */
 
/*
-----------------------------------------------------------------------------
GLOBAL VARIABLE DECLARATION :
-----------------------------------------------------------------------------
*/
 
/* Matrix stack*/
__TDE_EXTERN TDE_tdsSuperObjectMatrix       MatrixStack[TDE_kSTACKDEPTH];
/* Position in matrix stack*/
__TDE_EXTERN short                          MS_Position;
/* Transparency tables for 5 and 6 bits coded colors*/
__TDE_EXTERN unsigned char                  a_cTransparencyTable5[64][32];
__TDE_EXTERN unsigned char                  a_cTransparencyTable6[64][64];
/* Flicking of the cursor*/
__TDE_EXTERN char                           TDE_g_cFlick;
/* The main Z-list and the Z-list of the cursor*/
__TDE_EXTERN TDE_p_stSuperObject            TDE_g_apZList       [TDE_kMAXPRIORITY];
__TDE_EXTERN TDE_p_stSuperObject            TDE_g_apZListCursor [TDE_kMAXPRIORITY];
 
/*
-----------------------------------------------------------------------------
*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
 
#endif /* __TDE_VAR_H  */
 
 
