/*********************************************************************************/
/*    Struct.h : public header file for the CPA Timer library. Pentium Version	 */
/*               Just the defintion of the structure used to store timer values  */
/*    Author : JENTEY F.													                               */
/*    Last update : 03/03/97										                                 */
/*********************************************************************************/
 
 
#ifndef _TIMER_STRUCT_H
#define _TIMER_STRUCT_H
 
 
/* This structure store 64 bits values. Timer value are returned in this structure */
/* The m_ulHighPart isn't used for low precision timer.							   */
 
typedef struct _stTimerCount
{
	u_long		m_ulLowPart;
	u_long		m_ulHighPart;
 
}	stTimerCount;
 
 
 
#endif
