/*
------------------------------------------------------------------------------------------
HEADER FILE FOR :
Miscellaneous definition for mathematical module
------------------------------------------------------------------------------------------
File Name :
Mth_Misc.h
------------------------------------------------------------------------------------------
Creation :
  * Date : 
    February 28,1997
  * Author : 
    Albert PAIS
------------------------------------------------------------------------------------------
Contents :
This file defines miscellaneous structure, macros and functions
of the mathematical module
------------------------------------------------------------------------------------------
Modification :
  * Date : 
  * Author : 
  * Modify :
------------------------------------------------------------------------------------------
*/
#if !defined(__MTHMISC_TYPES__)
#define __MTHMISC_TYPES__
 
#if !defined(ONLY_TYPES)
#define MTHMISC_UNDEF
#define ONLY_TYPES
#endif /* !ONLY_TYPES */
 
/*
------------------------------------------------------------------------------------------
INCLUDE FILES :
------------------------------------------------------------------------------------------
*/
 
#if defined(MTHMISC_UNDEF)
#undef ONLY_TYPES
#undef MTHMISC_UNDEF
#endif /* !MTHMISC_UNDEF */
 
/*
------------------------------------------------------------------------------------------
TYPE DEFINITION :
If enumerate :
 M_BeginDeclareEnumerate(<type>)
 M_EndDeclareEnumerate(<type>, <basic type>)
------------------------------------------------------------------------------------------
*/
 
#endif /* !__MTHMISC_TYPES__ */
 
#if !defined(ONLY_TYPES)
 
#if !defined(__MTHMISC_VARS__)
#define __MTHMISC_VARS__
 
#undef MTH_MISC_EXTERN
#undef extern
#if !defined(MTH_MISC_GLOBALS)
#define MTH_MISC_EXTERN extern
#else /* !GLOBALS */
#define MTH_MISC_EXTERN
#endif /* !GLOBALS */
 
/*
------------------------------------------------------------------------------------------
VARIABLE DECLARATION :
 <type> <variable name>
 #if defined(GLOBALS)
 = <initial values>
 #endif
 ;
------------------------------------------------------------------------------------------
*/
 
 
/*
------------------------------------------------------------------------------------------
MACROS-CONSTANT DECLARATION:
------------------------------------------------------------------------------------------
*/
 
#endif /* !__MTHMISC_VARS__ */
 
#if !defined (__MTHMISC_PROTOS__)
#define __MTHMISC_PROTOS__
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
/*
------------------------------------------------------------------------------------------
MACROS-FUNCTIONS DECLARATION:
------------------------------------------------------------------------------------------
*/
 
/*
------------------------------------------------------------------------------------------
FUNCTIONS DECLARATION:
------------------------------------------------------------------------------------------
*/
MTH_MISC_EXTERN CPA_EXPORT void MTH_fnv_InitModule(unsigned long);
MTH_MISC_EXTERN CPA_EXPORT void MTH_fnv_DesinitModule(void);
 
MTH_MISC_EXTERN CPA_EXPORT void MTH_PrintUsedStaticMemory(void);
 
 
#endif /* !__MTHMISC_PROTOS__ */
 
#endif /* !ONLY_TYPES */
