/*
------------------------------------------------------------------------------------------
INCLUDE FILE :
------------------------------------------------------------------------------------------
*/
/*
memory and error management :
*/
#include "AIUseCpa.h"
#include "specif/AIOption.h"
#define __DeclareGlobalVariableMmgAIDebug_h__
#include "AID_Mmg.h"
#undef __DeclareGlobalVariableMmgAIDebug_h__
#define __DeclareGlobalVariableErrAIDebug_h__
#include "AID_Erm.h"
#undef __DeclareGlobalVariableErrAIDebug_h__
 
#include "Action.h"
#include "DsgMem.h"
#include "specif/ActTable.h"
#include "StrIntel.h"
#include "GetSet.h"
 
#include "AID_Main.h"
/*#include "AID_Eng.h"*/
/*#include "AID_Misc.h"*/
 
#ifdef ACTIVE_AIDEBUG /* For AI debugger*/
 
/* Oliv' - becoz'of codewarrior (compatible with gcc)*/
#ifdef U64_AIDEBUG
#include "AID_Trac.h"
extern tdstU64AIDebug g_stU64AIDebug;
#endif
 
void AIDebug_fnv_InitMain(void)
{ 
 /* Init error module :*/
	Erm_M_InitErrMsg(AIDebug);
	Mmg_M_InitMmg(AIDebug);
/* Oliv' - becoz'of codewarrior (compatible with gcc)*/
#ifdef U64_AIDEBUG
	g_stU64AIDebug.iU64AIDMaxIndex= D_SizeOfU64AIDBuffer;
	g_stU64AIDebug.iU64AIDCurrentIndex=0;
	memset( g_stU64AIDebug.a_stU64AIDBuffer, 0, D_SizeOfU64AIDBuffer*sizeof(AIDebug_tdstSectionEntry) );
#endif
}
 
#endif /* ACTIVE_AIDEBUG For AI debugger*/
