/************************************************************************************************
* Name: DataRay2.h                                                                              *
* Use : Datas structures for Rayman II                                                          *
* Author: Christophe Giraud                                                                     *                                                                    
*                                  (c) UBI Simulations Annecy                                   *
************************************************************************************************/
 
#ifndef _DATARAY2_H
#define _DATARAY2_H
 
/*ANNECY CG    {*/
/*ANNECY VL 11/05/98{*/
/*#define	C_MAXMAGICPOINTS	255*/
/*#define	C_MAXAIRPOINTS		255*/
/*ENDANNECY VL}*/
 
typedef struct
{
  int			iMagicPoints4Ray;
  int			iMagicPointsMax4Ray;
  /*ANNECY VL 11/05/98{*/
  MTH_tdxReal	xAirPoints4Ray;
  MTH_tdxReal	xAirPointsMax4Ray;
  /*ENDANNECY VL}*/
} tdstExtendDatas4Ray;
 
extern tdstExtendDatas4Ray stExtendDatas4Ray;
 
/*ENDANNECY CG }*/
 
#endif /*_DATARAY2_H*/
