/****************************************
 * Here is the list of disabled WARNING *
 ****************************************/
#if defined(VISUAL)
#pragma warning(disable:4010) /** single-line comment contains line-continuation character **/
#pragma warning(disable:4032) /** formal parameter 1 has different type when promoted **/
#pragma warning(disable:4100) /** unreferenced formal parameter **/
#pragma warning(disable:4115) /** named type definition in parentheses **/
#pragma warning(disable:4127) /** conditional expression is constant **/
#pragma warning(disable:4201) /** nonstandard extension used : nameless struct/union **/
#pragma warning(disable:4214) /** nonstandard extension used : bit field types other than int **/
#pragma warning(disable:4310) /** cast truncates constant value **/
#pragma warning(disable:4514) /** unreferenced inline function has been removed **/
#pragma warning(disable:4702) /** unreachable code **/
#pragma warning(disable:4711) /** selected for automatic inline expansion **/
#endif /* VISUAL */
/**************************************************************************/
#if defined(WIN32)
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#endif /* WIN32 */
/**************************************************************************/
#define D_DPT_VariableDefine
#include "DPT_str.h"

#ifndef U64 
#ifndef ACTIVE_EDITOR
#ifdef _DEBUG

#include "acp_base.h"

EXTERN ACP_tdxBool	g_bDreamcast;

#endif /* _DEBUG */
#endif /* ACTIVE_EDITOR */
#endif /* U64 */
 
/**************************************************************************/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
void fn_vSetEngineDLLPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szEngineDLL,_p_szPath);
}
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
char *fn_szGetEngineDLLPath(void)
{
 return(g_stDataPath.szEngineDLL);
}
/**************************************************************************/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
void fn_vSetGameDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szGameData,_p_szPath);
}
char *fn_szGetGameDataPath(void)
{
 return(g_stDataPath.szGameData);
}
/**************************************************************************/
void fn_vSetSaveGameDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szSaveGame,_p_szPath);
}
char *fn_szGetSaveGameDataPath(void)
{
 return(g_stDataPath.szSaveGame);
}
/**************************************************************************/
void fn_vSetExtrasDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szExtras,_p_szPath);
}
char *fn_szGetExtrasDataPath(void)
{
 return(g_stDataPath.szExtras);
}
/**************************************************************************/
void fn_vSetWorldDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szWorld,_p_szPath);
}
char *fn_szGetWorldDataPath(void)
{
 return(g_stDataPath.szWorld);
}
/**************************************************************************/
void fn_vSetTextsDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szTexts,_p_szPath);
}
char *fn_szGetTextsDataPath(void)
{
 return(g_stDataPath.szTexts);
}
/**************************************************************************/
void fn_vSetFamiliesDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szFamilies,_p_szPath);
}
char *fn_szGetFamiliesDataPath(void)
{
 return(g_stDataPath.szFamilies);
}
/**************************************************************************/
void fn_vSetCharactersDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szCharacters,_p_szPath);
}
char *fn_szGetCharactersDataPath(void)
{
 return(g_stDataPath.szCharacters);
}
/**************************************************************************/
void fn_vSetLevelsDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szLevels,_p_szPath);
}
char *fn_szGetLevelsDataPath(void)
{
 return(g_stDataPath.szLevels);
}
/**************************************************************************/
void fn_vSetAnimDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szAnim,_p_szPath);
}
char *fn_szGetAnimDataPath(void)
{
 return(g_stDataPath.szAnim);
}
/**************************************************************************/
void fn_vSetGameMaterialDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szGameMaterial,_p_szPath);
}
char *fn_szGetGameMaterialDataPath(void)
{
 return(g_stDataPath.szGameMaterial);
}
/**************************************************************************/
void fn_vSetCollideMaterialDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szCollideMaterial,_p_szPath);
}
char *fn_szGetCollideMaterialDataPath(void)
{
 return(g_stDataPath.szCollideMaterial);
}
/**************************************************************************/
void fn_vSetSoundMaterialDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szSoundMaterial,_p_szPath);
}
char *fn_szGetSoundMaterialDataPath(void)
{
 return(g_stDataPath.szSoundMaterial);
}
/**************************************************************************/
void fn_vSetMechanicsMaterialDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szMechanicsMaterial,_p_szPath);
}
char *fn_szGetMechanicsMaterialDataPath(void)
{
 return(g_stDataPath.szMechanicsMaterial);
}
/**************************************************************************/
void fn_vSetVisualMaterialDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szVisualMaterial,_p_szPath);
}
char *fn_szGetVisualMaterialDataPath(void)
{
 return(g_stDataPath.szVisualMaterial);
}
/**************************************************************************/
void fn_vSetTexturesDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szTextures,_p_szPath);
}
char *fn_szGetTexturesDataPath(void)
{
 return(g_stDataPath.szTextures);
}
/**************************************************************************/
void fn_vSetSoundDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szSound,_p_szPath);
}
char *fn_szGetSoundDataPath(void)
{
 return(g_stDataPath.szSound);
}
/**************************************************************************/
void fn_vSetGraphicsClassesDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szGraphicsClasses,_p_szPath);
}
char *fn_szGetGraphicsClassesDataPath(void)
{
 return(g_stDataPath.szGraphicsClasses);
}
/**************************************************************************/
void fn_vSetGraphicsBanksDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szGraphicsBanks,_p_szPath);
}
char *fn_szGetGraphicsBanksDataPath(void)
{
 return(g_stDataPath.szGraphicsBanks);
}
/**************************************************************************/
void fn_vSetMechanicsDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szMechanics,_p_szPath);
}
char *fn_szGetMechanicsDataPath(void)
{
 return(g_stDataPath.szMechanics);
}
/**************************************************************************/
void fn_vSetEnvironmentDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szEnvironment,_p_szPath);
}
char *fn_szGetEnvironmentDataPath(void)
{
 return(g_stDataPath.szEnvironment);
}
/**************************************************************************/
void fn_vSetVignettesDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szVignettes,_p_szPath);
}
char *fn_szGetVignettesDataPath(void)
{
 return(g_stDataPath.szVignettes);
}
/**************************************************************************/
void fn_vSetOptionsDataPath(char *_p_szPath)
{
#ifndef U64
#ifndef ACTIVE_EDITOR
#ifdef _DEBUG
	if (g_bDreamcast)
	{
		strcat(_p_szPath,"_DC");
	}

#endif /* _DEBUG */
#endif /* ACTIVE_EDITOR */
#endif /* U64 */

	strcpy(g_stDataPath.szOptions,_p_szPath);

}
char *fn_szGetOptionsDataPath(void)
{
 return(g_stDataPath.szOptions);
}
/**************************************************************************/
void fn_vSetSyncLipsDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szSyncLips,_p_szPath);
}
char *fn_szGetSyncLipsDataPath(void)
{
 return(g_stDataPath.szSyncLips);
}
/**************************************************************************/
void fn_vSetZdxDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szZdx,_p_szPath);
}
char *fn_szGetZdxDataPath(void)
{
 return(g_stDataPath.szZdx);
}
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
/**************************************************************************/
void fn_vComputeTempDataPath(void)
{
/*XB980514*/
#ifndef U64
	GetTempPath(_MAX_PATH,g_stDataPath.szTemp);
 if (g_stDataPath.szTemp[strlen(g_stDataPath.szTemp)-1]=='\\'||g_stDataPath.szTemp[strlen(g_stDataPath.szTemp)-1]=='/')
  g_stDataPath.szTemp[strlen(g_stDataPath.szTemp)-1]=0;
#endif /* !U64 */
/*End XB*/
}
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
char *fn_szGetTempDataPath(void)
{
 return(g_stDataPath.szTemp);
}
/**************************************************************************/
void fn_vSetEffectsDataPath(char *_p_szPath)
{
 strcpy(g_stDataPath.szEffects,_p_szPath);
}
char *fn_szGetEffectsDataPath(void)
{
 return(g_stDataPath.szEffects);
}
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
/**************************************************************************/
