#ifndef _ERROR_OPERATOR_DIALOG_REPORT_
#define _ERROR_OPERATOR_DIALOG_REPORT_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ErOReprt.hpp : header file
//

#include "ErO_Res.h"

/////////////////////////////////////////////////////////////////////////////
// ErrorOperator_DialogReport dialog

class ErrorOperator_DialogReport : public CDialog
{
// Construction
public:
	ErrorOperator_DialogReport(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(ErrorOperator_DialogReport)
	enum { IDD = IDD_DIALOG_REPORT };
	int		m_iChosenReportType;
	CString	m_csFileName;
	BOOL	m_bSendToMainProgrammer;
	BOOL	m_bSendToSecondProgrammer;
	BOOL	m_bSendToResponsible;
	BOOL	m_bDeleteReport;
	CString	m_csAddedComments;
	//}}AFX_DATA

private:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ErrorOperator_DialogReport)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
private:
	void m_pri_fn_vSaveFile();
	void m_pri_fn_vPrint();
	void m_pri_fn_vCopyToClipboard();
	void m_pri_fn_vCopyIntoClipBoard(CString csText);
	void m_pri_fn_vSendByMail();

protected:

	// Generated message map functions
	//{{AFX_MSG(ErrorOperator_DialogReport)
	virtual void OnOK();
	afx_msg void OnButtonFileBrowse();
	afx_msg void OnRadioReportClipboard();
	afx_msg void OnRadioReportFile();
	afx_msg void OnRadioReportPrinter();
	afx_msg void OnRadioReportMail();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG

	
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // _ERROR_OPERATOR_DIALOG_REPORT_
