// ErOTeam.hpp : header file
/////////////////////////////////////////////////////////////////////////////
#ifndef _ERROR_OPERATOR_TEAM_DIALOG_
#define _ERROR_OPERATOR_TEAM_DIALOG_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Ero_Res.h"

#include <afxtempl.h>

//############################################################################
class ErrorOperator_Team
{
public:
	ErrorOperator_Team(	//Module
											CString _csModuleName,
											CString _csModuleVersion,

											//Main Programmer
											CString _csMainProgrammerName,
											CString _csMainProgrammerPhoneNumber,
											CString _csMainProgrammerEMailAddress,
											
											//Responsible
											CString _csResponsibleName,
											CString _csResponsiblePhoneNumber,
											CString _csResponsibleEMailAddress,
											
											//Second Programmer
											CString _csSecondProgrammerName,
											CString _csSecondProgrammerPhoneNumber,
											CString _csSecondProgrammerEMailAddress
										);
	~ErrorOperator_Team();

//Members
public:
	//Module
	CString m_csModuleName;
	CString m_csModuleVersion;

	//Main Programmer
	CString m_csMainProgrammerName;
	CString m_csMainProgrammerPhoneNumber;
	CString m_csMainProgrammerEMailAddress;
	
	//Responsible
	CString m_csResponsibleName;
	CString m_csResponsiblePhoneNumber;
	CString m_csResponsibleEMailAddress;
	
	//Second Programmer
	CString m_csSecondProgrammerName;
	CString m_csSecondProgrammerPhoneNumber;
	CString m_csSecondProgrammerEMailAddress;

};

//############################################################################
class  ErrorOperator_TeamList : public CList<ErrorOperator_Team *, ErrorOperator_Team *>
{
public:
	ErrorOperator_TeamList();
	~ErrorOperator_TeamList();

//Members
public:

protected:

private:

//Functions
public:
	ErrorOperator_Team *m_pub_fn_pclAddTeam(//Module
																					CString _csModuleName,
																					CString _csModuleVersion,

																					//Main Programmer
																					CString _csMainProgrammerName,
																					CString _csMainProgrammerPhoneNumber,
																					CString _csMainProgrammerEMailAddress,
																					
																					//Responsible
																					CString _csResponsibleName,
																					CString _csResponsiblePhoneNumber,
																					CString _csResponsibleEMailAddress,
																					
																					//Second Programmer
																					CString _csSecondProgrammerName,
																					CString _csSecondProgrammerPhoneNumber,
																					CString _csSecondProgrammerEMailAddress);

	ErrorOperator_Team *m_pub_fn_pclGetTeamFromModuleName(CString _csModuleName);

protected:

private:
	void m_pri_fn_vEmptyList();

friend class ErrorOperator_TeamDialog;
};

#endif //_ERROR_OPERATOR_TEAM_DIALOG_
