#if !defined(AFX_ERO_DGIF_HPP__DF0D3853_6662_11D1_B657_006097828C2B__INCLUDED_)
#define AFX_ERO_DGIF_HPP__DF0D3853_6662_11D1_B657_006097828C2B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ErO_DgIf.hpp : header file
//

#include <afxtempl.h>

#include "ErO_Res.h"

#define ERO_BITMAP_AS_BACKGROUND

/////////////////////////////////////////////////////////////////////////////
// ErO_MoreInfoDialog dialog

class ErO_MoreInfoDialog : public CDialog
{
// Construction
public:
  //Standard constructor
	ErO_MoreInfoDialog(CWnd* pParent,
										 CPoint cpPoint,
										 enum ErO_eStaticType _tdeType);
	
	~ErO_MoreInfoDialog();

// Dialog Data
	//{{AFX_DATA(ErO_MoreInfoDialog)
	enum { IDD = IDD_DIALOG_MORE_INFO1 };
	//}}AFX_DATA
private:
	CPoint m_pri_cpPoint;
	enum ErO_eStaticType m_pri_eType;
	BOOL m_pri_bHasCapturedMouse;
	CRect m_pri_crWindowRect;

	CList<UINT *, UINT *> m_pri_clListOfID;

#ifdef ERO_BITMAP_AS_BACKGROUND
	CBitmap m_pri_cBackgroundBitmap;
#endif //ERO_BITMAP_AS_BACKGROUND

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ErO_MoreInfoDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ErO_MoreInfoDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnButtonMakeReport();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
#ifdef ERO_BITMAP_AS_BACKGROUND
	afx_msg void OnPaint();
#endif //ERO_BITMAP_AS_BACKGROUND
	//}}AFX_MSG

private:
	void m_pri_BuilListOfID();
	void m_pri_MoveControls(long _lWidth);
	long m_pri_fn_l_ComputeLongestString();

	
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ERO_DGIF_HPP__DF0D3853_6662_11D1_B657_006097828C2B__INCLUDED_)
