/*=========================================================================
* //ANNECY CO SPOFLAG 03/02/98
* 
* EDTdFlag.h :  class EDT_DialogFlag
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR


#ifndef __DIALOGFLAG_H__
#define __DIALOGFLAG_H__

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#include "EDTRes.h"

class EDT_HierarchyEditor;
class EDT_SuperObject;
class CPA_Interface;

/*===========================================================================
*		Description:	EDT_DialogFlag dialog
*		Creation date:
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                        Author:
*=========================================================================*/

class EDT_DialogFlag : public CDialog
{
protected:
	EDT_HierarchyEditor		*m_pEditor;
	EDT_SuperObject			*m_pSuperObject;
	unsigned long			m_ulInitialFlags;

public:
// parent editor
	EDT_HierarchyEditor * GetParentEditor	(void) { return m_pEditor; }
	CPA_Interface		* GetInterface		(void);

// standard constructor
	EDT_DialogFlag (CWnd* pParent = NULL);   
// dialog
	void fn_vDoDialog (EDT_HierarchyEditor *pEditor, EDT_SuperObject *pSupObj);


// Dialog Data
	//{{AFX_DATA(EDT_DialogFlag)
	enum { IDD = EDT_IDD_DIALOGFLAGS };
	CButton	m_cCheckPicking;
	CButton	m_cCheckHidden;
//ANNECY Shaitan SPOFlags 17/02/98
	CButton	m_cCheckTransformMatrix;
	CButton	m_cCheckZoomForScale;
//ANNECY TQ 27/02/98{
	CButton m_cCheckBoundingBox;
	CButton m_cCheckImpose;
	CButton m_cCheckNoRayTrace;
	CButton m_cCheckChildren;
	CButton m_cCheckNoShadowOnMe;
//ENDANNECY TQ}

//ENDANNECY Shaitan SPOFlags
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EDT_DialogFlag)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EDT_DialogFlag)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__DIALOGMOVE_H__
#endif // ACTIVE_EDITOR
