/*=========================================================================
* 
* EDTdUpdt.h :  class EDT_DialogList
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#ifndef __DIALOGUPDATE_H__
#define __DIALOGUPDATE_H__

#include "EDTRes.h"

#include "ITF.h"

class EDT_HierarchyEditor;
class EDT_SuperObject;
class CPA_Interface;

/*===========================================================================
*		Description:	EDT_DialogUpdate dialog
*		Creation date:
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                        Author:
*=========================================================================*/

class EDT_DialogUpdate : public CDialog
{
protected:
	EDT_HierarchyEditor *m_pEditor;
	
public:

// parent editor
	EDT_HierarchyEditor * GetParentEditor	(void) { return m_pEditor; }
	CPA_Interface		* GetInterface		(void);

// Construction
	EDT_DialogUpdate (CWnd* pParent = NULL);  

	void fn_vInitDialog (EDT_HierarchyEditor *pEditor);

// function
	BOOL fn_bIsInHierarchy (EDT_SuperObject *pEdObj);

// lists
	CPA_List<EDT_SuperObject> m_stListDestroy;
	CPA_List<EDT_SuperObject> m_stListInsert;
// position
	POS_tdstCompletePosition m_stRefMatrix;



// Dialog Data
	//{{AFX_DATA(EDT_Update)
	enum { IDD = EDT_IDD_DIALOGUPDATE };
	CListBox	m_cListInsert1;
	CListBox	m_cListDestroy1;
	CListBox	m_cListInsert;
	CListBox	m_cListDestroy;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EDT_Update)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EDT_Update)
	afx_msg void OnSelchangeListDestroy();
	afx_msg void OnSelchangeListReinsert();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__DIALOGUPDATE_H__
#endif // ACTIVE_EDITOR
