/*=========================================================================
* 
* EDTdVect.hpp :  class EDT_DialogVector
* 
*
* Version			1.0
* Creation date		17-06-98
* Author			Corneliu Babiuc
* Revision date
*
**=======================================================================*/
#ifdef ACTIVE_EDITOR


#ifndef __DIALOGVECTOR_H__
#define __DIALOGVECTOR_H__

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#include "EDTRes.h"
#include "mth.h"

/*===========================================================================
*		Description:	EDT_DialogVector dialog
*		Creation date:
*		Author:			Corneliu Babiuc
*---------------------------------------------------------------------------
*		Revision date:                        Author:
*=========================================================================*/

class EDT_DialogVector : public CDialog
{
// Construction
public:
	EDT_DialogVector(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(EDT_DialogVector)
	enum { IDD = EDT_IDD_DIALOGVECTOR };
	MTH_tdxReal	m_xComponentX;
	MTH_tdxReal	m_xComponentY;
	MTH_tdxReal	m_xComponentZ;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EDT_DialogVector)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EDT_DialogVector)
	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif // __DIALOGVECTOR_H__
#endif // ACTIVE_EDITOR