/*=========================================================================
*
* EDTEnum.hpp
*
*
* Version			1.0
* Creation date
* Revision date
*
* Shaitan
*=======================================================================*/
#ifdef ACTIVE_EDITOR

//**************************************
#ifndef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
#define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
#define CPA_EXPORT __declspec(dllexport)
#else
#define CPA_EXPORT
#endif
#endif
//**************************************

#ifndef __EDTENUM_HPP__
#define __EDTENUM_HPP__


// mousemove mode
typedef enum tdeMouseMoveMode_
{
	E_mmm_NoMouseMove, 
	E_mmm_MouseMove, 
	E_mmm_MouseRotateXY, 
	E_mmm_MouseRotateXZ
} 
tdeMouseMoveMode;

// modif canceled for message
typedef enum tdeCancelMode_
{
	E_cm_CancelParent, 
	E_cm_CancelCopy, 
	E_cm_CancelInsert, 
	E_cm_CancelDelete,
	E_cm_CancelMove, 
	E_cm_CancelPaste, 
	E_cm_NoCancel
}
tdeCancelMode;

// editor mode
typedef enum tdeEditorMode_
{
	E_em_PyramidMode, 
	E_em_HierarchyMode, 
	E_em_ChoiceMode, 
	E_em_ParentMode, 
	E_em_PositionMode, 
	E_em_CopyAllMode, 
	E_em_CopyAloneMode,
	E_em_MoveToMode,
//CPA2 Corneliu Babiuc (multiple registration) 07-07-98
	E_em_RegisterSelection,
	E_em_ClearRegistration,
//CPA2 Corneliu Babiuc (multiple registration) 07-07-98
//CPA2 Corneliu Babiuc 14-06-98
	E_em_MoveToInstance,
	E_em_MoveCameraToInstance,
	E_em_MoveCameraCentered,
//CPA2 Corneliu Babiuc 17-06-98
	E_em_OrientMode,
	E_em_VOrientMode,
// Begin Silviu Simen 18 August 1998 Cut/Paste Mechanism
	E_em_CutPasteMode,
// End Silviu Simen 18 August 1998 Cut/Paste Mechanism
	E_em_NoMode
}
tdeEditorMode;

//CPA2 Corneliu Babiuc (multiple registration) 03-07-98
// selection of list
typedef enum tdeList_
{
	E_lst_SelectedList,
	E_lst_RegisteredList
}
tdeList;
//END CPA2 Corneliu Babiuc (multiple registration) 03-07-98

#endif // __EDTENUM_HPP__
#endif // ACTIVE_EDITOR