//ROMTEAM StickObjects (Nicolae Suparatu 10/02/98)

// Get the transform parameters (rotation + translation) in order to move one
// triangle over another one, if they are congruent
// Author: Nicolae Suparatu


#define eps 1e-4
typedef float Matrix[3][3];
typedef float Vector[3];


// dst = destination triangle (on lines)
// src = source triangle (on lines)
// r = resulting rotation matrix
// t = resulting translation matrix
int GetTransform(Matrix &dst, Matrix &src, Matrix &r, Vector &t);

void Convert(Matrix &r, Vector &t, Matrix &mo, Vector &vo);

float sqr(float f);

//ENDROMTEAM StickObjects (Nicolae Suparatu)
