#if !defined(__FIL_Bmp_h__)
#define __FIL_Bmp_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
#include "CPA_Expt.h"
 
#undef EXTERN
#undef extern
#if !defined(D_FIL_Globals)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_FIL_Globals */
 
#pragma pack(push,1)
typedef struct FIL_tdstBmpFileHeader_
{
 unsigned short uwType;
 unsigned long  ulSize;
 unsigned long  ulReserved;
 unsigned long  ulOffsetBits;
} FIL_tdstBmpFileHeader;
 
typedef struct FIL_tdstBmpInfoHeader_
{
 unsigned long  ulSize;
 unsigned long  ulWidth;
 unsigned long  ulHeight;
 unsigned short uwPlanes;
 unsigned short uwBitCount;
 unsigned long  ulCompression;
 unsigned long  ulSizeImage;
 unsigned long  ulXPelsPerMeter;
 unsigned long  ulYPelsPerMeter;
 unsigned long  ulColorsUsed;
 unsigned long  ulColorsImportant;
} FIL_tdstBmpInfoHeader;
#pragma pack(pop)
 
typedef struct FIL_tdstBmp_
{
 struct FIL_tdstBmpFileHeader_ stFileHeader;
 struct FIL_tdstBmpInfoHeader_ stInfoHeader;
 
 unsigned char *p_ucBitMap;
} FIL_tdstBmp;
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __FIL_Bmp_h__ */
