#if !defined(__FIL_Tga_h__)
#define __FIL_Tga_h__
 
/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif /* _MSC_VER >= 1000 */
/******************************************/
 
#if defined(__cplusplus)
extern "C"
{
#endif /* __cplusplus */
 
#include "CPA_Expt.h"
 
#undef EXTERN
#undef extern
#if !defined(D_FIL_Globals)
#define EXTERN extern
#else
#define EXTERN
#endif /* D_FIL_Globals */
 
#pragma pack(push,1)
typedef struct FIL_tdstTgaFileHeader_
{
 unsigned char ucNumberOfCharInIdentField;
 unsigned char ucColorMapType;
 unsigned char ucImageTypeCode;
 struct
 {
  unsigned short uwOrigin;
  unsigned short uwLength;
  unsigned char  ucEntrySize;
 } stColorMapSpecification;
 struct
 {
  unsigned short uwXOrigin;
  unsigned short uwYOrigin;
  unsigned short uwWidth;
  unsigned short uwHeight;
  unsigned char  ucPixelSize;
  unsigned char  ucDescriptorByte;
 } stImageSpecification;
} FIL_tdstTgaFileHeader;
#pragma pack(pop)
 
typedef struct FIL_tdstTga_
{
 struct FIL_tdstTgaFileHeader_ stFileHeader;
 
 unsigned char *szIdentificationField;
 unsigned char *ucColorMapData;
 unsigned char *p_ucBitMap;
} FIL_tdstTga;
 
#if defined(__cplusplus)
}
#endif /* __cplusplus */
 
#endif /* __FIL_Tga_h__ */
