/* (c) Ubi R&D 1997*/
/* See Alain Robin for any comment or question*/
 
/****************************************************************************/
/* INCLUDES                                                                                                                                     */
/****************************************************************************/
#include "cpa_std.h"
#include "acp_base.h"
 
#include "MTH.h"
#include "SCR.h"
 
#define __DeclareGlobalFunctionPointersVariableGmt_h__ /* For function pointers declarations */
#include "GmtStruc.h"   /* structure definition*/
#undef __DeclareGlobalFunctionPointersVariableGmt_h__
#include "GmtFunct.h"   /* access function definition*/
#include "GMTProto.h"
#include "GmtVProt.h"
 
/*---------------------------------------------------------------------------/
//  Description : GMT_fn_vInitFor3DOS
//  Must be called before anything else
------------------------------------------------------------------------------
//  Methods :  Affect the correct function pointers
------------------------------------------------------------------------------
//  Input :             
//  Output : 
------------------------------------------------------------------------------
//  Creation date : Apr 97				Author: Alain Robin
------------------------------------------------------------------------------
//  Modifications :	
//  Modification date :						Modification author : 
---------------------------------------------------------------------------*/
void GMT_fn_vInitFor3DOS(void)
{
	GMT_p_fn_hVirtualCreate=&GMT_fn_hCreateFor3DOS;
	GMT_p_fn_vVirtualCopy=&GMT_fn_vCopyFor3DOS;
/*XB 22/06/99*/
#ifndef U64
	GMT_p_fn_vVirtualDestroy=&GMT_fn_vDestroyFor3DOS;
#endif /* U64 */
/*End XB 22/06/99*/
	GMT_p_fn_vVirtualInitLoadGameMaterial=&GMT_fn_vInitLoadGameMaterialFor3DOS;
	
	/*XB*/
#ifndef U64
	GMT_fn_vInitGameMaterialErrorAndMemory();
#endif /* U64 */
	/*End XB*/
}
 
/*---------------------------------------------------------------------------/
//  Description : GMT_fn_vInitForA3D
//  Must be called before anything else
------------------------------------------------------------------------------
//  Methods :  Affect the correct function pointers for using module with A3D
------------------------------------------------------------------------------
//  Input :             
//  Output : 
------------------------------------------------------------------------------
//  Creation date : Apr 97				Author: Alain Robin
------------------------------------------------------------------------------
//  Modifications :	
//  Modification date :						Modification author : 
---------------------------------------------------------------------------*/
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
/*void GMT_fn_vInitForA3D(void)
{	
	GMT_p_fn_hVirtualCreate=&GMT_fn_hCreateForA3D;
	GMT_p_fn_vVirtualCopy=&GMT_fn_vCopyForA3D;
	GMT_p_fn_vVirtualDestroy=&GMT_fn_vDestroyForA3D;
	GMT_p_fn_vVirtualInitLoadGameMaterial=&GMT_fn_vInitLoadGameMaterialForA3D;
 
	GMT_fn_vInitGameMaterialErrorAndMemory();
}
*/
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
