/* only macros needed to get/set attributes of a screen vertex*/
#ifndef GLI_VTX_GLIDE2
#define __MSC__
#include <GLIDE.H>
 
#include "drawflags.h"
 
#define GLI_GLIDE1_CurrentTmu 0
 
/* GET*/
#define GetX(a) a->x
#define GetY(a) a->y
#define GetZ(a) a->oow
#define GetPackedColor(a) *(unsigned long *)&(a->r)
#define GetPackedSpecular(a,b)
#define GetU(a) a->tmuvtx[GLI_GLIDE1_CurrentTmu].sow
#define GetV(a) a->tmuvtx[GLI_GLIDE1_CurrentTmu].tow
#define GetRed(pVtx)	pVtx->r
#define GetGreen(pVtx)	pVtx->g
#define GetBlue(pVtx)	pVtx->b
#define GetAlpha(pVtx)	pVtx->a
/* SET*/
#define SetX(a,b) a->x = b
#define SetY(a,b) a->y = b
#define SetZ(a,b) a->oow = b
#define SetPackedColor(a,b) *(unsigned long *)&(a->r) = b
/* don't bother packing and unpacking colors*/
#define SetRGBA(pVtx, red, green, bleu, alpha)	\
					pVtx->r = (float) red;		\
					pVtx->g = (float) green;	\
					pVtx->b = (float) bleu;		\
					pVtx->a = (float) alpha;
 
#define SetPackedSpecular(a,b)
#define SetU(a,b) a->tmuvtx[GLI_GLIDE1_CurrentTmu].sow = b
#define SetV(a,b) a->tmuvtx[GLI_GLIDE1_CurrentTmu].tow = b
#define SetU_Cpy(a,b) *(unsigned long *)&a->tmuvtx[GLI_GLIDE1_CurrentTmu].sow = *(unsigned long *)&b
#define SetV_Cpy(a,b) *(unsigned long *)&a->tmuvtx[GLI_GLIDE1_CurrentTmu].tow = *(unsigned long *)&b
/* GET*/
#define GetXSt(a) a.x
#define GetYSt(a) a.y
#define GetZSt(a) a.oow
#define GetPackedColorSt(a) *(unsigned long *)&(a.r)
#define GetPackedSpecularSt(a,b)
#define GetUSt(a) a.tmuvtx[GLI_GLIDE1_CurrentTmu].sow
#define GetVSt(a) a.tmuvtx[GLI_GLIDE1_CurrentTmu].tow
#define GetRedSt(pVtx)	pVtx.r
#define GetGreenSt(pVtx)	pVtx.g
#define GetBlueSt(pVtx)	pVtx.b
#define GetAlphaSt(pVtx)	pVtx.a
/* SET*/
#define SetXSt(a,b) a.x = b
#define SetYSt(a,b) a.y = b
#define SetZSt(a,b) a.oow = b
#define SetPackedColorSt(a,b) *(unsigned long *)&(a.r) = b
/* don't bother packing and unpacking colors*/
#define SetRGBASt(pVtx, red, green, bleu, alpha)	\
					pVtx.r = (float) red;		\
					pVtx.g = (float) green;	\
					pVtx.b = (float) bleu;		\
					pVtx.a = (float) alpha;
 
#define SetPackedSpecularSt(a,b)
#define SetUSt(a,b) a.tmuvtx[GLI_GLIDE1_CurrentTmu].sow = b
#define SetVSt(a,b) a.tmuvtx[GLI_GLIDE1_CurrentTmu].tow = b
#define SetU_CpySt(a,b) *(unsigned long *)&a.tmuvtx[GLI_GLIDE1_CurrentTmu].sow = *(unsigned long *)&b
#define SetV_CpySt(a,b) *(unsigned long *)&a.tmuvtx[GLI_GLIDE1_CurrentTmu].tow = *(unsigned long *)&b
 
 
/* Fond de roulement GLIDE1*/
/* GLOBALS*/
#define GLI_tdScreenVertx GrVertex
 
#endif /* GLI_VTX_GLIDE2*/
