/* Testing Errors */

//#define OGL_VER2_2 // OpenGL version 2.2

#if defined (_DEBUG)
 #define ERROR_TEST
#endif


//#define OPENGL_3DFX

#if defined (OPENGL_3DFX)
#define WORKAROUNDBUG  //Work around bug in mini drivers
#endif //defined (OPENGL_3DFX)

/* Perspective */

//#define Z_BUFFER // if not defined => W_BUFFER

#define PERSP_CORRECTION

#if !defined (Z_BUFFER)
	//#define ACCURATE_DEPTH_BUFFER // if defined in Rayman2 => nothing drawn in the "second viewport"
#endif


/* Texture test (fail if not in video memory) */

#if defined (_DEBUG)
 //#define TEX_TEST
#endif


/* MIPMAP */
#if !defined (OGL_VER2_2)
	#define MIPMAP_DOWN_TO_1x1
#endif

//#define REINIT_DEVICE_ONSIZE

//#define IGNORE_TEXTUREWRAP // to keep TexParameters GL_TEXTURE_WRAP_S & GL_TEXTURE_WRAP_T to GL_REPEAT value (because rastering GL_CLAMP'ed textures costs a lot !)

//#define NO_MIPMAP_FOR_TRANSPARENT_TEX // bug on the ATI RAGE PRO harware rasterization pipe : bilinear filtering is very ugly on transparent textures, so it looks better without Mipmaping these textures (on the software rasterization pipe, it is ok)

#define NO_FOG

/* window creation */

//#define USE_DEVMODE

//#define USE_DDRAW
#if defined (USE_DDRAW)
	#define FULL_SCREEN
#endif //USE_DDRAW

#define SIZABLE


/* locking backbuffer*/

#define INVERT_Y
#define USE_ALPHA
