/*
 =======================================================================================
  Name        : GLI_Menu.h
  Author      : vincent lhullier            Date :10/03/99
  Description : function to display gli menu
 =======================================================================================
 =======================================================================================
    !!!! Warning : In retail version this file define only empty symbols !!!!
 =======================================================================================
 =======================================================================================
 */

#if defined(RETAIL) || defined(PRESS_DEMO)

#define GLI_fnv_ManageMenu()
#define GLI_fn_vAddDisplayedVisualMaterial( _hVisualMaterial )
#define GLI_M_vAddDisplayedVisualMaterialForSprite( p_stEltSprite )
#define GLI_M_vAddDisplayedVisualMaterialForEltIndexedTriangle( p_stEltIndexedTriangle )
 
#else

void GLI_fnv_ManageMenu( void );
void GLI_fn_vAddDisplayedVisualMaterial( ACP_tdxHandleOfMaterial _hVisualMaterial );

#define GLI_M_vAddDisplayedVisualMaterialForSprite( p_stEltSprite ) \
{ \
    if(    p_stEltSprite -> d_stListOfSprites[lSpriteIndex].hSprite -> d_hMaterial[0] \
        && p_stEltSprite -> d_stListOfSprites[lSpriteIndex].hSprite -> d_hMaterial[0] -> hVisualMaterial ) \
    {  \
        GLI_fn_vAddDisplayedVisualMaterial( p_stEltSprite -> d_stListOfSprites[lSpriteIndex].hSprite -> d_hMaterial[0] -> hVisualMaterial ); \
    } \
}

#define GLI_M_vAddDisplayedVisualMaterialForEltIndexedTriangle( p_stEltIndexedTriangle ) \
{ \
    if(    p_stEltIndexedTriangle -> hMaterial \
        && p_stEltIndexedTriangle -> hMaterial -> hVisualMaterial ) \
    { \
        GLI_fn_vAddDisplayedVisualMaterial( p_stEltIndexedTriangle -> hMaterial -> hVisualMaterial ); \
    } \
}


#endif /* RETAIL */
