/* Handle module */
/* Copyright 1997 Ubi research */
/* See Alain Robin for any remark or question */
 
/* Add here all call of needed ACP modules */
#include "acp_base.h"
#include "GMT.h"
 
#include "HDL/HDLProto.h"
/*----------------------------------------------------------------------------
--  Description : HDL_fn_vInitModulesFor3DOS()
--  Initialise all the ACP modules for the 3dos client 
------------------------------------------------------------------------------
--  Methods : Call all needed initialisation functions
------------------------------------------------------------------------------
--  Input :             
--  Output : 
------------------------------------------------------------------------------
--  Creation date : 28 Apr 97				Author: Alain Robin
------------------------------------------------------------------------------
--  Modifications :	
--  Modification date :						Modification author : 
----------------------------------------------------------------------------*/
void HDL_fn_vInitModulesFor3DOS()
{
	GMT_fn_vInitFor3DOS(); /* Initialisation of game material module */
}
 
/*----------------------------------------------------------------------------
--  Description : HDL_fn_vInitModulesForA3D()
--  Initialise all the ACP modules for the A3D client 
------------------------------------------------------------------------------
--  Methods : Call all needed initialisation functions
------------------------------------------------------------------------------
--  Input :             
--  Output : 
------------------------------------------------------------------------------
--  Creation date : 28 Apr 97				Author: Alain Robin
------------------------------------------------------------------------------
--  Modifications :	
--  Modification date :						Modification author : 
----------------------------------------------------------------------------*/
void HDL_fn_vInitModulesForA3D()
{
	GMT_fn_vInitForA3D(); /* Initialisation of game material module */
}
