/***************************************************************************/
/*  Description: INOInot.h, part of CPA INO library                        */                                
/*               Header for error, memory and direct input initialisation  */
/*                                                                         */
/*  Author: F. Jentey                                                      */
/*  Creation date: 21/04/97                                                */
/*  Last Update:   30/07/97  Direct Input                                  */
/***************************************************************************/
 
 
 
#include "CPA_std.h"
#include "DInput.h"
 
/*
  Direct Input interface
*/
extern LPDIRECTINPUT  INO_g_p_stDInputInterface;
extern HINSTANCE      INO_g_hAppInstance;
extern HWND           INO_g_hAppMainWindow;
 
 
 
/*
  Function to call for cpa error initialisation
*/
 
#ifdef USE_CPA
extern short INO_fn_wInitError();
extern short INO_fn_wInitMemory();
#endif
 
extern short INO_fn_wInitDirectInput(HINSTANCE hInstance,HWND hWindow);
extern void  INO_fn_vReleaseDirectInput();
