#include "MEC/dnmlkmat.h"
#include "acp_base.h"
/*#include "BIN.h"*/
 
/* Private Link Table */
#if !defined(U64)
SCR_tdst_Link_Table stLinkTableOfMecMatCharacteristics;
#endif /* U64 */
 
/*----------------------*/
/*    Init Functions    */
/*----------------------*/
/* Author : Jean-Marc Soudagne */
/* Date : 1997-04-08           */
/* Version : 1.00              */
/* Modify : yyyy-mm-dd         */
void DNM_fn_vInitLinkTableOfMecMatCharacteristics()
{ 
#if !defined(U64)
 SCR_fn_v_Link_InitTable(&stLinkTableOfMecMatCharacteristics);
#endif /* U64 */
}
 
/*----------------------*/
/*   Create an Entry    */
/*----------------------*/
/* Author : Jean-Marc Soudagne */
/* Date : 1997-04-08           */
/* Version : 1.00              */
/* Modify : yyyy-mm-dd         */
void DNM_fn_vSetValueInLinkTableOfMecMatCharacteristics( char *_p_szKey,unsigned long _ulValue)
{
#if !defined(U64)
 SCR_fnp_st_Link_SetValue(&stLinkTableOfMecMatCharacteristics,_p_szKey,_ulValue); 
#endif /* U64 */
}
 
/*----------------------*/
/* Find Handle with Key */
/*----------------------*/
/* Author : Jean-Marc Soudagne */
/* Date : 1997-04-08           */
/* Version : 1.00              */
/* Modify : yyyy-mm-dd         */
unsigned long DNM_fn_ulLink_SearchKeyInLinkTableOfMecMatCharacteristics( char *_p_szKey)
{
#if !defined(U64)
 return SCR_M_ul_Link_GetValue(SCR_fnp_st_Link_SearchKey(&stLinkTableOfMecMatCharacteristics,_p_szKey)); 
#else
/* XB 05/05/99 */
/*	unsigned long ul; */
/*	return ul; */
	return 0L;
/* End XB 05/05/99 */
#endif /* U64 */
}
 
/*----------------------*/
/* Find Key with Handle */
/*----------------------*/
/* Author : Jean-Marc Soudagne */
/* Date : 1997-04-08           */
/* Version : 1.00              */
/* Modify : yyyy-mm-dd         */
char * DNM_fn_p_cSearchValueInLinkTableOfMecMatCharacteristics( unsigned long _ulValue)
{ 
#if !defined(U64)
 return SCR_M_p_sz_Link_GetKey(SCR_fnp_st_Link_SearchValue(&stLinkTableOfMecMatCharacteristics,_ulValue));
#else
/* XB 05/05/99 */
/*	char *pChar; */
/*	return pChar; */
 return NULL;
/* End XB 05/05/99 */
#endif /* U64 */
}
 
 
/*----------------------*/
/*    Get the Table     */
/*----------------------*/
/* Author : Benoit Germain     */
/* Date : 1997-04-28           */
/* Version : 1.00              */
/* Modify : yyyy-mm-dd         */
#if !defined(U64)
SCR_tdst_Link_Table *DNM_fn_p_stGetLinkTableOfMecMatCharacteristics()
{
	return &stLinkTableOfMecMatCharacteristics;
}
#endif /* U64 */
 
/*---------------------------------------*/
/* Prepare the Table for the binary save */
/*---------------------------------------*/
/* Author : Alain Robin                  */
/* Date : 1997-08-04                     */
/* Version : 1.00                        */
/* Modify : yyyy-mm-dd                   */
/*
void DNM_fn_vPrepareSaveMaterialBinaryBloc()
{
#if !defined (U64)
	BIN_fn_vCreateBinaryIds(DNM_fn_p_stGetLinkTableOfMecMatCharacteristics(),BIN_C_MMTID);
#endif // U64 
}
*/
