/*----------------------*/
/*     DNMLinkT.c       */
/*----------------------*/
/* (c) Ubi R&D 1997     */
/*----------------------*/
 
#include "MEC/DNMLinkI.h"
 
/* Private Link Table */
#if !defined(U64)
SCR_tdst_Link_Table stLinkTableOfIdCard;
SCR_tdst_Link_Table* g_a_p_stIdCardsLinkTables[2];
#endif /* U64 */
 
/*----------------------*/
/*    Init Functions    */
/*----------------------*/
/* Author : S Leroy     */
/* Date : 1997-04-02    */
/* Version : 0.10       */
/* Modify : 1997-04-02  */
/* By : S Leroy         */
/* (c) Ubi R&D 1997     */
/*----------------------*/
void DNM_fn_vInitLinkTableOfIdCard()
{ 
#if !defined(U64)
 SCR_fn_v_Link_InitTable(&stLinkTableOfIdCard);
 
#ifdef _DNM_BINARISER
 /* For Binarisation purposes */
 g_a_p_stIdCardsLinkTables[2]=&stLinkTableOfMecCameraIdCard;
#endif /*_DNM_BINARISER*/
 
#endif /* U64 */
}
 
/*----------------------------*/
/*    Gives the link Table    */
/*----------------------------*/
/* Author : S Leroy     */
/* Date : 1997-04-02    */
/* Version : 1.00       */
/* Modify : 1997-07-31  */
/* By : S Leroy         */
/* (c) Ubi R&D 1997     */
/*----------------------*/
#if !defined(U64)
SCR_tdst_Link_Table * DNM_fn_p_stGetIdCardLinkTable()
{  
 return (&stLinkTableOfIdCard) ;
}
#endif /* U64 */
 
 
/*----------------------*/
/*   Create an Entry    */
/*----------------------*/
/* Author : S Leroy     */
/* Date : 1997-04-02    */
/* Version : 0.10       */
/* Modify : 1997-04-02  */
/* By : S Leroy         */
/* (c) Ubi R&D 1997     */
/*----------------------*/
void DNM_fn_v_SetValueInLinkTableOfIdCard( char *_p_szKey,unsigned long _ulValue)
{
#if !defined(U64)
 SCR_fnp_st_Link_SetValue(&stLinkTableOfIdCard,_p_szKey,_ulValue); 
#endif /* U64 */
}
 
/*----------------------*/
/* Find Handle with Key */
/*----------------------*/
/* Author : S Leroy     */
/* Date : 1997-04-02    */
/* Version : 0.10       */
/* Modify : 1997-04-02  */
/* By : S Leroy         */
/* (c) Ubi R&D 1997     */
/*----------------------*/
unsigned long DNM_fn_ulLink_SearchKeyInLinkTableOfIdCard( char *_p_szKey)
{
#if !defined(U64)
 return SCR_M_ul_Link_GetValue(SCR_fnp_st_Link_SearchKey(&stLinkTableOfIdCard,_p_szKey)); 
#else
	unsigned long ul;
	return ul;
#endif /* U64 */
}
 
/*----------------------*/
/* Find Key with Handle */
/*----------------------*/
/* Author : S Leroy     */
/* Date : 1997-04-02    */
/* Version : 0.10       */
/* Modify : 1997-04-02  */
/* By : S Leroy         */
/* (c) Ubi R&D 1997     */
/*----------------------*/
char * DNM_fn_p_cSearchValueInLinkTableOfIdCard( unsigned long _ulValue)
{ 
#if !defined(U64)
 return SCR_M_p_sz_Link_GetKey(SCR_fnp_st_Link_SearchValue(&stLinkTableOfIdCard,_ulValue));
#else
	char *pChar;
	return pChar;
#endif /* U64 */
}
 
/*----------------------*/
/* Find Key with Handle */
/*----------------------*/
/* Author : Yves B.     */
/* Date : 1997-05-12    */
/* Version : 1.00       */
/* Modify : yyyy-mm-dd  */
/* (c) Ubi R&D 1997     */
/*----------------------*/
#if !defined(U64)
SCR_tdst_Link_Table *DNM_fn_p_stGetLinkTableOfIdCard(void)
{
	return &stLinkTableOfIdCard;
}
#endif /* U64 */
