/**********************************************************
 *                                                        *
 *                   Magnet                               *
 *                                                        *
 * Author : Ubi China - Marc Trabucato                    *
 *                                                        *
 **********************************************************/
 
#ifdef MGT_RASTER
 
#if !defined(_MGTRAST_H_)
#define _MGTRAST_H_
 
/*************************************************************************************************/
extern unsigned long gs_ulMGTRasterSearch;
extern unsigned long gs_ulMGTCounterSearch;
extern unsigned long gs_ulMGTRasterCompute;
extern unsigned long gs_ulMGTCounterCompute;
extern unsigned long gs_ulTmp;
extern unsigned long gs_ulMGTRasterAlloc;
extern unsigned long gs_ulMGTCounterAlloc;
/* ======================================== Macros ========================================*/
 
#define RDTSC   __asm _emit 0x0F  __asm _emit 0x31
 
/* ======================================== Inline functions ========================================*/
 
#pragma warning (disable : 4035)    /* To prevent from displaying the 'no return value' warning message*/
 
/*-----------------------------------------------------------------------------*/
/* PRF_fn_lGetPentiumTimerValue*/
/* Give the current value of the Pentium timer*/
/*-----------------------------------------------------------------------------*/
INLINE
long __fastcall PRF_fn_lGetPentiumTimerValue ()
    {
        __asm
        {
            PUSH EDX
            RDTSC
            SHRD EAX,EDX,4
            POP  EDX
        }
    }
 
#pragma warning (default : 4035)
 
 
#endif /* _MGTRAST_H_ */
 
#endif /* MGT_RASTER */
