/**********************************************************
 *                                                        *
 *                   Magnet                               *
 *                                                        *
 * Author : Ubi China - Marc Trabucato                    *
 *                                                        *
 **********************************************************/
 
#if !defined( _MGTMM_H_ )
#define _MGTMM_H_
 
/*************************************************************************************************/
#include "cpa_expt.h"
 
#include "MGT\MGTStruc.h"
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
/*************************************************************************************************/
 
 
MGT_tdxHandleToMagnetModification MGT_fn_hCreateMagnetModification                 ( ACP_tdxIndex x_Magnet , ACP_tdxIndex x_ModifiedObject );
MGT_tdxHandleToMagnetModification MGT_fn_hFindOrAddMagnetModification              ( ACP_tdxIndex x_Magnet , ACP_tdxIndex x_ModifiedObject , GEO_tdstGeometricObject *p_stObject );
void                              MGT_fn_vClearModifiedPointsOfMagnetModification  ( MGT_tdxHandleToMagnetModification h_MagnetModif );
void                              MGT_fn_vClearInfluencedPointsOfMagnetModification( MGT_tdxHandleToMagnetModification h_MagnetModif );
ACP_tdxBool						  MGT_fn_bIsExistModifiedPointsOnMagnetModification( MGT_tdxHandleToMagnetModification h_MagnetModif );
void                              MGT_fn_vDeleteMagnetModification                 ( MGT_tdxHandleToMagnetModification h_MagnetModif );
 
 
/*************************************************************************************************/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
/*************************************************************************************************/
 
#endif /* _MGTMM_H_ */
