/*///////////////////////////////////////////////////////////*/
/**/
/*    Memory Management of the Module : Net*/
/**/
/* File Name  : MmgNet.h*/
/* Date     : 703/10/96*/
/* Author   : First_Name Last_Name*/
/**/
/*///////////////////////////////////////////////////////////*/
#ifndef __MmgNet_H__
#define __MmgNet_H__
 
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
 
 
/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif
 
 
#include "MMG.h"
 
typedef enum e_ucNetStaticBlocks_{
  E_ucNetBlock1, 
/*  E_ucNetBlock2,*/
/*  ...*/
  E_ucNetMaxBlocksNb  /* maximum number of static block, You have to follow this syntax 'E_uc+ Abbreviation Module +MaxBlocksNb'*/
} e_ucNetStaticBlocks;
 
#undef EXTERN
#ifdef __DeclareGlobalVariableMmgNet_h__
#define EXTERN /*nothing*/
#else /* no __DeclareGlobalVariableMmgNet_h__*/
#define EXTERN extern
#endif /*__DeclareGlobalVariableMmgNet_h__*/
 
EXTERN CPA_EXPORT  struct tdstBlockInfo_ g_a_stNetBlocksInfo[E_ucNetMaxBlocksNb];
 
#ifdef __DYNAMIC_MALLOC_ALLOWED__
#ifdef __DEBUG_MALLOC_MODE__
EXTERN CPA_EXPORT  struct tdstDynInfo_ g_stNetDynInfo;
#endif /*__DEBUG_MALLOC_MODE__*/
#endif /*__DYNAMIC_MALLOC_ALLOWED__*/
 
#ifdef __cplusplus
};
#endif /* __cplusplus */
 
#endif /*__MmgNet_H__*/
