/*
 
  PrivL0GSUBI.h
 
*/
 
#ifndef PRIVL0GSUBI_H
#define PRIVL0GSUBI_H
 
/* 
 * universal multiplayer library level 0 header file
 * transport layer: Game Service UBI Soft PC-windows 95
 */
 
#if !defined(__L0GSUBIPCWIN95_TYPES__)
#define __L0GSUBIPCWIN95_TYPES__
 
#if !defined(ONLY_TYPES)
#define L0GSUBIPCWIN95_UNDEF
#define ONLY_TYPES
#endif /* !ONLY_TYPES */
 
/*
 * include here any other include files you need
 */
#include <windows.h>
#include "L0GlDef.h"
 
#if defined(L0GSUBIPCWIN95_UNDEF)
#undef ONLY_TYPES
#undef L0GSUBIPCWIN95_UNDEF
#endif /* !L0GSUBIPCWIN95_UNDEF */
 
#endif /* !__L0GSUBIPCWIN95_TYPES__ */
 
#if !defined(ONLY_TYPES)
 
#if !defined(__L0GSUBIPCWIN95_VARS__)
#define __L0GSUBIPCWIN95_VARS__
 
#undef EXTERN
#undef extern
#if !defined(GLOBALS)
#define EXTERN extern
#else /* !GLOBALS */
#define EXTERN
#endif /* !GLOBALS */
 
/*
 * variables of the above types are here. declarations with initialization
 * are of the form:
 *
 * <type> <variable name>
 * #if defined(GLOBALS)
 * = <initial values>
 * #endif
 * ;
 */
#endif /* !__L0GSUBIPCWIN95_VARS__ */
 
#if !defined (__L0GSUBIPCWIN95_PROTOS__)
#define __L0GSUBIPCWIN95_PROTOS__
 
/*
 * put here the prototypes of the handler functions for the object
 */
void vL0PCWin95GSUBIConnectionResult(int iRes);
 
 
#endif /* !__L0GSUBIPCWIN95_PROTOS__ */
 
#endif /* !ONLY_TYPES */
 
#endif /* L0GSUBI_H */
