//*****************************************************************************
//*  ActQuery.hpp                                                             *
//*****************************************************************************
//*                                                                           *
//* This file contains all the constants used for the OnQueryAction function  *
//* of the Actor interface                                                    *
//*                                                                           *
//*****************************************************************************
//* Author : Alexis Vaisse                                                    *
//*****************************************************************************
#ifndef __ACTQUERY_HPP__
#define __ACTQUERY_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


//--------------------------------------------
// Constants to used with OnQueryAction
//      to communicate with the dll
//--------------------------------------------
#define  C_uiActor_GetANameList                   1
#define  C_uiActor_CreateANewObjectList           2
#define  C_uiActor_DeleteAnObjectList             3
#define  C_uiActor_GetAnObjectList                4
#define  C_uiActor_SetAnObjectList                5
#define  C_uiActor_SetAnObjectInObjectList        6
#define  C_uiActor_GetFirstActorUsingThisList     7
#define  C_uiActor_LoadNamesList                  8

#endif // __ACTQUERY_HPP__
