// CPACMSBu.hpp : header file
//
#ifndef _CPACMSBU_HPP_
#define _CPACMSBU_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class EdActors_MiniStructure;

typedef enum eCarMSButtonType
{
	ECAR_MS_BUTTON_TYPE_ALLOC = 0,
	ECAR_MS_BUTTON_TYPE_OPEN,

} tdeCarMSButtonType;

/////////////////////////////////////////////////////////////////////////////
// CPA_Editor_MiniStructureButton window

class CPA_Editor_MiniStructureButton : public CButton
{
// Construction
public:
	CPA_Editor_MiniStructureButton(	EdActors_MiniStructure *pclMS,
								CString csText,
								tdeCarMSButtonType tdeType);

// Attributes
public:

private:
	EdActors_MiniStructure *m_pclMS;
	CString m_csBaseText;
	tdeCarMSButtonType m_tdeType;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPA_Editor_MiniStructureButton)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPA_Editor_MiniStructureButton();
	
	void m_fn_vUpdateMSButton();

// Generated message map functions
protected:
	//{{AFX_MSG(CPA_Editor_MiniStructureButton)
	afx_msg void OnClicked();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif //_CPACMSBU_HPP_

