///////////////////////////////////////////////////////////////////////
// The CallBack Functions called by controls when a Data has changed //
///////////////////////////////////////////////////////////////////////
#ifndef ED_ACTORS_CALLBACK_FUNCTIONS
#define ED_ACTORS_CALLBACK_FUNCTIONS

void OAC_fn_vCurrentObjectTableHasChanged(class CTL_Editor_Data *_pclChangedData,
																					enum CTL_eUpdateReason _eReason,
																					long _lUserDefinedReason /*= 0*/);
void OAC_fn_vInitialObjectTableHasChanged(class CTL_Editor_Data *_pclChangedData,
																					enum CTL_eUpdateReason _eReason,
																					long _lUserDefinedReason /*= 0*/);
void OAC_fn_vCurrentActionHasChanged(class CTL_Editor_Data *_pclChangedData,
																		 enum CTL_eUpdateReason _eReason,
																		 long _lUserDefinedReason /*= 0*/);
void OAC_fn_vInitialActionHasChanged(class CTL_Editor_Data *_pclChangedData,
																		 enum CTL_eUpdateReason _eReason,
																		 long _lUserDefinedReason /*= 0*/);
void OAC_fn_vCallBackDynamicsObjectTypeHasChanged(class CTL_Editor_Data *_pclChangedData,
																									enum CTL_eUpdateReason _eReason,
																									long _lUserDefinedReason /*= 0*/);

//ANNECY CT 13/01/98 {  
void EDACTORS_fn_vCallBackInitialLocalLightHasChanged(CTL_Editor_Data *pclChangedData, enum CTL_eUpdateReason _eReason, long _lUserDefinedReason /*= 0*/);
void EDACTORS_fn_vCallBackInitialOnlyLocalLightHasChanged(CTL_Editor_Data *pclChangedData, enum CTL_eUpdateReason _eReason, long _lUserDefinedReason /*= 0*/);
//ENDANNECY CT }

#endif //ED_ACTORS_CALLBACK_FUNCTIONS
