// Header for the definition of a characteristic type
////////////////////////////////////////////////////////
//	A characteristic type is an abstract class which defines 
//	some common functions of specific characteristic (like Booleans,
//	numerical values, aso)
//	Every specific type of characteristic will inherit of this class
///////////////////////////////////////////////////////////////////////
#ifndef _CPACWDAT_HPP_
#define _CPACWDAT_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CTL_Editor_Data;

//#########################################################
class EdActors_WatchData
{
public:
	//Constructor
	EdActors_WatchData(CTL_Editor_Data *pclData);

	// Destructor
	~EdActors_WatchData();

//Attributes
public:
	CTL_Editor_Data *m_pclData;

protected:

private:
	CString m_csActorName;
	CString m_csCharacName;

//Member functions
public:
	CString m_fn_csGetActorName();
	CString m_fn_csGetFieldName();
	CString m_fn_csGetDataValue();

protected:

private:

};

#endif //_CPACWDAT_HPP_
