// EDACDgIL.hpp : header file
/////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_EDACDGIL_HPP__98F53447_EB9D_11D0_B553_006097828C2B__INCLUDED_)
#define AFX_EDACDGIL_HPP__98F53447_EB9D_11D0_B553_006097828C2B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
//
#include "EDAcIRes.h"

class EdActors_EditorActor;
class CPA_Actor;
class CPA_Family;

/////////////////////////////////////////////////////////////////////////////
// EdActors_Dialog_ActorChoice dialog

class EdActors_Dialog_ActorChoice : public CDialog
{
// Construction
public:
	// standard constructors
	EdActors_Dialog_ActorChoice(CPA_Actor *,
															CPoint cpPoint,
															CWnd* pParent = NULL);
	EdActors_Dialog_ActorChoice(CPA_Family *,
															CPoint cpPoint,
															CWnd* pParent = NULL);

	~EdActors_Dialog_ActorChoice();

// Dialog Data
	//{{AFX_DATA(EdActors_Dialog_ActorChoice)
	enum { IDD = IDD_CAR_D_ACTOR_CHOICE };
	int		m_iSelectedItem;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EdActors_Dialog_ActorChoice)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

public:
	EdActors_EditorActor *m_pclSelectedActor;

private:
	HINSTANCE m_hOldInstance;
	CPoint m_cpRefPoint;

	CPA_Actor *m_pclModel;
	CPA_Family *m_pri_pclFamily;

	short m_wCurrentWidth;
	short m_wCurrentHeight;
	short m_wFinalWidth;
	short m_wFinalHeight;
	short m_wInitialTop;
	short m_wInitialLeft;
	char m_cCurrentPercentage;

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(EdActors_Dialog_ActorChoice)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnDblclkListInstancesOfModel();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDACDGIL_HPP__98F53447_EB9D_11D0_B553_006097828C2B__INCLUDED_)
