// CPACDGMI.hpp : header file
/////////////////////////////////////////////////////////////////////////////
#ifndef _CPACMIDG_HPP_
#define _CPACMIDG_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EdAcIRes.h"

/////////////////////////////////////////////////////////////////////////////
// EdActors_ModelIconDialog dialog

class EdActors_ModelIconDialog : public CDialog
{
// Construction
public:		
	// standard constructor
	EdActors_ModelIconDialog(CWnd* pParent = NULL, 	CPA_SuperObject	*pclModel = NULL);   

 	//Destructor
	~EdActors_ModelIconDialog();

// Dialog Data
	//{{AFX_DATA(EdActors_ModelIconDialog)
	enum { IDD = IDD_CAR_D_CHOOSEBITMAP };
	//}}AFX_DATA

private:
	HINSTANCE hOldInstance;

	//Bitmap
	struct m_stBitmapDescription
	{
		CString csFileName;
		HBITMAP hBitmap;
		CSize csSize;
		BOOL bLoaded;
	};
	CPA_List<struct m_stBitmapDescription> m_clListOfBitmapsForActors;

	CPA_SuperObject		*m_pModel;
	CString				m_csBitmapName;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EdActors_ModelIconDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	CString m_fn_csGetBitmapName();

protected:

	// Generated message map functions
	//{{AFX_MSG(EdActors_ModelIconDialog)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeListBitmaps();
	afx_msg void OnDestroy();
	//}}AFX_MSG

private:
	void m_fn_vFillListBoxWithBitmapNames(CPA_List<struct m_stBitmapDescription> *lstBitmapList);
	BOOL m_fn_bGetBitmapSize(CString csFileName, CSize *sz);

	DECLARE_MESSAGE_MAP()
};

#endif //_CPACMCDG_HPP_

