// Constant string definitions
////////////////////////////////
#ifndef _CPA_CAR_STRING_DEF_
#define _CPA_CAR_STRING_DEF_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "IncGAM.h"
#include "x:\cpa\Main\Inc\_EditID.h"

#undef extern

//Ini file
#define C_szActorsIniFileName				"Actors.ini"

//Used for Errors
const CString g_c_csActorModuleNameForErrors	= "Actors Editor";


const CString g_c_csActorDLLName		= C_szDLLActorName;
const CString g_c_csActorType				= C_szActorInstanceTypeName;
const CString g_c_csActorModelType	= C_szActorModelTypeName;
//CPA2 Stegaru Cristian 98-05
const CString g_c_csUnloadedAlwaysType	= "UnloadedAlwaysType";
//End CPA2 Stegaru Cristian 98-05

const CString g_c_csGenericNameListType = C_szGenericNameListType;
const CString g_c_csObjectNameType = C_szObjectNameType;
const CString g_c_csZDeNameListType = C_szZDeNameListType;
const CString g_c_csZDmNameListType = C_szZDmNameListType;
const CString g_c_csZDdNameListType = C_szZDdNameListType;
const CString g_c_csZDrNameListType = C_szZDrNameListType;
const CString g_c_csWayNameListType = C_szWayNameListType;

const CString g_c_csActorsEnumDescriptorName						= "__Actors__";
const CString g_c_csObjectTablesEnumDescriptorName			= "__Object_Tables__";
const CString g_c_csBoxSetEnumDescriptorName						= "__Box_Set__";
const CString g_c_csInstanciatedItemEnumDescriptorName	= "__Instanciated_Item__";
const CString g_c_csGameMaterialEnumDescriptorName			= "__Game_Material__";
const CString g_c_csSectorsEnumDescriptorName						= "__Sectors__";
const CString g_c_csPartGenEnumDescriptorName						= "__Particle_Generators__";
const CString g_c_csGraphEnumDescriptorName						  = "__Reseau__";
//////////////////////
// Used for Scripts	//
//////////////////////
//Global (scripts)
const CString g_c_csActorScriptModelSectionName			= "CreateEditorActorModel";
const CString g_c_csActorScriptLevelSectionName			= "CreateEditorActorLevel";
const CString g_c_csActorScriptNamesListSectionName	= "CreateNamesList";
const CString g_c_csActorScriptZoneListSectionName      = "CreateNewArrayOfZdx";
const CString g_c_csActorScriptWayListSectionName       = "WayLst";

const CString g_csModelExtension					= ".ema";
const CString g_csInstanceExtension				= CString(".") + C_ScriptCharacterSuffixe;
const CString g_csNamesListExtension			= ".enl";
const CString g_csZoneListExtension       = ".zdx";
const CString g_csWayListExtension        = ".way";

//Used for both Models and Instances
const CString g_c_csActorFamily				= "Family";

//Used for Models
const CString g_c_csModelType					= "Type";
const CString g_c_csModelTypeGenDoor	= "GenDoorType";
const CString g_c_csModelTypeActor		= "ActorType";
const CString g_c_csBitmapName				= "Bitmap";
const CString g_c_csModelNamePrefix		= "";

//Used for MS
const CString g_c_csMSSection				= "MiniStructure";
const CString g_c_csAllocatedMS			= "Allocated";
const CString g_c_csNotAllocatedMS	= "Not_Allocated";
const CString g_c_csGroupName				= "Group_";

//Used for Data
const CString g_c_csLinkedField					= "Linked";
const CString g_c_csNotLinkedField			= "Not_Linked";
const CString g_c_csNeverLinkedField		= "Never_Linked";
const CString g_c_csAlwaysLinkedField		= "Always_Linked";
const CString g_c_csFieldInWatch				= "In_Watch";
const CString g_c_csFieldNotInWatch			= "Not_In_Watch";

//Used for Fields in Watch
const CString g_c_csEdActors_EditorLevelExtension												=	"elv";
const CString g_c_csEdActors_ActorInWatchSectionName										= "ActorInWatch";
const CString g_c_csEdActors_ActorInWatchSectionNameParamValue_Open			= "ActorIsOpen";
const CString g_c_csEdActors_ActorInWatchSectionNameParamValue_Closed		= "ActorIsClosed";
const CString g_c_csEdActors_FieldInWatchEntryName											= "FieldInWatch";


#define M_MAKECHAR(a) ((char *)(LPCTSTR(a)))

#endif //_CPA_CAR_STRING_DEF_
