#if !defined(AFX_CHARACTERINFODLG_H__F8257D3B_E4B5_11D1_A14B_00A0244F34C3__INCLUDED_)
#define AFX_CHARACTERINFODLG_H__F8257D3B_E4B5_11D1_A14B_00A0244F34C3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// CharacterInfoDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCharacterInfoDlg dialog
class CPA_SuperObject;
class CCharacterInfoDlg : public CDialog
{
// Construction
public:
	CCharacterInfoDlg(CPA_SuperObject *pSuperObject, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CCharacterInfoDlg)
	enum { IDD = IDD_CHARACTER_INFO };
	CString	m_csFamily;
	CString	m_csInstance;
	CString	m_csModel;
	CString	m_csNumberOfModules;
	CString	m_csXSize;
	CString	m_csYSize;
	CString	m_csZSize;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCharacterInfoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CPA_SuperObject *m_pSuperObject; 
	void ComputeVariables ();
	int mfn_iGetModulesNumber (CPA_SuperObject *pSuperObject);
	void mfn_vGetModulesNumber (CPA_SuperObject *pSuperObject, int &riModulesNumber);
	MTH3D_tdstVector mfn_GetSize (CPA_SuperObject *pSuperObject);
	void mfn_vGetMinMaxCoordinates (CPA_SuperObject *pSuperObject, MTH3D_tdstVector &rtdstMinCoordinates, MTH3D_tdstVector &rtdstMaxCoordinates);
	void mfn_vFillModulesList (CPA_SuperObject *pSuperObject, CStringList &rlstOfModules);
	// Generated message map functions
	//{{AFX_MSG(CCharacterInfoDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHARACTERINFODLG_H__F8257D3B_E4B5_11D1_A14B_00A0244F34C3__INCLUDED_)
