
#ifndef AFX_COMPPROP_HPP
#define AFX_COMPPROP_HPP

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


// compprop.hpp : header file
//

#include "pagebase.hpp"
#include "pagetarget.hpp"
#include "pagerotcenter.hpp"
#include "pagegeneral.hpp"



/////////////////////////////////////////////////////////////////////////////
// CompleteProperties dialog
class Camera;

class CompleteProperties : public CDialog
{

	typedef enum {TargetPage = 0, RotCenterPage, GeneralPage }tdePages;

// Construction
public:
	CompleteProperties(Camera* p_oCamera, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CompleteProperties)
	enum { IDD = IDD_COMPLETEPROPERTIES };
	CTabCtrl	m_oTabControl;
	CString	m_csTypeName;
	CString	m_csCameraName;
	//}}AFX_DATA

private:

	PageTarget			m_oTargetPage;
	PageRotationCenter	m_oRotCenterPage;
	PageGeneral			m_oGeneralPage;

	Camera				*m_p_oCamera;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CompleteProperties)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CompleteProperties)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangingTabProperties(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeTabProperties(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMPPROP_HPP__CC24C3C7_DC14_11D0_BE57_00609775AC86__INCLUDED_)
