// DlgPnt3D.hpp : header file
//

#ifndef __DLGPNT3D_HPP__
#define __DLGPNT3D_HPP__

#include "3DGe_res.h"

class Point3D;

/////////////////////////////////////////////////////////////////////////////
// CDlgPoint3D dialog

class CDlgPoint3D : public CDialog
{
// Construction
public:
	CDlgPoint3D(Point3D *pPoint3D, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgPoint3D)
	enum { IDD = IDD_DIALOGPOINT3D };
	CString	m_Edition_Zone_X;
	CString	m_Edition_Zone_Y;
	CString	m_Edition_Zone_Z;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgPoint3D)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

    // Generated message map functions
	//{{AFX_MSG(CDlgPoint3D)
	afx_msg void On_Change_Edition_Zone_X();
	afx_msg void On_Change_Edition_Zone_Y();
	afx_msg void On_Change_Edition_Zone_Z();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Personal data
private:
	Point3D   * m_pPoint3D;
    void RefreshData ();                       // Called when the data need to be refreshed
	void RedrawBackground ();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !__DLGPNT3D_HPP__
