//ROMTEAM WorldEditor
////////////////////////////////////////////////////////////////////////////////////////
// File        : CDlgObject.hpp: interface for the CDlgObject class.
// Author      : Ionut Grozea
// Date        : 97.11
// Description :
////////////////////////////////////////////////////////////////////////////////////////
#ifndef __AFX_DLGOBJECT_HPP__
#define __AFX_DLGOBJECT_HPP__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// DlgObject.h : header file
//
#include "3dge_res.h"
#include "stdafx.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgObject dialog
class ITObject3D;
class CDlgObject : public CDialog
{
// Construction

public:
	CDlgObject(ITObject3D* p_ITObject , CWnd* pParent = NULL);   // standard constructor
	ITObject3D * m_pITObject ;
	int  mfn_iGetIntPos(float fVal);
	float mfn_fSliderInt2Float(int sliderVal);
// Dialog Data
	//{{AFX_DATA(CDlgObject)
	enum { IDD = IDD_DIALOGOBJECT };
 	float	m_fscaleX;
	float	m_fscaleY;
	float	m_fscaleZ;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgObject)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:


	// Generated message map functions
	//{{AFX_MSG(CDlgObject)
	afx_msg void OnChangeEditscalex();
	afx_msg void OnChangeEditscaley();
	afx_msg void OnChangeEditscalez();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __AFX_DLGOBJECT_HPP__
