/*=========================================================================
* 
* SECTdEnv.hpp :  class SECT_DialogEnv
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
/*
#ifndef __SECT_D_ENV_HPP__
#define __SECT_D_ENV_HPP__

#include "SECTres.h"

#include "SECTenv.hpp"

class Sector_Interface;
*/

/*===========================================================================
*		Description:	Class for the ListBox
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================*/
/*
class SECT_EnvParamListBox : public SECT_EnvListBox
{
public:
	SECT_EnvParamListBox  (void);
	~SECT_EnvParamListBox (void);
	
	BOOL fn_bIsCurrentElement	(CPA_BaseObject *pElem);
	BOOL fn_bIsSelectedElement	(CPA_BaseObject *pElem);
	BOOL fn_bIsAlreadyUsed		(CPA_BaseObject *pElem);
};
*/

/*===========================================================================
*		Description:	Class for the Dialog Environment
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================*/
/*
class SECT_DialogEnv : public CFormView
{
protected:
// dialog parameters
	Sector_Interface	*m_pSectorInterface;
	SECT_Environment	*m_pEnvironment;
	SECT_Environment	*m_pDefaultEnv;
	BOOL				m_bInitialised;

	CString				m_csName;
	SECT_MecEnvironment *m_pMecEnvironment;
	SECT_VisEnvironment	*m_pVisEnvironment;
	SECT_SndEnvironment	*m_pSndEnvironment;

public:
// standard constructor
	SECT_DialogEnv (CWnd* pParent = NULL);   

// Dialog
	void fn_vInitDialog			(Sector_Interface *p_oDLL, CWnd *pParent);
	void fn_vInitEnvironment	(SECT_Environment *pEnvironment, BOOL bNewEnv);
	void fn_vInitControls		(BOOL bEnable);
	void fn_vReinitDialog		(void);

// list box
	void fn_vInitMecListBox		(void);
	void fn_vInitVisListBox		(void);
	void fn_vInitSndListBox		(void);

// selection
	void fn_vSelectMechanic		(SECT_MecEnvironment *pMecEnv, BOOL bUpdateEnv = TRUE);
	void fn_vSelectVisual		(SECT_VisEnvironment *pVisEnv, BOOL bUpdateEnv = TRUE);
	void fn_vSelectSound		(SECT_SndEnvironment *pSndEnv, BOOL bUpdateEnv = TRUE);

// sound
	int	 GetSoundIndex			(DWORD pElem);

// Get Functions
	SECT_MecEnvironment * GetSelectedMecEnv (void) { return m_pMecEnvironment; }
	SECT_VisEnvironment	* GetSelectedVisEnv (void) { return m_pVisEnvironment; }
	SECT_SndEnvironment	* GetSelectedSndEnv (void) { return m_pSndEnvironment; }
	SECT_Environment	* GetCurrentEnv		(void) { return m_pEnvironment; }

protected:
	
// Dialog Data
	//{{AFX_DATA(SECT_DialogEnv)
	enum { IDD = SEC_IDD_DIALOGENV };

	// name
	CEdit		m_cName;
	CButton		m_cDefault;
	// modifs
	CButton		m_cCancel;
	CButton		m_cSave;
	// mechanic environment
	SECT_EnvParamListBox	m_cMecListBox;
	CButton					m_cEditMec;
	CButton					m_cNewMec;
	// mechanic environment
	SECT_EnvParamListBox	m_cVisListBox;
	CButton					m_cEditVis;
	CButton					m_cNewVis;
	// sound environment
	CListBox	m_cSndListBox;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SECT_DialogEnv)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SECT_DialogEnv)
	afx_msg void OnSize(UINT, int, int);
	afx_msg void OnDestroy();	

	// name
	afx_msg	void OnChangeName();
	afx_msg void OnDefault();
	// modifs
	afx_msg void OnCancel();
	afx_msg	void OnSave();
	// mechanic environment
	afx_msg void OnSelChangeMecListBox(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblClkMecListBox(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditMec();
	afx_msg	void OnNewMec();
	// mechanic environment
	afx_msg void OnSelChangeVisListBox(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblClkVisListBox(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditVis();
	afx_msg	void OnNewVis();
	// sound environment
	afx_msg void OnSelChangeSndListBox();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__SECT_D_ENV_HPP__
*/
