/*=========================================================================
* 
* SECdMode.hpp :  class SECT_DialogMode
* 
*
* Version			1.0
* Creation date		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifndef __SECT_D_MODE_HPP__
#define __SECT_D_MODE_HPP__

#include "SECTres.h"

class Sector_Interface;

/*===========================================================================
*		Description:	Class for the Dialog
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================*/

class SECT_DialogMode : public CFormView
{
// Construction
protected:
	Sector_Interface  *m_pOwnerDLL;
	BOOL			  m_bShowSymetric;
	BOOL			  m_bInitialised;

public:
// standard constructor
	SECT_DialogMode (CWnd* pParent = NULL);   

// get functions
	Sector_Interface	* GetOwnerDLL		(void) { return m_pOwnerDLL; }

// Dialog
	void fn_vInitDialog		  (Sector_Interface *pDLL, CWnd *pParent, BOOL bShowSymetric, const CString csTag);
	void fn_vInitControls	  (void);
	void fn_vUpdateEditMode (void);

protected:
	
// Dialog Data
	//{{AFX_DATA(SECT_DialogMode)
	enum { IDD = SEC_IDD_DIALOGMODE };
	CButton		m_cSector;
	CButton		m_cList;
//Shaitan Clean Env
//	CButton		m_cEnv;
	CStatic		m_cSectorText;
	CStatic		m_cListText;
//Shaitan Clean Env
//	CStatic		m_cEnvText;
	CButton		m_cModeSym;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SECT_DialogMode)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SECT_DialogMode)
	afx_msg void OnSize(UINT, int, int);
	afx_msg void OnDestroy();	

	afx_msg void OnSectors();
	afx_msg void OnList();
//Shaitan Clean Env
//	afx_msg void OnEnv();
	afx_msg void OnModeSym();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__SECT_D_MODE_HPP__
