/*
///////////////////////////////////////////////////////////////////////////////////////////////////
// Description : LinkBez.hpp
//   
//  Edit the Bezier links         
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// inherit from  :	Link
///////////////////////////////////////////////////////////////////////////////////////////////////
// Creation date: 29 jan 1997                        Author: J Thnoz
///////////////////////////////////////////////////////////////////////////////////////////////////
// Modification date:			                      Author: 
// 
//
// 
//
///////////////////////////////////////////////////////////////////////////////////////////////////
*/

//ANNECY Shaitan Nettoyage (12/05/98) {
/*

#ifndef __LinkBez_HPP__
#define __LinkBez_HPP__

//ROMTEAM WorldEditor (Viorel Preoteasa 20/01/98) 
#include "ogd.h"
//ENDROMTEAM WorldEditor (Viorel Preoteasa) 

class LinkBez : public Link
{
protected:	
	static char ms_cType;						// type of link 
	static char ms_szName [10];					// name of the link

//ROMTEAM WorldEditor (Viorel Preoteasa 20/01/98) 
//	EDWAY_tdhBezierObject m_hBezierObject;		// editor object
	Bezier3D m_hBezierObject;		// editor object
//ENDROMTEAM WorldEditor (Viorel Preoteasa) 

	Tangent* m_pstStartTangent;					// Tangent object first point
	Tangent* m_pstFinishTangent;				// Tangent object second point
	BOOL m_bFirstEdition;


public:
	static void fn_vRegisterObject (void);	// this function is used to register this object
	static Link* fn_pConstruct ( CPA_ObjectDLLBase *p_oDLL, CPA_BaseObject *p_oOwner, WP_tdhLink hLink) {	if (hLink) return new LinkBez ( p_oDLL, p_oOwner, hLink); 
																																			else return new LinkBez ( p_oDLL, p_oOwner ); }
	LinkBez ( CPA_ObjectDLLBase *p_oDLL, CPA_BaseObject *p_oOwner, WP_tdhLink hLink );
	LinkBez ( CPA_ObjectDLLBase *p_oDLL, CPA_BaseObject *p_oOwner );

	char fn_cGetType (void) { return ms_cType; }
	char* fn_pGetName (void) { return ms_szName; }
//ROMTEAM WorldEditor (Viorel Preoteasa 20/01/98) 
//	EDWAY_tdhBezierObject fn_hGetEditBezierObject (void) { return m_hBezierObject; }
	Bezier3D *fn_hGetEditBezierObject (void) { return &m_hBezierObject; }
//ENDROMTEAM WorldEditor (Viorel Preoteasa) 

	void fn_vChangeNeighbourTangent (Tangent* pTangent);
	void fn_vSetTangent ( int iSide, MTH3D_tdstVector* pTangentVertex );

	void fn_vConstructGraphic (void);
	void fn_vInitGraphic (void);
	void fn_vRotationGraphic (BOOL bRotation);	
	void fn_vDrawNormal (void);
	void fn_vDrawOutHierarchy (GLD_tdstViewportAttributes *pViewportAttributes);
	void fn_vGetSaveInfo ( char dszParam [20][20], long& lNbParam );
	void fn_vInitEditorFromEngine (void);

	CDialog* fn_pGetSpecificDialog (CWnd* pParentWnd);
	void fn_vFreeSpecificDialog (CDialog* pDialog);	 

protected :
	void fn_vSetEngineStructure (void);

};

#endif

*/
//ENDANNECY Shaitan Nettoyage }
