/*
///////////////////////////////////////////////////////////////////////////////////////////////////
// Description : WPMod.hpp
//   
// Modification classes
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// inherit from CPA_Modif
//					
///////////////////////////////////////////////////////////////////////////////////////////////////
// Creation date: 21 jan 1997                        Author: J Thnoz
///////////////////////////////////////////////////////////////////////////////////////////////////
// Modification date:			                      Author: 
// 
//
// 
//
///////////////////////////////////////////////////////////////////////////////////////////////////
*/

#ifndef __WPMOD_HPP__
#define __WPMOD_HPP__

#define TYPE_RADIUS_WP		3
#define TYPE_COORDINATE_WP	4

class ModifWayPointRadius : public CPA_Modif
{
protected:
	WayPoint* m_poWP;
	GLI_tdxValue    m_xOldRadius;
	GLI_tdxValue    m_xNewRadius;
	BOOL			m_bFirstTime;
public :
	ModifWayPointRadius (WayPoint* poWP, GLI_tdxValue* pxR, BOOL pBlock=0);
	BOOL Do (void);
	BOOL Undo (void);
};

class ModifWayPointCoordinate : public CPA_Modif
{
protected:
	WayPoint* m_poWP;
	BOOL			m_bFirstTime;
public :
	ModifWayPointCoordinate (WayPoint* poWP, BOOL pBlock=0);
	BOOL Do (void);
	BOOL Undo (void);
protected :	
	inline void fn_vChangeSystemCoordinate (void);
};


#endif