/*
0         1         2         3         4         5         6         7
01234567890123456789012345678901234567890123456789012345678901234567890123456789
--------------------------------------------------------------------------------
-- Description : Particles system
--------------------------------------------------------------------------------
-- Creation date : 12 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
#ifndef D_THROW_PRT
 
#include "acp_base.h"
#include "MTH.h"
#include "RND.h"
#include "MEC.h"
#include "GMT.h"
#include "GEO.h"
#include "GLI.h"
#include "COL.h"
 
#include "PRT/PrtEnv.h"
 
/*
--------------------------------------------------------------------------------
-- Description : Global variables
--------------------------------------------------------------------------------
*/
 
/*
--------------------------------------------------------------------------------
-- Description : Particles environment creation
--------------------------------------------------------------------------------
-- Creation date : 12 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
 
void PRT_fn_vCreateParticlesEnvironment ( PRT_tdstParticlesEnvironment **_p_pstParticlesEnvironment )
{
  GEO_M_CPAMalloc ( *_p_pstParticlesEnvironment,
                    PRT_tdstParticlesEnvironment *,
                    sizeof ( PRT_tdstParticlesEnvironment ),
                    E_uwGEONotEnoughtMemory );
}
 
/*
--------------------------------------------------------------------------------
-- Description : Particles environment destruction
--------------------------------------------------------------------------------
-- Creation date : 12 jun 1997               Author : FPI
--------------------------------------------------------------------------------
*/
 
 
#ifndef _FIRE_DEADCODE_U64_ /* Added by RUC */
void PRT_fn_vDestructParticlesEnvironment ( PRT_tdstParticlesEnvironment *_p_stParticlesEnvironment )
{
  GEO_M_CPAFree ( _p_stParticlesEnvironment );
}
#endif /* _FIRE_DEADCODE_U64_ */ /* Added by RUC */
 
 
#endif /* D_THROW_PRT */
