
//		Maxi Sound 64 Specific functionalities

#include <INITGUID.H>


//	DSPROPERTY_Dream3D
//
//	Property supported by the IPropertySet interface associated with the 
//	Primary Buffer interface.
//
// {E8C0D100-503E-11d1-99DE-444553540000}
DEFINE_GUID(DSPROPERTY_Dream3D, 
0xe8c0d100, 0x503e, 0x11d1, 0x99, 0xde, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0);

//	DSPROPERTY_DreamBuffer
//
//	Property supported by the IPropertySet interface associated with the 
//	IDirectSoundBuffer interface.
//
// {E8C0D101-503E-11d1-99DE-444553540000}
DEFINE_GUID(DSPROPERTY_DreamBuffer, 
0xe8c0d101, 0x503e, 0x11d1, 0x99, 0xde, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0);

typedef enum 
{
    	DSPROPERTY_DREAM3D_NOMIDI,				// no data
	DSPROPERTY_DREAM3D_REMOVEALLBANKS,		// no data
	DSPROPERTY_DREAM3D_REMOVEBANK,			// pPropertyData=BankName[8]
	DSPROPERTY_DREAM3D_ADDBANK,				// pPropertyData=Sound Bank Path 
	DSPROPERTY_DREAM3D_REVERB,				//*pPropertyData=(BOOL) TRUE(set )/FALSE(remove )
	DSPROPERTY_DREAM3D_CHORUS,				//*pPropertyData=(BOOL) TRUE(set )/FALSE(remove )
	DSPROPERTY_DREAM3D_ECHO,				//*pPropertyData=(BOOL) TRUE(set )/FALSE(remove )
	DSPROPERTY_DREAM3D_AUDIOIN,				//*pPropertyData=(BOOL) TRUE(set )/FALSE(remove )
	DSPROPERTY_DREAM3D_EQUALIZER			//*pPropertyData=(BOOL) TRUE(set )/FALSE(remove )
} DSPROPERTY_DREAM3D;				


typedef enum 
{
    DSPROPERTY_DREAMBUFFER_LOOPPOINT		// *pPropertyData=(DWORD) LoopPoint
} DSPROPERTY_DREAMBUFFER;	