// Machine generated IDispatch wrapper class(es) created with ClassWizard

#include "stdafx.h"
#include "soundeditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// ISoundEditor properties

LPDISPATCH ISoundEditor::GetEventGroups()
{
	LPDISPATCH result;
	GetProperty(0x1, VT_DISPATCH, (void*)&result);
	return result;
}

void ISoundEditor::SetEventGroups(LPDISPATCH propVal)
{
	SetProperty(0x1, VT_DISPATCH, propVal);
}

long ISoundEditor::GetVersionNumber()
{
	long result;
	GetProperty(0x2, VT_I4, (void*)&result);
	return result;
}

void ISoundEditor::SetVersionNumber(long propVal)
{
	SetProperty(0x2, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// ISoundEditor operations

BOOL ISoundEditor::OpenDocument(LPCTSTR csFilename)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csFilename);
	return result;
}

BOOL ISoundEditor::SaveDocument(LPCTSTR csFilename)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csFilename);
	return result;
}

BOOL ISoundEditor::AddSoundDirectory(LPCTSTR csPath)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csPath);
	return result;
}

BOOL ISoundEditor::RebuildBanks()
{
	BOOL result;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL ISoundEditor::SaveLocalizedBanks(LPCTSTR _csDocumentPath, LPCTSTR _csLanguage)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		_csDocumentPath, _csLanguage);
	return result;
}

LPDISPATCH ISoundEditor::FindResFromEditorId(long _iId)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		_iId);
	return result;
}

BOOL ISoundEditor::SetSoundDriver(BOOL bSet)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		bSet);
	return result;
}

BOOL ISoundEditor::UnloadAllEvents()
{
	BOOL result;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long ISoundEditor::GetPosSound(long Handle)
{
	long result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0xb, DISPATCH_METHOD, VT_I4, (void*)&result, parms,
		Handle);
	return result;
}

BOOL ISoundEditor::SetDriverActivation(BOOL bActivate)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BOOL;
	InvokeHelper(0xc, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		bActivate);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// IEventGroup properties

long IEventGroup::GetId()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void IEventGroup::SetId(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

CString IEventGroup::GetName()
{
	CString result;
	GetProperty(0x2, VT_BSTR, (void*)&result);
	return result;
}

void IEventGroup::SetName(LPCTSTR propVal)
{
	SetProperty(0x2, VT_BSTR, propVal);
}

LPDISPATCH IEventGroup::GetResources()
{
	LPDISPATCH result;
	GetProperty(0x3, VT_DISPATCH, (void*)&result);
	return result;
}

void IEventGroup::SetResources(LPDISPATCH propVal)
{
	SetProperty(0x3, VT_DISPATCH, propVal);
}

LPDISPATCH IEventGroup::GetEvents()
{
	LPDISPATCH result;
	GetProperty(0x4, VT_DISPATCH, (void*)&result);
	return result;
}

void IEventGroup::SetEvents(LPDISPATCH propVal)
{
	SetProperty(0x4, VT_DISPATCH, propVal);
}

CString IEventGroup::GetFilePath()
{
	CString result;
	GetProperty(0x5, VT_BSTR, (void*)&result);
	return result;
}

void IEventGroup::SetFilePath(LPCTSTR propVal)
{
	SetProperty(0x5, VT_BSTR, propVal);
}

long IEventGroup::GetVersionNumber()
{
	long result;
	GetProperty(0x6, VT_I4, (void*)&result);
	return result;
}

void IEventGroup::SetVersionNumber(long propVal)
{
	SetProperty(0x6, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// IEventGroup operations

BOOL IEventGroup::RemoveAll()
{
	BOOL result;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL IEventGroup::CompactIds()
{
	BOOL result;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// ISND_EdiBank properties

/////////////////////////////////////////////////////////////////////////////
// ISND_EdiBank operations


/////////////////////////////////////////////////////////////////////////////
// ISND_EdiMap properties

/////////////////////////////////////////////////////////////////////////////
// ISND_EdiMap operations


/////////////////////////////////////////////////////////////////////////////
// IEventGroups properties

long IEventGroups::GetCount()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void IEventGroups::SetCount(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// IEventGroups operations

LPDISPATCH IEventGroups::Item(long Index)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		Index);
	return result;
}

LPDISPATCH IEventGroups::FindItem(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

LPDISPATCH IEventGroups::Add(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

BOOL IEventGroups::Remove(LPCTSTR csEventGroupName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csEventGroupName);
	return result;
}

LPDISPATCH IEventGroups::FindItemByID(long ulBinID)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		ulBinID);
	return result;
}

LPUNKNOWN IEventGroups::Get_NewEnum()
{
	LPUNKNOWN result;
	InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, NULL);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// IResource properties

CString IResource::GetName()
{
	CString result;
	GetProperty(0x1, VT_BSTR, (void*)&result);
	return result;
}

void IResource::SetName(LPCTSTR propVal)
{
	SetProperty(0x1, VT_BSTR, propVal);
}

long IResource::GetVolume()
{
	long result;
	GetProperty(0x2, VT_I4, (void*)&result);
	return result;
}

void IResource::SetVolume(long propVal)
{
	SetProperty(0x2, VT_I4, propVal);
}

LPDISPATCH IResource::GetSampleRes()
{
	LPDISPATCH result;
	GetProperty(0x3, VT_DISPATCH, (void*)&result);
	return result;
}

void IResource::SetSampleRes(LPDISPATCH propVal)
{
	SetProperty(0x3, VT_DISPATCH, propVal);
}

long IResource::GetType()
{
	long result;
	GetProperty(0x4, VT_I4, (void*)&result);
	return result;
}

void IResource::SetType(long propVal)
{
	SetProperty(0x4, VT_I4, propVal);
}

long IResource::GetDataOffset()
{
	long result;
	GetProperty(0x5, VT_I4, (void*)&result);
	return result;
}

void IResource::SetDataOffset(long propVal)
{
	SetProperty(0x5, VT_I4, propVal);
}

long IResource::GetDataSize()
{
	long result;
	GetProperty(0x6, VT_I4, (void*)&result);
	return result;
}

void IResource::SetDataSize(long propVal)
{
	SetProperty(0x6, VT_I4, propVal);
}

long IResource::GetId()
{
	long result;
	GetProperty(0x7, VT_I4, (void*)&result);
	return result;
}

void IResource::SetId(long propVal)
{
	SetProperty(0x7, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// IResource operations


/////////////////////////////////////////////////////////////////////////////
// IResources properties

long IResources::GetCount()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void IResources::SetCount(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// IResources operations

LPDISPATCH IResources::Item(long Index)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		Index);
	return result;
}

LPDISPATCH IResources::FindItem(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

LPDISPATCH IResources::Add(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

LPDISPATCH IResources::AddSampleRes(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

BOOL IResources::Remove(LPCTSTR csResName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csResName);
	return result;
}

LPDISPATCH IResources::FindItemByID(long EdiID)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		EdiID);
	return result;
}

LPUNKNOWN IResources::Get_NewEnum()
{
	LPUNKNOWN result;
	InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, NULL);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// ISampleResource properties

CString ISampleResource::GetFileName()
{
	CString result;
	GetProperty(0x1, VT_BSTR, (void*)&result);
	return result;
}

void ISampleResource::SetFileName(LPCTSTR propVal)
{
	SetProperty(0x1, VT_BSTR, propVal);
}

long ISampleResource::GetZipType()
{
	long result;
	GetProperty(0x2, VT_I4, (void*)&result);
	return result;
}

void ISampleResource::SetZipType(long propVal)
{
	SetProperty(0x2, VT_I4, propVal);
}

BOOL ISampleResource::GetLoop()
{
	BOOL result;
	GetProperty(0x3, VT_BOOL, (void*)&result);
	return result;
}

void ISampleResource::SetLoop(BOOL propVal)
{
	SetProperty(0x3, VT_BOOL, propVal);
}

long ISampleResource::GetStartLoop()
{
	long result;
	GetProperty(0x4, VT_I4, (void*)&result);
	return result;
}

void ISampleResource::SetStartLoop(long propVal)
{
	SetProperty(0x4, VT_I4, propVal);
}

long ISampleResource::GetLoopLength()
{
	long result;
	GetProperty(0x5, VT_I4, (void*)&result);
	return result;
}

void ISampleResource::SetLoopLength(long propVal)
{
	SetProperty(0x5, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// ISampleResource operations

BOOL ISampleResource::SetSampleData(LPCTSTR csFilename)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csFilename);
	return result;
}

LPDISPATCH ISampleResource::GetResource()
{
	LPDISPATCH result;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, NULL);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// IEvents properties

long IEvents::GetCount()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void IEvents::SetCount(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// IEvents operations

LPDISPATCH IEvents::Item(long Index)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x2, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		Index);
	return result;
}

LPDISPATCH IEvents::FindItem(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x3, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

LPDISPATCH IEvents::Add(LPCTSTR csName)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x4, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		csName);
	return result;
}

LPDISPATCH IEvents::AddPlayEvent(LPDISPATCH Resource)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x5, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		Resource);
	return result;
}

LPDISPATCH IEvents::AddStopEvent(LPDISPATCH lpEvent)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_DISPATCH;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		lpEvent);
	return result;
}

BOOL IEvents::Remove(LPCTSTR csEventName)
{
	BOOL result;
	static BYTE parms[] =
		VTS_BSTR;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms,
		csEventName);
	return result;
}

LPDISPATCH IEvents::FindItemByID(long EdiID)
{
	LPDISPATCH result;
	static BYTE parms[] =
		VTS_I4;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms,
		EdiID);
	return result;
}

LPUNKNOWN IEvents::Get_NewEnum()
{
	LPUNKNOWN result;
	InvokeHelper(0xfffffffc, DISPATCH_PROPERTYGET, VT_UNKNOWN, (void*)&result, NULL);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// IEvent properties

long IEvent::GetId()
{
	long result;
	GetProperty(0x1, VT_I4, (void*)&result);
	return result;
}

void IEvent::SetId(long propVal)
{
	SetProperty(0x1, VT_I4, propVal);
}

CString IEvent::GetName()
{
	CString result;
	GetProperty(0x2, VT_BSTR, (void*)&result);
	return result;
}

void IEvent::SetName(LPCTSTR propVal)
{
	SetProperty(0x2, VT_BSTR, propVal);
}

BOOL IEvent::GetDynamic()
{
	BOOL result;
	GetProperty(0x3, VT_BOOL, (void*)&result);
	return result;
}

void IEvent::SetDynamic(BOOL propVal)
{
	SetProperty(0x3, VT_BOOL, propVal);
}

BOOL IEvent::GetStopable()
{
	BOOL result;
	GetProperty(0x4, VT_BOOL, (void*)&result);
	return result;
}

void IEvent::SetStopable(BOOL propVal)
{
	SetProperty(0x4, VT_BOOL, propVal);
}

long IEvent::GetType()
{
	long result;
	GetProperty(0x5, VT_I4, (void*)&result);
	return result;
}

void IEvent::SetType(long propVal)
{
	SetProperty(0x5, VT_I4, propVal);
}

/////////////////////////////////////////////////////////////////////////////
// IEvent operations

LPDISPATCH IEvent::GetResource()
{
	LPDISPATCH result;
	InvokeHelper(0x6, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, NULL);
	return result;
}

BOOL IEvent::LoadData()
{
	BOOL result;
	InvokeHelper(0x7, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

BOOL IEvent::UnloadData()
{
	BOOL result;
	InvokeHelper(0x8, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}

long IEvent::Play()
{
	long result;
	InvokeHelper(0x9, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
	return result;
}

BOOL IEvent::LoadPlayUnload()
{
	BOOL result;
	InvokeHelper(0xa, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
	return result;
}


/////////////////////////////////////////////////////////////////////////////
// IOptionsSheet properties

/////////////////////////////////////////////////////////////////////////////
// IOptionsSheet operations


/////////////////////////////////////////////////////////////////////////////
// IEventOptionsPage properties

/////////////////////////////////////////////////////////////////////////////
// IEventOptionsPage operations


/////////////////////////////////////////////////////////////////////////////
// IResOptionsPage properties

/////////////////////////////////////////////////////////////////////////////
// IResOptionsPage operations


/////////////////////////////////////////////////////////////////////////////
// IPlugInOptionsPage properties

/////////////////////////////////////////////////////////////////////////////
// IPlugInOptionsPage operations


/////////////////////////////////////////////////////////////////////////////
// ILanguageOptionsPage properties

/////////////////////////////////////////////////////////////////////////////
// ILanguageOptionsPage operations


/////////////////////////////////////////////////////////////////////////////
// IViewSettingsOptions properties

/////////////////////////////////////////////////////////////////////////////
// IViewSettingsOptions operations
