// supervis.h : main header file for the SUPERVIS DLL
//

#if !defined(AFX_SUPERVIS_H__2CEA4ECB_D8B0_11D2_9F3A_00104B6833D0__INCLUDED_)
#define AFX_SUPERVIS_H__2CEA4ECB_D8B0_11D2_9F3A_00104B6833D0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "SuperVisSheet.h"	// Added by ClassView
#include "SuperVisThread.h"

//ACP
#include "SCR.h"



//user defined window message
#define WM_USER_UPDATE_DATA  0x00008001
#define WM_USER_DESTROY_WINDOW 0x00008002
#define WM_USER_MIXERPAGE 0x00008003



SCR_tde_Anl_ReturnValue fn_AnalyseLCB(
	SCR_tdst_File_Description		*_p_stFile,
	char 	           				*_p_szName,
	char             				*_ap_szParameters[],
	SCR_tde_Anl_Action				_eAction );


SCR_tde_Anl_ReturnValue fn_AnalyseCsbHeader(
	SCR_tdst_File_Description		*_p_stFile,
	char 	           				*_p_szName,
	char             				*_ap_szParameters[],
	SCR_tde_Anl_Action				_eAction );


SCR_tde_Anl_ReturnValue fn_FindEventNameInCSB(
	SCR_tdst_File_Description		*_p_stFile,
	char							*_p_szName,
	char							*_ap_szParameters[],
	SCR_tde_Anl_Action				_eAction);


SCR_tde_Anl_ReturnValue fn_FindResNameInCSB(
	SCR_tdst_File_Description		*_p_stFile,
	char							*_p_szName,
	char							*_ap_szParameters[],
	SCR_tde_Anl_Action				_eAction);

void erreur(SCR_tdst_Err_GlobalError *test);


/////////////////////////////////////////////////////////////////////////////
// CSupervisApp
// See supervis.cpp for the implementation of this class
//

class CSupervisApp : public CWinApp
{
public:
	BOOL m_bSuperVisaterActive;
	CString m_cLCBFileTitle;
	CString m_cLCBPath;
	CSuperVisThread * m_SuperVisThread;
	CSupervisApp();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSupervisApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CSupervisApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SUPERVIS_H__2CEA4ECB_D8B0_11D2_9F3A_00104B6833D0__INCLUDED_)
