
;--offsets des champs de la structure C BUFFER_DISPO
offset_pt_sign		EQU		0
offset_inc_sign		EQU		4
offset_pt_max		EQU		8
offset_pt_loop		EQU		12
offset_pt_zero		EQU		16

offset_vol			EQU		20
offset_sample		EQU		24
offset_fct_callback EQU		28
offset_pan			EQU		32

offset_must_looping	EQU		40
offset_is_playing	EQU		44
offset_is_looping	EQU		48
offset_callback		EQU		52

offset_is_mixing	EQU		64
offset_space		EQU		68

offset_DeltaPitch	EQU		80
offset_DeltaTemps	EQU		84
offset_DeltaReste	EQU		88
offset_stereo		EQU		96
offset_coef_mag		EQU		104

;***********************************************************
;!!!!!!!!!!!!!!!!! ATTENTION a la stereo !!!!!!!!!!!!!!!!!!!
;
;Pan=0 -> son  gauche
;Pan=1 -> son  droite
;	
;sample stereo  adr:adr+1;adr+2;adr+3
;	sample gauche  adr:adr+1
;	sample droit  adr+2:adr+3
;************************************************************

REVERBOUT                      	EQU  	1
FLANGEOUT                      	EQU   	2

READY_TO_INC_FLANGE_OFFSET     	EQU   	200
MASQUE                          EQU   	65534
NB_DECAL						EQU		8

; nombre de bits par lequel on decale a gauche le volume global
; avant de multiplier par la valeur du sample.
; Le sample est code sur 16 bits, le volume sur 15(non signe oblige)
; on doit donc tenir compte du volume d'entree 
; ex : 127(max) * 127(max) = 14 bits => on decale donc de 1 pour joindre 15

NB_BITS_MUL_VOL					EQU		1

INC_SAMPLE_MONO                 EQU     2
INC_SAMPLE_STEREO               EQU     4


; quatre mille octets pour l'historique de la reverb

NBVOIES                       	EQU 	2
REVERBHISTOSIZE                	EQU    	2*8192
FLANGEHISTOSIZE                 EQU   	2*8192
SURROUNDSIZE					EQU   	44000
FLANGEMAX                       EQU   	FLANGEHISTOSIZE/2
FLANGEMIN                       EQU    	FLANGEHISTOSIZE/16
FLANGEINC                       EQU    	FLANGEHISTOSIZE/2048

NB_COEFS						EQU		32


