/*/==============================================================================================
//							FICHIER D'IMPLEMENTATION DU MODULE DE TRAITEMENT DE L'"ADPCM"
//
//		Crer	  :	17 / 02 / 98
//		Fichier	  :	ApmThrd.c
//		Auteur	  :	Nicolas Meyer
//
//		Descriptif:	Codes sources des fonctions spcifiques  une target Win32. Dcrit un ensemble
//					de fonctions multi-thread
//
//
//==============================================================================================*/

#include "ApmThrd.h"

/*********************************************************************************************************
void SND_fn_vInitializeCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )

Paramtres
	Entre:	- lpSND_tdstADPCMCriticalSection	pstSection
	Sortie: - NEANT
Valeur retourne:
			- NEANT
Description:
	Procdure qui initialise une section critique

*/
void SND_fn_vInitializeCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )
{
	InitializeCriticalSection( (LPCRITICAL_SECTION)pstSection );
}

/*********************************************************************************************************
void SND_fn_vDeleteCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )

Paramtres
	Entre:	- lpSND_tdstADPCMCriticalSection	pstSection
	Sortie: - NEANT
Valeur retourne:
			- NEANT
Description:
	Procdure qui dtruit une section critique

*/
void SND_fn_vDeleteCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )
{
	DeleteCriticalSection( (LPCRITICAL_SECTION)pstSection );
}

/*********************************************************************************************************
void SND_fn_vEnterCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )

Paramtres
	Entre:	- lpSND_tdstADPCMCriticalSection	pstSection
	Sortie: - NEANT
Valeur retourne:
			- NEANT
Description:
	Procdure qui initialise une section critique

*/
void SND_fn_vEnterCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )
{
	EnterCriticalSection( (LPCRITICAL_SECTION)pstSection );
}

/*********************************************************************************************************
void SND_fn_vLeaveCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )

Paramtres
	Entre:	- lpSND_tdstADPCMCriticalSection	pstSection
	Sortie: - NEANT
Valeur retourne:
			- NEANT
Description:
	Procdure qui initialise une section critique

*/
void SND_fn_vLeaveCriticalSection( lpSND_tdstADPCMCriticalSection pstSection )
{
	LeaveCriticalSection( (LPCRITICAL_SECTION)pstSection );
}