#include "SNDinc.H"
#include "sndrec.h"
#include "sndlst2.h"
#include "sndxd.h"
 
#ifndef DISABLE_RECORD
/*-------------------------------------------------------------*/
/*	SND_fn_vInitRecord: init SNDREC*/
/*-------------------------------------------------------------*/
int SND_CALL SND_fn_iInitRecord(SND_tdstInitStruct *pInitStruct)
{
	return C_INIT_FAILED;
}
 
/*-------------------------------------------------------------*/
/*	SND_fn_vDesInitRecord: desinit SNDREC*/
/*-------------------------------------------------------------*/
void SND_CALL SND_fn_vDesInitRecord(void)
{
}
 
/*---------------------------------------------------------------*/
/*	SND_fn_bTestFormatRecord:test is a fromat is valid for recording*/
/*	Parameters:*/
/*		pformat: format to be tested; some fields may be filled depending of flags value*/
/*			to return a effective valid format*/
/*		flags: boolean combinaison of following*/
/*			FORMATREC_RESOLUTION: test Resolution field value; will fill pFormat with a valid value*/
/*			FORMATREC_FREQUENCY: test Frequency field value; will fill pFormat with a valid value*/
/*			FORMATREC_NBCHANNEL: test NbChannlel field value; will fill pFormat with a valid value*/
/*			FORMATREC_ZIP: test eZip field value; will fill pFormat with a valid value*/
/*	Return:*/
/*		TRUE when a calid format was found; some filed of pFormat could be changed*/
/*		FALSE when no format is availlable regardless to flags value*/
/*---------------------------------------------------------------*/
SndBool SND_CALL SND_fn_bTestFormatRecord(SND_tdstFormat* pformat,int flags)
{
	return FALSE;
}
 
/*-----------------------------------------------------------*/
/*	SND_fn_lCreateBufferRecord: create a recording buffer*/
/*	Parameters:*/
/*		SND_tdstFormat: format souhaite*/
/*		pCallback; type de callback*/
/*	Return:*/
/*		C_PLAY_FAILED if failed; else, Buffer is ready to record*/
/*-----------------------------------------------------------*/
long SND_CALL SND_fn_lCreateBufferRecord(SND_tdstFormat* pformat,SND_tdstCallback* pCallback)
{
	return C_PLAY_FAILED;
}
 
/*---------------------------------------------------------------*/
/*	SND_fn_ucGetInstantVuMeterRecordSound: get current value for VuMeter*/
/*	Return:*/
/*		volume (0=silence; 127= maximum power)*/
/*-----------------------------------------------------------------*/
unsigned char SND_CALL SND_fn_ucGetInstantVuMeterRecord(void)
{
	return 0;
}
 
/*---------------------------------------------------------------*/
/*	SND_fn_lPushBufferToRecord: add a new buffer to record data into*/
/*	Parameters:*/
/*		id_buffer: id of RecordBuffer*/
/*		ptr: pointer where copy recorded data*/
/*		size_ptr: nb bytes to copy*/
/*	Return:*/
/*		id of data buffer*/
/*-----------------------------------------------------------------*/
long SND_CALL SND_fn_lPushBufferToRecord(long id_buffer,void* ptr,int size_ptr)
{
	return C_PLAY_FAILED;
}
 
SndBool SND_CALL SND_fn_bStartRecord(long id_buffer)
{
	return FALSE;
}
 
void SND_CALL SND_fn_vStopRecord(long id_buffer)
{
}
 
SndBool SND_CALL SND_fn_bIsBufferFullDuplexRecord(long id_buffer)
{
	return FALSE;
}
 
SndBool SND_CALL SND_fn_bIsWorkingRecord(long id_buffer)
{
	return FALSE;
}
 
/*---------------------------------------------------------*/
/*	SND_fn_bManageMsgForRecord: traitement des messages envoyes  la Thread Wave*/
/*	Parametres:*/
/*		msg: message to be processed*/
/*	Return:*/
/*		TRUE if message was processed  for WaveIn*/
/*		FALSE if message must be processed by the thread*/
/*---------------------------------------------------------*/
SndBool SND_CALL SND_fn_bManageMsgForRecord(long p_msg)
{
	return FALSE;
}
 
#endif /*DISABLE_RECORD*/
