#if !defined(AFX_WAVVOICESPAGE_H__6F53E3C9_F8C0_11D2_9F71_00104B6833D0__INCLUDED_)
#define AFX_WAVVOICESPAGE_H__6F53E3C9_F8C0_11D2_9F71_00104B6833D0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// WavVoicesPage.h : header file
//


//Wav Voices Structure used by the Supervisater
typedef struct WavVoiceArrayElement{
	
	long	lId;
	tdstBlockResourceMem    *res_pstPtr;
	tdxId					res_Id;
	BOOL	bPaused;
	unsigned char ucVolume;
	unsigned char ucPan;
	unsigned char ucSpace;
	double dFreq;

}WavVoiceArrayElement;

typedef struct RegKeyWavVoicePage{
	int iColWavVoiceId;
	int iColResPtr;
	int iColResId;
	int iColPaused;
	int iColVol;
	int iColPan;
	int iColSpace;
	int iColFreq;
}RegKeyWavVoicePage;





/////////////////////////////////////////////////////////////////////////////
// CWavVoicesPage dialog

class CWavVoicesPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CWavVoicesPage)

// Construction
public:
	void AddWavVoices(long lIndex);
	void RefreshVoicesList();
	CWavVoicesPage();
	~CWavVoicesPage();

// Dialog Data
	//{{AFX_DATA(CWavVoicesPage)
	enum { IDD = IDD_WAV_VOICES_PAGE };
	CListCtrl	m_WavVoicesListCtrl;
	long	m_lProcessTime;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CWavVoicesPage)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CWavVoicesPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WAVVOICESPAGE_H__6F53E3C9_F8C0_11D2_9F71_00104B6833D0__INCLUDED_)
