// T3DFrame.cpp: implementation of the Tool3D_Frame class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "ACP_Base.h"

#include "Itf.h"
#include "animview.h"
#include "T3DFrame.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


extern "C" CPA_DLLBase  *fn_p_oGetDLL(long lKey);
extern tdstDLLIdentity g_stTool3DIdentity;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Tool3D_Frame::Tool3D_Frame()
{
	m_p_clBaseObjectList = new CPA_BaseObjectList();	
	m_p_clDialogList = new CPA_DialogList();
	m_bDisplayAllFam = TRUE;
}

Tool3D_Frame::~Tool3D_Frame()
{
	delete m_p_clBaseObjectList;
	delete m_p_clDialogList;
}

BOOL Tool3D_Frame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext * pContext)
{
	
	if (!(CreateSplitter(C_cHorizontalSplitter,2)))
		return FALSE;

	//Creates Dialog List View
	
	m_p_clDialogList->fn_vInitDialog( fn_p_oGetDLL(0), this );
	SetPaneView( 0,	m_p_clDialogList,"Selection", 200);

	HINSTANCE hOldInst = AfxGetResourceHandle();
    AfxSetResourceHandle( g_stTool3DIdentity.hModule );
		
	//Creates other views
	if ( !CreateView( 1,RUNTIME_CLASS(CAnimationView),"Animation control", 800 ) )									
		return FALSE;
	AfxSetResourceHandle( hOldInst );

	return TRUE;
}
