// DlgInput.hpp : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDlgInputText dialog

#ifndef __DLGINPUT_H__
#define __DLGINPUT_H__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#include "TAct_res.h"

class CDlgInputText : public CDialog
{
// Construction
public:
	CDlgInputText(CWnd* pParent = NULL);   // standard constructor
	// set methods
	void SetTitle			(char *_szTitle);
	void SetMessage			(char *_szMessage);
    void SetPos				(POINT *_pPoint);
	void SetSelect			(BOOL _bSelect = TRUE );
	void SetDefaultValue	(char *_szValue);
	// get methods
	char * GetInputText		(void);

// Dialog Data
	//{{AFX_DATA(CDlgInputText)
	enum { IDD = IDD_DLG_INPUTTEXT };
	CString	m_Data_EditText;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgInputText)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CString m_oCstMessage;
	CString m_oCstTitle;
    POINT   m_xPoint;
	BOOL	m_bSelect;
	CString m_csDefaultValue;
	// Generated message map functions
	//{{AFX_MSG(CDlgInputText)
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__DLGINPUT_H__