#ifndef __MaterialDefines_HPP__
#define __MaterialDefines_HPP__

#ifdef ACTIVE_EDITOR

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#define C_szActivationModeNever "Never"
#define C_szActivationModeOnce "Once"
#define C_szActivationModeAlways "Always"


#define C_szFileNameForDefaultMaterial "Common\\Common.gmt"
#define C_szNameOfDefaultMaterial "Default"

#define C_szNoMaterialComboEntry "Nothing"

#define C_wTextureSize 48

#define C_wListViewTItemWidth 105
#define C_wListViewTItemHeight 20

#define C_wListViewBItemWidth (C_wTextureSize + 2)
#define C_wListViewBItemHeight (C_wTextureSize + 2)

#define C_wListViewBTItemWidth C_wListViewTItemWidth
#define C_wListViewBTItemHeight (C_wListViewBItemHeight + C_wListViewTItemHeight)

#define C_wListViewPlusPathWidth 40

#define C_szDefaultLeftPaneWidth "274"
#define C_szDefaultVisualPaneHeight "171"
#define C_szDefaultMechanicsPaneHeight "314"
#define C_szDefaultCollidePaneHeight "311"
#define C_szDefaultSoundPaneHeight "70"
#define C_szDefaultMainPaneHeight "104"
#define C_szDefaultTexturePaneWidth "309"
#define C_szDefaultListPaneWidth "683"
#define C_szDefaultMaterialListHeight "169"
#define C_szDisplayFilterEnabled "Used"
#define C_szDisplayFilterDisabled "All"
#define C_szDefaultDisplayFilter C_szDisplayFilterEnabled
#define C_szDefaultLoadWarningsActivation C_szActivationModeAlways

#define C_szPreferencesProfileSection "Material Editor Preferences"
#define C_szMechanicsHighlightProfileSection "Mechanical Characteristics Highlighting"
#define C_szCollideHighlightProfileSection "Mechanical Characteristics Highlighting"
#define C_szDisplayModeProfileString "Display Mode"
#define C_szDisplayMaterialUnderCursorProfileString "Show Material Under Cursor"
#define C_szLeftPaneWidthProfileString "Left Pane Width"
#define C_szVisualPaneHeightProfileString "Visual Pane Height"
#define C_szMechanicsPaneHeightProfileString "Mechanics Pane Height"
#define C_szCollidePaneHeightProfileString "Collide Pane Height"
#define C_szMainPaneHeightProfileString "Main Pane Height"
#define C_szSoundPaneHeightProfileString "Sound Pane Height"
#define C_szMaterialListHeightProfileString "Material List Height"
#define C_szTexturePaneWidthProfileString "Texture Pane Width"
#define C_szListPaneWidthProfileString "List Pane Width"
#define C_szLoadWarningsActivationProfileString "Load Warnings"

#endif // ACTIVE_EDITOR
#endif // __MaterialDefines_HPP__
