// EdIRBVwA.cpp : header file
//

#ifndef _EDIRBVWA_HPP_
#define _EDIRBVWA_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_UndoCreateBehaviour
/////////////////////////////////////////////////////////////////////////////

#include "ITF\CPAMdf.hpp"

class CPA_EdIR_DiagView;
class CPA_EdIR_MainBehaviour;
class CPA_EdIR_MainBehaviourList;

class CPA_EdIR_UndoCreateBehaviour : public CPA_Modif
{
	// Construction
	public:
		CPA_EdIR_UndoCreateBehaviour(CPA_EdIR_DiagView *,CPA_EdIR_MainBehaviour *,CPA_EdIR_MainBehaviourList *,BOOL bBloc=FALSE);
		~CPA_EdIR_UndoCreateBehaviour();

	// Attributes
	private:
		CPA_EdIR_DiagView						*m_pclDiagView;
		CPA_EdIR_MainBehaviour			*m_pclMainBehaviour;
		CPA_EdIR_MainBehaviourList	*m_pclMainBehaviourList;

	// Operations
	public:
		BOOL	Do();
		BOOL	Undo();
};

#endif //_EDIRBVWA_HPP_
