// EdIRBVwR.cpp : header file
//

#ifndef _EDIRBVWR_HPP_
#define _EDIRBVWR_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_UndoRenameBehaviour
/////////////////////////////////////////////////////////////////////////////

#include "ITF\CPAMdf.hpp"

class CPA_EdIR_DiagView;
class CPA_EdIR_MainBehaviour;
class CPA_EdIR_MainBehaviourList;

class CPA_EdIR_UndoRenameBehaviour : public CPA_Modif
{
	// Construction
	public:
		CPA_EdIR_UndoRenameBehaviour(CPA_EdIR_DiagView *,CPA_EdIR_MainBehaviour *,CPA_EdIR_MainBehaviourList *,CString,CString,BOOL bBloc=FALSE);
		~CPA_EdIR_UndoRenameBehaviour();

	// Attributes
	private:
		CPA_EdIR_DiagView						*m_pclDiagView;
		CPA_EdIR_MainBehaviour			*m_pclMainBehaviour;
		CPA_EdIR_MainBehaviourList	*m_pclMainBehaviourList;
		CString											m_csOldName;
		CString											m_csNewName;

	// Operations
	public:
		BOOL	Do();
		BOOL	Undo();
};

#endif //_EDIRBVWR_HPP_
