// EdIRDVLs.hpp : header file
//

#ifndef _EDIRDVLS_HPP_
#define _EDIRDVLS_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//////////////////////////////////////////////////////////////////
// class CPA_EdIR_DesignerVariableList
//////////////////////////////////////////////////////////////////

#include <afxtempl.h>

#include "EdIRDV.hpp"

class CPA_EdIR_DesignerVariableList : public CList<CPA_EdIR_DesignerVariable *,CPA_EdIR_DesignerVariable *>
{
	private:
		POSITION	m_fn_posGetPosition(long);
//ANNECY CB
		POSITION	m_fn_posGetPosition(CString&);
//		POSITION	m_fn_posGetPosition(CString);
//END
	public:
		CMapStringToPtr		*map;
		CMapPtrToPtr		*map1;

		//Empty constructor
		CPA_EdIR_DesignerVariableList();
		//Copy constructor
		CPA_EdIR_DesignerVariableList(CPA_EdIR_DesignerVariableList &);

		CPA_EdIR_DesignerVariableList operator =(CPA_EdIR_DesignerVariableList &);

		//Destructor;
		~CPA_EdIR_DesignerVariableList();

		void				m_fn_vDestroyAndRemoveAllEntries();
		void				AddTail(CPA_EdIR_DesignerVariable *);

//ANNECY CB
		long				m_fn_bIsADesignerVariable(CString&);
//		BOOL				m_fn_bIsADesignerVariable(CString);
		long				m_fn_lGetIndexOfADesignerVariable(CString&);
//		long				m_fn_lGetIndexOfADesignerVariable(CString);
//END
		CString			m_fn_csGetTypeOfADesignerVariable(CString);
		CString			m_fn_csGetTypeOfADesignerVariable(long);
		CString			m_fn_csGetFirstValueOfADesignerVariable(CString);
		// BEGIN ROMTEAM Cristi Petrescu 99-01- debug
		CString			m_fn_csGetFirstValueOfADesignerVariable(long);
		// END ROMTEAM Cristi Petrescu 99-01- debug
		CStringList	*m_fn_pcslGetValuesOfADesignerVariable(CString);
		BOOL				m_fn_bDesignerVariableIsInWatchWindow(CString);
		void				m_fn_vDesignerVariableSetInWatchWindow(CString,BOOL);

		long				m_fn_lGetSizeOfAllDesignerVariables();

		//BEGIN ROMTEAM Cristi Petrescu 98-06-
		BOOL			m_fn_bIsPrivateDesignerVariable (CString);
		//END ROMTEAM Cristi Petrescu 98-06-
};

#endif //_EDIRDVLS_HPP_
