// EdIRREdA.cpp : implementation file
//

#include "stdafx.h"

#include "Defines.hpp"

#ifdef D_ED_IR_ACTIVE

#include "EdIRREdA.hpp"

#include "EdIRREd.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// class CPA_EdIR_UndoPressAKey
/////////////////////////////////////////////////////////////////////////////

/**********************************************************************************/
CPA_EdIR_UndoPressAKey::CPA_EdIR_UndoPressAKey(CPA_EdIR_EditCtrl *pclEditCtrl,
											   UINT nKey,
											   long lIndex,long lScrollPosition,
											   BOOL bBlock)
	:CPA_Modif(2,"Press A Key",bBlock)
{
	m_nKey=nKey;
	m_lIndex=lIndex;
	m_lScrollPosition=lScrollPosition;
	m_pclEditCtrl=pclEditCtrl;
}

/**********************************************************************************/
CPA_EdIR_UndoPressAKey::~CPA_EdIR_UndoPressAKey()
{
}

/**********************************************************************************/
BOOL CPA_EdIR_UndoPressAKey::Do()
{
	m_pclEditCtrl->m_fn_vAddChar(m_lIndex,m_lScrollPosition,m_nKey);
	m_pclEditCtrl->m_fn_vSetModified(TRUE);

	return TRUE;
}

/**********************************************************************************/
BOOL CPA_EdIR_UndoPressAKey::Undo()
{
	m_pclEditCtrl->m_fn_vDelChar(m_lIndex,m_lScrollPosition,m_nKey);
	m_pclEditCtrl->m_fn_vSetModified(TRUE);

	return TRUE;
}

#endif //D_ED_IR_ACTIVE
