// Constants definition for the Charactersitics Editor
////////////////////////////////////////////////////////
#ifndef _EDCAR_CONST_HPP_
#define _EDCAR_CONST_HPP_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//Definitions for Editor
#define C_EDITOR_SUBSTRACTED_HEIGHT	0
#define C_EDITOR_WIDTH				250
#define C_SCROLLBAR_WIDTH			7

//Definitions for MS placing
#define C_SPACE_FOR_BORDER			2
#define C_MS_LINE_HEIGHT			20
#define C_MS_SPACING				3

//Definitions for MS internal controls
#define C_TABULATION				0
#define C_ALLOC_BUTTON_PERCENT_WIDTH	20

//Definitions for special tool tips windows
#define C_TTIPS_SPACING				4

//Definitions for Actors' View
//Defines for next/prev buttons display
#define C_BUTTON_SIZE				20	//square buttons
//Defines for direct acces buttons display
#define C_BUTTON_SPACING			2
#define C_BUTTON_HEIGHT				20
#define C_BUTTONS_COLUMNS			3	//Number of direct access buttons per line

//Definitions for Main View
#define C_MAIN_VIEW_SPACING			2

//Definitions for Buttons
#define C_BUTTON_MARGIN				3

//Definitions for Spin Buttons
#define C_SPIN_PRECISION			3
#define C_ACCEL_NB					5


//Global definitions for control
#define C_SPACE_BETWEEN_CONTROLS	2
#define C_EDIT_HEIGHT				15

//Definitions for Boolean control
#define C_BOOL_NAME_BOX_PERCENT_WIDTH	70
#define C_BOOL_NAME_BOX_MIN_WIDTH		40
#define C_BOOL_BUTTON_PERCENT_WIDTH		30
#define C_BUTTON_HEIGHT					20
#define C_BUTTON_WIDTH					40

//Definitions for Enum control
#define C_ENUM_BOX_TOTAL_HEIGHT		100
#define C_ENUM_COMBO_BOX_HEIGHT		20
#define C_ENUM_BOX_PERCENT_WIDTH	50
#define C_ENUM_BOX_MIN_WIDTH		90
#define C_ENUM_NAME_PERCENT_WIDTH	50

//Definitions for Float control
#define C_DECIMAL_NAME_BOX_PERCENT_WIDTH		60
#define C_DECIMAL_CURRENT_VALUE_PERCENT_WIDTH	35
#define C_DECIMAL_CURRENT_VALUE_MIN_WIDTH		50		//for Auto Spacing
#define C_DECIMAL_SPIN_PERCENT_WIDTH			5
#define C_DECIMAL_SPIN_MIN_WIDTH				10		//for Auto Spacing
#define C_SPIN_HEIGHT							17		//for Auto Spacing

//Definitions for Int control
#define C_INT_NAME_BOX_PERCENT_WIDTH		70
#define C_INT_CURRENT_VALUE_PERCENT_WIDTH	25
#define C_INT_CURRENT_VALUE_MIN_WIDTH		30		//for Auto Spacing
#define C_INT_SPIN_PERCENT_WIDTH			5
#define C_INT_SPIN_MIN_WIDTH				10		//for Auto Spacing

//Definitions for List control
#define C_LIST_NUMBER_OF_CONTROLS			3
#define C_LIST_BUTTON_HEIGHT				20
#define C_LIST_EDIT_BUTTON_PERCENT_WIDTH	15
#define C_LIST_DEV_BUTTON_PERCENT_WIDTH		15
#define C_LIST_NAME_BOX_PERCENT_WIDTH		70
#define C_LIST_ADDING_HEIGHT_WHEN_DEV		70

//Definitions for Matrice control
#define C_MATRICE_NUMBER_OF_CONTROLS			3
#define C_MATRICE_BUTTON_HEIGHT					20
#define C_MATRICE_EDIT_BUTTON_PERCENT_WIDTH		15
#define C_MATRICE_DEV_BUTTON_PERCENT_WIDTH		15
#define C_MATRICE_NAME_BOX_PERCENT_WIDTH		70
#define C_MATRICE_ADDING_HEIGHT_WHEN_DEV		50

//Definitions for Text control
#define C_TEXT_NAME_BOX_PERCENT_WIDTH		70
#define C_TEXT_CURRENT_VALUE_PERCENT_WIDTH	30
#define C_TEXT_CURRENT_VALUE_MIN_WIDTH		30		//for Auto Spacing


#endif //_EDCAR_CONST_HPP_
