/*=========================================================================
* 
* LPDdLoad.hpp :  class OT_DialogLoad
* 
*
* Version			1.0
* Creation date		18/08/97		
* Revision date
*
* Shaitan
*=======================================================================*/
#ifndef __OT_D_LOAD_HPP__
#define __OT_D_LOAD_HPP__

#include "OTres.h"

class ObjectTableInterface;

/*===========================================================================
*		Description:	Class OT_DialogLoad
*		Creation date:	
*		Author:			Shaitan
*---------------------------------------------------------------------------
*		Revision date:                                                                                          Author:         
*=========================================================================*/

class OT_DialogLoad : public CDialog
{
protected:
	ObjectTableInterface			*m_pOwnerEditor;
    CPA_List<CPA_BaseObject>		m_oObjectsToLoad;
	HTREEITEM					m_hFirstItem;

	CImageList					m_oIconList;

public:
    CPA_BaseObjectList          *m_p_oListOfFamilies;

// Construction
public:
	OT_DialogLoad (ObjectTableInterface *pOwnerEditor, CWnd* pParent = NULL);   

    CPA_List<CPA_BaseObject>  * GetObjectsToLoad (void) { return &m_oObjectsToLoad; }

	HTREEITEM GetCorrespondingItem (CPA_BaseObject *pObject, HTREEITEM hElem = NULL);

// Dialog Data
	//{{AFX_DATA(CDlgLoad)
	enum { IDD = TOT_IDD_DIALOGLOAD };

	CTreeCtrl m_cTree;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgLoad)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);   
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgLoad)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeTreeControl(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRightClkTreeControl(NMHDR* pNMHDR, LRESULT* pResult); 
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__OT_D_LOAD_HPP__

