/////////////////////////////////////////////////////////////
//
//			Management of the Module : LDT
//
// File Name	: ErrLDT.h
// Date			: 
// Author		: CPA_Ed_1 team
//
/////////////////////////////////////////////////////////////
//
// abbreviation of the module-name. Used in macro is 'LDT'
//
/////////////////////////////////////////////////////////////

#ifndef __ERRLDT_H__
#define __ERRLDT_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define C_szLDTVersion "LDT V1.0.0" /* The format is LDT Va.b.c with LDT is the Tag of the module */
#define C_szLDTFullName  "LDT Module"/* the complete and clear name of the module */
#define C_szLDTDate __DATE__ /*The format is "Mmm dd yyyy".You can use __DATE__ but be careful that you have the control of the compilation*/

/* For DLLs who are using this module : */ 
#undef CPA_EXPORT
#if defined(CPA_WANTS_IMPORT)
 #define CPA_EXPORT __declspec(dllimport)
#elif defined(CPA_WANTS_EXPORT)
 #define CPA_EXPORT __declspec(dllexport)
#else
 #define CPA_EXPORT
#endif


#include "ERM.h"

//------------------
// Global Variables
//------------------
#undef __ERRLDT_EXTERN
#ifndef __DeclareGlobalVariableErrLDT_h__
#define __ERRLDT_EXTERN extern /*external declaration*/
#else //__DeclareGlobalVariableErrLDT_h__
#define __ERRLDT_EXTERN /*replace by nothing : we have to declare*/
#endif //__DeclareGlobalVariableErrLDT_h__

__ERRLDT_EXTERN CPA_EXPORT  unsigned char g_ucLDTModuleId /*number of identification of the Erm module*/
#if defined(__DeclareGlobalVariableErrLDT_h__) && !defined(CPA_WANTS_IMPORT)
= C_ucModuleNotInitialized
#endif //__DeclareGlobalVariableErrLDT_h__&& CPA_WANTS_IMPORT
;

#ifdef __ERROR_STRINGS__

__ERRLDT_EXTERN CPA_EXPORT  char * g_a_szLDTInformationModule []
#if defined(__DeclareGlobalVariableErrLDT_h__) && !defined(CPA_WANTS_IMPORT)
= {C_szLDTVersion, C_szLDTFullName, C_szLDTDate}
#endif /*__DeclareGlobalVariableErrLDT_h__ &&  CPA_WANTS_IMPORT*/
;

__ERRLDT_EXTERN CPA_EXPORT  struct tdstErrorMsg_ g_a_stLDTTabErr [] 	/* Mandatory syntax 'g_a_st'+[Abbreviation of ModuleName]+'TabErr'*/
#if defined(__DeclareGlobalVariableErrLDT_h__) && !defined(CPA_WANTS_IMPORT)
= {0, NULL}; /*The Erm module need this variable even if it's equal to NULL*/ 
#endif //__DeclareGlobalVariableErrLgh_h__ && CPA_WANTS_IMPORT
;

#endif //__ERROR_STRINGS__

#ifdef __cplusplus
};
#endif /* __cplusplus */

#endif //__ERRLDT_H__
