
/*
 **************************************************************************************************
        *       CPA_Ed_1        team *  
        *   general types *
 **************************************************************************************************
*/



#ifndef __LDT_TYPE_H__
#define __LDT_TYPE_H__



#include "StdInc.h"



/*---------------------------------------------------------
  Define for types
-----------------------------------------------------------*/

/*---------------------------------------------------------
  Define for error types
-----------------------------------------------------------*/
/*
 *  Enum that describes the list of all errors Id.
 */
typedef enum LDT_tde_Err_Identification_
{
 LDT_EI_Err_InvalidAddress = 0xffffffff,
 LDT_EI_Err_None = 0,
 LDT_EI_Err_Malloc,
 LDT_EI_Err_OpenFile,                    
 LDT_EI_Err_OpenWrite,
 LDT_EI_Err_CloseFile,
 LDT_EI_Err_ReadFile,                     
 LDT_EI_Err_SeekFile,                     
 LDT_EI_Err_MemMove,                                     
 LDT_EI_Err_NotEnoughDataForMove,  
 LDT_EI_Err_AllreadyClose,                
 LDT_EI_Err_SeekInMem,
 LDT_EI_Err_NotEnoughPlaceForWrite,
 LDT_EI_Err_EndOfFile,
 LDT_EI_Err_AtemptTOWriteInReadFile,
 LDT_EI_Err_DuplicateRegister,
 LDT_EI_Err_RegisterWorkspaceNULL,
 LDT_EI_Err_NotRegistered,

 LDT_EI_Err_AddressConflict,
 LDT_EI_Err_InexistentLink

} LDT_tde_Err_Identification;

typedef enum  LDT_D_tType_
{
        ReadType,
        WriteType
} LDT_D_tType;


/*---------------------------------------------------------
  Define for types
-----------------------------------------------------------*/

#endif  /*__LDT_TYPE_H__*/
